/*
 Pri vytvareni noveho dokladu nastavi u ucetniho obdobi chybu preceneni pokud je treba

 Autor:       Jan Besta
*/
create or replace function dDoklFakInsDelPreceneni() returns trigger as $$
declare ZAZNAM record;
begin
  if (tg_op = 'DELETE') then
    ZAZNAM := OLD;
  else
    ZAZNAM := NEW;
  end if;

  if (ZAZNAM.Ucetni = true) then
    if (ZAZNAM.sumCelkemMen <> 0) then                  -- pokud je nula nemuze nastat chyba preceneni (zrejme to neni doklad v cizi mene)
      execute uNastavChybaPreceneni(ZAZNAM.datUcto);
    end if;
  end if;
  
  return ZAZNAM;
end;
$$ LANGUAGE plpgsql;

drop trigger if exists dDoklFakInsDelPreceneni on dDoklFak;

create trigger dDoklFakInsDelPreceneni before insert or delete on dDoklFak
for each row execute procedure dDoklFakInsDelPreceneni();