/*
 Aktualizace obrat v uObraty

 Pvodn autor:        Josef Weinreb
 Verze pro PostgreSQL: Pavel Cvrcek
*/
create or replace function dPolDoklUpdateUcto() returns trigger as $$
begin

  execute createOrUpdateObraty(OLD.Ucetni, OLD.Storno, OLD.DatUcto, OLD.idZklMdUcet, OLD.idZklDalUcet,
      OLD.idMeny, OLD.idStred, -OLD.sumZkl, -OLD.sumZklMen);

  execute createOrUpdateObraty(OLD.Ucetni, OLD.Storno, OLD.DatUcto, OLD.idDphMdUcet, OLD.idDphDalUcet,
      OLD.idMeny, OLD.idStred, -OLD.sumDph, -OLD.sumDphMen);

  execute createOrUpdateObraty(NEW.Ucetni, NEW.Storno, NEW.DatUcto, NEW.idZklMdUcet, NEW.idZklDalUcet,
      NEW.idMeny, NEW.idStred, NEW.sumZkl, NEW.sumZklMen);

  execute createOrUpdateObraty(NEW.Ucetni, NEW.Storno, NEW.DatUcto, NEW.idDphMdUcet, NEW.idDphDalUcet,
      NEW.idMeny, NEW.idStred, NEW.sumDph, NEW.sumDphMen);

  return NEW;
end;
$$ LANGUAGE plpgsql;


drop trigger if exists dPolDoklUpdateUcto on dpolfak;
drop trigger if exists dPolDoklUpdateUcto on dpolint;
drop trigger if exists dPolDoklUpdateUcto on dpolsklad;

create trigger dPolDoklUpdateUcto before update on dpolfak
for each row execute procedure dPolDoklUpdateUcto();

create trigger dPolDoklUpdateUcto before update on dpolint
for each row execute procedure dPolDoklUpdateUcto();

create trigger dPolDoklUpdateUcto before update on dpolsklad
for each row execute procedure dPolDoklUpdateUcto();