/*
  Provádí kontrolu, zda při mazání dokladu či položky dokladu 
  nezůstávají ve vazební tabulce nějaké vazby. V takovém případě
  trigger selže.

  Autor: Pavel Cvrček
*/

create or replace function dzDoklCheckVazby() returns trigger as $$
declare
  _idDokl integer;
  _notInDVazebTab boolean;  
begin  
  if (OLD.modul in ('FAV', 'FAP', 'PHL', 'ZAV')) then  
    _idDokl:= OLD.idDoklFak;  
  else  
    if (OLD.modul in ('SKL')) then  
      _idDokl:= OLD.idDoklSklad;  
    else  
      if (OLD.modul in ('BAN', 'POK', 'INT')) then  
        _idDokl:= OLD.idDoklInt;  
      else
        if (OLD.modul in ('PPP', 'NAV', 'OBP', 'PPV', 'NAP', 'OBV')) then
          _idDokl := OLD.idDoklObch;
        else  
          raise exception 'dDoklCheckVazby(): Neznámý modul: %', OLD.modul;
        end if;
      end if;
    end if;
  end if;
  
  _notInDVazebTab:= (select dZkontrolujVazebniTab (_idDokl, true, OLD.modul));
  if (_notInDVazebTab = false) then
    raise exception '0004:dDoklCheckVazby(): Ve vazební tabulce zůstávají vazby na doklad.';
  end if;
  
  return OLD;
end;
$$ LANGUAGE plpgsql;

drop trigger if exists dzDoklFakCheckVazby on ddoklfak;
drop trigger if exists dzDoklIntCheckVazby on ddoklint;
drop trigger if exists dzDoklSkladCheckVazby on ddoklsklad;

create trigger dzDoklFakCheckVazby before delete on ddoklfak 
for each row execute procedure dzDoklCheckVazby();

create trigger dzDoklIntCheckVazby before delete on ddoklint 
for each row execute procedure dzDoklCheckVazby();

create trigger dzDoklSkladCheckVazby before delete on ddoklsklad 
for each row execute procedure dzDoklCheckVazby();

CREATE TRIGGER dzdoklobchcheckvazby BEFORE DELETE ON ddoklobch
  FOR EACH ROW EXECUTE PROCEDURE dzdoklcheckvazby();