/**
 * odecte obrat splatkoveho kalendare v tabulce uObraty
 * 
 * @author jdrahos
 */
create or replace function mSplatKalDelete() returns trigger as $$
declare
    mena integer;
begin
  select leasing.idMeny into mena from mleasing leasing where OLD.idleasing = leasing.idleasing;

  execute createOrUpdateObraty(OLD.Ucetni, false, OLD.DatUcto, OLD.idZklMdUcet, OLD.idZklDalUcet,
        mena, OLD.idStred, -OLD.sumZkl, -OLD.sumZklMen);

  execute createOrUpdateObraty(OLD.Ucetni, false, OLD.DatUcto, OLD.idDphMdUcet, OLD.idDphDalUcet,
        mena, OLD.idStred, -OLD.sumDph, -OLD.sumDphMen);

  return OLD;
end;
$$ LANGUAGE plpgsql;

drop trigger if exists mSplatKalDelete on msplatkal;

create trigger mSplatKalDelete before delete on msplatkal
for each row execute procedure mSplatKalDelete();