/* Add column if not exists */
CREATE OR REPLACE FUNCTION add_column_if_not_exists(table_name character varying, column_name character varying, column_def character varying)
  RETURNS void AS
$BODY$  
declare  
  _pocetColumnu integer;
begin
 select count(*) into _pocetColumnu from pg_attribute as a where
  a.attname = column_name and 
  a.attrelid = (
        SELECT c.oid
        FROM pg_catalog.pg_class c
            LEFT JOIN pg_catalog.pg_namespace n ON n.oid = c.relnamespace
        WHERE c.relname ~ ('^('||table_name||')$')
            AND pg_catalog.pg_table_is_visible(c.oid)
    );
 if(_pocetColumnu = 0) then
   execute 'Alter table '||table_name||' add '||column_name||' '||column_def||';';
 end if;
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;