/*
 Funkce zjiuje, zda uveden slo dokladu ji nhodou nen v databzi. Pokud ne, vrac true, pokud ano, pak false.
 
 Vstupn parametry:
 - i_idDokl      - id slo dokladu. Me bt i -1, kdy doklad dosud nen v db.
 - i_Modul       - modul (FAV, FAP apod.)
 - i_TypPohybuK  - typ pohybu (pjem/vdej). Prozatm vdy NULL.
 - i_CisDokl     - vygenerovan slo dokladu

 Mon moduly:
 ==============
 FAP - Faktury pijat
 FAV - Faktury vydan
 FAH - Hotovostn prodej
 BAN - Banka
 POK - Pokladna
 SKL - Sklad
 INT - Intern doklad
 NAP - Nabdka pijat
 NAV - Nabdka vydan
 PPP - Poptvka pijat
 PPV - Poptvka vydan
 OBP - Objednvka pijat
 OBV - Objednvka vydan
 PHL - Pohledvky
 ZAV - Zvazky
 MAJ - Majetek
 LEA - Leasing 

 Verze pro PostgreSQL:     Pavel Cvrek
 Pvodn verze pro Sybase: Josef Weinreb
*/

create or replace function dUniqueCisDokl (in i_idDokl integer, in i_Modul varchar(3), in i_TypPohybuK varchar(50), in i_CisDokl varchar(20))  
returns boolean as $$
declare
  _idDokl integer;
begin
  if (i_Modul in( 'FAV','FAP','PHL','ZAV') ) then
    select idDoklFak into _idDokl from dDoklFak where Kod = i_CisDokl and modul = i_Modul limit 1;
  end if;
  if (i_Modul in( 'SKL') ) then
    select idDoklSklad into _idDokl from dDoklSklad where Kod = i_CisDokl and modul = i_Modul limit 1;
  end if;
  if (i_Modul in( 'BAN','POK','INT')) then
    select idDoklInt into _idDokl from dDoklInt where Kod = i_CisDokl and modul = i_Modul limit 1;
  end if;
  if(i_Modul in( 'NAP','NAV','PPP','PPV','OBP','OBV') ) then
    select idDoklObch into _idDokl from dDoklObch where Kod = i_CisDokl and modul = i_Modul limit 1;
  end if;
  
  if((_idDokl is not null) and (_idDokl <> i_idDokl)) then
    return false;
  else
    return true;
  end if;
end;
$$ LANGUAGE plpgsql;