--------------------------------------------------
-- Bug 46263 - Možnost přidání dalšího typu pracovního poměru Motivační příspěvek
--------------------------------------------------
 create or replace function runupgrade()
   returns void as $$
 declare
   stat character varying(10);
 begin
   select a.uuid into stat from nnastav n 
     left join utyporg u on u.idtyporg = n.idtyporg
     left join astaty a on a.idstatu = u.idstatu
   order by coalesce(n.platioddata, '1900-01-01') desc limit 1;
 
   if (stat = 'CZ_CZ') then
        -- nový typ pracovního poměru
        INSERT INTO ptyppracpom (idtyppracpom, lastupdate, kod, nazev, poznam, popis, show, platiod)
            VALUES (12, '2017-02-08 00:00:00.000', 'Z - MOTIV. PŘÍSPĚVEK', 'Motivační příspěvek', 'Aktuální výše je 5.000 Kč, respektive 10.000 Kč (VŠ). AFB výši aktuálně neřeší.', 'ZP, SP se odvádí jen v případě, kdy se odvádí pojištění na základě jiného prac. poměru', true, '2011-01-01');
    
        -- pomocné složky
    
        INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, popis, show, typslozkyk, skupslozkyk, naosobu, vsdatod, vsdatdo, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vshodinysvatek, vscastnahod, vscastnaden, vsprocmzd, vszaklmzd, vszakljekracen, vscastmzd, vszmenacastmzd, vspocetmes, vscisdoklnem, vsdoplatzdrpoj, vsprumnadennem, vsprumnahodnem, dnyprac, dnykal, dnysvatek, hodiny, castkahod, castkaden, procmzd, zaklmzd, zakljekracen, castmzd, zmenacastmzd, prumnadennem, prumnahodnem, pracovni, ukladatnulove, paskamala, paskavelka, zapoctovylist, uuid)
            VALUES (392, '2017-02-10 00:00:00.000', 'SP-POM.MOT.PŘ.SPOL.', 'Sociální pojištění pro motivační příspěvek (společné pro všechny PP)', 'Pomocná složka pro určení, zda se má v případě motivačního příspěvku počítat SP.', true, 'typSlozky.vypocet', 'skupinaSlozky.socPoj', true, false, false, false, false, false, false, false, false, false, true, true, false, true, false, false, false, false, false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, 0.0, false, 0.0, 0.0, true, false, false, false, false, 'SP-POM.MOT.PR.SPOL.');
        INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, popis, show, typslozkyk, skupslozkyk, naosobu, vsdatod, vsdatdo, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vshodinysvatek, vscastnahod, vscastnaden, vsprocmzd, vszaklmzd, vszakljekracen, vscastmzd, vszmenacastmzd, vspocetmes, vscisdoklnem, vsdoplatzdrpoj, vsprumnadennem, vsprumnahodnem, dnyprac, dnykal, dnysvatek, hodiny, castkahod, castkaden, procmzd, zaklmzd, zakljekracen, castmzd, zmenacastmzd, prumnadennem, prumnahodnem, pracovni, ukladatnulove, paskamala, paskavelka, zapoctovylist, uuid)
            VALUES (393, '2017-02-10 00:00:00.000', 'SP-POM.MOT.PŘ.', 'Sociální pojištění pro motivační příspěvek', 'Pomocná složka pro určení, zda se má v případě motivačního příspěvku počítat SP.', true, 'typSlozky.vypocet', 'skupinaSlozky.socPoj', false, false, false, false, false, false, false, false, false, false, true, true, false, true, false, false, false, false, false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, 0.0, false, 0.0, 0.0, true, false, false, false, false, 'SP-POM.MOT.PR.');
        INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, popis, show, typslozkyk, skupslozkyk, naosobu, vsdatod, vsdatdo, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vshodinysvatek, vscastnahod, vscastnaden, vsprocmzd, vszaklmzd, vszakljekracen, vscastmzd, vszmenacastmzd, vspocetmes, vscisdoklnem, vsdoplatzdrpoj, vsprumnadennem, vsprumnahodnem, dnyprac, dnykal, dnysvatek, hodiny, castkahod, castkaden, procmzd, zaklmzd, zakljekracen, castmzd, zmenacastmzd, prumnadennem, prumnahodnem, pracovni, ukladatnulove, paskamala, paskavelka, zapoctovylist, uuid)
            VALUES (394, '2017-02-10 00:00:00.000', 'ZP-POM.MOT.PŘ.SPOL.', 'Zdravotní pojištění pro motivační příspěvek (společné pro všechny PP)', 'Pomocná složka pro určení, zda se má v případě motivačního příspěvku počítat ZP.', true, 'typSlozky.vypocet', 'skupinaSlozky.zdravPoj', true, false, false, false, false, false, false, false, false, false, false, true, false, false, false, false, false, false, false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, 0.0, false, 0.0, 0.0, true, false, false, false, false, 'ZP-POM.MOT.PR.SPOL.');
        INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, popis, show, typslozkyk, skupslozkyk, naosobu, vsdatod, vsdatdo, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vshodinysvatek, vscastnahod, vscastnaden, vsprocmzd, vszaklmzd, vszakljekracen, vscastmzd, vszmenacastmzd, vspocetmes, vscisdoklnem, vsdoplatzdrpoj, vsprumnadennem, vsprumnahodnem, dnyprac, dnykal, dnysvatek, hodiny, castkahod, castkaden, procmzd, zaklmzd, zakljekracen, castmzd, zmenacastmzd, prumnadennem, prumnahodnem, pracovni, ukladatnulove, paskamala, paskavelka, zapoctovylist, uuid)
            VALUES (395, '2017-02-10 00:00:00.000', 'ZP-POM.MOT.PŘ.', 'Zdravotní pojištění pro motivační příspěvek', 'Pomocná složka pro určení, zda se má v případě motivačního příspěvku počítat ZP.', true, 'typSlozky.vypocet', 'skupinaSlozky.zdravPoj', false, false, false, false, false, false, false, false, false, false, true, true, false, true, false, false, false, false, false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, 0.0, false, 0.0, 0.0, true, false, false, false, false, 'ZP-POM.MOT.PR.');
        
        -- úprava kalkulačky - úprava výpočtu
        UPDATE pmzdcalc SET cisrad = 305 WHERE idmzdcalc = 8450;
        UPDATE pmzdcalc SET cisrad = 306 WHERE idmzdcalc = 8451;
        UPDATE pmzdcalc SET cisrad = 307 WHERE idmzdcalc = 8452;
        UPDATE pmzdcalc SET cisrad = 308 WHERE idmzdcalc = 8453;
        UPDATE pmzdcalc SET cisrad = 309 WHERE idmzdcalc = 8454;
        UPDATE pmzdcalc SET cisrad = 310 WHERE idmzdcalc = 8455;
        UPDATE pmzdcalc SET cisrad = 311 WHERE idmzdcalc = 8456;
        UPDATE pmzdcalc SET cisrad = 312 WHERE idmzdcalc = 8457;
        UPDATE pmzdcalc SET cisrad = 313 WHERE idmzdcalc = 8458;
        UPDATE pmzdcalc SET cisrad = 314 WHERE idmzdcalc = 8459;
        UPDATE pmzdcalc SET cisrad = 315 WHERE idmzdcalc = 8460;
        UPDATE pmzdcalc SET cisrad = 316 WHERE idmzdcalc = 8461;
        UPDATE pmzdcalc SET cisrad = 317 WHERE idmzdcalc = 8462;
        UPDATE pmzdcalc SET cisrad = 318 WHERE idmzdcalc = 8463;
        UPDATE pmzdcalc SET cisrad = 319 WHERE idmzdcalc = 8464;
        UPDATE pmzdcalc SET cisrad = 320 WHERE idmzdcalc = 8465;
        UPDATE pmzdcalc SET cisrad = 321 WHERE idmzdcalc = 8466;
        UPDATE pmzdcalc SET cisrad = 322 WHERE idmzdcalc = 8467;
        UPDATE pmzdcalc SET cisrad = 323 WHERE idmzdcalc = 8468;
        UPDATE pmzdcalc SET cisrad = 324 WHERE idmzdcalc = 8469;
        UPDATE pmzdcalc SET cisrad = 325 WHERE idmzdcalc = 8470;
        UPDATE pmzdcalc SET cisrad = 326 WHERE idmzdcalc = 8471;
        UPDATE pmzdcalc SET cisrad = 327 WHERE idmzdcalc = 8472;
        UPDATE pmzdcalc SET cisrad = 328 WHERE idmzdcalc = 8473;
        UPDATE pmzdcalc SET cisrad = 330 WHERE idmzdcalc = 8474;
        UPDATE pmzdcalc SET cisrad = 336 WHERE idmzdcalc = 8475;
        UPDATE pmzdcalc SET cisrad = 337 WHERE idmzdcalc = 8476;
        UPDATE pmzdcalc SET cisrad = 338 WHERE idmzdcalc = 8477;
        UPDATE pmzdcalc SET cisrad = 339 WHERE idmzdcalc = 8478;
        UPDATE pmzdcalc SET cisrad = 340 WHERE idmzdcalc = 8479;
        UPDATE pmzdcalc SET cisrad = 341 WHERE idmzdcalc = 8480;
        UPDATE pmzdcalc SET cisrad = 342 WHERE idmzdcalc = 8481;
        UPDATE pmzdcalc SET cisrad = 343 WHERE idmzdcalc = 8482;
        UPDATE pmzdcalc SET cisrad = 344 WHERE idmzdcalc = 8483;
        UPDATE pmzdcalc SET cisrad = 345 WHERE idmzdcalc = 8484;
        UPDATE pmzdcalc SET cisrad = 346 WHERE idmzdcalc = 8485;
        UPDATE pmzdcalc SET cisrad = 347 WHERE idmzdcalc = 8486;
        UPDATE pmzdcalc SET cisrad = 348 WHERE idmzdcalc = 8487;
        UPDATE pmzdcalc SET cisrad = 349 WHERE idmzdcalc = 8488;
        UPDATE pmzdcalc SET cisrad = 350 WHERE idmzdcalc = 8489;
        UPDATE pmzdcalc SET cisrad = 351 WHERE idmzdcalc = 8490;
        UPDATE pmzdcalc SET cisrad = 352 WHERE idmzdcalc = 8491;
        UPDATE pmzdcalc SET cisrad = 353 WHERE idmzdcalc = 8492;
        UPDATE pmzdcalc SET cisrad = 354 WHERE idmzdcalc = 8493;
        UPDATE pmzdcalc SET cisrad = 355 WHERE idmzdcalc = 8494;
        UPDATE pmzdcalc SET cisrad = 356 WHERE idmzdcalc = 8495;
        UPDATE pmzdcalc SET cisrad = 357 WHERE idmzdcalc = 8496;
        UPDATE pmzdcalc SET cisrad = 358 WHERE idmzdcalc = 8497;
        UPDATE pmzdcalc SET cisrad = 359 WHERE idmzdcalc = 8498;
        UPDATE pmzdcalc SET cisrad = 360 WHERE idmzdcalc = 8499;
        UPDATE pmzdcalc SET cisrad = 361 WHERE idmzdcalc = 8500;
        UPDATE pmzdcalc SET cisrad = 362 WHERE idmzdcalc = 8501;
        UPDATE pmzdcalc SET cisrad = 363 WHERE idmzdcalc = 8502;
        UPDATE pmzdcalc SET cisrad = 364 WHERE idmzdcalc = 8503;
        UPDATE pmzdcalc SET cisrad = 365 WHERE idmzdcalc = 8504;
        UPDATE pmzdcalc SET cisrad = 366 WHERE idmzdcalc = 8505;
        UPDATE pmzdcalc SET cisrad = 367 WHERE idmzdcalc = 8506;
        UPDATE pmzdcalc SET cisrad = 368 WHERE idmzdcalc = 8507;
        UPDATE pmzdcalc SET cisrad = 369 WHERE idmzdcalc = 8508;
        UPDATE pmzdcalc SET cisrad = 370 WHERE idmzdcalc = 8509;
        UPDATE pmzdcalc SET cisrad = 371 WHERE idmzdcalc = 8510;
        UPDATE pmzdcalc SET cisrad = 372 WHERE idmzdcalc = 8511;
        UPDATE pmzdcalc SET cisrad = 373 WHERE idmzdcalc = 8512;
        UPDATE pmzdcalc SET cisrad = 374 WHERE idmzdcalc = 8513;
        UPDATE pmzdcalc SET cisrad = 375 WHERE idmzdcalc = 8514;
        UPDATE pmzdcalc SET cisrad = 376 WHERE idmzdcalc = 8515;
        UPDATE pmzdcalc SET cisrad = 377 WHERE idmzdcalc = 8516;
        UPDATE pmzdcalc SET cisrad = 378 WHERE idmzdcalc = 8517;
        UPDATE pmzdcalc SET cisrad = 379 WHERE idmzdcalc = 8518;
        UPDATE pmzdcalc SET cisrad = 380 WHERE idmzdcalc = 8519;
        UPDATE pmzdcalc SET cisrad = 381 WHERE idmzdcalc = 8520;
        UPDATE pmzdcalc SET cisrad = 382 WHERE idmzdcalc = 8521;
        UPDATE pmzdcalc SET cisrad = 383 WHERE idmzdcalc = 8522;
        UPDATE pmzdcalc SET cisrad = 384 WHERE idmzdcalc = 8523;
        UPDATE pmzdcalc SET cisrad = 385 WHERE idmzdcalc = 8524;
        UPDATE pmzdcalc SET cisrad = 386 WHERE idmzdcalc = 8525;
        UPDATE pmzdcalc SET cisrad = 387 WHERE idmzdcalc = 8526;
        UPDATE pmzdcalc SET cisrad = 388 WHERE idmzdcalc = 8527;
        UPDATE pmzdcalc SET cisrad = 389 WHERE idmzdcalc = 8528;
        UPDATE pmzdcalc SET cisrad = 390 WHERE idmzdcalc = 8529;
        UPDATE pmzdcalc SET cisrad = 391 WHERE idmzdcalc = 8530;
        UPDATE pmzdcalc SET cisrad = 392 WHERE idmzdcalc = 8531;
        UPDATE pmzdcalc SET cisrad = 393 WHERE idmzdcalc = 8532;
        UPDATE pmzdcalc SET cisrad = 394 WHERE idmzdcalc = 8533;
        UPDATE pmzdcalc SET cisrad = 395 WHERE idmzdcalc = 8534;
        UPDATE pmzdcalc SET cisrad = 396 WHERE idmzdcalc = 8535;
        UPDATE pmzdcalc SET cisrad = 397 WHERE idmzdcalc = 8536;
        UPDATE pmzdcalc SET cisrad = 398 WHERE idmzdcalc = 8537;
        UPDATE pmzdcalc SET cisrad = 399 WHERE idmzdcalc = 8538;
        UPDATE pmzdcalc SET cisrad = 400 WHERE idmzdcalc = 8539;
        UPDATE pmzdcalc SET cisrad = 401 WHERE idmzdcalc = 8540;
        UPDATE pmzdcalc SET cisrad = 402 WHERE idmzdcalc = 8541;
        UPDATE pmzdcalc SET cisrad = 403 WHERE idmzdcalc = 8542;
        UPDATE pmzdcalc SET cisrad = 404 WHERE idmzdcalc = 8543;
        UPDATE pmzdcalc SET cisrad = 405 WHERE idmzdcalc = 8544;
        UPDATE pmzdcalc SET cisrad = 406 WHERE idmzdcalc = 8545;
        UPDATE pmzdcalc SET cisrad = 407 WHERE idmzdcalc = 8546;
        UPDATE pmzdcalc SET cisrad = 408 WHERE idmzdcalc = 8547;
        UPDATE pmzdcalc SET cisrad = 409 WHERE idmzdcalc = 8548;
        UPDATE pmzdcalc SET cisrad = 410 WHERE idmzdcalc = 8549;
        UPDATE pmzdcalc SET cisrad = 411 WHERE idmzdcalc = 8550;
        UPDATE pmzdcalc SET cisrad = 412 WHERE idmzdcalc = 8551;
        UPDATE pmzdcalc SET cisrad = 413 WHERE idmzdcalc = 8552;
        UPDATE pmzdcalc SET cisrad = 414 WHERE idmzdcalc = 8553;
        UPDATE pmzdcalc SET cisrad = 415 WHERE idmzdcalc = 8554;
        UPDATE pmzdcalc SET cisrad = 416 WHERE idmzdcalc = 8555;
        UPDATE pmzdcalc SET cisrad = 417 WHERE idmzdcalc = 8556;
        UPDATE pmzdcalc SET cisrad = 418 WHERE idmzdcalc = 8557;
        UPDATE pmzdcalc SET cisrad = 419 WHERE idmzdcalc = 8558;
        UPDATE pmzdcalc SET cisrad = 420 WHERE idmzdcalc = 8559;
        UPDATE pmzdcalc SET cisrad = 421 WHERE idmzdcalc = 8560;
        UPDATE pmzdcalc SET cisrad = 422 WHERE idmzdcalc = 8561;
        UPDATE pmzdcalc SET cisrad = 423 WHERE idmzdcalc = 8562;
        UPDATE pmzdcalc SET cisrad = 424 WHERE idmzdcalc = 8563;
        UPDATE pmzdcalc SET cisrad = 425 WHERE idmzdcalc = 8564;
        UPDATE pmzdcalc SET cisrad = 426 WHERE idmzdcalc = 8565;
        UPDATE pmzdcalc SET cisrad = 427 WHERE idmzdcalc = 8566;
        UPDATE pmzdcalc SET cisrad = 428 WHERE idmzdcalc = 8567;
        UPDATE pmzdcalc SET cisrad = 429 WHERE idmzdcalc = 8568;
        UPDATE pmzdcalc SET cisrad = 430 WHERE idmzdcalc = 8569;
        UPDATE pmzdcalc SET cisrad = 431 WHERE idmzdcalc = 8570;
        UPDATE pmzdcalc SET cisrad = 432 WHERE idmzdcalc = 8571;
        UPDATE pmzdcalc SET cisrad = 433 WHERE idmzdcalc = 8572;
        UPDATE pmzdcalc SET cisrad = 434 WHERE idmzdcalc = 8573;
        UPDATE pmzdcalc SET cisrad = 435 WHERE idmzdcalc = 8574;
        UPDATE pmzdcalc SET cisrad = 436 WHERE idmzdcalc = 8575;
        UPDATE pmzdcalc SET cisrad = 437 WHERE idmzdcalc = 8576;
        UPDATE pmzdcalc SET cisrad = 438 WHERE idmzdcalc = 8577;
        UPDATE pmzdcalc SET cisrad = 439 WHERE idmzdcalc = 8578;
        UPDATE pmzdcalc SET cisrad = 440 WHERE idmzdcalc = 8579;
        UPDATE pmzdcalc SET cisrad = 441 WHERE idmzdcalc = 8580;
        UPDATE pmzdcalc SET cisrad = 442 WHERE idmzdcalc = 8581;
        UPDATE pmzdcalc SET cisrad = 443 WHERE idmzdcalc = 8582;
        UPDATE pmzdcalc SET cisrad = 444 WHERE idmzdcalc = 8583;
        UPDATE pmzdcalc SET cisrad = 445 WHERE idmzdcalc = 8584;
        UPDATE pmzdcalc SET cisrad = 446 WHERE idmzdcalc = 8585;
        UPDATE pmzdcalc SET cisrad = 447 WHERE idmzdcalc = 8586;
        UPDATE pmzdcalc SET cisrad = 448 WHERE idmzdcalc = 8587;
        UPDATE pmzdcalc SET cisrad = 449 WHERE idmzdcalc = 8588;
        UPDATE pmzdcalc SET cisrad = 450 WHERE idmzdcalc = 8589;
        UPDATE pmzdcalc SET cisrad = 451 WHERE idmzdcalc = 8590;
        UPDATE pmzdcalc SET cisrad = 452 WHERE idmzdcalc = 8591;
        UPDATE pmzdcalc SET cisrad = 453 WHERE idmzdcalc = 8592;
        UPDATE pmzdcalc SET cisrad = 454 WHERE idmzdcalc = 8593;
        UPDATE pmzdcalc SET cisrad = 455 WHERE idmzdcalc = 8594;
        UPDATE pmzdcalc SET cisrad = 456 WHERE idmzdcalc = 8595;
        UPDATE pmzdcalc SET cisrad = 457 WHERE idmzdcalc = 8596;
        UPDATE pmzdcalc SET cisrad = 458 WHERE idmzdcalc = 8597;
        UPDATE pmzdcalc SET cisrad = 459 WHERE idmzdcalc = 8598;
        UPDATE pmzdcalc SET cisrad = 460 WHERE idmzdcalc = 8599;
        UPDATE pmzdcalc SET cisrad = 461 WHERE idmzdcalc = 8600;
        UPDATE pmzdcalc SET cisrad = 462 WHERE idmzdcalc = 8601;
        UPDATE pmzdcalc SET cisrad = 463 WHERE idmzdcalc = 8602;
        UPDATE pmzdcalc SET cisrad = 464 WHERE idmzdcalc = 8603;
        UPDATE pmzdcalc SET cisrad = 465 WHERE idmzdcalc = 8604;
        UPDATE pmzdcalc SET cisrad = 466 WHERE idmzdcalc = 8605;
        UPDATE pmzdcalc SET cisrad = 467 WHERE idmzdcalc = 8606;
        UPDATE pmzdcalc SET cisrad = 468 WHERE idmzdcalc = 8607;
        UPDATE pmzdcalc SET cisrad = 469 WHERE idmzdcalc = 8608;
        UPDATE pmzdcalc SET cisrad = 470 WHERE idmzdcalc = 8609;
        UPDATE pmzdcalc SET cisrad = 471 WHERE idmzdcalc = 8610;
        UPDATE pmzdcalc SET cisrad = 472 WHERE idmzdcalc = 8611;
        UPDATE pmzdcalc SET cisrad = 473 WHERE idmzdcalc = 8612;
        UPDATE pmzdcalc SET cisrad = 474 WHERE idmzdcalc = 8613;
        UPDATE pmzdcalc SET cisrad = 475 WHERE idmzdcalc = 8614;
        UPDATE pmzdcalc SET cisrad = 476 WHERE idmzdcalc = 8615;
        UPDATE pmzdcalc SET cisrad = 477 WHERE idmzdcalc = 8616;
        UPDATE pmzdcalc SET cisrad = 478 WHERE idmzdcalc = 8617;
        UPDATE pmzdcalc SET cisrad = 479 WHERE idmzdcalc = 8618;
        UPDATE pmzdcalc SET cisrad = 480 WHERE idmzdcalc = 8619;
        UPDATE pmzdcalc SET cisrad = 481 WHERE idmzdcalc = 8620;
        UPDATE pmzdcalc SET cisrad = 482 WHERE idmzdcalc = 8621;
        UPDATE pmzdcalc SET cisrad = 483 WHERE idmzdcalc = 8622;
        UPDATE pmzdcalc SET cisrad = 484 WHERE idmzdcalc = 8623;
        UPDATE pmzdcalc SET cisrad = 485 WHERE idmzdcalc = 8624;
        UPDATE pmzdcalc SET cisrad = 486 WHERE idmzdcalc = 8625;
        UPDATE pmzdcalc SET cisrad = 487 WHERE idmzdcalc = 8626;
        UPDATE pmzdcalc SET cisrad = 488 WHERE idmzdcalc = 8627;
        UPDATE pmzdcalc SET cisrad = 489 WHERE idmzdcalc = 8628;
        UPDATE pmzdcalc SET cisrad = 490 WHERE idmzdcalc = 8629;
        UPDATE pmzdcalc SET cisrad = 491 WHERE idmzdcalc = 8630;
        UPDATE pmzdcalc SET cisrad = 492 WHERE idmzdcalc = 8631;
        UPDATE pmzdcalc SET cisrad = 493 WHERE idmzdcalc = 8632;
        UPDATE pmzdcalc SET cisrad = 494 WHERE idmzdcalc = 8633;
        UPDATE pmzdcalc SET cisrad = 495 WHERE idmzdcalc = 8634;
        UPDATE pmzdcalc SET cisrad = 496 WHERE idmzdcalc = 8635;
        UPDATE pmzdcalc SET cisrad = 497 WHERE idmzdcalc = 8636;
        UPDATE pmzdcalc SET cisrad = 498 WHERE idmzdcalc = 8637;
        UPDATE pmzdcalc SET cisrad = 499 WHERE idmzdcalc = 8638;
        UPDATE pmzdcalc SET cisrad = 500 WHERE idmzdcalc = 8639;
        UPDATE pmzdcalc SET cisrad = 501 WHERE idmzdcalc = 8640;
        UPDATE pmzdcalc SET cisrad = 502 WHERE idmzdcalc = 8641;
        UPDATE pmzdcalc SET cisrad = 503 WHERE idmzdcalc = 8642;
        UPDATE pmzdcalc SET cisrad = 504 WHERE idmzdcalc = 8643;
        UPDATE pmzdcalc SET cisrad = 505 WHERE idmzdcalc = 8644;
        UPDATE pmzdcalc SET cisrad = 506 WHERE idmzdcalc = 8645;
        UPDATE pmzdcalc SET cisrad = 507 WHERE idmzdcalc = 8646;
        UPDATE pmzdcalc SET cisrad = 508 WHERE idmzdcalc = 8647;
        UPDATE pmzdcalc SET cisrad = 509 WHERE idmzdcalc = 8648;
        UPDATE pmzdcalc SET cisrad = 510 WHERE idmzdcalc = 8649;
        UPDATE pmzdcalc SET cisrad = 511 WHERE idmzdcalc = 8650;
        UPDATE pmzdcalc SET cisrad = 512 WHERE idmzdcalc = 8651;
        UPDATE pmzdcalc SET cisrad = 513 WHERE idmzdcalc = 8652;
        UPDATE pmzdcalc SET cisrad = 514 WHERE idmzdcalc = 8653;
        UPDATE pmzdcalc SET cisrad = 515 WHERE idmzdcalc = 8654;
        UPDATE pmzdcalc SET cisrad = 516 WHERE idmzdcalc = 8655;
        UPDATE pmzdcalc SET cisrad = 517 WHERE idmzdcalc = 8656;
        UPDATE pmzdcalc SET cisrad = 518 WHERE idmzdcalc = 8657;
        UPDATE pmzdcalc SET cisrad = 519 WHERE idmzdcalc = 8658;
        UPDATE pmzdcalc SET cisrad = 520 WHERE idmzdcalc = 8659;
        UPDATE pmzdcalc SET cisrad = 521 WHERE idmzdcalc = 8660;
        UPDATE pmzdcalc SET cisrad = 522 WHERE idmzdcalc = 8661;
        UPDATE pmzdcalc SET cisrad = 523 WHERE idmzdcalc = 8662;
        UPDATE pmzdcalc SET cisrad = 524 WHERE idmzdcalc = 8663;
        UPDATE pmzdcalc SET cisrad = 525 WHERE idmzdcalc = 8664;
        UPDATE pmzdcalc SET cisrad = 526 WHERE idmzdcalc = 8665;
        UPDATE pmzdcalc SET cisrad = 527 WHERE idmzdcalc = 8666;
        UPDATE pmzdcalc SET cisrad = 528 WHERE idmzdcalc = 8667;
        UPDATE pmzdcalc SET cisrad = 529 WHERE idmzdcalc = 8668;
        UPDATE pmzdcalc SET cisrad = 530 WHERE idmzdcalc = 8669;
        UPDATE pmzdcalc SET cisrad = 531 WHERE idmzdcalc = 8670;
        UPDATE pmzdcalc SET cisrad = 532 WHERE idmzdcalc = 8671;
        UPDATE pmzdcalc SET cisrad = 533 WHERE idmzdcalc = 8672;
        UPDATE pmzdcalc SET cisrad = 534 WHERE idmzdcalc = 8673;
        UPDATE pmzdcalc SET cisrad = 535 WHERE idmzdcalc = 8674;
        UPDATE pmzdcalc SET cisrad = 536 WHERE idmzdcalc = 8675;
        UPDATE pmzdcalc SET cisrad = 537 WHERE idmzdcalc = 8676;
        UPDATE pmzdcalc SET cisrad = 538 WHERE idmzdcalc = 8677;
        UPDATE pmzdcalc SET cisrad = 539 WHERE idmzdcalc = 8678;
        UPDATE pmzdcalc SET cisrad = 540 WHERE idmzdcalc = 8679;
        UPDATE pmzdcalc SET cisrad = 541 WHERE idmzdcalc = 8680;
        UPDATE pmzdcalc SET cisrad = 542 WHERE idmzdcalc = 8681;
        UPDATE pmzdcalc SET cisrad = 543 WHERE idmzdcalc = 8682;
        UPDATE pmzdcalc SET cisrad = 544 WHERE idmzdcalc = 8683;
        UPDATE pmzdcalc SET cisrad = 545 WHERE idmzdcalc = 8684;
        UPDATE pmzdcalc SET cisrad = 546 WHERE idmzdcalc = 8685;
        UPDATE pmzdcalc SET cisrad = 547 WHERE idmzdcalc = 8686;
        UPDATE pmzdcalc SET cisrad = 548 WHERE idmzdcalc = 8687;
        UPDATE pmzdcalc SET cisrad = 549 WHERE idmzdcalc = 8688;
        UPDATE pmzdcalc SET cisrad = 550 WHERE idmzdcalc = 8689;
        UPDATE pmzdcalc SET cisrad = 551 WHERE idmzdcalc = 8690;
        UPDATE pmzdcalc SET cisrad = 552 WHERE idmzdcalc = 8691;
        UPDATE pmzdcalc SET cisrad = 553 WHERE idmzdcalc = 8692;
        UPDATE pmzdcalc SET cisrad = 554 WHERE idmzdcalc = 8693;
        UPDATE pmzdcalc SET cisrad = 555 WHERE idmzdcalc = 8694;
        UPDATE pmzdcalc SET cisrad = 556 WHERE idmzdcalc = 8695;
        UPDATE pmzdcalc SET cisrad = 557 WHERE idmzdcalc = 8696;
        UPDATE pmzdcalc SET cisrad = 558 WHERE idmzdcalc = 8697;
        UPDATE pmzdcalc SET cisrad = 559 WHERE idmzdcalc = 8698;
        UPDATE pmzdcalc SET cisrad = 560 WHERE idmzdcalc = 8699;
        UPDATE pmzdcalc SET cisrad = 561 WHERE idmzdcalc = 8700;
        UPDATE pmzdcalc SET cisrad = 562 WHERE idmzdcalc = 8701;
        UPDATE pmzdcalc SET cisrad = 563 WHERE idmzdcalc = 8702;
        UPDATE pmzdcalc SET cisrad = 564 WHERE idmzdcalc = 8703;
        UPDATE pmzdcalc SET cisrad = 565 WHERE idmzdcalc = 8704;
        UPDATE pmzdcalc SET cisrad = 566 WHERE idmzdcalc = 8705;
        UPDATE pmzdcalc SET cisrad = 567 WHERE idmzdcalc = 8706;
        UPDATE pmzdcalc SET cisrad = 568 WHERE idmzdcalc = 8707;
        UPDATE pmzdcalc SET cisrad = 569 WHERE idmzdcalc = 8708;
        UPDATE pmzdcalc SET cisrad = 570 WHERE idmzdcalc = 8709;
        UPDATE pmzdcalc SET cisrad = 571 WHERE idmzdcalc = 8710;
        UPDATE pmzdcalc SET cisrad = 572 WHERE idmzdcalc = 8711;
        UPDATE pmzdcalc SET cisrad = 573 WHERE idmzdcalc = 8712;
        UPDATE pmzdcalc SET cisrad = 574 WHERE idmzdcalc = 8713;
        UPDATE pmzdcalc SET cisrad = 575 WHERE idmzdcalc = 8714;
        UPDATE pmzdcalc SET cisrad = 576 WHERE idmzdcalc = 8715;
        UPDATE pmzdcalc SET cisrad = 577 WHERE idmzdcalc = 8716;
        UPDATE pmzdcalc SET cisrad = 578 WHERE idmzdcalc = 8717;
        UPDATE pmzdcalc SET cisrad = 579 WHERE idmzdcalc = 8718;
        UPDATE pmzdcalc SET cisrad = 580 WHERE idmzdcalc = 8719;
        UPDATE pmzdcalc SET cisrad = 581 WHERE idmzdcalc = 8720;
        UPDATE pmzdcalc SET cisrad = 582 WHERE idmzdcalc = 8721;
        UPDATE pmzdcalc SET cisrad = 583 WHERE idmzdcalc = 8722;
        UPDATE pmzdcalc SET cisrad = 584 WHERE idmzdcalc = 8723;
        UPDATE pmzdcalc SET cisrad = 585 WHERE idmzdcalc = 8724;
        UPDATE pmzdcalc SET cisrad = 586 WHERE idmzdcalc = 8725;
        UPDATE pmzdcalc SET cisrad = 587 WHERE idmzdcalc = 8726;
        UPDATE pmzdcalc SET cisrad = 588 WHERE idmzdcalc = 8727;
        UPDATE pmzdcalc SET cisrad = 589 WHERE idmzdcalc = 8728;
        UPDATE pmzdcalc SET cisrad = 590 WHERE idmzdcalc = 8729;
        UPDATE pmzdcalc SET cisrad = 591 WHERE idmzdcalc = 8730;
        UPDATE pmzdcalc SET cisrad = 592 WHERE idmzdcalc = 8731;
        UPDATE pmzdcalc SET cisrad = 593 WHERE idmzdcalc = 8732;
        UPDATE pmzdcalc SET cisrad = 594 WHERE idmzdcalc = 8733;
        UPDATE pmzdcalc SET cisrad = 595 WHERE idmzdcalc = 8734;
        UPDATE pmzdcalc SET cisrad = 596 WHERE idmzdcalc = 8735;
        UPDATE pmzdcalc SET cisrad = 597 WHERE idmzdcalc = 8736;
        UPDATE pmzdcalc SET cisrad = 598 WHERE idmzdcalc = 8737;
        UPDATE pmzdcalc SET cisrad = 599 WHERE idmzdcalc = 8738;
        UPDATE pmzdcalc SET cisrad = 600 WHERE idmzdcalc = 8739;
        UPDATE pmzdcalc SET cisrad = 601 WHERE idmzdcalc = 8740;
        UPDATE pmzdcalc SET cisrad = 602 WHERE idmzdcalc = 8741;
        UPDATE pmzdcalc SET cisrad = 603 WHERE idmzdcalc = 8742;
        UPDATE pmzdcalc SET cisrad = 604 WHERE idmzdcalc = 8743;
        UPDATE pmzdcalc SET cisrad = 605 WHERE idmzdcalc = 8744;
        UPDATE pmzdcalc SET cisrad = 606 WHERE idmzdcalc = 8745;
        UPDATE pmzdcalc SET cisrad = 607 WHERE idmzdcalc = 8746;
        UPDATE pmzdcalc SET cisrad = 608 WHERE idmzdcalc = 8747;
        UPDATE pmzdcalc SET cisrad = 609 WHERE idmzdcalc = 8748;
        UPDATE pmzdcalc SET cisrad = 610 WHERE idmzdcalc = 8749;
        UPDATE pmzdcalc SET cisrad = 611 WHERE idmzdcalc = 8750;
        UPDATE pmzdcalc SET cisrad = 612 WHERE idmzdcalc = 8751;
        UPDATE pmzdcalc SET cisrad = 613 WHERE idmzdcalc = 8752;
        UPDATE pmzdcalc SET cisrad = 614 WHERE idmzdcalc = 8753;
        UPDATE pmzdcalc SET cisrad = 615 WHERE idmzdcalc = 8754;
        UPDATE pmzdcalc SET cisrad = 616 WHERE idmzdcalc = 8755;
        UPDATE pmzdcalc SET cisrad = 617 WHERE idmzdcalc = 8756;
        UPDATE pmzdcalc SET cisrad = 618 WHERE idmzdcalc = 8757;
        UPDATE pmzdcalc SET cisrad = 619 WHERE idmzdcalc = 8758;
        UPDATE pmzdcalc SET cisrad = 620 WHERE idmzdcalc = 8759;
        UPDATE pmzdcalc SET cisrad = 621 WHERE idmzdcalc = 8760;
        UPDATE pmzdcalc SET cisrad = 622 WHERE idmzdcalc = 8761;
        UPDATE pmzdcalc SET cisrad = 623 WHERE idmzdcalc = 8762;
        UPDATE pmzdcalc SET cisrad = 624 WHERE idmzdcalc = 8763;
        UPDATE pmzdcalc SET cisrad = 625 WHERE idmzdcalc = 8764;
        UPDATE pmzdcalc SET cisrad = 626 WHERE idmzdcalc = 8765;
        UPDATE pmzdcalc SET cisrad = 627 WHERE idmzdcalc = 8766;
        UPDATE pmzdcalc SET cisrad = 628 WHERE idmzdcalc = 8767;
        UPDATE pmzdcalc SET cisrad = 629 WHERE idmzdcalc = 8768;
        UPDATE pmzdcalc SET cisrad = 630 WHERE idmzdcalc = 8769;
        UPDATE pmzdcalc SET cisrad = 631 WHERE idmzdcalc = 8770;
        UPDATE pmzdcalc SET cisrad = 632 WHERE idmzdcalc = 8771;
        UPDATE pmzdcalc SET cisrad = 633 WHERE idmzdcalc = 8772;
        UPDATE pmzdcalc SET cisrad = 634 WHERE idmzdcalc = 8773;
        UPDATE pmzdcalc SET cisrad = 635 WHERE idmzdcalc = 8774;
        UPDATE pmzdcalc SET cisrad = 636 WHERE idmzdcalc = 8775;
        UPDATE pmzdcalc SET cisrad = 637 WHERE idmzdcalc = 8776;
        UPDATE pmzdcalc SET cisrad = 638 WHERE idmzdcalc = 8777;
        UPDATE pmzdcalc SET cisrad = 639 WHERE idmzdcalc = 8778;
        UPDATE pmzdcalc SET cisrad = 640 WHERE idmzdcalc = 8779;
        UPDATE pmzdcalc SET cisrad = 641 WHERE idmzdcalc = 8780;
        UPDATE pmzdcalc SET cisrad = 642 WHERE idmzdcalc = 8781;
        UPDATE pmzdcalc SET cisrad = 643 WHERE idmzdcalc = 8782;
        UPDATE pmzdcalc SET cisrad = 644 WHERE idmzdcalc = 8783;
        UPDATE pmzdcalc SET cisrad = 645 WHERE idmzdcalc = 8784;
        UPDATE pmzdcalc SET cisrad = 646 WHERE idmzdcalc = 8785;
        UPDATE pmzdcalc SET cisrad = 647 WHERE idmzdcalc = 8786;
        UPDATE pmzdcalc SET cisrad = 648 WHERE idmzdcalc = 8787;
        UPDATE pmzdcalc SET cisrad = 649 WHERE idmzdcalc = 8788;
        UPDATE pmzdcalc SET cisrad = 650 WHERE idmzdcalc = 8789;
        UPDATE pmzdcalc SET cisrad = 651 WHERE idmzdcalc = 8790;
        UPDATE pmzdcalc SET cisrad = 652 WHERE idmzdcalc = 8791;
        UPDATE pmzdcalc SET cisrad = 653 WHERE idmzdcalc = 8792;
        UPDATE pmzdcalc SET cisrad = 654 WHERE idmzdcalc = 8793;
        UPDATE pmzdcalc SET cisrad = 655 WHERE idmzdcalc = 8794;
        UPDATE pmzdcalc SET cisrad = 656 WHERE idmzdcalc = 8795;
        UPDATE pmzdcalc SET cisrad = 657 WHERE idmzdcalc = 8796;
        UPDATE pmzdcalc SET cisrad = 658 WHERE idmzdcalc = 8797;
        UPDATE pmzdcalc SET cisrad = 659 WHERE idmzdcalc = 8798;
        UPDATE pmzdcalc SET cisrad = 660 WHERE idmzdcalc = 8799;
        UPDATE pmzdcalc SET cisrad = 661 WHERE idmzdcalc = 8800;
        UPDATE pmzdcalc SET cisrad = 662 WHERE idmzdcalc = 8801;
        UPDATE pmzdcalc SET cisrad = 663 WHERE idmzdcalc = 8802;
        UPDATE pmzdcalc SET cisrad = 664 WHERE idmzdcalc = 8803;
        UPDATE pmzdcalc SET cisrad = 665 WHERE idmzdcalc = 8804;
        UPDATE pmzdcalc SET cisrad = 666 WHERE idmzdcalc = 8805;
        UPDATE pmzdcalc SET cisrad = 667 WHERE idmzdcalc = 8806;
        UPDATE pmzdcalc SET cisrad = 668 WHERE idmzdcalc = 8807;
        UPDATE pmzdcalc SET cisrad = 669 WHERE idmzdcalc = 8808;
        UPDATE pmzdcalc SET cisrad = 670 WHERE idmzdcalc = 8809;
        UPDATE pmzdcalc SET cisrad = 671 WHERE idmzdcalc = 8810;
        UPDATE pmzdcalc SET cisrad = 672 WHERE idmzdcalc = 8811;
        UPDATE pmzdcalc SET cisrad = 673 WHERE idmzdcalc = 8812;
        UPDATE pmzdcalc SET cisrad = 674 WHERE idmzdcalc = 8813;
        UPDATE pmzdcalc SET cisrad = 675 WHERE idmzdcalc = 8814;
        UPDATE pmzdcalc SET cisrad = 676 WHERE idmzdcalc = 8815;
        UPDATE pmzdcalc SET cisrad = 677 WHERE idmzdcalc = 8816;
        UPDATE pmzdcalc SET cisrad = 678 WHERE idmzdcalc = 8817;
        UPDATE pmzdcalc SET cisrad = 679 WHERE idmzdcalc = 8818;
        UPDATE pmzdcalc SET cisrad = 680 WHERE idmzdcalc = 8819;
        UPDATE pmzdcalc SET cisrad = 681 WHERE idmzdcalc = 8820;
        UPDATE pmzdcalc SET cisrad = 682 WHERE idmzdcalc = 8821;
        UPDATE pmzdcalc SET cisrad = 683 WHERE idmzdcalc = 8822;
        UPDATE pmzdcalc SET cisrad = 684 WHERE idmzdcalc = 8823;
        UPDATE pmzdcalc SET cisrad = 685 WHERE idmzdcalc = 8824;
        UPDATE pmzdcalc SET cisrad = 686 WHERE idmzdcalc = 8825;
        UPDATE pmzdcalc SET cisrad = 687 WHERE idmzdcalc = 8826;
        UPDATE pmzdcalc SET cisrad = 688 WHERE idmzdcalc = 8827;
        UPDATE pmzdcalc SET cisrad = 689 WHERE idmzdcalc = 8828;
        UPDATE pmzdcalc SET cisrad = 690 WHERE idmzdcalc = 8829;
        UPDATE pmzdcalc SET cisrad = 691 WHERE idmzdcalc = 8830;
        UPDATE pmzdcalc SET cisrad = 692 WHERE idmzdcalc = 8831;
        UPDATE pmzdcalc SET cisrad = 693 WHERE idmzdcalc = 8832;
        UPDATE pmzdcalc SET cisrad = 694 WHERE idmzdcalc = 8833;
        UPDATE pmzdcalc SET cisrad = 695 WHERE idmzdcalc = 8834;
        UPDATE pmzdcalc SET cisrad = 696 WHERE idmzdcalc = 8835;
        UPDATE pmzdcalc SET cisrad = 697 WHERE idmzdcalc = 8836;
        UPDATE pmzdcalc SET cisrad = 698 WHERE idmzdcalc = 8837;
        UPDATE pmzdcalc SET cisrad = 699 WHERE idmzdcalc = 8838;
        UPDATE pmzdcalc SET cisrad = 700 WHERE idmzdcalc = 8839;
        UPDATE pmzdcalc SET cisrad = 701 WHERE idmzdcalc = 8840;
        UPDATE pmzdcalc SET cisrad = 702 WHERE idmzdcalc = 8841;
        UPDATE pmzdcalc SET cisrad = 703 WHERE idmzdcalc = 8842;
        UPDATE pmzdcalc SET cisrad = 704 WHERE idmzdcalc = 8843;
        UPDATE pmzdcalc SET cisrad = 705 WHERE idmzdcalc = 8844;
        UPDATE pmzdcalc SET cisrad = 706 WHERE idmzdcalc = 8845;
        UPDATE pmzdcalc SET cisrad = 707 WHERE idmzdcalc = 8846;
        UPDATE pmzdcalc SET cisrad = 708 WHERE idmzdcalc = 8847;
        UPDATE pmzdcalc SET cisrad = 709 WHERE idmzdcalc = 8848;
        UPDATE pmzdcalc SET cisrad = 710 WHERE idmzdcalc = 8849;
        UPDATE pmzdcalc SET cisrad = 711 WHERE idmzdcalc = 8850;
        UPDATE pmzdcalc SET cisrad = 712 WHERE idmzdcalc = 8851;
        UPDATE pmzdcalc SET cisrad = 713 WHERE idmzdcalc = 8852;
        UPDATE pmzdcalc SET cisrad = 714 WHERE idmzdcalc = 8853;
        UPDATE pmzdcalc SET cisrad = 715 WHERE idmzdcalc = 8854;
        UPDATE pmzdcalc SET cisrad = 716 WHERE idmzdcalc = 8855;
        UPDATE pmzdcalc SET cisrad = 717 WHERE idmzdcalc = 8856;
        UPDATE pmzdcalc SET cisrad = 718 WHERE idmzdcalc = 8857;
        UPDATE pmzdcalc SET cisrad = 719 WHERE idmzdcalc = 8858;
        UPDATE pmzdcalc SET cisrad = 720 WHERE idmzdcalc = 8859;
        UPDATE pmzdcalc SET cisrad = 721 WHERE idmzdcalc = 8860;
        UPDATE pmzdcalc SET cisrad = 722 WHERE idmzdcalc = 8861;
        UPDATE pmzdcalc SET cisrad = 723 WHERE idmzdcalc = 8862;
        UPDATE pmzdcalc SET cisrad = 724 WHERE idmzdcalc = 8863;
        UPDATE pmzdcalc SET cisrad = 725 WHERE idmzdcalc = 8864;
        UPDATE pmzdcalc SET cisrad = 726 WHERE idmzdcalc = 8865;
        UPDATE pmzdcalc SET cisrad = 727 WHERE idmzdcalc = 8866;
        UPDATE pmzdcalc SET cisrad = 728 WHERE idmzdcalc = 8867;
        UPDATE pmzdcalc SET cisrad = 729 WHERE idmzdcalc = 8868;
        UPDATE pmzdcalc SET cisrad = 730 WHERE idmzdcalc = 8869;
        UPDATE pmzdcalc SET cisrad = 731 WHERE idmzdcalc = 8870;
        UPDATE pmzdcalc SET cisrad = 732 WHERE idmzdcalc = 8871;
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, vstupnapricpomery, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8872, '2017-02-09 00:00:00.000', 'SP-POM.MOT.PŘ.SPOL.', 'Zákl. mzdy pro SP pro mot. př. (spol.)', true, 299, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, false, 10, 162, 392);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, vstupnapricpomery, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8873, '2017-02-09 00:00:00.000', 'SP-POM.MOT.PŘ.', 'Zákl. mzdy pro SP pro mot. př. (akt.)', true, 300, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, false, 10, 162, 393);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, vstupnapricpomery, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8874, '2017-02-09 00:00:00.000', 'SP-POM.MOT.PŘ.', 'SP pro mot. př. (ostatní PP)', true, 301, 1.0, -1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, true, 10, 392, 393);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, vstupnapricpomery, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8875, '2017-02-09 00:00:00.000', 'SP-POM.MOT.PŘ.', 'SP pro mot. př.', e'Má se počítat SP pro motivační příspěvek?\n - zjistíme to porovnáním základu SP pro ostatní PP - pokud je různý od 0 (zde menší, protož dříve odečteno větší od menšího), tak si uložíme k = 2 a o více se postarají parametry typu prac. poměru.', true, 302, 0.0, 2.0, 1.0, 'zaklMzd', 'castkaDen', 0.0, 0.0, 'mzdCalcOper.mensiRovno', false, 0, false, false, 10, 393, 393);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, vstupnapricpomery, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8876, '2017-02-09 00:00:00.000', 'SP-POM.MOT.PŘ.', 'Základní koeficient pro výpočet SP', 'Do procMzd dáme 1, případné vynulování se děje v parametrech typu prac. poměru.', true, 303, 1.0, 1.0, 0.0, '1', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, false, 10, 393, 393);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, vstupnapricpomery, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (8877, '2017-02-09 00:00:00.000', 'ZÁKL.SP-1 PRAC.POMĚR', 'Nulování SP v případě mot. př.', 'V případě motivačního příspěvku může být v procMzd 0 a tím dojde k vynulování zaklMzd.', true, 304, 1.0, 0.0, 0.0, 'procMzd', 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, false, 10, 393, 162, 162);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, vstupnapricpomery, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8878, '2017-02-07 00:00:00.000', 'ZP-POM.MOT.PŘ.SPOL.', 'Zákl. mzdy pro ZP pro mot. př. (spol.)', true, 331, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, false, 10, 163, 394);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, vstupnapricpomery, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8879, '2017-02-07 00:00:00.000', 'ZP-POM.MOT.PŘ.', 'Zákl. mzdy pro ZP pro mot. př. (akt.)', true, 332, 1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, false, 10, 163, 395);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, vstupnapricpomery, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8880, '2017-02-08 00:00:00.000', 'ZP-POM.MOT.PŘ.', 'ZP pro mot. př. (ostatní PP)', true, 333, 1.0, -1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, true, 10, 394, 395);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, vstupnapricpomery, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8881, '2017-02-09 00:00:00.000', 'ZP-POM.MOT.PŘ.', 'Zdravotní pojištění pro motivační příspěvek', e'Má se počítat ZP pro motivační příspěvek?\n - zjistíme to porovnáním základu ZP pro ostatní PP - pokud je různý od 0 (zde menší, protož dříve odečteno větší od menšího), tak si uložíme k = 2 a o více se postarají parametry typu prac. poměru.', true, 334, 0.0, 2.0, 1.0, 'zaklMzd', 'castkaDen', 0.0, 0.0, 'mzdCalcOper.mensiRovno', false, 0, false, false, 10, 395, 395);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, vstupnapricpomery, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
         VALUES (8882, '2017-02-07 00:00:00.000', 'ZÁKL.ZP-1 PRAC.POMĚR', 'Nulování ZP v případě mot. př.', 'V případě motivačního příspěvku může být v procMzd 0 a tím dojde k vynulování zaklMzd.', true, 335, 1.0, 0.0, 0.0, 'procMzd', 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, false, 10, 395, 163, 163);
        INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, vstupnapricpomery, idmzdcalchlav, idmzdslozin, idmzdslozout)
         VALUES (8883, '2017-02-07 00:00:00.000', 'ZP-POM.MOT.PŘ.', 'Základní koeficient pro výpočet ZP', 'Do procMzd dáme 1, případné vynulování se děje v parametrech typu prac. poměru.', true, 329, 1.0, 1.0, 0.0, '1', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, false, 10, 395, 395);
        
        -- úprava kalkulačky - doplnění parametrů typu prac. poměru
        UPDATE ptyppracpomparam SET poznam = '2015-12-22' WHERE idtyppracpomparam = 290;
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
            VALUES (320, '2017-02-08 00:00:00.000', 'SP-POM.MOT.PŘ.', 'Sociální pojištění pro motivační příspěvek', 'Hodnota 2 je v castkaDen v případě, kdy je SP jen z motivačního příspěvku', true, 170, 2.0, 2.0, 0.0, 'castkaDen', 'procMzd', true, true, true, true, true, true, true, true, 10, 12, 393);
        INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
            VALUES (321, '2017-02-08 00:00:00.000', 'ZP-POM.MOT.PŘ.', 'Zdravotní pojištění pro motivační příspěvek', 'Hodnota 2 je v castkaDen v případě, kdy je ZP jen z motivačního příspěvku', true, 171, 2.0, 2.0, 0.0, 'castkaDen', 'procMzd', true, true, true, true, true, true, true, true, 10, 12, 395);
        
        PERFORM pg_catalog.setval('seq_ptyppracpom', 12, true);
        PERFORM pg_catalog.setval('seq_pcismzdsloz', 395, true);
        PERFORM pg_catalog.setval('seq_pmzdcalc', 8883, true);
        PERFORM pg_catalog.setval('seq_ptyppracpomparam', 321, true);
   end if;
end;
 $$ LANGUAGE plpgsql;
 ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;
 
 alter table pmzdcalc add column vstupNapricPomery boolean not null default false;
 
 select runupgrade();
 
 drop function runupgrade();
 -- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 1077, 't', %appVersion%, clock_timestamp());
