-- Bug 14676 – [WinStrom] Aktualizovat kódy bank
-------------------------------------------
-- pridani sloupce obsahujiciho pomer stran obrazku
alter table asmerkod drop constraint asmerkod_kod_key;

create or replace function testuniquekodvplatnosti() 
        returns trigger as 
$BODY$
declare
        pocetstejnych integer;
begin
        select count(1) into pocetstejnych from asmerkod akod
                where akod.kod = new.kod and (akod.platiod < new.platido and akod.platido > new.platiod);
        if (pocetstejnych != 0) then
                raise exception 'Test unikatnosti kodu % s platiOd % do platiDo % neprosel.', new.kod, new.platiod, new.platido;
        end if;
        return new;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION testuniquekodvplatnosti() OWNER TO %firmaRole%;

CREATE TRIGGER testuniquekodvplatnostitrigger
  BEFORE INSERT
  ON asmerkod
  FOR EACH ROW
  EXECUTE PROCEDURE testuniquekodvplatnosti();

--------------------------------------------------------------------------------
-- uprava dat
--------------------------------------------------------------------------------
create or replace function updateceskeasmerkody()
    returns void as
$BODY$
begin
    update asmerkod set nazev = 'Komerční banka, a.s.', lastupdate = '2009-07-23' where kod = '0100';
    update asmerkod set nazev = 'Československá obchodní banka, a.s.', lastupdate = '2009-07-23' where kod = '0300';
    update asmerkod set nazev = 'GE Money Bank, a.s.', lastupdate = '2009-07-23' where kod = '0600';
    update asmerkod set nazev = 'Česká spořitelna, a.s.', lastupdate = '2009-07-23' where kod = '0800';
    update asmerkod set platido = 1998, lastupdate = '2009-07-23' where kod = '1600';
    update asmerkod set platido = 1999, lastupdate = '2009-07-23' where kod = '1900';
    update asmerkod set nazev = 'Fio, družstevní záložna', lastupdate = '2009-07-23' where kod = '2010';
    update asmerkod set nazev = 'AKCENTA, spořitelní a úvěrní družstvo', lastupdate = '2009-07-23' where kod = '2030';
    update asmerkod set nazev = 'UNIBON – spořitelní a úvěrní družstvo', lastupdate = '2009-07-23' where kod = '2040';
    update asmerkod set nazev = 'Moravský Peněžní Ústav – spořitelní družstvo', lastupdate = '2009-07-23' where kod = '2070';
    update asmerkod set platido = 2004, lastupdate = '2009-07-23' where kod = '2100';
    update asmerkod set platido = 2000, lastupdate = '2009-07-23' where kod = '2200';
    update asmerkod set nazev = 'Evropsko-ruská banka, a.s.', lastupdate = '2009-07-23' where kod = '2210';
    update asmerkod set platido = 2008, lastupdate = '2009-07-23' where kod = '2500';
    update asmerkod set nazev = 'Citibank Europe plc, organizační složka', lastupdate = '2009-07-23' where kod = '2600';
    update asmerkod set platido = 1997, lastupdate = '2009-07-23' where kod = '3200';
    update asmerkod set platido = 2001, lastupdate = '2009-07-23' where kod = '3300';
    update asmerkod set platido = 2003, lastupdate = '2009-07-23' where kod = '3400';
    update asmerkod set platido = 1999, lastupdate = '2009-07-23' where kod = '3700';
    update asmerkod set platido = 1998, lastupdate = '2009-07-23' where kod = '3800';
    update asmerkod set nazev = 'Českomoravská záruční a rozvojová banka, a.s.', lastupdate = '2009-07-23' where kod = '4300';
    update asmerkod set platido = 2005, lastupdate = '2009-07-23' where kod = '4400';
    update asmerkod set platido = 1999, lastupdate = '2009-07-23' where kod = '4500';
    update asmerkod set platido = 2003, lastupdate = '2009-07-23' where kod = '4600';
    update asmerkod set nazev = 'CALYON S.A., organizační složka', lastupdate = '2009-07-23' where kod = '5000';
    update asmerkod set platido = 2000, lastupdate = '2009-07-23' where kod = '5100';
    update asmerkod set platido = 1998, lastupdate = '2009-07-23' where kod = '5700';
    update asmerkod set nazev = 'BRE Bank S.A., organizační složka podniku', lastupdate = '2009-07-23' where kod = '6210';
    update asmerkod set nazev = 'Fortis Bank SA/NV, pobočka ČR', lastupdate = '2009-07-23' where kod = '6300';
    update asmerkod set platido = 1999, lastupdate = '2009-07-23' where kod = '6400';
    update asmerkod set nazev = 'Všeobecná úverová banka a.s., pobočka Praha', lastupdate = '2009-07-23' where kod = '6700';
    update asmerkod set nazev = 'Volksbank CZ', lastupdate = '2009-07-23' where kod = '6800';
    update asmerkod set nazev = 'Deutsche Bank A.G. Filiale Prag', lastupdate = '2009-07-23' where kod = '7910';
    update asmerkod set platido = 1998, lastupdate = '2009-07-23' where kod = '7920';
    update asmerkod set nazev = 'Waldviertler Sparkasse von 1842 AG', lastupdate = '2009-07-23' where kod = '7940';
    update asmerkod set nazev = 'Českomoravská stavební spořitelna, a.s', lastupdate = '2009-07-23' where kod = '7960';
    update asmerkod set nazev = 'Modrá pyramida stavební spořitelna, a.s.', lastupdate = '2009-07-23' where kod = '7990';
    update asmerkod set nazev = 'Raiffeisenbank im Stiftland eG pobočka Cheb, odštěpný závod', lastupdate = '2009-07-23' where kod = '8030';
    update asmerkod set nazev = 'Oberbank AG pobočka Česká republika', lastupdate = '2009-07-23' where kod = '8040';
    update asmerkod set platido = 1998, lastupdate = '2009-07-23' where kod = '8050';
    update asmerkod set nazev = 'Stavební spořitelna České spořitelny, a.s.', lastupdate = '2009-07-23' where kod = '8060';
    update asmerkod set platido = 2009, lastupdate = '2009-07-23' where kod = '8070';
    update asmerkod set nazev = 'Česká exportní banka, a.s.', lastupdate = '2009-07-23' where kod = '8090';
    update asmerkod set nazev = 'HSBC Bank plc - pobočka Praha', lastupdate = '2009-07-23' where kod = '8150';
    update asmerkod set nazev = 'PRIVAT BANK AG der Raiffeisenlandesbank Oberösterreich v České republice', lastupdate = '2009-07-23' where kod = '8200';

    INSERT INTO asmerkod (Kod, Nazev, PlatiOd, PlatiDo, LastUpdate, Show, uuid)
      VALUES ('2060', 'Citfin, spořitelní družstvo', 2009, 9999, '2009-07-23', true, 'CZ_2060_2009');
    INSERT INTO asmerkod (Kod, Nazev, PlatiOd, PlatiDo, LastUpdate, Show, uuid)
      VALUES ('2200', 'Peněžní dům, spořitelní družstvo', 2008, 9999, '2009-07-23', true, 'CZ_2200_2008');
    INSERT INTO asmerkod (Kod, Nazev, PlatiOd, PlatiDo, LastUpdate, Show, uuid)
      VALUES ('2100', 'Hypoteční banka, a.s.', 2005, 9999, '2009-07-23', true, 'CZ_2100_2005');
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION updateceskeasmerkody() OWNER TO %firmaRole%;

create or replace function updateslovenskeasmerkody()
    returns void as
$BODY$
begin
    update asmerkod set nazev = 'Všeobecná úverová banka, a.s.', lastupdate = '2009-07-23' where kod = '0200';
    update asmerkod set nazev = 'Slovenska Sporiteľňa, a.s.', lastupdate = '2009-07-23' where kod = '0900';
    update asmerkod set nazev = 'Tatra banka, a.s.', lastupdate = '2009-07-23' where kod = '1100';
    update asmerkod set nazev = 'Slovenská záručná a rozvojová banka, a.s.', lastupdate = '2009-07-23' where kod = '3000';
    update asmerkod set nazev = 'VOLKSBANK Slovensko, a.s.', lastupdate = '2009-07-23' where kod = '3100';
    update asmerkod set nazev = 'ISTROBANKA, a.s.', platido = 2009, lastupdate = '2009-07-23' where kod = '4900';
    update asmerkod set nazev = 'OTP Banka Slovensko, a.s.', lastupdate = '2009-07-23' where kod = '5200';
    update asmerkod set nazev = 'Dexia banka Slovensko a.s.', lastupdate = '2009-07-23' where kod = '5600';
    update asmerkod set nazev = 'Prvá stavebná sporiteľňa, a.s.', lastupdate = '2009-07-23' where kod = '5900';
    update asmerkod set nazev = 'Poštová banka, a.s.', lastupdate = '2009-07-23' where kod = '6500';
    update asmerkod set nazev = 'Československá obchodná banka, a.s.', lastupdate = '2009-07-23' where kod = '7500';
    update asmerkod set nazev = 'Wüstenrot stavebná sporiteľňa, a.s.', lastupdate = '2009-07-23' where kod = '7930';
    update asmerkod set nazev = 'CALYON S.A., pobočka zahraničnej banky', lastupdate = '2009-07-23' where kod = '8020';
    update asmerkod set nazev = 'COMMERZBANK Aktiengesellschaft, pobočka zahraničnej banky, Bratislava', lastupdate = '2009-07-23' where kod = '8050';
    update asmerkod set nazev = 'KOMERČNÍ BANKA Bratislava, a.s.', lastupdate = '2009-07-23' where kod = '8100';
    update asmerkod set nazev = 'Citibank Europe plc, pobočka zahraničnej banky', lastupdate = '2009-07-23' where kod = '8130';
    update asmerkod set nazev = 'EXIMBANKA SR', lastupdate = '2009-07-23' where kod = '8160';
    update asmerkod set nazev = 'ČSOB stavebná sporiteľňa, a.s.', lastupdate = '2009-07-23' where kod = '8170';
    update asmerkod set nazev = 'HSBC Bank plc, pobočka zahraničnej banky', lastupdate = '2009-07-23' where kod = '8300';
    update asmerkod set nazev = 'J&T BANKA, a.s., pobočka zahraničnej banky', lastupdate = '2009-07-23' where kod = '8320';
    update asmerkod set nazev = 'Fio, sporiteľné družstvo, organizačná zložka zahraničnej osoby', lastupdate = '2009-07-23' where kod = '8330';
    update asmerkod set nazev = 'BRE Bank SA, pobočka zahraničnej banky mBank v Slovenskej republike', lastupdate = '2009-07-23' where kod = '8360';

    INSERT INTO asmerkod (Kod,Nazev,NazevA,NazevB,NazevC,Popis,Poznam,PlatiOd,PlatiDo,LastUpdate,Show,uuid)
        VALUES ('1030', 'Národná banka Slovenska – prevádzkovateľ platobného systému EURO SIPS',null,null,null,null,null,0,9999,'2009-07-23',true,'SK_8400');
    INSERT INTO asmerkod (Kod,Nazev,NazevA,NazevB,NazevC,Popis,Poznam,PlatiOd,PlatiDo,LastUpdate,Show,uuid)
        VALUES ('8370', 'Oberbank AG pobočka zahraničnej banky v Slovenskej republike',null,null,null,null,null,0,9999,'2009-07-23',true,'SK_8400');
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION updateslovenskeasmerkody() OWNER TO %firmaRole%;

create or replace function runupgrade()
    returns void as
$BODY$
declare
    stat character varying(10);
begin
    select a.uuid into stat from nnastav n  left join
        utyporg u on u.idtyporg = n.idtyporg
        left join astaty a on a.idstatu = u.idstatu
        where ((select max(platioddata) from nnastav) is null
        or (select max(platioddata) from nnastav) = platioddata);
    if (stat = 'CZ_CZ') then
        execute updateceskeasmerkody();
    end if;
    
    if (stat = 'SK_SK') then
        execute updateslovenskeasmerkody();
    end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function updateceskeasmerkody();
drop function updateslovenskeasmerkody();
drop function runupgrade();

insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 126, 't');
