-- Bug 13538 – [WINSTROM]-Rozvaha potřebuje "likvidaci" rozdílu aktiv a pasiv při zaokrouhlení na celé tisíce

ALTER TABLE usestavy ADD COLUMN idradrozdil1 integer;
ALTER TABLE usestavy ADD COLUMN idradrozdil2 integer;

ALTER TABLE usestavy ADD CONSTRAINT fk5372f39c577bd0b7 FOREIGN KEY (idradrozdil1)
  REFERENCES usesradky (idsesradky) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

ALTER TABLE usestavy ADD CONSTRAINT fk5372f39c577bd0b8 FOREIGN KEY (idradrozdil2)
  REFERENCES usesradky (idsesradky) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX uSestavy_IdRadRozdil1_index ON uSestavy USING btree (IdRadRozdil1);
CREATE INDEX uSestavy_IdRadRozdil2_index ON uSestavy USING btree (IdRadRozdil2);


-- nastavení řádek do sestav
-- český podnikatelé
update usestavy as S set idRadRozdil1 = (select idsesradky from usesradky as R where cisrad = 1 and R.idsestavy = S.idsestavy),
                         idRadRozdil2 = (select idsesradky from usesradky as R where cisrad = 68 and R.idsestavy = S.idsestavy)
 where kod = 'ROZVAHA2006' and idtyporg = (select idtyporg from utyporg where kod = 'PODNIKATELE');

-- příspěvkovky
update usestavy as S set idRadRozdil1 = (select idsesradky from usesradky as R where cisrad = 125 and R.idsestavy = S.idsestavy),
                         idRadRozdil2 = (select idsesradky from usesradky as R where cisrad = 202 and R.idsestavy = S.idsestavy)
 where kod = 'ROZ_K' and idtyporg = (select idtyporg from utyporg where kod = 'ROZPOCTOVE');

-- slovenský podnikatelé
update usestavy as S set idRadRozdil1 = (select idsesradky from usesradky as R where cisrad = 1 and R.idsestavy = S.idsestavy),
                         idRadRozdil2 = (select idsesradky from usesradky as R where cisrad = 65 and R.idsestavy = S.idsestavy)
 where kod = 'ROZVAHA2009' and idtyporg = (select idtyporg from utyporg where kod = 'PODNIKATELIA');

-- zvýšení verze databáze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 133, 't');
