-------------------------------------------------------
-- Bug 14659 – [WinStrom] Ceník - záložka Dodavatelé
-------------------------------------------------------

CREATE SEQUENCE seq_cdodavatele
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

ALTER TABLE public.seq_cdodavatele OWNER TO %firmaRole%;

CREATE TABLE cdodavatele (
    iddodavatel integer DEFAULT nextval('seq_cdodavatele'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,

    kodindi character varying(20),
    nakupcena numeric(19,6) DEFAULT 0.0 NOT NULL,
    poznam text,
    primarni boolean DEFAULT false NOT NULL,

    idcenik integer NOT NULL,
    idfirmy integer NOT NULL,

    CONSTRAINT cdodavatele_pkey PRIMARY KEY (iddodavatel),
    CONSTRAINT cdodavatele_idcenik FOREIGN KEY (idcenik)
        REFERENCES ccenik (idcenik)
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT cdodavatele_idfirmy FOREIGN KEY (idfirmy)
        REFERENCES aadresar (idfirmy)
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT cdodavatele_unique_key UNIQUE (idcenik, idfirmy)
);

ALTER TABLE public.cdodavatele OWNER TO %firmaRole%;

CREATE INDEX cdodavatele_idcenik_index ON cdodavatele USING btree (idcenik);
CREATE INDEX cdodavatele_idfirmy_index ON cdodavatele USING btree (idfirmy);


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 151, 't');
