----------------------------------------------------------------
-- Bug 16816 – [winstrom] Chyba v obratech
----------------------------------------------------------------

-- [1] Přidání zámku do přepočtu obratů

CREATE OR REPLACE FUNCTION createorupdateobraty(ucetni boolean, storno boolean, datumucto date, castkamducet integer, castkadalucet integer, mena integer, stredisko integer, castka numeric, castkamen numeric) RETURNS void
    AS $$
declare
  nRok integer;
  nObdobi integer;
  idUcetniObdobi integer;
  idMenyTuzemsko integer;
  id integer;
  puvodniMD numeric(15,2);
  puvodniDal numeric(15,2);
begin
  if ucetni = false or storno = true or datumucto is null or stredisko is null or castkamducet is null or castkadalucet is null then
    return;
  end if;

  select idMeny into idMenyTuzemsko from nNastav where (platiOdData is null or platiOdData <= datumucto)
    order by coalesce(platioddata, '0001-01-01') desc limit 1;

  nRok:= date_part('year', datumUcto);
  nObdobi:= date_part('month', datumUcto);

  select idUcetObdobi into idUcetniObdobi from nUcetObdobi where (datumUcto >= PlatiOdData and datumUcto <= PlatiDoData) limit 1;

  /* TODO ma byt podminka na ucetni obdobi"?" */
  if(nRok is not null) and (nRok <> 0) and (nObdobi is not null) and (nObdobi <> 0) and (idMenyTuzemsko is not null) and (idUcetniObdobi is not null) then

    /*dph tuzemsko*/
    if (castkaMdUcet is not null and stredisko is not null and castka <> 0) then
      select idObrat, obrMD, obrDal into id, puvodniMD, puvodniDal from uObraty where idUcet = castkaMdUcet and Rok = nRok and Obdobi = nObdobi and
          idStred = stredisko and idMeny = idMenyTuzemsko for update; -- zamek !!!

      if (id is null) then
        insert into uObraty(idUcet, Rok, Obdobi, idStred, idMeny, ObrDal, ObrMD, idUcetObdobi, LastUpdate)
	         values(castkaMdUcet, nRok, nObdobi, stredisko, idMenyTuzemsko, 0.0, castka, idUcetniObdobi, now());
      else
        puvodniMD := puvodniMD + castka;
        if (puvodniMD = 0 and puvodniDal = 0) then
          delete from uObraty where idObrat = id;
        else
          update uObraty set obrMD = obrMD + castka, LastUpdate = now() where idObrat = id;
        end if;
      end if;
    end if;

    if (castkaDalUcet is not null and stredisko is not null and castka <> 0) then
      select idObrat, obrMD, obrDal into id, puvodniMD, puvodniDal from uObraty where idUcet = castkaDalUcet and Rok = nRok and Obdobi = nObdobi and
          idStred = stredisko and idMeny = idMenyTuzemsko for update;

      if (id is null) then
        insert into uObraty (idUcet, Rok, Obdobi, idStred, idMeny, ObrDal, ObrMD, idUcetObdobi, LastUpdate)
                 values(castkaDalUcet, nRok, nObdobi, stredisko, idMenyTuzemsko, castka, 0.0, idUcetniObdobi, now());
      else
        puvodniDal := puvodniDal + castka;
        if (puvodniMD = 0 and puvodniDal = 0) then
          delete from uObraty where idObrat = id;
        else
          update uObraty set obrDal = obrDal + castka, LastUpdate = now() where idObrat = id;
        end if;
      end if;
    end if;

    -- cizi mena, v pripade, ze se mena nema zapocitavat tak ma hodnotu -1
    if (mena <> -1) and mena <> idMenyTuzemsko then
          if(castkaMdUcet is not null and stredisko is not null and castkaMen <> 0) then
            select idObrat, obrMD, obrDal into id, puvodniMD, puvodniDal from uObraty
            where idUcet = castkaMdUcet and Rok = nRok and Obdobi = nObdobi and
              idStred = stredisko and idMeny = mena for update;

            if (id is null) then
              insert into uObraty(idUcet, Rok, Obdobi, idStred, idMeny, ObrDal, ObrMD, idUcetObdobi, LastUpdate)
              values(castkaMdUcet, nRok, nObdobi, stredisko, mena, 0.0, castkaMen, idUcetniObdobi, now());
            else
              puvodniMD := puvodniMD + castkaMen;
              if (puvodniMD = 0 and puvodniDal = 0) then
                delete from uObraty where idObrat = id;
              else
                update uObraty set obrMD = obrMD + castkaMen, LastUpdate = now() where idObrat = id;
              end if;
            end if;
          end if;

          if(castkaDalUcet is not null and stredisko is not null and castkaMen <> 0) then
            select idObrat, obrMD, obrDal into id, puvodniMD, puvodniDal from uObraty
            where idUcet = castkaDalUcet and Rok = nRok and Obdobi = nObdobi and
              idStred = stredisko and idMeny = mena for update;

            if (id is null) then
              insert into uObraty(idUcet, Rok, Obdobi, idStred, idMeny, ObrDal, ObrMD, idUcetObdobi, LastUpdate)
              values(castkaDalUcet, nRok, nObdobi, stredisko, mena, castkaMen, 0.0, idUcetniObdobi, now());
            else
              puvodniDal := puvodniDal + castkaMen;
              if (puvodniMD = 0 and puvodniDal = 0) then
                delete from uObraty where idObrat = id;
              else
                update uObraty set obrDal = obrDal + castkaMen, LastUpdate = now() where idObrat = id;
              end if;
            end if;
          end if;
    end if;

  else
    -- v pripade, ze dany objekt nema vyplneno datumUcto, nejsou hodnoty nastaveny a nezapocitavaji se do obratu
    if (datumUcto is not null) then
        raise exception 'aktualizace zaznamu tabulky uObraty: Neplatné vstupní hodnoty. % % % %',idMenyTuzemsko,idUcetniObdobi,nRok,nObdobi;
    end if;
  end if;
end;
$$ LANGUAGE plpgsql;

ALTER FUNCTION createorupdateobraty(ucetni boolean, storno boolean, datumucto date,
 castkamducet integer, castkadalucet integer, mena integer, stredisko integer,
 castka numeric, castkamen numeric) OWNER TO %firmaRole%;


-- [2] Odstranění potenciálních duplicit v obratech
-- [3] Přidání chybějícího integritního omezení na unikátnost obratu

-- Odstranění potenciálních duplicit v obratech zajistíme přepočtem stavů účtů.
-- To ale chceme provést jen tam, kde existují duplicity.
-- Při detekci duplicit, ale chceme ignorovat obraty 0 a 99, které nejsme
-- přepočtem obratů opravit.

-- Přidání chybějícího integritního omezení na unikátnost obratu provedeme
-- jen tehdy, nebude-li existovat duplicita v obratech (včetně 0 a 99).

create or replace function runupgrade()
    returns void as
$BODY$
declare
  zaznam record;
  maxpocet integer;
begin
  -- V obdobi kde existuji duplicity v obratech provedeme jejich přepočet.
  for zaznam in select * from nucetobdobi loop
    select max(a.pocet) into maxpocet
    from (
      select count(*) as pocet
      from uobraty
      where iducetobdobi = zaznam.iducetobdobi and obdobi not in (0,99)   -- obdobi not in (0,99) kvůli duplicitám u Kartonie
      group by obdobi,rok,idmeny,iducet,idstred,iducetobdobi
    ) as a;

    if(maxpocet > 1) then
      --raise notice 'prepoctiobraty(id=%, kod=%)', zaznam.iducetobdobi, zaznam.kod;
      perform prepoctiobraty(zaznam.iducetobdobi);
    end if;
  end loop;


  -- Přidání chybějícího integritního omezení na unikátnost obratu
  select max(a.pocet) into maxpocet
  from (
    select count(*) as pocet
    from uobraty
    group by obdobi,rok,idmeny,iducet,idstred,iducetobdobi
  ) as a;

  if(maxpocet < 2) then
    ALTER TABLE ONLY uobraty
      ADD CONSTRAINT uobraty_unique_key UNIQUE (obdobi,rok,idmeny,iducet,idstred,iducetobdobi);
  end if;

end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 184, 't');