--------------------------------------------------------------------------------
-- Bug 17045 – [Winstrom] Úprava účtového rozvrhu pro rozpočtové organizace 2009
--------------------------------------------------------------------------------

-- Zrušení unikátnosti kódu a typu organizace
ALTER TABLE ONLY ustducty
  DROP CONSTRAINT ustducty_kod_typorg_key;


-- Aktualizace dat pro příspěvkové organizace

create or replace function runupgrade()
    returns void as $$
declare
    _idtyporg integer;
begin
  select idtyporg into _idtyporg from nnastav where ((select max(platioddata) from nnastav) is null
        or (select max(platioddata) from nnastav) = platioddata);

  if (_idtyporg = 2) then

    -- [1] Přejmenování stávajících účtů [505]
    UPDATE ustducty SET nazev='Kulturní předměty' WHERE uuid='CZ_ROZ_032';
    UPDATE ustducty SET nazev='Dluhové cenné papíry držené do splatnosti' WHERE uuid='CZ_ROZ_063';
    UPDATE ustducty SET nazev='Jiné dlouhodobé půjčky' WHERE uuid='CZ_ROZ_067';
    UPDATE ustducty SET nazev='Oprávky k software' WHERE uuid='CZ_ROZ_073';
    UPDATE ustducty SET nazev='Běžné účty fondů organizačních složek státu' WHERE uuid='CZ_ROZ_225';
    UPDATE ustducty SET nazev='Základní běžný účet územních samosprávných celků' WHERE uuid='CZ_ROZ_231';
    UPDATE ustducty SET nazev='Běžné účty fondů územních samosprávných celků' WHERE uuid='CZ_ROZ_236';
    UPDATE ustducty SET nazev='Běžný účet FKSP' WHERE uuid='CZ_ROZ_243';
    UPDATE ustducty SET nazev='Jiné běžné účty' WHERE uuid='CZ_ROZ_245';
    UPDATE ustducty SET nazev='Dluhové cenné papíry k obchodování' WHERE uuid='CZ_ROZ_253';
    UPDATE ustducty SET nazev='Jiné cenné papíry' WHERE uuid='CZ_ROZ_256';
    UPDATE ustducty SET nazev='Krátkodobé úvěry' WHERE uuid='CZ_ROZ_281';
    UPDATE ustducty SET nazev='Vydané krátkodobé dluhopisy' WHERE uuid='CZ_ROZ_283';
    UPDATE ustducty SET nazev='Jiné krátkodobé půjčky' WHERE uuid='CZ_ROZ_289';
    UPDATE ustducty SET nazev='Krátkodobé poskytnuté zálohy' WHERE uuid='CZ_ROZ_314';
    UPDATE ustducty SET nazev='Jiné pohledávky z hlavní činnosti' WHERE uuid='CZ_ROZ_315';
    UPDATE ustducty SET nazev='Krátkodobé přijaté zálohy' WHERE uuid='CZ_ROZ_324';
    UPDATE ustducty SET nazev='Jiné závazky vůči zaměstnancům' WHERE uuid='CZ_ROZ_333';
    UPDATE ustducty SET nazev='Jiné přímé daně' WHERE uuid='CZ_ROZ_342';
    UPDATE ustducty SET nazev='Jiné daně a poplatky' WHERE uuid='CZ_ROZ_345';
    UPDATE ustducty SET nazev='Pohledávky za státním rozpočtem' WHERE uuid='CZ_ROZ_346';
    UPDATE ustducty SET nazev='Závazky ke státnímu rozpočtu' WHERE uuid='CZ_ROZ_347';
    UPDATE ustducty SET nazev='Pohledávky za rozpočtem územních samosprávných celků' WHERE uuid='CZ_ROZ_348';
    UPDATE ustducty SET nazev='Závazky k rozpočtům územních samosprávných celků' WHERE uuid='CZ_ROZ_349';
    UPDATE ustducty SET nazev='Náklady příštích období' WHERE uuid='CZ_ROZ_381';
    UPDATE ustducty SET nazev='Spotřeba jiných neskladovatelných dodávek' WHERE uuid='CZ_ROZ_503';
    UPDATE ustducty SET nazev='Jiné sociální pojištění' WHERE uuid='CZ_ROZ_525';
    UPDATE ustducty SET nazev='Jiné sociální náklady' WHERE uuid='CZ_ROZ_528';
    UPDATE ustducty SET nazev='Jiné daně a poplatky' WHERE uuid='CZ_ROZ_538';
    UPDATE ustducty SET nazev='Jiné pokuty a penále' WHERE uuid='CZ_ROZ_542';
    UPDATE ustducty SET nazev='Ostatní náklady z činnosti' WHERE uuid='CZ_ROZ_549';
    UPDATE ustducty SET nazev='Odpisy dlouhodobého majetku' WHERE uuid='CZ_ROZ_551';
    UPDATE ustducty SET nazev='Výnosy z prodeje vlastních výrobků' WHERE uuid='CZ_ROZ_601';
    UPDATE ustducty SET nazev='Výnosy z prodeje služeb' WHERE uuid='CZ_ROZ_602';
    UPDATE ustducty SET nazev='Výnosy z prodaného zboží' WHERE uuid='CZ_ROZ_604';
    UPDATE ustducty SET nazev='Změna stavu nedokončené výroby' WHERE uuid='CZ_ROZ_611';
    UPDATE ustducty SET nazev='Změna stavu polotovarů' WHERE uuid='CZ_ROZ_612';
    UPDATE ustducty SET nazev='Změna stavu výrobků ' WHERE uuid='CZ_ROZ_613';
    UPDATE ustducty SET nazev='Změna stavu ostatních zásob' WHERE uuid='CZ_ROZ_614';
    UPDATE ustducty SET nazev='Jiné pokuty a penále' WHERE uuid='CZ_ROZ_642';
    UPDATE ustducty SET nazev='Výnosy z odepsaných pohledávek' WHERE uuid='CZ_ROZ_643';
    UPDATE ustducty SET nazev='Čerpání fondů' WHERE uuid='CZ_ROZ_648';
    UPDATE ustducty SET nazev='Ostatní výnosy z činnosti' WHERE uuid='CZ_ROZ_649';


    -- [2] Zrušení platnosti starých účtů [505]
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_026';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_064';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_065';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_086';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_124';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_139';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_201';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_202';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_203';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_204';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_205';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_206';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_211';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_212';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_213';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_214';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_215';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_216';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_217';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_218';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_221';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_223';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_232';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_235';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_246';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_259';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_271';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_272';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_273';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_274';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_275';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_277';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_316';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_325';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_358';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_367';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_368';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_371';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_372';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_373';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_375';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_378';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_379';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_386';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_387';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_391';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_410';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_420';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_430';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_440';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_450';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_460';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_543';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_544';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_545';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_546';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_548';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_552';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_553';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_554';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_556';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_559';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_644';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_645';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_651';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_652';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_653';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_654';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_655';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_656';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_659';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_691';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_901';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_902';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_903';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_904';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_905';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_909';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_911';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_912';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_914';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_916';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_917';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_918';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_921';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_922';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_924';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_931';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_932';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_933';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_941';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_951';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_953';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_954';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_955';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_958';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_959';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_961';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_962';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_963';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_964';
    UPDATE ustducty SET platido=2009 WHERE uuid='CZ_ROZ_965';


    -- [3] Vložení nových účtů [505]
    INSERT INTO ustducty (lastupdate, kod, nazev, platido, platiod, druhuctuk, typuctuk, idtyporg, uuid) VALUES
    ('2009-12-10 00:00:00.000', '015', 'Povolenky na emise a preferenční limity', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_015'),
    ('2009-12-10 00:00:00.000', '044', 'Uspořádací účet technického zhodnocení dlouhodobého nehmotného majetku', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_044'),
    ('2009-12-10 00:00:00.000', '045', 'Uspořádací účet technického zhodnocení dlouhodobého hmotného majetku', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_045'),
    ('2009-12-10 00:00:00.000', '053', 'Poskytnuté zálohy na dlouhodobý finanční majetek', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_053'),
    ('2009-12-10 00:00:00.000', '068', 'Termínované vklady dlouhodobé', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_068'),
    ('2009-12-10 00:00:00.000', '138', 'Zboží na cestě', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_138'),
    ('2009-12-10 00:00:00.000', '139', 'Ostatní zásoby', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_139'),
    ('2009-12-10 00:00:00.000', '151', 'Opravné položky k nehmotným výsledkům výzkumu a vývoje', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_151'),
    ('2009-12-10 00:00:00.000', '152', 'Opravné položky k software', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_152'),
    ('2009-12-10 00:00:00.000', '153', 'Opravné položky k ocenitelným právům', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_153'),
    ('2009-12-10 00:00:00.000', '154', 'Opravné položky k povolenkám na emise a preferenčním limitům', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_154'),
    ('2009-12-10 00:00:00.000', '155', 'Opravné položky k drobnému dlouhodobému nehmotnému majetku', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_155'),
    ('2009-12-10 00:00:00.000', '156', 'Opravné položky k ostatnímu dlouhodobému nehmotnému majetku', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_156'),
    ('2009-12-10 00:00:00.000', '157', 'Opravné položky k nedokončenému dlouhodobému nehmotnému majetku', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_157'),
    ('2009-12-10 00:00:00.000', '161', 'Opravné položky k pozemkům', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_161'),
    ('2009-12-10 00:00:00.000', '162', 'Opravné položky ke kulturním předmětům', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_162'),
    ('2009-12-10 00:00:00.000', '163', 'Opravné položky ke stavbám', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_163'),
    ('2009-12-10 00:00:00.000', '164', 'Opravné položky k samostatným movitým věcem a souborům movitých věcí', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_164'),
    ('2009-12-10 00:00:00.000', '165', 'Opravné položky k pěstitelským celkům trvalých porostů', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_165'),
    ('2009-12-10 00:00:00.000', '166', 'Opravné položky k drobnému dlouhodobému hmotnému majetku', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_166'),
    ('2009-12-10 00:00:00.000', '167', 'Opravné položky k ostatnímu dlouhodobému hmotnému majetku', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_167'),
    ('2009-12-10 00:00:00.000', '168', 'Opravné položky k nedokončenému dlouhodobému hmotnému majetku', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_168'),
    ('2009-12-10 00:00:00.000', '171', 'Opravné položky k majetkovým účastem v osobách s rozhodujícím vlivem', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_171'),
    ('2009-12-10 00:00:00.000', '172', 'Opravné položky k majetkovým účastem v osobách s podstatným vlivem', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_172'),
    ('2009-12-10 00:00:00.000', '173', 'Opravné položky k dluhovým cenným papírům drženým do splatnosti', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_173'),
    ('2009-12-10 00:00:00.000', '174', 'Opravné položky k půjčkám osobám ve skupině', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_174'),
    ('2009-12-10 00:00:00.000', '175', 'Opravné položky k jiným dlouhodobým půjčkám', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_175'),
    ('2009-12-10 00:00:00.000', '176', 'Opravné položky k ostatnímu dlouhodobému finančnímu majetku', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_176'),
    ('2009-12-10 00:00:00.000', '177', 'Opravné položky k pořizovanému dlouhodobému finančnímu majetku', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_177'),
    ('2009-12-10 00:00:00.000', '181', 'Opravné položky k materiálu', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_181'),
    ('2009-12-10 00:00:00.000', '182', 'Opravné položky k nedokončené výrobě', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_182'),
    ('2009-12-10 00:00:00.000', '183', 'Opravné položky k polotovarům vlastní výroby', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_183'),
    ('2009-12-10 00:00:00.000', '184', 'Opravné položky k výrobkům', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_184'),
    ('2009-12-10 00:00:00.000', '185', 'Opravné položky ke zboží', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_185'),
    ('2009-12-10 00:00:00.000', '186', 'Opravné položky k ostatním zásobám', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_186'),
    ('2009-12-10 00:00:00.000', '191', 'Opravné položky k dlouhodobým pohledávkám z postoupených úvěrů', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_191'),
    ('2009-12-10 00:00:00.000', '192', 'Opravné položky k dlouhodobým pohledávkám z ručení', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_192'),
    ('2009-12-10 00:00:00.000', '193', 'Opravné položky k ostatním dlouhodobým pohledávkám', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_193'),
    ('2009-12-10 00:00:00.000', '194', 'Opravné položky k odběratelům', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_194'),
    ('2009-12-10 00:00:00.000', '195', 'Opravné položky ke krátkodobým pohledávkám z postoupených úvěrů', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_195'),
    ('2009-12-10 00:00:00.000', '196', 'Opravné položky k pohledávkám z titulu daní a obdobných dávek', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_196'),
    ('2009-12-10 00:00:00.000', '197', 'Opravné položky k pohledávkám za účastníky sdružení', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_197'),
    ('2009-12-10 00:00:00.000', '198', 'Opravné položky ke krátkodobým pohledávkám z ručení', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_198'),
    ('2009-12-10 00:00:00.000', '199', 'Opravné položky k ostatním krátkodobým pohledávkám', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_199'),
    ('2009-12-10 00:00:00.000', '222', 'Příjmový účet organizačních složek státu', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_222'),
    ('2009-12-10 00:00:00.000', '223', 'Zvláštní výdajový účet', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_223'),
    ('2009-12-10 00:00:00.000', '244', 'Termínované vklady krátkodobé', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_244'),
    ('2009-12-10 00:00:00.000', '247', 'Účty spravovaných prostředků', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_247'),
    ('2009-12-10 00:00:00.000', '248', 'Souhrnné účty', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_248'),
    ('2009-12-10 00:00:00.000', '249', 'Účty pro sdílení daní a pro dělenou správu', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_249'),
    ('2009-12-10 00:00:00.000', '316', 'Poskytnuté návratné finanční výpomoci krátkodobé', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_316'),
    ('2009-12-10 00:00:00.000', '317', 'Krátkodobé pohledávky z postoupených úvěrů', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_317'),
    ('2009-12-10 00:00:00.000', '318', 'Pohledávky z titulu daní a obdobných dávek', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_318'),
    ('2009-12-10 00:00:00.000', '319', 'Pohledávky ze sdílených daní', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_319'),
    ('2009-12-10 00:00:00.000', '323', 'Závazky z dávek sociálního zabezpečení', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_323'),
    ('2009-12-10 00:00:00.000', '325', 'Závazky z dělené správy a kaucí', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_325'),
    ('2009-12-10 00:00:00.000', '326', 'Přijaté návratné finanční výpomoci krátkodobé', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_326'),
    ('2009-12-10 00:00:00.000', '327', 'Přijaté zálohy daní', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_327'),
    ('2009-12-10 00:00:00.000', '328', 'Závazky z výběru daní', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_328'),
    ('2009-12-10 00:00:00.000', '329', 'Závazky ze sdílených daní', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_329'),
    ('2009-12-10 00:00:00.000', '351', 'Pohledávky za účastníky sdružení', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_351'),
    ('2009-12-10 00:00:00.000', '352', 'Závazky k účastníkům sdružení', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_352'),
    ('2009-12-10 00:00:00.000', '361', 'Krátkodobé pohledávky z ručení', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_361'),
    ('2009-12-10 00:00:00.000', '362', 'Krátkodobé závazky z ručení', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_362'),
    ('2009-12-10 00:00:00.000', '363', 'Pevné termínové operace a opce', 9999, 2010, 'druhUctu.aktpasvy', 'typUctu.rozvahovy', 2, 'CZ_505_2010_363'),
    ('2009-12-10 00:00:00.000', '364', 'Závazky z neukončených finančních operací', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_364'),
    ('2009-12-10 00:00:00.000', '365', 'Pohledávky z finančního zajištění', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_365'),
    ('2009-12-10 00:00:00.000', '366', 'Závazky z finančního zajištění', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_366'),
    ('2009-12-10 00:00:00.000', '367', 'Pohledávky z vydaných dluhopisů', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_367'),
    ('2009-12-10 00:00:00.000', '368', 'Závazky z upsaných nesplacených cenných papírů a podílů', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_368'),
    ('2009-12-10 00:00:00.000', '371', 'Krátkodobé pohledávky z nástrojů spolufinancovaných ze zahraničí', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_371'),
    ('2009-12-10 00:00:00.000', '372', 'Krátkodobé závazky z nástrojů spolufinancovaných ze zahraničí', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_372'),
    ('2009-12-10 00:00:00.000', '373', 'Poskytnuté zálohy na dotace', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_373'),
    ('2009-12-10 00:00:00.000', '374', 'Přijaté zálohy na dotace', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_374'),
    ('2009-12-10 00:00:00.000', '377', 'Ostatní krátkodobé pohledávky', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_377'),
    ('2009-12-10 00:00:00.000', '378', 'Ostatní krátkodobé závazky', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_378'),
    ('2009-12-10 00:00:00.000', '401', 'Jmění účetní jednotky', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_401'),
    ('2009-12-10 00:00:00.000', '402', 'Fond privatizace', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_402'),
    ('2009-12-10 00:00:00.000', '403', 'Dotace na pořízení dlouhodobého majetku', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_403'),
    ('2009-12-10 00:00:00.000', '404', 'Agregované příjmy a výdaje minulých let', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_404'),
    ('2009-12-10 00:00:00.000', '405', 'Kursové rozdíly', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_405'),
    ('2009-12-10 00:00:00.000', '406', 'Oceňovací rozdíly při změně metody', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_406'),
    ('2009-12-10 00:00:00.000', '407', 'Jiné oceňovací rozdíly', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_407'),
    ('2009-12-10 00:00:00.000', '408', 'Opravy chyb minulých období', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_408'),
    ('2009-12-10 00:00:00.000', '411', 'Fond odměn', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_411'),
    ('2009-12-10 00:00:00.000', '412', 'Fond kulturních a sociálních potřeb', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_412'),
    ('2009-12-10 00:00:00.000', '413', 'Rezervní fond tvořený ze zlepšeného výsledku hospodaření', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_413'),
    ('2009-12-10 00:00:00.000', '414', 'Rezervní fond z ostatních titulů', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_414'),
    ('2009-12-10 00:00:00.000', '416', 'Fond reprodukce majetku, investiční fond', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_416'),
    ('2009-12-10 00:00:00.000', '419', 'Ostatní fondy', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_419'),
    ('2009-12-10 00:00:00.000', '431', 'Výsledek hospodaření ve schvalovacím řízení', 9999, 2010, 'druhUctu.pasivhvy', 'typUctu.rozvahovy', 2, 'CZ_505_2010_431'),
    ('2009-12-10 00:00:00.000', '432', 'Nerozdělený zisk, neuhrazená ztráta minulých let', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_432'),
    ('2009-12-10 00:00:00.000', '441', 'Rezervy', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_441'),
    ('2009-12-10 00:00:00.000', '451', 'Dlouhodobé úvěry', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_451'),
    ('2009-12-10 00:00:00.000', '452', 'Přijaté návratné finanční výpomoci dlouhodobé', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_452'),
    ('2009-12-10 00:00:00.000', '453', 'Vydané dluhopisy ', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_453'),
    ('2009-12-10 00:00:00.000', '454', 'Závazky z pronájmu', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_454'),
    ('2009-12-10 00:00:00.000', '455', 'Dlouhodobé přijaté zálohy', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_455'),
    ('2009-12-10 00:00:00.000', '456', 'Dlouhodobé závazky z ručení', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_456'),
    ('2009-12-10 00:00:00.000', '457', 'Dlouhodobé směnky k úhradě', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_457'),
    ('2009-12-10 00:00:00.000', '458', 'Dlouhodobé závazky z nástrojů spolufinancovaných ze zahraničí', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_458'),
    ('2009-12-10 00:00:00.000', '459', 'Ostatní dlouhodobé závazky', 9999, 2010, 'druhUctu.pasivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_459'),
    ('2009-12-10 00:00:00.000', '462', 'Poskytnuté návratné finanční výpomoci dlouhodobé', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_462'),
    ('2009-12-10 00:00:00.000', '464', 'Dlouhodobé pohledávky z postoupených úvěrů', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_464'),
    ('2009-12-10 00:00:00.000', '465', 'Dlouhodobé poskytnuté zálohy', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_465'),
    ('2009-12-10 00:00:00.000', '466', 'Dlouhodobé pohledávky z ručení', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_466'),
    ('2009-12-10 00:00:00.000', '468', 'Dlouhodobé pohledávky z nástrojů spolufinancovaných ze zahraničí', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_468'),
    ('2009-12-10 00:00:00.000', '469', 'Ostatní dlouhodobé pohledávky', 9999, 2010, 'druhUctu.aktivni', 'typUctu.rozvahovy', 2, 'CZ_505_2010_469'),
    ('2009-12-10 00:00:00.000', '491', 'Počáteční účet rozvažný', 9999, 2010, 'druhUctu.otevknih', 'typUctu.zaverkovy', 2, 'CZ_505_2010_491'),
    ('2009-12-10 00:00:00.000', '492', 'Konečný účet rozvažný', 9999, 2010, 'druhUctu.uzavknih', 'typUctu.zaverkovy', 2, 'CZ_505_2010_492'),
    ('2009-12-10 00:00:00.000', '493', 'Výsledek hospodaření běžného účetního období', 9999, 2010, 'druhUctu.prhosvys', 'typUctu.zaverkovy', 2, 'CZ_505_2010_493'),
    ('2009-12-10 00:00:00.000', '499', 'Zúčtování na základě zvláštních předpisů', 9999, 2010, null, null, 2, 'CZ_505_2010_499'),
    ('2009-12-10 00:00:00.000', '523', 'Náklady z dávek sociálního zabezpečení', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_523'),
    ('2009-12-10 00:00:00.000', '539', 'Vratky daní z nadměrných odpočtů', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_539'),
    ('2009-12-10 00:00:00.000', '543', 'Dary', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_543'),
    ('2009-12-10 00:00:00.000', '544', 'Prodaný materiál', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_544'),
    ('2009-12-10 00:00:00.000', '547', 'Manka a škody', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_547'),
    ('2009-12-10 00:00:00.000', '548', 'Tvorba fondů', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_548'),
    ('2009-12-10 00:00:00.000', '552', 'Zůstatková cena prodaného dlouhodobého nehmotného majetku', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_552'),
    ('2009-12-10 00:00:00.000', '553', 'Zůstatková cena prodaného dlouhodobého hmotného majetku', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_553'),
    ('2009-12-10 00:00:00.000', '554', 'Prodané pozemky', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_554'),
    ('2009-12-10 00:00:00.000', '555', 'Tvorba a zúčtování rezerv', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_555'),
    ('2009-12-10 00:00:00.000', '556', 'Tvorba a zúčtování opravných položek', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_556'),
    ('2009-12-10 00:00:00.000', '557', 'Náklady z odepsaných pohledávek', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_557'),
    ('2009-12-10 00:00:00.000', '561', 'Prodané cenné papíry a podíly', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_561'),
    ('2009-12-10 00:00:00.000', '562', 'Úroky', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_562'),
    ('2009-12-10 00:00:00.000', '563', 'Kurzové ztráty', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_563'),
    ('2009-12-10 00:00:00.000', '564', 'Náklady z přecenění reálnou hodnotou', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_564'),
    ('2009-12-10 00:00:00.000', '569', 'Ostatní finanční náklady', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_569'),
    ('2009-12-10 00:00:00.000', '571', 'Náklady na nároky na prostředky státního rozpočtu', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_571'),
    ('2009-12-10 00:00:00.000', '572', 'Náklady na nároky na prostředky rozpočtů územních samosprávných celků', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_572'),
    ('2009-12-10 00:00:00.000', '573', 'Náklady na nároky na prostředky státních fondů', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_573'),
    ('2009-12-10 00:00:00.000', '574', 'Náklady na ostatní nároky', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_574'),
    ('2009-12-10 00:00:00.000', '581', 'Náklady ze sdílené daně z příjmů fyzických osob', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_581'),
    ('2009-12-10 00:00:00.000', '582', 'Náklady ze sdílené daně z příjmů právnických osob', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_582'),
    ('2009-12-10 00:00:00.000', '584', 'Náklady ze sdílené daně z přidané hodnoty', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_584'),
    ('2009-12-10 00:00:00.000', '585', 'Náklady ze sdílených spotřebních daní', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_585'),
    ('2009-12-10 00:00:00.000', '586', 'Náklady ze sdílených majetkových daní', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_586'),
    ('2009-12-10 00:00:00.000', '588', 'Náklady ze sdílené daně silniční', 9999, 2010, 'druhUctu.naklady', 'typUctu.vysledkovy', 2, 'CZ_505_2010_588'),
    ('2009-12-10 00:00:00.000', '603', 'Výnosy z pronájmu', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_603'),
    ('2009-12-10 00:00:00.000', '605', 'Výnosy ze správních poplatků', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_605'),
    ('2009-12-10 00:00:00.000', '606', 'Výnosy z místních poplatků', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_606'),
    ('2009-12-10 00:00:00.000', '607', 'Výnosy ze soudních poplatků', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_607'),
    ('2009-12-10 00:00:00.000', '609', 'Jiné výnosy z vlastních výkonů', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_609'),
    ('2009-12-10 00:00:00.000', '631', 'Výnosy z daně z příjmů fyzických osob', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_631'),
    ('2009-12-10 00:00:00.000', '632', 'Výnosy z daně z příjmů právnických osob', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_632'),
    ('2009-12-10 00:00:00.000', '633', 'Výnosy ze sociálního pojištění', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_633'),
    ('2009-12-10 00:00:00.000', '634', 'Výnosy z daně z přidané hodnoty', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_634'),
    ('2009-12-10 00:00:00.000', '635', 'Výnosy ze spotřebních daní', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_635'),
    ('2009-12-10 00:00:00.000', '636', 'Výnosy z majetkových daní', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_636'),
    ('2009-12-10 00:00:00.000', '637', 'Výnosy z energetických daní', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_637'),
    ('2009-12-10 00:00:00.000', '638', 'Výnosy z daně silniční', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_638'),
    ('2009-12-10 00:00:00.000', '639', 'Výnosy z ostatních daní a poplatků', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_639'),
    ('2009-12-10 00:00:00.000', '644', 'Výnosy z prodeje materiálu ', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_644'),
    ('2009-12-10 00:00:00.000', '645', 'Výnosy z prodeje dlouhodobého nehmotného majetku', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_645'),
    ('2009-12-10 00:00:00.000', '646', 'Výnosy z prodeje dlouhodobého hmotného majetku kromě pozemků', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_646'),
    ('2009-12-10 00:00:00.000', '647', 'Výnosy z prodeje pozemků', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_647'),
    ('2009-12-10 00:00:00.000', '661', 'Výnosy z prodeje cenných papírů a podílů', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_661'),
    ('2009-12-10 00:00:00.000', '662', 'Úroky', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_662'),
    ('2009-12-10 00:00:00.000', '663', 'Kursové zisky', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_663'),
    ('2009-12-10 00:00:00.000', '664', 'Výnosy z přecenění reálnou hodnotou', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_664'),
    ('2009-12-10 00:00:00.000', '665', 'Výnosy z dlouhodobého finančního majetku', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_665'),
    ('2009-12-10 00:00:00.000', '669', 'Ostatní finanční výnosy', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_669'),
    ('2009-12-10 00:00:00.000', '671', 'Výnosy z nároků na prostředky státního rozpočtu', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_671'),
    ('2009-12-10 00:00:00.000', '672', 'Výnosy z nároků na prostředky rozpočtů územních samosprávných celků', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_672'),
    ('2009-12-10 00:00:00.000', '673', 'Výnosy z nároků na prostředky státních fondů', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_673'),
    ('2009-12-10 00:00:00.000', '674', 'Výnosy z ostatních nároků', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_674'),
    ('2009-12-10 00:00:00.000', '681', 'Výnosy ze sdílené daně z příjmů fyzických osob', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_681'),
    ('2009-12-10 00:00:00.000', '682', 'Výnosy ze sdílené daně z příjmů právnických osob', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_682'),
    ('2009-12-10 00:00:00.000', '684', 'Výnosy ze sdílené daně z přidané hodnoty', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_684'),
    ('2009-12-10 00:00:00.000', '685', 'Výnosy ze sdílených spotřebních daní', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_685'),
    ('2009-12-10 00:00:00.000', '686', 'Výnosy ze sdílených majetkových daní', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_686'),
    ('2009-12-10 00:00:00.000', '688', 'Výnosy ze sdílené daně silniční', 9999, 2010, 'druhUctu.vynosy', 'typUctu.vysledkovy', 2, 'CZ_505_2010_688'),
    ('2009-12-10 00:00:00.000', '901', 'Jiný drobný dlouhodobý nehmotný majetek', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_901'),
    ('2009-12-10 00:00:00.000', '902', 'Jiný drobný dlouhodobý hmotný majetek', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_902'),
    ('2009-12-10 00:00:00.000', '903', 'Ostatní majetek', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_903'),
    ('2009-12-10 00:00:00.000', '911', 'Odepsané pohledávky', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_911'),
    ('2009-12-10 00:00:00.000', '912', 'Odepsané závazky', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_912'),
    ('2009-12-10 00:00:00.000', '921', 'Krátkodobé podmíněné pohledávky z důvodu úplatného užívání majetku jinou osobou', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_921'),
    ('2009-12-10 00:00:00.000', '922', 'Dlouhodobé podmíněné pohledávky z důvodu úplatného užívání majetku jinou osobou', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_922'),
    ('2009-12-10 00:00:00.000', '923', 'Krátkodobé podmíněné pohledávky z důvodu užívání majetku jinou osobou na základě smlouvy o výpůjčce', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_923'),
    ('2009-12-10 00:00:00.000', '924', 'Dlouhodobé podmíněné pohledávky z důvodu užívání majetku jinou osobou na základě smlouvy o výpůjčce', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_924'),
    ('2009-12-10 00:00:00.000', '925', 'Krátkodobé podmíněné pohledávky z důvodu užívání majetku jinou osobou z jiných důvodů', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_925'),
    ('2009-12-10 00:00:00.000', '926', 'Dlouhodobé podmíněné pohledávky z důvodu užívání majetku jinou osobou z jiných důvodů', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_926'),
    ('2009-12-10 00:00:00.000', '931', 'Krátkodobé podmíněné pohledávky ze smluv o prodeji dlouhodobého majetku', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_931'),
    ('2009-12-10 00:00:00.000', '932', 'Dlouhodobé podmíněné pohledávky ze smluv o prodeji dlouhodobého majetku', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_932'),
    ('2009-12-10 00:00:00.000', '933', 'Krátkodobé podmíněné pohledávky z jiných smluv', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_933'),
    ('2009-12-10 00:00:00.000', '934', 'Dlouhodobé podmíněné pohledávky z jiných smluv', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_934'),
    ('2009-12-10 00:00:00.000', '939', 'Krátkodobé podmíněné pohledávky ze vztahu k prostředkům EU', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_939'),
    ('2009-12-10 00:00:00.000', '941', 'Dlouhodobé podmíněné pohledávky ze vztahu k prostředkům EU', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_941'),
    ('2009-12-10 00:00:00.000', '942', 'Krátkodobé podmíněné pohledávky ze vztahu k jiným zdrojům', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_942'),
    ('2009-12-10 00:00:00.000', '943', 'Dlouhodobé podmíněné pohledávky ze vztahu k jiným zdrojům', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_943'),
    ('2009-12-10 00:00:00.000', '944', 'Krátkodobé podmíněné úhrady pohledávek z přijatých zajištění', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_944'),
    ('2009-12-10 00:00:00.000', '945', 'Dlouhodobé podmíněné úhrady pohledávek z přijatých zajištění', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_945'),
    ('2009-12-10 00:00:00.000', '947', 'Krátkodobé podmíněné pohledávky ze soudních sporů, správních řízení a jiných řízení', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_947'),
    ('2009-12-10 00:00:00.000', '948', 'Dlouhodobé podmíněné pohledávky ze soudních sporů, správních řízení a jiných řízení', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_948'),
    ('2009-12-10 00:00:00.000', '949', 'Ostatní krátkodobá podmíněná aktiva', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_949'),
    ('2009-12-10 00:00:00.000', '951', 'Ostatní dlouhodobá podmíněná aktiva', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_951'),
    ('2009-12-10 00:00:00.000', '961', 'Krátkodobé podmíněné závazky z leasingových smluv', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_961'),
    ('2009-12-10 00:00:00.000', '962', 'Dlouhodobé podmíněné závazky z leasingových smluv', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_962'),
    ('2009-12-10 00:00:00.000', '963', 'Krátkodobé podmíněné závazky z důvodu úplatného užívání cizího majetku na základě jiného důvodu', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_963'),
    ('2009-12-10 00:00:00.000', '964', 'Dlouhodobé podmíněné závazky z důvodu úplatného užívání cizího majetku na základě jiného důvodu', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_964'),
    ('2009-12-10 00:00:00.000', '965', 'Krátkodobé podmíněné závazky z důvodu užívání cizího majetku na základě smlouvy o výpůjčce', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_965'),
    ('2009-12-10 00:00:00.000', '966', 'Dlouhodobé podmíněné závazky z důvodu užívání cizího majetku na základě smlouvy o výpůjčce', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_966'),
    ('2009-12-10 00:00:00.000', '967', 'Krátkodobé podmíněné závazky z důvodu užívání cizího majetku nebo jeho převzetí z jiných důvodů', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_967'),
    ('2009-12-10 00:00:00.000', '968', 'Dlouhodobé podmíněné závazky z důvodu užívání cizího majetku nebo jeho převzetí z jiných důvodů', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_968'),
    ('2009-12-10 00:00:00.000', '971', 'Krátkodobé podmíněné závazky ze smluv o pořízení dlouhodobého majetku', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_971'),
    ('2009-12-10 00:00:00.000', '972', 'Dlouhodobé podmíněné závazky ze smluv o pořízení dlouhodobého majetku', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_972'),
    ('2009-12-10 00:00:00.000', '973', 'Krátkodobé podmíněné závazky z jiných smluv', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_973'),
    ('2009-12-10 00:00:00.000', '974', 'Dlouhodobé podmíněné závazky z jiných smluv', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_974'),
    ('2009-12-10 00:00:00.000', '975', 'Krátkodobé podmíněné závazky ze vztahu k prostředkům EU', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_975'),
    ('2009-12-10 00:00:00.000', '976', 'Dlouhodobé podmíněné závazky ze vztahu k prostředkům EU', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_976'),
    ('2009-12-10 00:00:00.000', '978', 'Krátkodobé podmíněné závazky vyplývající z právních předpisů a další činnosti moci zákonodárné, výkonné nebo soudní', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_978'),
    ('2009-12-10 00:00:00.000', '979', 'Dlouhodobé podmíněné závazky vyplývající z právních předpisů a další činnosti moci zákonodárné, výkonné nebo soudní', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_979'),
    ('2009-12-10 00:00:00.000', '981', 'Krátkodobé podmíněné závazky z poskytnutých zajištění', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_981'),
    ('2009-12-10 00:00:00.000', '982', 'Dlouhodobé podmíněné závazky z poskytnutých zajištění', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_982'),
    ('2009-12-10 00:00:00.000', '983', 'Krátkodobé podmíněné závazky ze soudních sporů, správních řízení a jiných řízení', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_983'),
    ('2009-12-10 00:00:00.000', '984', 'Dlouhodobé podmíněné závazky ze soudních sporů, správních řízení a jiných řízení', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_984'),
    ('2009-12-10 00:00:00.000', '985', 'Ostatní krátkodobá podmíněná pasiva', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_985'),
    ('2009-12-10 00:00:00.000', '986', 'Ostatní dlouhodobá podmíněná pasiva', 9999, 2010, null, 'typUctu.podrozvahovy', 2, 'CZ_505_2010_986');


    -- [4] Oprava účtů 336 a 999 [505]
    UPDATE ustducty SET druhuctuk='druhUctu.aktpasvy' WHERE uuid='CZ_ROZ_336';
    UPDATE ustducty SET druhuctuk=null, typuctuk='typUctu.podrozvahovy' WHERE uuid='CZ_ROZ_999';

    UPDATE uucty
    SET druhuctuk='druhUctu.aktpasvy'
    FROM ustducty
    WHERE uucty.idstducet = ustducty.idstducet AND ustducty.uuid='CZ_ROZ_336';

    UPDATE uucty
    SET druhuctuk=null, typuctuk='typUctu.podrozvahovy'
    FROM ustducty
    WHERE uucty.idstducet = ustducty.idstducet AND ustducty.uuid='CZ_ROZ_999';


    -- [5] Ukončení platnosti účtů z účtového rozvrhu [505]
    UPDATE uucty
    SET iducetobdobido = (SELECT iducetobdobi from nucetobdobi uo where uo.platioddata < '2009-12-31' and (uo.platidodata > '2009-12-31' or uo.platidodata = '2009-12-31'))
    FROM ustducty
    WHERE uucty.idstducet = ustducty.idstducet AND ustducty.platido = 2009;


  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 199, 't');