--------------------------------------------------------------------------------
-- Bug 17287 – [WinStrom] Přenášení účtů/protiúčtu u nových skladových vazeb
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION ddoklskladupdateucty() RETURNS trigger
    AS $$
declare idFak int;
declare idSklad int;
begin
  if (NEW.typPohybuK = 'typPohybu.prijem' and compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then
    for idFak in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabB = NEW.idDoklSklad and
            compareId((select idProtiUcet from dDoklFak where idDoklFak = idTabA), NEW.idProtiUcet) = false)
    loop
        execute dNastavUcetDokladu(0, idFak, 1, NEW.idProtiUcet);
    end loop;

    for idSklad in (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSklKus' and idTabA = NEW.idDoklSklad and
            compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabB), NEW.idProtiUcet) = false)
    loop
        execute dNastavUcetDokladu(2, idSklad, 1, NEW.idProtiUcet);
    end loop;

  else
    if (NEW.typPohybuK = 'typPohybu.vydej' and compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then

      for idSklad in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSklKus' and idTabB = NEW.idDoklSklad and
              compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabA), NEW.idProtiUcet) = false)
      loop
          execute dNastavUcetDokladu(2, idSklad, 1, NEW.idProtiUcet);
      end loop;

    end if;
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;

ALTER FUNCTION public.ddoklskladupdateucty() OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION dpolskladupdateucty() RETURNS trigger
    AS $$
declare
  nelzeZmena int;
  _modul character varying;
begin
  if ((select typPohybuK from dDoklSklad where idDoklSklad = NEW.idDoklSklad) = 'typPohybu.prijem') then
    if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false and NEW.kopZklDalUcet = false) then
      select modulA into _modul from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl';
      if(_modul like 'POK') then
        select count(*) into nelzeZmena from dPolInt where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and
          idPolInt in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
        --raise exception 'nelze zmena je % ....', nelzeZmena;
        if (nelzeZmena = 0) then
          update dPolInt set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and
            idPolInt in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
        else
          raise exception 'dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.';
        end if;
      else
        select count(*) into nelzeZmena from dPolFak where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
        --raise exception 'nelze zmena je % ....', nelzeZmena;
        if (nelzeZmena = 0) then
          update dPolFak set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
        else
          raise exception 'dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.';
        end if;

        select count(*) into nelzeZmena from dPolSklad where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklKus');
        if (nelzeZmena = 0) then
          update dPolSklad set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklKus');
        else
          raise exception 'dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky. (typVazbyDokl.polozkaSklKus, prijem)';
        end if;
      end if;

    end if;
  else
    if (compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false and NEW.kopZklMdUcet = false) then

      select count(*) into nelzeZmena from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and
          idPolSklad in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklKus');
      if (nelzeZmena = 0) then
        update dPolSklad set idZklDalUcet = NEW.idZklMdUcet where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and
          idPolSklad in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklKus');
      else
        raise exception 'dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky. (typVazbyDokl.polozkaSklKus, vydej)';
      end if;

    end if;
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;

ALTER FUNCTION public.dpolskladupdateucty() OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 213, 't');