----------------------------------------------------------------------
--  Bug 17187 -  [WinStrom] - Zboží - příjemka s výrobním číslem - 
--  při změněn skladu na položce s výrobními čísly tato zůstanou ve vazbě na původní sklad
----------------------------------------------------------------------

-- Function: svyrobnicisloupdatesklad()
-- DROP FUNCTION svyrobnicisloupdatesklad();
CREATE OR REPLACE FUNCTION svyrobnicisloupdatesklad()
  RETURNS trigger AS
$BODY$  
declare
  _idSkladu integer;
  _idCenik integer;
begin  
  if(NEW.idPolSkladPrijem is not null) then
    if(OLD.idPolSkladPrijem is null or NEW.idPolSkladPrijem <> OLD.idPolSkladPrijem) then
      select idSkladu, idCenik into _idSkladu, _idCenik from dPolSklad where idPolSklad = NEW.idPolSkladPrijem;
      NEW.idTypDokl = _idSkladu;
      NEW.idCenik = _idCenik;
    end if;
  end if;
  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION svyrobnicisloupdatesklad() OWNER TO %firmaRole%;

CREATE TRIGGER svyrobnicisloupdatesklad
  BEFORE UPDATE
  ON svyrobnicislo
  FOR EACH ROW
  EXECUTE PROCEDURE svyrobnicisloupdatesklad();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 219, 't');
