/* Odstraneni unikatnosti kodu na typu dokladu */
select drop_constraint_if_exists('dtypdokl', 'dtypdokl_kod_modul_key');
select add_constraint_if_not_exists('dtypdokl', 'dtypdokl_kod_modul_typorg_key', 'UNIQUE (kod, modul, idtyporg)');

/* Pridani sloupce do typu majetku */
select add_column_if_not_exists('mtypmaj', 'idtyporg', 'integer not null default 1');
update mtypmaj set idTypOrg = 1 where idTypOrg is null;
create index mTypMaj_TypOrg_index on mTypMaj using btree (IdTypOrg);
select add_constraint_if_not_exists('mTypMaj', 'mTypMaj_idtyporg_vazba', 'foreign key (idTypOrg) references utyporg(idTypOrg)');

select drop_constraint_if_exists('mTypMaj', 'mtypmaj_kod_key');
select add_constraint_if_not_exists('mTypMaj', 'mtypmaj_kod_typorg_key', 'UNIQUE (kod, idtyporg)');

/* Pridani sloupce do typu leasingu */
select add_column_if_not_exists('mtypleas', 'idtyporg', 'integer not null default 1');
update mTypLeas set idTypOrg = 1 where idTypOrg is null;
create index mTypLeas_TypOrg_index on mTypLeas using btree (IdTypOrg);
select add_constraint_if_not_exists('mTypLeas', 'mTypLeas_idtyporg_vazba', 'foreign key (idTypOrg) references utyporg(idTypOrg)');

select drop_constraint_if_exists('mTypLeas', 'mtypleas_kod_key');
select add_constraint_if_not_exists('mTypLeas', 'mtypleas_kod_typorg_key', 'UNIQUE (kod, idtyporg)');

/* Pridani sloupce do skupiny firem */
select add_column_if_not_exists('askupfir', 'idtyporg', 'integer not null default 1');
update askupfir set idTypOrg = 1 where idTypOrg is null;
create index aSkupFir_TypOrg_index on aSkupFir using btree (IdTypOrg);
select add_constraint_if_not_exists('aSkupFir', 'aSkupFir_idtyporg_vazba', 'foreign key (idTypOrg) references utyporg(idTypOrg)');

select drop_constraint_if_exists('aSkupFir', 'askupfir_kod_key');
select add_constraint_if_not_exists('aSkupFir', 'askupfir_kod_typorg_key', 'UNIQUE (kod, idtyporg)');

/* Pridani sloupce do skupiny zbozi */
select add_column_if_not_exists('cskupzboz', 'idtyporg', 'integer not null default 1');
update cskupzboz set idTypOrg = 1 where idTypOrg is null;
create index cSkupZboz_TypOrg_index on cSkupZboz using btree (IdTypOrg);
select add_constraint_if_not_exists('cSkupZboz', 'cSkupZboz_idtyporg_vazba', 'foreign key (idTypOrg) references utyporg(idTypOrg)');

select drop_constraint_if_exists('cSkupZboz', 'cskupzboz_kod_key');
select add_constraint_if_not_exists('cSkupZboz', 'cskupzboz_kod_typorg_key', 'UNIQUE (kod, idtyporg)');


insert into dbversion(iddbversion, dbversion, needreimport) values (nextval('seq_dbversion'), 28, 't');
