-------------------------------------------------------------------
-- Bug 16383 – [WinStrom] Doplnit na polozku faktury nakupni cenu
-------------------------------------------------------------------

-- Function: dpoldoklinsertsklad()
-- DROP FUNCTION dpoldoklinsertsklad();
CREATE OR REPLACE FUNCTION dpoldoklinsertsklad()
  RETURNS trigger AS
$BODY$ 
declare 
  pocetNavazanychDokladu integer; 
  _idPolFak integer; 
  _idDoklFak integer; 
  _idPolSklad integer; 
  _dokladGenerovatSkl boolean; 
  _typDoklGenerovatSkl boolean; 
  _typZasobyK character varying; 
  _sadaItemCount integer;
  _cenaMjNakup numeric(19,6);  
begin 
 
  if(NEW.typPolozkyK like 'typPolozky.katalog') then 
    if(NEW.modul like 'POK') then 
      _idPolFak = NEW.idPolInt; 
      _idDoklFak = NEW.idDoklInt; 
      select generovatSkl into _dokladGenerovatSkl from dDoklInt where idDoklInt = NEW.idDoklInt; 
      select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklInt where idDoklInt = NEW.idDoklInt); 
 
      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolint where idpolint = NEW.idPolInt); 
    else 
      _idPolFak = NEW.idPolFak; 
      _idDoklFak = NEW.idDoklFak; 
      select generovatSkl into _dokladGenerovatSkl from dDoklFak where idDoklFak = NEW.idDoklFak; 
      select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = NEW.idDoklFak); 
 
      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolfak where idpolfak = NEW.idPolFak); 
    end if; 
 
    select typZasobyK into _typZasobyK from cCenik where idCenik = NEW.idCenik; 
     
    if ((_typZasobyK like 'typZasoby.skladem' or _typZasobyK like 'typZasoby.vyrobek')  
      and _dokladGenerovatSkl and _typDoklGenerovatSkl and NEW.zdrojProSkl) then 
      select count(*) into pocetNavazanychDokladu from dvazebtab where 
        typVazbyK like 'typVazbyDokl.hlavaSkl' 
        and ( 
        (idTabA = _idDoklFak and modulA like NEW.modul) 
        or 
        (idTabB = _idDoklFak and modulB like NEW.modul)); 
 
      if(pocetNavazanychDokladu > 2) then 
        --neco jeste nevim co 
      else 
        if(_sadaItemCount > 0) then 
          execute createPolSkladSada(_idPolFak, NEW.modul); 
        else 
          select createPolSklad(_idPolFak, NEW.modul) into _idPolSklad;  
        end if; 
      end if; 
  
      execute putglotxvariable('vypniSklad', 'true');
      select skladGetCenaMjNakup(_idPolFak, NEW.modul, NEW.mnozMj) into _cenaMjNakup;
      if(NEW.modul = 'FAV') then
        update dpolfak set cenaMjNakup = _cenaMjNakup where idpolfak = _idPolFak;
      elsif(NEW.modul = 'POK') then
        update dpolint set cenaMjNakup = _cenaMjNakup where idpolint = _idPolFak;
      end if;
      execute removeglotxvariable('vypniSklad');
    end if; 
  end if;
 
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklinsertsklad() OWNER TO %firmaRole%;


create or replace function skladGetCenaMjNakup(i_idPolFak integer, i_modul character varying, i_mnozMj numeric(19,6)) returns numeric(19, 6) as
$BODY$
declare
  _result numeric(19,6);
  _polSklad record;
  _fifoPolSklad record;
  _mnozMj numeric(19,6);
  _cenik record;
  _polDokl record;
  _isDobropis boolean;
  _typDoklK character varying;
begin
  _isDobropis = false;
  if(i_modul = 'FAV') then
    select * into _polDokl from dPolFak where idPolFak = i_idPolFak;
    select * into _cenik from ccenik where idcenik = _polDokl.idCenik; 
    select typDoklK into _typDoklK from dtypdokl where idtypdokl = (select idtypdokl from ddoklfak where iddoklfak = _polDokl.idDoklFak);
    if(_typDoklK = 'typDokladu.dobropis') then
      _isDobropis = true;
    end if;
  elsif(i_modul = 'POK') then
    select * into _polDokl from dPolInt where idPolInt = i_idPolFak;
    select * into _cenik from ccenik where idcenik = _polDokl.idCenik; 
  else
    select null into _cenik; 
  end if;

  if(_cenik is null) then
    return 0.0;
  end if;

  if(_isDobropis) then
    _mnozMj = 0 - i_mnozMj;
  else
    _mnozMj = i_mnozMj;
  end if;
  
  if(_cenik.typZasobyK <> 'typZasoby.skladem' and _cenik.typZasobyK <> 'typZasoby.vyrobek') then
    return _cenik.cenaMjNakup;
  end if;
  _result = 0.0;
  --_mnozMj = 0.0;
  for _polSklad in (select * from dpolsklad where idPolSklad in 
    (select idTabB from dVazebTab where idTabA = i_idPolFak and modulA = i_modul and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSkl')) loop
    if(_polSklad.mnozMj = 0.0) then
      _result = _result + _polSklad.cenaMj;
    else
      _result = _result + _polSklad.sumZkl;
    end if;
    --_mnozMj = _mnozMj + _polSklad.mnozMj;
    for _fifoPolSklad in (select * from dpolsklad where idPolSklad in 
      (select idpolskladcil from svazbypolsklad where idPolSkladZdroj = _polSklad.idPolSklad)) loop
        if(_fifoPolSklad.mnozMj = 0.0) then
          _result = _result + _fifoPolSklad.cenaMj;
        else
          _result = _result + _fifoPolSklad.sumZkl;
        end if;
        --_mnozMj = _mnozMj + _fifoPolSklad.mnozMj;
    end loop;
  end loop;

  for _polSklad in (select * from dpolsklad where idPolSklad in 
    (select idTabB from dVazebTab where idTabA = i_idPolFak and modulA = i_modul and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklSada')) loop
    if(_polSklad.mnozMj = 0.0) then
      _result = _result + _polSklad.cenaMj;
    else
      _result = _result + _polSklad.sumZkl;
    end if;
    --_mnozMj = _mnozMj + _polSklad.mnozMj;
    for _fifoPolSklad in (select * from dpolsklad where idPolSklad in 
      (select idpolskladcil from svazbypolsklad where idPolSkladZdroj = _polSklad.idPolSklad)) loop
        if(_fifoPolSklad.mnozMj = 0.0) then
          _result = _result + _fifoPolSklad.cenaMj;
        else
          _result = _result + _fifoPolSklad.sumZkl;
        end if;
        --_mnozMj = _mnozMj + _fifoPolSklad.mnozMj;
    end loop;
  end loop;
  

  if(_mnozMj = 0) then
  else
    _result = _result / _mnozMj;
  end if;
  return _result;
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladGetCenaMjNakup(integer, character varying, numeric(19,6)) OWNER TO %firmaRole%;


-- Function: dpoldoklupdatesklad()
-- DROP FUNCTION dpoldoklupdatesklad();
CREATE OR REPLACE FUNCTION dpoldoklupdatesklad()
  RETURNS trigger AS
$BODY$ 
declare 
  _idPolDokl integer; 
  _idDoklad integer; 
  _idPolSklad integer; 
  _idDoklSklad integer; 
  _dokladGenerovatSkl boolean; 
  _typDoklGenerovatSkl boolean; 
  _typZasobyK character varying; 
  _vyrobniCislo record; 
  _typPohybuK character varying; 
  _sadaItemCount integer;
  _vypnutySklad character varying; 
begin
  select getglotxvariable('vypniSklad') into _vypnutySklad;
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then
    --raise exception 'sem sem se nemel dostat';
    if(NEW.storno <> OLD.storno or NEW.stornoPol <> OLD.stornoPol) then 
      return NEW; 
    end if; 
 
    if(NEW.modul like 'POK') then 
      _idPolDokl = NEW.idPolInt; 
      _idDoklad = NEW.idDoklInt; 
      select generovatSkl into _dokladGenerovatSkl from dDoklInt where idDoklInt = NEW.idDoklInt; 
      select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklInt where idDoklInt = NEW.idDoklInt); 
 
      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolInt where idpolint = NEW.idPolInt); 
    elsif (NEW.modul like 'FAV' or NEW.modul like 'FAP') then 
      _idPolDokl = NEW.idPolFak; 
      _idDoklad = NEW.idDoklFak; 
      select generovatSkl into _dokladGenerovatSkl from dDoklFak where idDoklFak = NEW.idDoklFak; 
      select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = NEW.idDoklFak); 
 
      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolfak where idpolfak = NEW.idPolFak); 
    else  
      return NEW;   
    end if; 
 
    -- pokud se lisi sklad, cenik, typPolozky, mnozMj, sarze, expirace 
    -- tak skladovou polozku musim smazat a vytvorit znovu kvuli fifu 
    if((NEW.idSkladu <> OLD.idSkladu or NEW.idCenik <> OLD.idCenik  
       or NEW.typPolozkyK <> OLD.typPolozkyK or NEW.mnozMj <> OLD.mnozMj 
       or NEW.sarze <> OLD.sarze or NEW.expirace <> OLD.expirace) 
       and _dokladGenerovatSkl and NEW.zdrojProSkl) then   
      --raise exception 'mazu polSklad'; 
      execute deleteNavazanePolSklad(_idPolDokl, NEW.modul); 
    end if; 
 
    if(NEW.typPolozkyK like 'typPolozky.katalog' and _dokladGenerovatSkl and _typDoklGenerovatSkl and NEW.zdrojProSkl) then   
      select typZasobyK into _typZasobyK from cCenik where idCenik = NEW.idCenik; 
     
      if (_typZasobyK like 'typZasoby.skladem' or _typZasobyK like 'typZasoby.vyrobek') then 
        select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSklad; 
        if(_idPolSklad is null) then 
          --select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;  
          if(_sadaItemCount > 0) then 
            execute createPolSkladSada(_idPolDokl, NEW.modul); 
          else 
            select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;  
          end if; 
        else 
          if(_sadaItemCount > 0) then 
            execute fillPolSkladSada(_idPolDokl, NEW.modul); 
          else 
            select fillPolSklad(_idPolSklad, _idPolDokl, NEW.modul) into _idPolSklad;  
          end if; 
        end if; 
        -- provedeni upgradu vyrobnich cisel 
        if(NEW.modul like 'FAV') then 
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakVydej = NEW.idPolFak loop 
            update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
          end loop; 
        end if; 
        if(NEW.modul like 'FAP') then 
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakPrijem = NEW.idPolFak loop 
            update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
          end loop; 
        end if; 
        if(NEW.modul like 'POK') then 
          select typPohybuK into _typPohybuK from dDoklInt where idDoklInt = _idDoklad; 
          if(_typPohybuK like 'typPohybu.prijem') then 
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntVydej = NEW.idPolInt loop 
              update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
            end loop; 
          else 
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntPrijem = NEW.idPolInt loop 
              update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
            end loop; 
          end if; 
        end if; 
 
      end if; 
      -- prepocteni sum na dokladu 
      select findParovanyDoklSklad(_idDoklad, NEW.modul) into _idDoklSklad; 
      execute sprepoctiSumyDokladu(_idDoklSklad, NEW.datVyst); 
    end if; 
  end if;
  return NEW; 
end 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklupdatesklad() OWNER TO %firmaRole%;



-- Function: skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer)
-- DROP FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer);
create or replace function skladFindCenaMjNakup(i_mnozmj numeric(19,6), i_idcenik integer, i_idskladu integer, i_datum date, i_sarze character varying, i_expirace date, i_idvyrobnihocisla integer) returns numeric(19,6) as
$BODY$
declare
  _sklfifo boolean;
  _mazatTmpTable boolean;
  _idkarty integer;
  _rozsirenaPolozka record;
  _iducetobdobi integer;
  _result numeric(19,6);
  _pomocDPolSkladF record;
  _mnozstvi numeric(19,6);
  _potrebnyPocet numeric(19,6);
  _sadaItemCount integer;
  _polozkaSady record;
  _pomoc numeric(19,6);
begin
  _result = 0.0;
  _mnozstvi = 0.0;

  if(i_mnozMj > 0) then
    select count(*) into _sadaItemCount from csady where idceniksada = i_idcenik; 
    if(_sadaItemCount > 0) then
      FOR _polozkaSady IN (select * from cSady where idCenikSada = i_idcenik) LOOP 
        -- TODO doresit sarze expirace a vyrobni cisla
        select skladfindcenamjnakup(i_mnozmj * _polozkaSady.mnozMj, _polozkaSady.idcenik, i_idskladu, i_datum, null, null, null) into _pomoc;
        _result = _result + _pomoc;
      end loop;
    else
      select iducetobdobi into _iducetobdobi from nucetobdobi;
      _sklfifo := (select isfifosklad(i_datum));
      if (_sklfifo) then
        if(i_idvyrobnihocisla is not null and i_idvyrobnihocisla > 0) then
          -- pokud je zadano vyrobni cislo ma nejvetsi prioritu
          select cenaMj into _result from dpolskladf where idcenik = i_idcenik and idskladu = i_idskladu and idvyrobnicislo = i_idvyrobnihocisla;
        elsif(i_sarze is not null and i_expirace is not null) then
          -- pokud je zadana sarze i expirace
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and sarze = i_sarze and expirace = i_expirace order by datVyst,idpolsklad) loop
            if(i_mnozMj > _mnozstvi) then
              _potrebnyPocet = _pomocDPolSkladF.pocet;
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then
                _potrebnyPocet = i_mnozMj - _mnozstvi;
              end if;
              _mnozstvi = _mnozstvi + _potrebnyPocet;
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj;
            end if;
          end loop;
          _result = _result / _mnozstvi;
        elsif(i_sarze is not null and i_expirace is null) then
          -- pokud je zadana jen sarze
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and sarze = i_sarze order by datVyst,idpolsklad) loop
            if(i_mnozMj > _mnozstvi) then
              _potrebnyPocet = _pomocDPolSkladF.pocet;
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then
                _potrebnyPocet = i_mnozMj - _mnozstvi;
              end if;
              _mnozstvi = _mnozstvi + _potrebnyPocet;
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj;
            end if;
          end loop;
          _result = _result / _mnozstvi;
        elsif(i_sarze is null and i_expirace is not null) then
          -- pokud je zadana jen expirace
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and expirace = i_expirace order by datVyst,idpolsklad) loop
            if(i_mnozMj > _mnozstvi) then
              _potrebnyPocet = _pomocDPolSkladF.pocet;
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then
                _potrebnyPocet = i_mnozMj - _mnozstvi;
              end if;
              _mnozstvi = _mnozstvi + _potrebnyPocet;
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj;
            end if;
          end loop;
          _result = _result / _mnozstvi;
        else
          -- pokud neni zadana ani sarze ani expirace ani vyrobni cislo
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu order by datVyst,idpolsklad) loop
            if(i_mnozMj >= _mnozstvi) then
              _potrebnyPocet = _pomocDPolSkladF.pocet;
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then
                _potrebnyPocet = i_mnozMj - _mnozstvi;
              end if;
              _mnozstvi = _mnozstvi + _potrebnyPocet;
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj;
            end if;
          end loop;
          _result = _result / _mnozstvi;
        end if;
      else
        -- generuji rozsirene polozky
        select idkarty into _idkarty from skarty where idcenik = i_idcenik and idtypdokl = i_idskladu and iducetobdobi = _iducetobdobi;
      
        -- bez pricteni +1 to pak vraci cenu na zacatku dne a my potrebujeme na konci dne (zacatku pristiho)
        select skladGenerujRozsirenePolozky(i_datum + 1, -1, _idkarty) into _mazatTmpTable;

        for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
          execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
        end loop;

        select prumCenaTuz into _result from skarty where idKarty = _idKarty;
    
        for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
          execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
        end loop;

        if(_mazatTmpTable) then
          drop table tmp_RozsirenePolozky;
          drop table tmp_SkladoveKarty;
        end if; 
      end if;
    end if;
  end if;
  return _result;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladFindCenaMjNakup(numeric(19,6), integer, integer, date, character varying, date, integer) OWNER TO %firmaRole%;




CREATE OR REPLACE FUNCTION dpolskladupdatecenamjnakupnafakture() RETURNS trigger AS
$BODY$ 
declare
  _cenaMjNakup numeric(19,6);
  _idPolFak integer;
  _modul character varying;
  _mnozMj numeric(19,6);
begin

  select idTabA, modulA into _idPolFak, _modul from dVazebTab where idTabB = NEW.idPolSklad and modulB = 'SKL' and 
     (typVazbyK = 'typVazbyDokl.polozkaSkl' or typVazbyK = 'typVazbyDokl.polozkaSklSada');
  

  if(_idPolFak is not null and _modul is not null and (_modul = 'FAV' or _modul = 'POK')) then
    if(_modul = 'FAV') then
      select mnozMj into _mnozMj from dPolFak where idPolFak = _idPolFak;
    elsif(_modul = 'POK') then
      select mnozMj into _mnozMj from dPolInt where idPolInt = _idPolFak;
    end if;

    execute putglotxvariable('vypniSklad', 'true');
    select skladGetCenaMjNakup(_idPolFak, _modul, _mnozMj) into _cenaMjNakup;
    if(_modul = 'FAV') then
      update dpolfak set cenaMjNakup = _cenaMjNakup where idpolfak = _idPolFak;
    elsif(_modul = 'POK') then
      update dpolint set cenaMjNakup = _cenaMjNakup where idpolint = _idPolFak;
    end if;
    execute removeglotxvariable('vypniSklad');
  end if;
  
  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdatecenamjnakupnafakture() OWNER TO %firmaRole%;

--drop trigger dpolskladupdatecenaMjNakupNaFakture on dpolsklad;
CREATE TRIGGER dpolskladupdatecenaMjNakupNaFakture
  AFTER UPDATE
  ON dpolsklad
  FOR EACH ROW
  EXECUTE PROCEDURE dpolskladupdatecenamjnakupnafakture();

CREATE OR REPLACE FUNCTION fillpolsklad(_idpolsklad integer, _idpoldokl integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _polDokl record; 
  _polSklad record; 
  _idDoklad integer; 
  _typPohybuK character varying; 
  _typPohybuSklad character varying; 
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _mnozMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _idDoklSklad integer; 
  _idUcetObdobi integer; 
  _idKarty integer; 
  _sklad record; 
  _kurz numeric(19,6); 
  _prumCenaTuz numeric(19,6); 
  _isCiziMena boolean; 
  _typDoklK character varying; 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
begin 
  if(_modul like 'POK') then 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  else 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  end if; 
 
  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad; 
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
  end if; 
 
  select * into _polSklad from dPolSklad where idPolSklad = _idPolSklad; 
  select typPohybuK into _typPohybuSklad from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad; 
 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idtypdokl = _polDokl.idskladu and iducetobdobi = _iducetobdobi; 
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu; 
   
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
 
  if(_typPohybuSklad like 'typPohybu.vydej') then 
    -- vsechny dobropisy generuji prijemky 
    --if(_typDoklK like 'typDokladu.dobropis') then 
    --  _mnozMj = -_polDokl.mnozMj; 
    --else 
      _mnozMj = _polDokl.mnozMj; 
    --end if; 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _polSklad.cenaMj; 
    _sumZkl = _polSklad.sumZkl; 
    _sumZklMen = _polSklad.sumZklMen; 
    -- nastaveni uctu pro polSklad vydej 
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet; 
    _idZklDalUcet = _sklad.idPrimUcet; 
  else 
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then 
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny; 
      _mnozMj = -_polDokl.mnozMj; 
      _cenaMjTuz = _polDokl.cenaMjNakup; 
      if(_cenaMjTuz = 0.0) then 
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik); 
        if(_cenaMj = 0.0) then 
          _cenaMj = _polDokl.cenaMj * _kurz; 
        end if; 
      end if; 
      _cenaMj = _cenaMjTuz / _kurz; 
      _sumZkl = _mnozMj * _cenaMjTuz; 
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if; 
    else 
      -- pokud na sklad prijmam zkopiruji se ceny z faktury 
      _mnozMj = _polDokl.mnozMj; 
      _sumZkl = _polDokl.sumZkl; 
      if(_mnozMj <> 0.0) then 
        _cenaMj = _sumZkl / _mnozMj; 
      else 
        _cenaMj = _sumZkl; 
      end if; 
      _cenaMj = _cenaMj / _kurz; 
      if(_isCiziMena) then 
        if(_mnozMj <> 0.0) then 
          _sumZklMen = _cenaMj * _mnozMj;   
        else 
          _sumZklMen = _cenaMj; 
        end if; 
      else 
        _sumZklMen = 0.0;   
      end if;  
    end if; 
    -- nastaveni uctu pro polSklad prijem 
    _idZklMdUcet = _sklad.idPrimUcet; 
    _idZklDalUcet = _polDokl.idZklMdUcet; 
  end if; 
   
  update dPolSklad set  
    cenaMj = _cenaMj,  
    mnozMj = _mnozMj,  
    sumZkl = _sumZkl,  
    sumZklMen = _sumZklMen,  
    nazev = _polDokl.nazev,  
    nazevA = _polDokl.nazevA,  
    nazevB = _polDokl.nazevB,  
    nazevC = _polDokl.nazevC,  
    datVyst = _polDokl.datVyst,  
    datUcto = _polDokl.datVyst, 
    baleniId = _polDokl.baleniId,  
    mnozBaleni = _polDokl.mnozBaleni,  
    sarze = _polDokl.sarze,  
    expirace = _polDokl.expirace,  
    cisRad = _polDokl.cisRad,  
    eankod = _polDokl.eanKod,  
    idmj = _polDokl.idmj,  
    idStred = _polDokl.idStred,  
    idMeny = _polSklad.idMeny,  
    idZakazky = _polDokl.idZakazky,  
    idZklMdUcet = _idZklMdUcet,  
    idZklDalUcet = _idZklDalUcet, 
    ucetni = true 
    where idPolSklad = _idPolSklad; 
 
  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillpolsklad(integer, integer, character varying) OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION createpolsklad(_idpoldokl integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _idDoklSklad integer; 
  _idDoklad integer; 
  _polDokl record; 
  _iducetobdobi integer; 
  _idkarty integer; 
  _idPolSklad integer; 
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _typPohybuK character varying; 
  _prumCenaTuz numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _kurz numeric(19,6); 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _kopZklMdUcet boolean; 
  _kopZklDalUcet boolean; 
  _sklad record; 
  _typDoklK character varying; 
  _mnozMj numeric(19,6); 
  _isCiziMena boolean; 
  _idMeny integer;   
begin 
  if(_modul like 'FAV' or _modul like 'FAP') then 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    _idDoklad = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  else 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    _idDoklad = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  end if; 
 
  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad; 
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
  end if; 
 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idtypdokl = _polDokl.idskladu and iducetobdobi = _iducetobdobi; 
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu; 
   
  select typPohybuK into _typPohybuK from dDoklSklad where idDoklSklad = _idDoklSklad; 
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
  select idMeny into _idMeny from dDoklSklad where idDoklSklad = _idDoklSklad; 
       
  if(_typPohybuK like 'typPohybu.vydej') then 
    -- vsechny dobropisy generuji prijemky 
    --if(_typDoklK like 'typDokladu.dobropis') then 
    --  _mnozMj = -_polDokl.mnozMj; 
    --else 
      _mnozMj = _polDokl.mnozMj; 
    --end if; 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _prumCenaTuz / _kurz; 
    _sumZkl = _prumCenaTuz * _mnozMj; 
    if(_isCiziMena) then 
      _sumZklMen = _mnozMj * _cenaMj; 
    else 
      _sumZklMen = 0.0; 
    end if; 
    -- nastaveni uctu pro polSklad vydej 
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet; 
    _idZklDalUcet = _sklad.idPrimUcet; 
  else 
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then 
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny; 
      _mnozMj = -_polDokl.mnozMj; 
      --_cenaMjTuz = _prumCenaTuz; 
      _cenaMjTuz = _polDokl.cenaMjNakup;
      if(_cenaMjTuz = 0.0) then 
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik); 
        if(_cenaMj = 0.0) then 
          _cenaMj = _polDokl.cenaMj * _kurz; 
        end if; 
      end if; 
      _cenaMj = _cenaMjTuz / _kurz; 
      _sumZkl = _mnozMj * _cenaMjTuz; 
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if; 
    else 
      -- pokud na sklad prijmam zkopiruji se ceny z faktury 
      _mnozMj = _polDokl.mnozMj; 
      _sumZkl = _polDokl.sumZkl; 
      if(_mnozMj <> 0.0) then 
        _cenaMj = _sumZkl / _mnozMj; 
      else 
        _cenaMj = _sumZkl; 
      end if; 
      _cenaMj = _cenaMj / _kurz; 
      if(_isCiziMena) then 
        if(_mnozMj <> 0.0) then 
          _sumZklMen = _cenaMj * _mnozMj;   
        else 
          _sumZklMen = _cenaMj; 
        end if; 
      else 
        _sumZklMen = 0.0;   
      end if; 
    end if; 
    -- nastaveni uctu pro polSklad prijem 
    _idZklMdUcet = _sklad.idPrimUcet; 
    _idZklDalUcet = _polDokl.idZklMdUcet; 
  end if; 
   
  select nextval('seq_dpolsklad') into _idPolSklad;   
  insert into dpolsklad(idPolSklad, idcenik, idskladu, idkarty, datVyst, datUcto, modul, typPolozkyK, idDoklSklad,    
        mnozMj, cenaMj, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni,   
        nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni,  
        idStred, idZakazky, idMeny, zdrojProFak)   
      values (_idPolSklad, _polDokl.idcenik, _polDokl.idskladu, _idkarty, _polDokl.datVyst, _polDokl.datUcto, 'SKL', 'typPolozky.katalog', _idDoklSklad,    
        _mnozMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, false, false, _polDokl.baleniid, _polDokl.mnozBaleni,    
        _polDokl.nazev, _polDokl.nazevA, _polDokl.nazevB, _polDokl.nazevC, _polDokl.sarze, _polDokl.expirace, _polDokl.cisRad, true,  
        _polDokl.idStred, _polDokl.idZakazky, _idMeny, false);   
  
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSkl'); 
 
  -- prepocteni sum na dokladu 
  execute sprepoctiSumyDokladu(_idDoklSklad); 
 
  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createpolsklad(integer, character varying) OWNER TO %firmaRole%;


--select skladFindCenaMjNakup(11.0, 2, 12, '2010-05-15', cast(null as character varying), cast(null as date), cast(null as integer));

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 295, 't');
