--------------------------------------------------------------------------------
-- Bug 19813 – [WinStrom] Strom dle výrobce
--------------------------------------------------------------------------------

create or replace function findUzlySCenikemVyrobce(_idstrom integer, _idvyrobce integer)
returns setof integer as
$BODY$
declare
  iduzlusvyr integer;
  idotectmp integer;
begin
  create temporary table tmp_uzlysvyr (
        iduzel integer
  ) with (OIDS=true) on commit drop;

  -- vsechny uzly co obsahuji cenik s vyrobcem si zadame do temp tabulky
  for iduzlusvyr in
	(select distinct iduzlu
	from wvazuzel vu
	left join wuzel u on vu.iduzlu = u.iduzel
		where u.idstrom = _idstrom and
		vu.idzaznamu in (select idcenik
				from ccenik
				where idvyrobce = _idvyrobce)) loop
	insert into tmp_uzlysvyr(iduzel) values (iduzlusvyr);
  end loop;

  -- projdeme temp tabulku uzlu a pridame vsechny jejich otce
  for iduzlusvyr in (select iduzel from tmp_uzlysvyr) loop
	select iduzlusvyr into idotectmp;
	while idotectmp is not null loop
	  -- prejdeme na dalsiho otce
	  select idotec into idotectmp from wuzel u where u.iduzel = idotectmp;
	  -- otec jeste neni v temp tabulce
	  if (select 1 from tmp_uzlysvyr where iduzel = idotectmp) is null and idotectmp is not null  then
	    insert into tmp_uzlysvyr(iduzel) values (idotectmp);
	  -- jiz tam je nema cenu prochazet zbytek stromu znovu
	  else
	    exit;
	  end if;
	end loop;
  end loop;

  -- projdeme temp tabulku a vytvorime set uzlu
  for iduzlusvyr in (select iduzel from tmp_uzlysvyr) loop
	return next iduzlusvyr;
  end loop;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION findUzlySCenikemVyrobce(integer, integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 344, 't');