--------------------------------------------------------------------------------
-- Bug 20362 – [WinStrom] Změna data dokladu se nepromitne do obratu
--------------------------------------------------------------------------------

CREATE or replace FUNCTION prepoctiobraty(iducetobd integer) RETURNS void
    AS $$ 
declare 
  _platiOd date; 
  _platiDo date; 
begin 
  select platioddata, platidodata into _platiOd, _platiDo from nucetobdobi where iducetobdobi = idUcetObd; 
 
  if (_platiOd is not null and _platiDo is not null) then 
    delete from uobraty where obdobi > 0 and (iducetobdobi = idUcetObd or 
      (obdobi < 99 and date(rok || '-' || obdobi || '-02') between _platiOd and _platiDo)); 
     
    -- zauctovani polozek faktur 
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idZklMdUcet, P.idZklDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumZkl, P.sumZklMen) from dpolfak as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
      
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idDphMdUcet, P.idDphDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumDph, P.sumDphMen) from dpolfak as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
        
     -- zauctovani polozek internich dokladu 
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idZklMdUcet, P.idZklDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumZkl, P.sumZklMen) from dpolint as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
        
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idDphMdUcet, P.idDphDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumDph, P.sumDphMen) from dpolint as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
                                 
     -- zauctovani polozek skladovych dokladu                      
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idZklMdUcet, P.idZklDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumZkl, P.sumZklMen) from dpolsklad as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
        
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idDphMdUcet, P.idDphDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumDph, P.sumDphMen) from dpolsklad as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
     
     -- danove naklady 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, L.idMeny, P.idStred,  
          P.sumZkl, P.sumZklMen) from mdannakl as P left outer join mleasing as L on L.idleasing = P.idleasing  
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
           
     -- danove odpisy 
     -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu dosazujeme -1 a za sumZklMen 0.0 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, -1, P.idStred,  
          P.sumZkl, 0.0) from mdanodpisy as P 
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
      
     -- splatkovy kalendar 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, L.idMeny, P.idStred,  
          P.sumZkl, P.sumZklMen) from msplatkal as P left outer join mleasing as L on L.idleasing = P.idleasing  
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
           
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idDphMdUcet, P.idDphDalUcet, L.idMeny, P.idStred,  
          P.sumDph, P.sumDphMen) from msplatkal as P left outer join mleasing as L on L.idleasing = P.idleasing  
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
      
     -- ucetni odpisy 
     -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu dosazujeme -1 a za sumZklMen 0.0 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, -1, P.idStred,  
          P.sumZkl, 0.0) from mucetodpisy as P 
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
      
     -- udalosti 
     -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu dosazujeme -1 a za sumZklMen 0.0 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, -1, P.idStred,  
          P.sumZkl, 0.0) from mudalosti as P 
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
        
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idDphMdUcet, P.idDphDalUcet, -1, P.idStred,  
          P.sumDph, 0.0) from mudalosti as P 
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo;
        
  end if; 
end;  
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.prepoctiobraty(iducetobd integer) OWNER TO %firmaRole%;


-- Function: dpoldoklupdateucto()
-- DROP FUNCTION dpoldoklupdateucto();
CREATE OR REPLACE FUNCTION dpoldoklupdateucto()
  RETURNS trigger AS
$BODY$  
begin  
    
 IF ( NEW.Ucetni <> OLD.Ucetni OR 
      NEW.Storno <> OLD.Storno OR 
      comparedate(NEW.DatUcto, OLD.DatUcto) = false OR 
 
      compareid(NEW.idZklMdUcet, OLD.idZklMdUcet) = false OR 
      compareid(NEW.idZklDalUcet, OLD.idZklDalUcet) = false OR 
      compareid(NEW.idDphMdUcet, OLD.idDphMdUcet) = false OR 
      compareid(NEW.idDphDalUcet, OLD.idDphDalUcet) = false OR 
 
      compareid(NEW.idMeny, OLD.idMeny) = false OR 
      compareid(NEW.idStred, OLD.idStred) = false OR 
      compareid(NEW.idCinnost, OLD.idCinnost) = false OR 
 
      NEW.sumZkl <> OLD.sumZkl OR 
      NEW.sumZklMen <> OLD.sumZklMen OR 
      NEW.sumDph <> OLD.sumDph OR 
      NEW.sumDphMen <> OLD.sumDphMen ) THEN 
 
  execute createOrUpdateObraty(OLD.Ucetni, OLD.Storno, OLD.DatUcto, OLD.idZklMdUcet, OLD.idZklDalUcet,  
      OLD.idMeny, OLD.idStred, OLD.idCinnost, -OLD.sumZkl, -OLD.sumZklMen);  
    
  execute createOrUpdateObraty(OLD.Ucetni, OLD.Storno, OLD.DatUcto, OLD.idDphMdUcet, OLD.idDphDalUcet,  
      OLD.idMeny, OLD.idStred, OLD.idCinnost, -OLD.sumDph, -OLD.sumDphMen);  
    
  execute createOrUpdateObraty(NEW.Ucetni, NEW.Storno, NEW.DatUcto, NEW.idZklMdUcet, NEW.idZklDalUcet,  
      NEW.idMeny, NEW.idStred, NEW.idCinnost, NEW.sumZkl, NEW.sumZklMen);  
    
  execute createOrUpdateObraty(NEW.Ucetni, NEW.Storno, NEW.DatUcto, NEW.idDphMdUcet, NEW.idDphDalUcet,  
      NEW.idMeny, NEW.idStred, NEW.idCinnost, NEW.sumDph, NEW.sumDphMen);  
 
 END IF; 
    
  return NEW;  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklupdateucto() OWNER TO %firmaRole%;


select prepoctiobraty(iducetobdobi) from nucetobdobi where zmenazaver = true;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 356, 't');
