--------------------------------------------------------------------------------
-- Bug 20692 – [WinStrom] Chybějící indexy v databázi
--------------------------------------------------------------------------------

-- Pridani chybejicich indexu
CREATE INDEX aNaklAkt_IdTypNaklAkt_index ON aNaklAkt USING btree (IdTypNaklAkt);

-- upgrade165 pridal index cOdberatele_IdSkupFir_index, ale v create skriptu chybel
DROP INDEX IF EXISTS cOdberatele_IdSkupFir_index;
CREATE INDEX cOdberatele_IdSkupFir_index ON cOdberatele USING btree (IdSkupFir);

CREATE INDEX dDoklObch_IdTypDoklNabFak_index ON dDoklObch USING btree (IdTypDoklNabFak);
CREATE INDEX nNastav_IdFinUrad_index ON nNastav USING btree (IdFinUrad);
CREATE INDEX nNastav_IdMenyDual_index ON nNastav USING btree (IdMenyDual);

CREATE INDEX sFifoVazby_idPolSkladPrijem_index ON sFifoVazby USING btree (idpolskladprijem);
CREATE INDEX sFifoVazby_idPolSkladVydej_index ON sFifoVazby USING btree (idpolskladvydej);
CREATE INDEX sRezervace_IdCenik_index ON sRezervace USING btree (IdCenik);
CREATE INDEX sRezervace_IdFirmy_index ON sRezervace USING btree (IdFirmy);
CREATE INDEX sRezervace_IdPolObch_index ON sRezervace USING btree (IdPolObch);
CREATE INDEX sRezervace_IdSklad_index ON sRezervace USING btree (IdSklad);
CREATE INDEX sRezervace_IdUziv_index ON sRezervace USING btree (IdUziv);
CREATE INDEX sVyrobniCislo_IdCenik_index ON sVyrobniCislo USING btree (IdCenik);
CREATE INDEX sVyrobniCislo_IdPolFakPrijem_index ON sVyrobniCislo USING btree (IdPolFakPrijem);
CREATE INDEX sVyrobniCislo_IdPolFakVydej_index ON sVyrobniCislo USING btree (IdPolFakVydej);
CREATE INDEX sVyrobniCislo_IdPolIntPrijem_index ON sVyrobniCislo USING btree (IdPolIntPrijem);
CREATE INDEX sVyrobniCislo_IdPolIntVydej_index ON sVyrobniCislo USING btree (IdPolIntVydej);
CREATE INDEX sVyrobniCislo_IdPolSkladPrijem_index ON sVyrobniCislo USING btree (IdPolSkladPrijem);
CREATE INDEX sVyrobniCislo_IdPolSkladVydej_index ON sVyrobniCislo USING btree (IdPolSkladVydej);
CREATE INDEX sVyrobniCislo_IdTypDokl_index ON sVyrobniCislo USING btree (IdTypDokl);

CREATE INDEX uZakazky_IdStavZakazky_index ON uZakazky USING btree (IdStavZakazky);
CREATE INDEX uZakazky_Idtypzakazky_index ON uZakazky USING btree (Idtypzakazky);
CREATE INDEX uZakazky_IdUzivatel_index ON uZakazky USING btree (IdUzivatel);
CREATE INDEX uZakazky_IdVyhZakazky_index ON uZakazky USING btree (IdVyhZakazky);

CREATE INDEX wAutCertCipher_IdAutCert_index ON wAutCertCipher USING btree (IdAutCert);
CREATE INDEX wExtId_IdAdresar_index ON wExtId USING btree (IdAdresar);
CREATE INDEX wExtId_IdCenik_index ON wExtId USING btree (IdCenik);
CREATE INDEX wExtId_IdDoklFak_index ON wExtId USING btree (IdDoklFak);
CREATE INDEX wExtId_IdDoklInt_index ON wExtId USING btree (IdDoklInt);
CREATE INDEX wExtId_IdDoklObch_index ON wExtId USING btree (IdDoklObch);
CREATE INDEX wExtId_IdDoklSklad_index ON wExtId USING btree (IdDoklSklad);
CREATE INDEX wExtId_IdKurz_index ON wExtId USING btree (IdKurz);
CREATE INDEX wExtId_IdPolFak_index ON wExtId USING btree (IdPolFak);
CREATE INDEX wExtId_IdPolInt_index ON wExtId USING btree (IdPolInt);
CREATE INDEX wExtId_IdPolObch_index ON wExtId USING btree (IdPolObch);
CREATE INDEX wExtId_IdPolSklad_index ON wExtId USING btree (IdPolSklad);
CREATE INDEX wExtId_IdSkladKarty_index ON wExtId USING btree (IdSkladKarty);
CREATE INDEX wKonektor_IdTypDoklObj_index ON wKonektor USING btree (IdTypDoklObj);
CREATE INDEX wKonektor_IdTypSklObjPol_index ON wKonektor USING btree (IdTypSklObjPol);
CREATE INDEX wReport_IdStatu_index ON wReport USING btree (IdStatu);
CREATE INDEX wReport_IdTypOrg_index ON wReport USING btree (IdTypOrg);


-- Odstraneni duplicitnich indexu
DROP INDEX dtypdokl_typorg_index;
DROP INDEX uucty_typorg_index;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 377, 't');
