--------------------------------------------------------------------------------
-- Bug 20656 – [WinStrom] Plnit sloupeček Rezervováno MJ v přehledu skladových karet
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION srezervaceupdateskladkarta()
  RETURNS trigger AS $$
declare
  ZAZNAM record;
begin
  if (tg_op = 'DELETE' or tg_op = 'UPDATE') then
    ZAZNAM := OLD;
    
    update skarty set rezervmj = (select coalesce(sum(mnozstvi), 0) from srezervace where idcenik = OLD.idcenik and idsklad = OLD.idsklad)
      where idcenik = OLD.idcenik and idtypdokl = OLD.idsklad;
  end if;
  
  if (tg_op = 'INSERT' or tg_op = 'UPDATE') then
    ZAZNAM := NEW;
    
    update skarty set rezervmj = (select coalesce(sum(mnozstvi), 0) from srezervace where idcenik = NEW.idcenik and idsklad = NEW.idsklad)
      where idcenik = NEW.idcenik and idtypdokl = NEW.idsklad;
  end if;
  
  return ZAZNAM;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.srezervaceupdateskladkarta() OWNER TO %firmaRole%;

CREATE TRIGGER srezervaceupdateskladkarta AFTER INSERT OR UPDATE OR DELETE ON srezervace
  FOR EACH ROW EXECUTE PROCEDURE srezervaceupdateskladkarta();


-- spocteni stavacicich rezervaci
CREATE OR REPLACE FUNCTION runupgrade() RETURNS void AS $$
declare
  _idCenik integer;
  _idSklad integer;
  _mnozstvi numeric(19,6);
begin
  for _idCenik, _idSklad, _mnozstvi in select idCenik, idSklad, sum(mnozstvi)  
                from srezervace group by idCenik, idSklad loop
    update skarty set rezervmj = _mnozstvi where idcenik = _idCenik and idtypdokl = _idSklad;
  end loop;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 388, 't');