-- Bug 10394 - uprava ulozene procedury udrzujici obraty na uctech

CREATE OR REPLACE FUNCTION createorupdateobraty(ucetni boolean, storno boolean, datumucto date, castkaMdUcet integer, castkaDalUcet integer, mena integer, stredisko integer, castka numeric, castkamen numeric)
  RETURNS void AS
$$
declare
  nRok integer;
  nObdobi integer;
  idUcetniObdobi integer;
  idMenyTuzemsko integer;
  id integer;
  puvodniMD numeric(15,2);
  puvodniDal numeric(15,2);
begin
  if ucetni = false or storno = true then
    return;
  end if;

  select idMeny into idMenyTuzemsko from nNastav where datumucto >= PlatiOdData order by PlatiOdData desc limit 1;
  if (idMenyTuzemsko is null) then
    select idMeny into idMenyTuzemsko from nNastav where PlatiOdData is null limit 1; 
  end if;

  nRok:= date_part('year', datumUcto);
  nObdobi:= date_part('month', datumUcto);

  select idUcetObdobi into idUcetniObdobi from nUcetObdobi where (datumUcto >= PlatiOdData and datumUcto <= PlatiDoData) limit 1;

  /* TODO ma byt podminka na ucetni obdobi"?" */
  if(nRok is not null) and (nRok <> 0) and (nObdobi is not null) and (nObdobi <> 0) and (idMenyTuzemsko is not null) and (idUcetniObdobi is not null) then  
    
    /*dph tuzemsko*/
    if (castkaMdUcet is not null and stredisko is not null and castka <> 0) then
      select idObrat, obrMD, obrDal into id, puvodniMD, puvodniDal from uObraty where idUcet = castkaMdUcet and Rok = nRok and Obdobi = nObdobi and
          idStred = stredisko and idMeny = idMenyTuzemsko;

      if (id is null) then
        insert into uObraty(idUcet, Rok, Obdobi, idStred, idMeny, ObrDal, ObrMD, idUcetObdobi, LastUpdate) 
	         values(castkaMdUcet, nRok, nObdobi, stredisko, idMenyTuzemsko, 0.0, castka, idUcetniObdobi, now());
      else
        puvodniMD := puvodniMD + castka;
        if (puvodniMD = 0 and puvodniDal = 0) then
          delete from uObraty where idObrat = id;
        else
          update uObraty set obrMD = puvodniMD, LastUpdate = now() where idObrat = id;
        end if;
      end if;
    end if;
    
    if (castkaDalUcet is not null and stredisko is not null and castka <> 0) then
      select idObrat, obrMD, obrDal into id, puvodniMD, puvodniDal from uObraty where idUcet = castkaDalUcet and Rok = nRok and Obdobi = nObdobi and
          idStred = stredisko and idMeny = idMenyTuzemsko;

      if (id is null) then
        insert into uObraty (idUcet, Rok, Obdobi, idStred, idMeny, ObrDal, ObrMD, idUcetObdobi, LastUpdate) 
                 values(castkaDalUcet, nRok, nObdobi, stredisko, idMenyTuzemsko, castka, 0.0, idUcetniObdobi, now());
      else
        puvodniDal := puvodniDal + castka;
        if (puvodniMD = 0 and puvodniDal = 0) then
          delete from uObraty where idObrat = id;
        else
          update uObraty set obrDal = puvodniDal, LastUpdate = now() where idObrat = id;
        end if;
      end if;
    end if;

    -- cizi mena, v pripade, ze se mena nema zapocitavat tak ma hodnotu -1
    if (mena <> -1) and mena <> idMenyTuzemsko then
          if(castkaMdUcet is not null and stredisko is not null and castkaMen <> 0) then
            select idObrat, obrMD, obrDal into id, puvodniMD, puvodniDal from uObraty where idUcet = castkaMdUcet and Rok = nRok and Obdobi = nObdobi and idStred = stredisko and idMeny = mena;

            if (id is null) then
              insert into uObraty(idUcet, Rok, Obdobi, idStred, idMeny, ObrDal, ObrMD, idUcetObdobi, LastUpdate) 
              values(castkaMdUcet, nRok, nObdobi, stredisko, mena, 0.0, castkaMen, idUcetniObdobi, now());
            else
              puvodniMD := puvodniMD + castkaMen;
              if (puvodniMD = 0 and puvodniDal = 0) then
                delete from uObraty where idObrat = id;
              else
                update uObraty set obrMD = puvodniMD, LastUpdate = now() where idObrat = id;
              end if;
            end if;
          end if;

          if(castkaDalUcet is not null and stredisko is not null and castkaMen <> 0) then
            select idObrat, obrMD, obrDal into id, puvodniMD, puvodniDal from uObraty where idUcet = castkaDalUcet and Rok = nRok and Obdobi = nObdobi and idStred = stredisko and idMeny = mena;

            if (id is null) then
              insert into uObraty(idUcet, Rok, Obdobi, idStred, idMeny, ObrDal, ObrMD, idUcetObdobi, LastUpdate) 
              values(castkaDalUcet, nRok, nObdobi, stredisko, mena, castkaMen, 0.0, idUcetniObdobi, now());
            else
              puvodniDal := puvodniDal + castkaMen;
              if (puvodniMD = 0 and puvodniDal = 0) then
                delete from uObraty where idObrat = id;
              else
                update uObraty set obrDal = puvodniDal, LastUpdate = now() where idObrat = id;
              end if;
            end if;
          end if;
    end if;

  else 
    -- v pripade, ze dany objekt nema vyplneno datumUcto, nejsou hodnoty nastaveny a nezapocitavaji se do obratu
    if (datumUcto is not null) then
        raise exception 'aktualizace zaznamu tabulky uObraty: Neplatné vstupní hodnoty. % % % %',idMenyTuzemsko,idUcetniObdobi,nRok,nObdobi;
    end if;
  end if;
end;
$$ LANGUAGE plpgsql;

insert into dbversion(iddbversion, dbversion, needreimport) values (nextval('seq_dbversion'), 4, 't')