--------------------------------------------------------------------------------
-- Bug 21029 – [WinStrom] Umoznit z obchodniho modulu autotisk bez sumaci
--------------------------------------------------------------------------------

alter table dautotisk add column rozsireny boolean NOT NULL DEFAULT false;
-- sumovany na true protoze vetsina je sumovanych, a kdyz nejsou sumovane existuje k nim jejich sumovana obdoba
alter table dautotisk add column sumovany boolean NOT NULL DEFAULT true;

--------------------------------------------------------------------------------
-- Bug 21292 – [WinStrom] Přenos účtů mezi doklady
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dpolfakupdateucty() RETURNS trigger
    AS $$  
declare typPohyb character varying(50);  
        nelzeZmena int;  
        idDokl int;  
begin  
  if (NEW.typPolozkyK = 'typPolozky.katalog' and compareid(NEW.idzklmducet, OLD.idzklmducet) = false) then  
      -- nacteni typu pohybu  
      select typPohybuK into typPohyb from dDoklFak where idDoklFak = NEW.idDoklFak;  
  
      -- prijata faktura  
      if (typPohyb = 'typPohybu.vydej') then  
        -- zjistime zda neexistujou nake co nesmime zmenit  
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and  
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.polozkaSkl');  
        -- pokud smime zmenit vsechny polozky co potrebujeme menime  
        if (nelzeZmena = 0) then  
          update dPolSklad set idZklDalUcet = NEW.idZklMdUcet where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and idPolSklad in  
            (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.polozkaSkl');  
        else  
          raise exception 'dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky.';  
        end if;  
      end if;  
  end if;  
  
  if (NEW.typPolozkyK in ('typPolozky.odpocetZdd','typPolozky.odpocetZalohy')) then  
      -- nacteni typu pohybu  
      select typPohybuK into typPohyb from dDoklFak where idDoklFak = NEW.idDoklFak;  
  
      -- vydana faktura  
      if (typPohyb = 'typPohybu.prijem') then  
        -- meni se ucet zakladu  
        if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idProtiUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idZklDalUcet) = false)  
            loop  
                execute dNastavUcetDokladu(0, idDokl, 1, NEW.idZklDalUcet);  
            end loop;  
          end if;  
          -- polozka odpocitava zalohu  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then  
            for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idZklDalUcet) = false and idDoklInt in  
                (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA in  
                  (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.odpocetZALOHY')))  
            loop  
                execute dNastavUcetDokladu(1, idDokl, 1, NEW.idZklDalUcet);  
            end loop;  
          end if;  
        end if;    -- konec zmena uctu zakladu  
  
        -- meni se ucet dane  
        if (compareId(NEW.idDphDalUcet, OLD.idDphDalUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            -- dph je zakladni  
            if (NEW.typSzbDphK = 'typSzbDph.dphZakl') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idDphZaklUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphDalUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 2, NEW.idDphDalUcet);  
              end loop;  
            end if;   -- konec dph zakladni  
  
            -- dph je snizena  
            if (NEW.typSzbDphK = 'typSzbDph.dphSniz') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                    compareId((select idDphSnizUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphDalUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 3, NEW.idDphDalUcet);  
              end loop;  
            end if;-- konec dph snizena  
          end if;  -- konec odpocet zdd  
        end if;    -- konec zmena uctu dane  
  
      end if;      -- konec jedna se o vydanou fakturu  
  
      --------------------------------------------------------------------------  
      -- prijata faktura  
      if (typPohyb = 'typPohybu.vydej') then  
        -- meni se ucet zakladu  
        if (compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idProtiUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idZklMdUcet) = false)  
            loop  
                execute dNastavUcetDokladu(0, idDokl, 1, NEW.idZklMdUcet);  
            end loop;  
          end if;  
  
          -- polozka odpocitava zalohu  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then  
            for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idZklMdUcet) = false and idDoklInt in  
                (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA in  
                  (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.odpocetZALOHY')))  
            loop  
                execute dNastavUcetDokladu(1, idDokl, 1, NEW.idZklMdUcet);  
            end loop;  
          end if;  
        end if;    -- konec zmena uctu zakladu  
  
        -- meni se ucet dane  
        if (compareId(NEW.idDphMdUcet, OLD.idDphMdUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            -- dph je zakladni  
            if (NEW.typSzbDphK = 'typSzbDph.dphZakl') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idDphZaklUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphMdUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 2, NEW.idDphMdUcet);  
              end loop;  
  
            end if;   -- konec dph zakladni  
  
            -- dph je snizena  
            if (NEW.typSzbDphK = 'typSzbDph.dphSniz') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                    compareId((select idDphSnizUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphMdUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 3, NEW.idDphMdUcet);  
              end loop;  
            end if;-- konec dph snizena  
          end if;  -- konec odpocet zdd  
        end if;    -- konec zmena uctu dane  
  
      end if;      -- konec jedna se o prijatou fakturu  
  
  end if;       -- konec podminky na typ dokladu  
  
  return NEW;  
end;  
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolfakupdateucty() OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION dpolskladupdateucty() RETURNS trigger
    AS $$
declare
  nelzeZmena int;
  _modul character varying;
begin
  if ((select typPohybuK from dDoklSklad where idDoklSklad = NEW.idDoklSklad) = 'typPohybu.prijem') then
    -- z prijemky se pres vazbu polozkaSklPrevod ma prenaset ucet zklDal na vydejku zklMd
    if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false and NEW.kopZklDalUcet = false) then
      select modulA into _modul from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod';
      if(_modul like 'SKL') then
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and 
          idPolSklad in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        if (nelzeZmena = 0) then 
          update dPolSklad set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and 
            idPolSklad in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        else 
          raise exception 'dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.'; 
        end if;
      end if;
    end if;
  else
    -- z vydejky se ma pres vazbu polozkaSklPrevod ma prenaset ucet zklMd na ucet zklDal
    if (compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false and NEW.kopZklMdUcet = false) then
      select modulB into _modul from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod';
      if(_modul like 'SKL') then
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and 
          idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        if (nelzeZmena = 0) then 
          update dPolSklad set idZklDalUcet = NEW.idZklMdUcet where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and 
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        else 
          raise exception 'dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.'; 
        end if;
      end if;
    end if;
  end if;

  if ((select typPohybuK from dDoklSklad where idDoklSklad = NEW.idDoklSklad) = 'typPohybu.prijem') then 
    if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false and NEW.kopZklDalUcet = false) then
      select modulA into _modul from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl';
      if(_modul like 'POK') then
        select count(*) into nelzeZmena from dPolInt where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and
          idPolInt in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
        
        if (nelzeZmena = 0) then
          update dPolInt set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and
            idPolInt in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
        else
          raise exception 'dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.';
        end if;
      else
        if _modul = 'FAP' then
          select count(*) into nelzeZmena from dPolFak where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
          
          if (nelzeZmena = 0) then
            update dPolFak set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and
              idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
          else
            raise exception 'dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.';
          end if;
        end if;
      end if;

    end if;
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolskladupdateucty() OWNER TO %firmaRole%;


-- oprava dokladu kde nesedi ucty na polozce a dokladu i kdyz by meli
UPDATE dpolfak AS P SET kopzklmducet = false FROM ddoklfak AS D
  WHERE P.iddoklfak = D.iddoklfak AND P.modul = 'FAP' AND P.kopzklmducet AND 
    compareid(P.idzklmducet, D.idprotiucet) = false;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 400, 't');
