--------------------------------------------------------------------------------
-- Bug 21292 – [WinStrom] Přenos účtů mezi doklady
--------------------------------------------------------------------------------

-- ze skladu na fakturu prenasime pouze pokud je typ pohybu prijem a FAP
CREATE OR REPLACE FUNCTION ddoklskladupdateucty() RETURNS trigger AS $$
declare idFak int;
declare idSklad int;
declare idPok int;
begin
  if (NEW.typPohybuK = 'typPohybu.prijem' and compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then
    -- musime testovat i jestli je modul FAP protoze u dobropisu muze byt prijem/vydej opacne
    for idFak in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabB = NEW.idDoklSklad and modulA = 'FAP' and
            compareId((select idProtiUcet from dDoklFak where idDoklFak = idTabA), NEW.idProtiUcet) = false)
    loop
        execute dNastavUcetDokladu(0, idFak, 1, NEW.idProtiUcet);
    end loop;

    for idPok in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabB = NEW.idDoklSklad and 
            compareId((select idProtiUcet from dDoklInt where idDoklInt = idTabA), NEW.idProtiUcet) = false) 
    loop 
        execute dNastavUcetDokladu(1, idPok, 1, NEW.idProtiUcet); 
    end loop; 
 
    for idSklad in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSklPrevod' and idTabB = NEW.idDoklSklad and 
            compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabA), NEW.idProtiUcet) = false) 
    loop 
        execute dNastavUcetDokladu(2, idSklad, 1, NEW.idProtiUcet); 
    end loop;

   /*for idSklad in (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSklKus' and idTabA = NEW.idDoklSklad and
            compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabB), NEW.idProtiUcet) = false)
    loop
        execute dNastavUcetDokladu(2, idSklad, 1, NEW.idProtiUcet);
    end loop;*/

  else
    /*if (NEW.typPohybuK = 'typPohybu.vydej' and compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then

      for idSklad in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSklKus' and idTabB = NEW.idDoklSklad and
              compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabA), NEW.idProtiUcet) = false)
      loop
          execute dNastavUcetDokladu(2, idSklad, 1, NEW.idProtiUcet);
      end loop;

    end if;*/

    if (NEW.typPohybuK = 'typPohybu.vydej' and compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then

      for idSklad in (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSklPrevod' and idTabA = NEW.idDoklSklad and 
              compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabB), NEW.idProtiUcet) = false) 
      loop 
          execute dNastavUcetDokladu(2, idSklad, 1, NEW.idProtiUcet); 
      end loop; 

    end if;
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ddoklskladupdateucty() OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION dpolfakupdateucty() RETURNS trigger AS $$  
declare typPohyb character varying(50);  
        nelzeZmena int;  
        idDokl int;  
begin  
  if (NEW.typPolozkyK = 'typPolozky.katalog' and compareid(NEW.idzklmducet, OLD.idzklmducet) = false) then  
      -- nacteni typu pohybu  
      select typPohybuK into typPohyb from dDoklFak where idDoklFak = NEW.idDoklFak;  
  
      -- prijata faktura  
      if (typPohyb = 'typPohybu.vydej') then  
        -- zjistime zda neexistujou nake co nesmime zmenit  
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and  
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.polozkaSkl');  
        -- pokud smime zmenit vsechny polozky co potrebujeme menime  
        if (nelzeZmena = 0) then  
          update dPolSklad set idZklDalUcet = NEW.idZklMdUcet where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and idPolSklad in  
            (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.polozkaSkl');  
        else  
          raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky.';  
        end if;  
      end if;  
  end if;  
  
  if (NEW.typPolozkyK in ('typPolozky.odpocetZdd','typPolozky.odpocetZalohy')) then  
      -- nacteni typu pohybu  
      select typPohybuK into typPohyb from dDoklFak where idDoklFak = NEW.idDoklFak;  
  
      -- vydana faktura  
      if (typPohyb = 'typPohybu.prijem') then  
        -- meni se ucet zakladu  
        if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idProtiUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idZklDalUcet) = false)  
            loop  
                execute dNastavUcetDokladu(0, idDokl, 1, NEW.idZklDalUcet);  
            end loop;  
          end if;  
          -- polozka odpocitava zalohu  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then  
            for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idZklDalUcet) = false and idDoklInt in  
                (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA in  
                  (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.odpocetZALOHY')))  
            loop  
                execute dNastavUcetDokladu(1, idDokl, 1, NEW.idZklDalUcet);  
            end loop;  
          end if;  
        end if;    -- konec zmena uctu zakladu  
  
        -- meni se ucet dane  
        if (compareId(NEW.idDphDalUcet, OLD.idDphDalUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            -- dph je zakladni  
            if (NEW.typSzbDphK = 'typSzbDph.dphZakl') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idDphZaklUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphDalUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 2, NEW.idDphDalUcet);  
              end loop;  
            end if;   -- konec dph zakladni  
  
            -- dph je snizena  
            if (NEW.typSzbDphK = 'typSzbDph.dphSniz') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                    compareId((select idDphSnizUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphDalUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 3, NEW.idDphDalUcet);  
              end loop;  
            end if;-- konec dph snizena  
          end if;  -- konec odpocet zdd  
        end if;    -- konec zmena uctu dane  
  
      end if;      -- konec jedna se o vydanou fakturu  
  
      --------------------------------------------------------------------------  
      -- prijata faktura  
      if (typPohyb = 'typPohybu.vydej') then  
        -- meni se ucet zakladu  
        if (compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idProtiUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idZklMdUcet) = false)  
            loop  
                execute dNastavUcetDokladu(0, idDokl, 1, NEW.idZklMdUcet);  
            end loop;  
          end if;  
  
          -- polozka odpocitava zalohu  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then  
            for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idZklMdUcet) = false and idDoklInt in  
                (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA in  
                  (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.odpocetZALOHY')))  
            loop  
                execute dNastavUcetDokladu(1, idDokl, 1, NEW.idZklMdUcet);  
            end loop;  
          end if;  
        end if;    -- konec zmena uctu zakladu  
  
        -- meni se ucet dane  
        if (compareId(NEW.idDphMdUcet, OLD.idDphMdUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            -- dph je zakladni  
            if (NEW.typSzbDphK = 'typSzbDph.dphZakl') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idDphZaklUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphMdUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 2, NEW.idDphMdUcet);  
              end loop;  
  
            end if;   -- konec dph zakladni  
  
            -- dph je snizena  
            if (NEW.typSzbDphK = 'typSzbDph.dphSniz') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                    compareId((select idDphSnizUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphMdUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 3, NEW.idDphMdUcet);  
              end loop;  
            end if;-- konec dph snizena  
          end if;  -- konec odpocet zdd  
        end if;    -- konec zmena uctu dane  
  
      end if;      -- konec jedna se o prijatou fakturu  
  
  end if;       -- konec podminky na typ dokladu  
  
  return NEW;  
end;  
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolfakupdateucty() OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION ddoklfakupdateucty() RETURNS trigger AS $$  
declare nelzeZmena int;  
        idDokl int;  
begin  
  nelzeZmena := 0;  
    
  --pokud dojde ke zmene primarniho uctu  
  if (compareId(NEW.idPrimUcet, OLD.idPrimUcet) = false) then  
    -- uprava banka/pokladna vazbami uhrada a vazbaZDD, pouze pokud ucet nesouhlasi aby nedochazelo k zacykleni  
    for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idPrimUcet) = false and idDoklInt in  
        (select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhrada','typVazbyDokl.vazbaZDD')))  
    loop  
        execute dNastavUcetDokladu(1, idDokl, 1, NEW.idPrimUcet);  
    end loop;  
  
    -- uhradaKR, preceneni - u kurzoveho rozdilu a preceneni nevim na ktere strane je hledany ucet, testuji oba  
    for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idPrimUcet) = false and compareId(idProtiUcet, OLD.idPrimUcet) = true and idDoklInt in  
        (select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))  
    loop  
        execute dNastavUcetDokladu(1, idDokl, 1, NEW.idPrimUcet);  
    end loop;  
  
    for idDokl in (select idDoklInt from dDoklInt where compareId(idPrimUcet,  NEW.idPrimUcet) = false and compareId(idPrimUcet,  OLD.idPrimUcet) = true and idDoklInt in  
        (select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))  
    loop  
        execute dNastavUcetDokladu(1, idDokl, 0, NEW.idPrimUcet);  
    end loop;  
  end if;  
  
  --pokud dojde ke zmene protiuctu (doklad je zdd menime ucty odpoctu)  
  if (compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then  
    if (NEW.typPohybuK = 'typPohybu.prijem') then             -- kdyz je to faktura vydana  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idZklDalUcet, NEW.idProtiUcet) = false and kopZklDalUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set idZklDalUcet = NEW.idProtiUcet where compareId(idZklDalUcet, NEW.idProtiUcet) = false and idPolFak in  
            (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  
    if (NEW.typPohybuK = 'typPohybu.vydej') then             -- kdyz je to faktura prijata  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idZklMdUcet, NEW.idProtiUcet) = false and kopZklMdUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set idZklMdUcet = NEW.idProtiUcet where compareId(idZklMdUcet, NEW.idProtiUcet) = false and idPolFak in  
            (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
  
      -- vazba na sklad  
      for idDokl in (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabA = NEW.idDoklFak and   
            compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabB), NEW.idProtiUcet) = false)  
      loop  
        execute dNastavUcetDokladu(2, idDokl, 1, NEW.idProtiUcet);  
      end loop;  
    end if;  
  end if;  
  
  --pokud dojde ke zmene protiuctu zakladni sazby dph (doklad je zdd menime ucty odpoctu)  
  if (compareId(NEW.idDphZaklUcet, OLD.idDphZaklUcet) = false and nelzeZmena = 0) then  
    if (NEW.typPohybuK = 'typPohybu.prijem') then             -- kdyz je to faktura vydana  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idDphDalUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and kopDphDalUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set idDphDalUcet = NEW.idDphZaklUcet where compareId(idDphDalUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and   
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  
    if (NEW.typPohybuK = 'typPohybu.vydej') then             -- kdyz je to faktura prijata  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idDphMdUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and kopDphMdUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set idDphMdUcet = NEW.idDphZaklUcet where compareId(idDphMdUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and   
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  end if;  
  
  --pokud dojde ke zmene protiuctu snizene sazby dph (doklad je zdd menime ucty odpoctu)  
  if (compareId(NEW.idDphSnizUcet, OLD.idDphSnizUcet) = false and nelzeZmena = 0) then  
    if (NEW.typPohybuK = 'typPohybu.prijem') then             -- kdyz je to faktura vydana  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idDphDalUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and kopDphDalUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set idDphDalUcet = NEW.idDphSnizUcet where compareId(idDphDalUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and   
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  
    if (NEW.typPohybuK = 'typPohybu.vydej') then             -- kdyz je to faktura prijata  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idDphMdUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and kopDphMdUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set idDphMdUcet = NEW.idDphSnizUcet where compareId(idDphMdUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and   
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  end if;  
  
  if (nelzeZmena > 0) then  
    raise exception '0008:dDoklFakUpdateUcty(): Nelze zmenit ucet u navazane polozky.';  
  end if;  
  
  return NEW;  
end;  
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ddoklfakupdateucty() OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION dpolskladupdateucty() RETURNS trigger AS $$
declare
  nelzeZmena int;
  _modul character varying;
begin
  if ((select typPohybuK from dDoklSklad where idDoklSklad = NEW.idDoklSklad) = 'typPohybu.prijem') then
    -- z prijemky se pres vazbu polozkaSklPrevod ma prenaset ucet zklDal na vydejku zklMd
    if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false and NEW.kopZklDalUcet = false) then
      select modulA into _modul from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod';
      if(_modul like 'SKL') then
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and 
          idPolSklad in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        if (nelzeZmena = 0) then 
          update dPolSklad set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and 
            idPolSklad in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        else 
          raise exception '0008:dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.'; 
        end if;
      end if;
    end if;
  else
    -- z vydejky se ma pres vazbu polozkaSklPrevod ma prenaset ucet zklMd na ucet zklDal
    if (compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false and NEW.kopZklMdUcet = false) then
      select modulB into _modul from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod';
      if(_modul like 'SKL') then
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and 
          idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        if (nelzeZmena = 0) then 
          update dPolSklad set idZklDalUcet = NEW.idZklMdUcet where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and 
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        else 
          raise exception '0008:dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.'; 
        end if;
      end if;
    end if;
  end if;

  if ((select typPohybuK from dDoklSklad where idDoklSklad = NEW.idDoklSklad) = 'typPohybu.prijem') then 
    if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false and NEW.kopZklDalUcet = false) then
      select modulA into _modul from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl';
      if(_modul like 'POK') then
        select count(*) into nelzeZmena from dPolInt where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and
          idPolInt in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
        
        if (nelzeZmena = 0) then
          update dPolInt set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and
            idPolInt in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
        else
          raise exception '0008:dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.';
        end if;
      else
        if _modul = 'FAP' then
          select count(*) into nelzeZmena from dPolFak where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
          
          if (nelzeZmena = 0) then
            update dPolFak set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and
              idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl');
          else
            raise exception '0008:dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.';
          end if;
        end if;
      end if;

    end if;
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolskladupdateucty() OWNER TO %firmaRole%;





CREATE OR REPLACE FUNCTION fillPolSkladSada(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$ 
declare 
  _polDokl record; 
  _polSklad record; 
  _idDoklad integer; 
  _typPohybuK character varying; 
  _typPohybuSklad character varying; 
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _mnozMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _idDoklSklad integer; 
  _idUcetObdobi integer; 
  _idKarty integer; 
  _sklad record; 
  _kurz numeric(19,6); 
  _prumCenaTuz numeric(19,6); 
  _isCiziMena boolean; 
  _typDoklK character varying; 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
begin
  if(_modul like 'POK') then 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  else 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  end if; 

  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad; 
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
  end if; 

  for _polSklad in  
    select * from dPolSklad where idPolSklad in ( 
      select idTabB from dvazebtab where 
        typVazbyK like 'typVazbyDokl.polozkaSklSada'  
        and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL' 
    ) 
  loop 
    select typPohybuK into _typPohybuSklad from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;  
 
    select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
    select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idtypdokl = _polDokl.idskladu and iducetobdobi = _iducetobdobi; 
    select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu; 
   
    select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
    select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
    select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _polSklad.cenaMj; 
    _mnozMj = _polSklad.mnozMj; 
    _sumZkl = _polSklad.sumZkl; 
    _sumZklMen = _polSklad.sumZklMen; 
    -- nastaveni uctu pro polSklad vydej 
    --TODO doresit zklMdUcet;
    --select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet; 
    _idZklDalUcet = _sklad.idPrimUcet; 
   
    update dPolSklad set  
      lastUpdate = LOCALTIMESTAMP,  
      cenaMj = _cenaMj,  
      mnozMj = _mnozMj,  
      sumZkl = _sumZkl,  
      sumZklMen = _sumZklMen,  
      --nazev = _polDokl.nazev,  
      --nazevA = _polDokl.nazevA,  
      --nazevB = _polDokl.nazevB,  
      --nazevC = _polDokl.nazevC,  
      datVyst = _polDokl.datVyst,  
      datUcto = _polDokl.datVyst,
      baleniId = _polDokl.baleniId,  
      mnozBaleni = _polDokl.mnozBaleni,  
      --sarze = _polDokl.sarze,  
      --expirace = _polDokl.expirace,  
      --cisRad = _polDokl.cisRad,  
      --eankod = _polDokl.eanKod,  
      --idmj = _polDokl.idmj,  
      idStred = _polDokl.idStred,  
      idMeny = _polSklad.idMeny,  
      idZakazky = _polDokl.idZakazky,  
      --idZklMdUcet = _idZklMdUcet,  
      --idZklDalUcet = _idZklDalUcet,
      ucetni = true 
      where idPolSklad = _polSklad.idPolSklad; 
  end loop;
  --return _idPolSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillpolskladsada(integer, character varying) OWNER TO %firmaRole%;




CREATE OR REPLACE FUNCTION fillPolSklad(_idPolSklad integer, _idPolDokl integer, _modul character varying) RETURNS integer AS
$BODY$
declare
  _polDokl record;
  _polSklad record;
  _idDoklad integer;
  _typPohybuK character varying;
  _typPohybuSklad character varying;
  _cenaMj numeric(19,6);
  _cenaMjTuz numeric(19,6);
  _mnozMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _idDoklSklad integer;
  _idUcetObdobi integer;
  _idKarty integer;
  _sklad record;
  _kurz numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _isCiziMena boolean;
  _typDoklK character varying;
  _idZklMdUcet integer;
  _idZklDalUcet integer;
begin
  if(_modul like 'POK') then
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou
  else
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);
  end if;

  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad;
  
  if(_idDoklSklad is null) then
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;
  end if;

  select * into _polSklad from dPolSklad where idPolSklad = _idPolSklad;
  select typPohybuK into _typPohybuSklad from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;

  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idtypdokl = _polDokl.idskladu and iducetobdobi = _iducetobdobi;
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu;
  
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;

  if(_typPohybuSklad like 'typPohybu.vydej') then
    -- vsechny dobropisy generuji prijemky
    --if(_typDoklK like 'typDokladu.dobropis') then
    --  _mnozMj = -_polDokl.mnozMj;
    --else
      _mnozMj = _polDokl.mnozMj;
    --end if;
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena
    _cenaMj = _polSklad.cenaMj;
    _sumZkl = _polSklad.sumZkl;
    _sumZklMen = _polSklad.sumZklMen;
    -- nastaveni uctu pro polSklad vydej
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet;
    _idZklDalUcet = _sklad.idPrimUcet;
  else
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny;
      _mnozMj = -_polDokl.mnozMj;
      _cenaMjTuz = _polDokl.cenaMjNakup; 
      if(_cenaMjTuz = 0.0) then
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik);
        if(_cenaMj = 0.0) then
          _cenaMj = _polDokl.cenaMj * _kurz;
        end if;
      end if;
      _cenaMj = _cenaMjTuz / _kurz;
      _sumZkl = _mnozMj * _cenaMjTuz;
      if(_isCiziMena) then
        _sumZklMen = _mnozMj * _cenaMj;
      else
        _sumZklMen = 0.0;
      end if;
    else
      -- pokud na sklad prijmam zkopiruji se ceny z faktury
      _mnozMj = _polDokl.mnozMj;
      _sumZkl = _polDokl.sumZkl;
      if(_mnozMj <> 0.0) then
        _cenaMj = _sumZkl / _mnozMj;
      else
        _cenaMj = _sumZkl;
      end if;
      _cenaMj = _cenaMj / _kurz;
      if(_isCiziMena) then
        if(_mnozMj <> 0.0) then
          _sumZklMen = _cenaMj * _mnozMj;  
        else
          _sumZklMen = _cenaMj;
        end if;
      else
        _sumZklMen = 0.0;  
      end if; 
    end if;
    -- nastaveni uctu pro polSklad prijem
    _idZklMdUcet = _sklad.idPrimUcet;
    _idZklDalUcet = _polDokl.idZklMdUcet;
  end if;


  if(_polSklad.cenaMj <> _cenaMj or _polSklad.sumZkl <> _sumZkl or _polSklad.sumZklMen <> _sumZklMen
    or not compareVarchar(_polSklad.nazev, _polDokl.nazev)
    or not compareVarchar(_polSklad.nazevA, _polDokl.nazevA)
    or not compareVarchar(_polSklad.nazevB, _polDokl.nazevB)
    or not compareVarchar(_polSklad.nazevC, _polDokl.nazevC)
    or not compareDate(_polSklad.datVyst, _polDokl.datVyst)
    or not compareDate(_polSklad.datUcto, _polDokl.datVyst)
    or not compareId(_polSklad.baleniId, _polDokl.baleniId)
    or not compareNumeric(_polSklad.mnozBaleni, _polDokl.mnozBaleni)
    or not compareVarchar(_polSklad.sarze, _polDokl.sarze)
    or not compareDate(_polSklad.expirace, _polDokl.expirace)
    or not compareId(_polSklad.cisRad, _polDokl.cisRad)
    or not compareVarchar(_polSklad.eankod, _polDokl.eanKod)
    or not compareId(_polSklad.idmj, _polDokl.idmj)
    or not compareId(_polSklad.idStred, _polDokl.idStred)
    or not compareId(_polSklad.idZakazky, _polDokl.idZakazky)
    or not compareId(_polSklad.idZklMdUcet, _idZklMdUcet)
    or not compareId(_polSklad.idZklDalUcet, _idZklDalUcet) )
  then
    update dPolSklad set
      lastUpdate = LOCALTIMESTAMP,
      cenaMj = _cenaMj,
      --mnozMj = _mnozMj,
      sumZkl = _sumZkl,
      sumZklMen = _sumZklMen,
      nazev = _polDokl.nazev,
      nazevA = _polDokl.nazevA,
      nazevB = _polDokl.nazevB,
      nazevC = _polDokl.nazevC,
      datVyst = _polDokl.datVyst,
      datUcto = _polDokl.datVyst,
      baleniId = _polDokl.baleniId,
      mnozBaleni = _polDokl.mnozBaleni,
      sarze = _polDokl.sarze,
      expirace = _polDokl.expirace,
      cisRad = _polDokl.cisRad,
      eankod = _polDokl.eanKod,
      idmj = _polDokl.idmj,
      idStred = _polDokl.idStred,
      idMeny = _polSklad.idMeny,
      idZakazky = _polDokl.idZakazky,
      --idZklMdUcet = _idZklMdUcet,
      --idZklDalUcet = _idZklDalUcet,
      ucetni = true
      where idPolSklad = _idPolSklad;
  end if;

  return _idPolSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillPolSklad(integer, integer, character varying) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 404, 't');
