-----------------------------------------------------------------------------------------------
-- Bug 22702 – [winstrom] - Tvorba výdejky z příjmu výrobku - rozpad kusovníku - špatně účtuje
-----------------------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dpolskladinsertkusovnik(i_idPolSklad integer)
  RETURNS integer AS
$BODY$
declare
    _polSklad record;
    _typPohybuK varchar;
    _typZasobyK varchar;
    _skladove boolean;
    _idKusovnik integer;
    _iducetobdobi integer;
    _stavNaSklade numeric;
    _sklKarta record;
    _cenik record;
    _sklzapor boolean;
    _idVydejPolSklad integer;
    _idParovanyDoklad integer;
    potKus record;
    _parKusMnoz numeric;
    _i integer;
    _kurz numeric;
    _isCiziMena boolean;
    _idMeny integer;
    _mnozMj numeric;
    _cenaMj numeric;
    _sumZkl numeric;
    _newSumZkl numeric;
    _sumZklMen numeric;
    _idSkladPotKus integer;
    _idProtiUcetDoklad integer;
    _idStred integer;
    _kopStred boolean;
    _sklad record;
    _typPohybuSkladK character varying;
    _cenaMjSkl numeric(19,6);
    _cenaMjNeskl numeric(19,6);
    _navazanaPolSklad record;
    _rozpadlaPolSklad record;
    _kurzDokladu numeric;
begin
  select * into _polSklad from dpolsklad where idpolsklad = i_idpolSklad;

  -- napriklad pokud se jedna o prevodku mezi sklady nechceme z prijemky vytvaret prevodku
  if (_polSklad.prevodka = true) then
    return null;
  end if;

  -- typem pohybu musi byt prijem
  select typpohybuk into _typPohybuK from ddoklsklad d where d.iddoklsklad = _polSklad.iddoklsklad;
  if (_typPohybuK <> 'typPohybu.prijem') then
    return null;
  end if;

  -- pokud neni nastaven typ pohybu sklad prijem z vyroby tak koncime
  select typpohybuskladk into _typPohybuSkladK from ddoklsklad d where d.iddoklsklad = _polSklad.iddoklsklad;
  if(_typPohybuSkladK is null or _typPohybuSkladK <> 'typPohybuSklad.prijemVyrob') then
    return null;
  end if;

  -- idcenik odkazuje na neco co je soucasti kusovniku.
  select ckus.idkusovnik into _idKusovnik from ckusovnik ckus where ckus.idcenik = _polSklad.idcenik
    and exists (select 1 from ckusovnik cPot where cPot.idotec = ckus.idkusovnik);
  if (_idKusovnik is null) then
    return null;
  end if;

  -- vytvorime nebo nalezneme zparovany doklad skl vydej
  select findparovanydoklsklad(_polSklad.iddoklsklad, _polSklad.modul, 'typVazbyDokl.hlavaSklKus') into _idParovanyDoklad;
  if (_idParovanyDoklad is null) then
    select createdoklsklad(_polSklad.idpolsklad, _polSklad.iddoklsklad, _polSklad.modul) into _idParovanyDoklad;
  end if;

  if(_idParovanyDoklad is null) then
    return null;
  end if;

  select isDoklSkladMenaCizi(_idParovanyDoklad, _polSklad.datVyst) into _isCiziMena;
  select getkurzfromdoklad(_idParovanyDoklad, _polSklad.datVyst) into _kurz;
  select idMeny into _idMeny from dDoklSklad where idDoklSklad = _idParovanyDoklad;

  _i = 0;
  _newSumZkl = 0.0;
  _cenaMjSkl = 0.0;
  _cenaMjNeskl = 0.0;

  perform putglotxvariable('zurnalTxName', 'rozpadKusovniku');

  -- pro vsechny kusovniky, ktere jsou pod nasim kusovnikem a jsou skladove nebo vyroba a nemaji nulove mnozstvi
  for potKus in (select * from ckusovnik cPot where cPot.idotec = _idKusovnik and cPot.mnoz > 0.0) loop
    select * into _cenik from cCenik where idCenik = potKus.idCenik;

    select mnoz into _parKusMnoz from ckusovnik where idkusovnik = _idKusovnik;

    select skladove into _skladove from cCenik cen where cen.idCenik = potKus.idCenik;
    if (not _skladove) then
        _newSumZkl = _newSumZkl + ((_cenik.nakupcena * potKus.mnoz * _polSklad.mnozMj) / _parKusMnoz);
        _cenaMjNeskl = _cenaMjNeskl + ((_cenik.nakupcena * potKus.mnoz) / _parKusMnoz);
        continue;
    end if;
    _i = _i + 1;

    select findIdUcetniObdobiKDatu(_polSklad.datVyst) into _iducetobdobi;
    -- vybereme skladovou kartu podle preferovaneho skladu
    select null into _sklKarta;
    _idSkladPotKus = null;

    select getPrefIdSkladu(
	(select idstred from ddoklsklad where iddoklsklad = _polSklad.iddoklsklad),
	_cenik.idskupzboz, potKus.idcenik) into _idSkladPotKus;

    if (_idSkladPotKus is not null) then
	select * into _sklKarta from skarty where idcenik = potKus.idcenik and idSkladu = _idSkladPotKus and iducetobdobi = _iducetobdobi;
    end if;

    -- sklad karta nebyla nalezena podle preferovaneho skladu, vezmeme sklad stejny jako z vytvarene polozky
    if (_sklKarta is null) then
	select * into _sklKarta from skarty where idcenik = potKus.idcenik and idSkladu = _polSklad.idBspSkl and iducetobdobi = _iducetobdobi;
	select _polSklad.idStred into _idStred;
	select _polSklad.kopstred into _kopStred;
    else
        select idstred into _idStred from dbsp d where _sklKarta.idskladu = d.idbsp;
	select false into _kopStred;
    end if;

    -- skladovou
    if (_sklKarta is null) then
	raise exception 'Nebyla nalezena skladova karta k polozce ceniku %. Definujte mapovani skladu pro tuto polozku nebo ji pridejte na sklad %',
		_cenik.kod, (select kod from dtypdokl where idtypdokl = _polSklad.idskladu);
    end if;

   _mnozMj = (potKus.mnoz / _parKusMnoz) * _polSklad.mnozMj;
   _cenaMj = _sklKarta.prumCenaTuz / _kurz;
   _sumZkl = _mnozMj * _sklKarta.prumCenaTuz;
   _cenaMjSkl = _cenaMjSkl + (_cenaMj * (potKus.mnoz / _parKusMnoz));
   _newSumZkl = _newSumZkl + _sumZkl;

   if(_isCiziMena) then
     _sumZklMen = _mnozMj * _cenaMj;
   else
     _sumZklMen = 0.0;
   end if;

    -- TODO doplnit sarze a expirace
    select dgetstavnasklade(_sklKarta.idkarty, _polSklad.datVyst, -1, _polSklad.idfirmy, NULL, NULL) into _stavNaSklade;

    -- osetreni zda je povoleny zaporny stav na sklade
    if (_stavNaSklade - _mnozMj < 0) then
        select sklzapor into _sklzapor from nNastav where _polSklad.datVyst >= PlatiOdData order by PlatiOdData desc limit 1;
        if (_sklzapor is null) then
            select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1;
        end if;
        if _sklzapor is null or _sklzapor = false then
            raise exception '0002:sPreporctiSkladKartu: neni povolen zaporny stav skladu';
        end if;
    end if;

    select nextval('seq_dpolsklad'::regclass) into _idVydejPolSklad;

    if(_cenik.idskupzboz is not null) then
      select idprotiucetsklv into _idProtiUcetDoklad from cskupzboz where idskupzboz = _cenik.idskupzboz;
    end if;
    if(_idProtiUcetDoklad is null) then
      select idprotiucet into _idProtiUcetDoklad from ddoklsklad where iddoklsklad = _idParovanyDoklad;
    end if;

    select * into _sklad from dBsp where _sklKarta.idSkladu = idBsp;

    insert into dpolsklad(idPolSklad, idcenik, idBspSkl, idkarty, datVyst, datUcto, modul, typPolozkyK, idDoklSklad,
        mnozMj, cenaMj, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni,
        nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni, idStred, idZakazky, idMeny, kopstred)
    values (_idVydejPolSklad, potKus.idcenik, _sklKarta.idSkladu, _sklKarta.idkarty, _polSklad.datVyst, _polSklad.datUcto, _polSklad.modul, _polSklad.typpolozkyk, _idParovanyDoklad,
        _mnozMj, _cenaMj, _sumZkl, _sumZklMen, _idProtiUcetDoklad, _sklad.idprimucet, false, false, _polSklad.baleniid, _polSklad.mnozbaleni,
        _cenik.nazev, _cenik.nazevA, _cenik.nazevB, _cenik.nazevC, NULL, NULL, _polSklad.cisRad * 100 + _i, true,
        _idStred, _polSklad.idZakazky, _idMeny, _kopStred);

    insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)
      values (0.0, _polSklad.idpolsklad, _idVydejPolSklad, 'SKL', 'SKL', false, 'typVazbyDokl.polozkaSklKus');

  end loop;

  perform removeglotxvariable('zurnalTxName');

  select getkurzfromdoklad(_polSklad.iddoklsklad, _polSklad.datvyst) into _kurz;
  _cenaMj = _newSumZkl / _polSklad.mnozMj / _kurz;

  select isDoklSkladMenaCizi(_polSklad.iddoklsklad, _polSklad.datVyst) into _isCiziMena;
  if (_isCiziMena) then
    _sumZklMen = _polSklad.cenaMj * _polSklad.mnozMj;
  else
    _sumZklMen = 0.0;
  end if;


  select getKurzFromDoklad(_polSklad.idDoklSklad, _polSklad.datVyst) into _kurzDokladu;
  _cenaMjSkl = 0.0;
  _cenaMj = _cenaMjNeskl;
  _sumZkl = _cenaMjNeskl * _polSklad.mnozMj;
  for _navazanaPolSklad in (select * from dPolSklad where idPolSklad in
    (select idTabB from dvazebtab where idTabA = _polSklad.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus') )
    loop
      if(_navazanaPolSklad.mnozMj <> 0.0) then
        _cenaMj = _cenaMj + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
        _cenaMjSkl = _cenaMjSkl + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
      else
        raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
      end if;
      _sumZkl = _sumZkl + _navazanaPolSklad.sumZkl;

      -- musime zohlednit i pripadne rozpady skladovych polozek
      for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in
        (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad))
        loop
          if(_rozpadlaPolSklad.mnozMj <> 0.0) then
            _cenaMj = _cenaMj + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
            _cenaMjSkl = _cenaMjSkl + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
          else
            raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
          end if;
          _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl;
      end loop;
  end loop;

  update dpolsklad set
       sumzkl = _sumZkl,
       cenaMj = _cenaMj,
       --sumZklMen = _sumZklMen,
       cenaMjSkl = _cenaMjSkl,
       cenaMjNeskl = _cenaMjNeskl
     where idpolsklad = _polSklad.idpolsklad;

  execute sprepoctisumydokladu(_polSklad.idDoklSklad);

  return _polSklad.idPolSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsertkusovnik(integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 444, 't', %appVersion%, clock_timestamp());
