--------------------------------------------------------------------------------
-- Bug 22941 – [winstrom] 1 - Sumace dokladů v modulu prodej
--------------------------------------------------------------------------------

alter table ddoklfak add column sumNaklady numeric(15,2) not null default 0.0;
alter table ddoklsklad add column sumNaklady numeric(15,2) not null default 0.0;
alter table ddoklint add column sumNaklady numeric(15,2) not null default 0.0;

CREATE OR REPLACE FUNCTION dpoldoklupdatesumNaklady()
  RETURNS trigger AS
$BODY$
declare
begin
  if(OLD.cenaMjNakup = NEW.cenaMjNakup and OLD.mnozMj = NEW.mnozMj) then
    return NEW;
  end if;
  if(NEW.modul = 'FAV') then
    update ddoklfak set
      sumNaklady = sumNaklady - round(OLD.mnozMj * OLD.cenaMjNakup, 2) + round(NEW.mnozMj * NEW.cenaMjNakup, 2)
      where idDoklFak = NEW.idDoklFak;
  elsif(NEW.modul = 'POK') then
    update ddoklint set
      sumNaklady = sumNaklady - round(OLD.mnozMj * OLD.cenaMjNakup, 2) + round(NEW.mnozMj * NEW.cenaMjNakup, 2)
      where idDoklInt = NEW.idDoklInt;
  end if;
  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklupdatesumNaklady() OWNER TO %firmaRole%;


CREATE TRIGGER dpolfakupdatesumNaklady
  AFTER UPDATE
  ON dpolfak
  FOR EACH ROW
  EXECUTE PROCEDURE dpoldoklupdatesumNaklady();


CREATE TRIGGER dpolintupdatesumNaklady
  AFTER UPDATE
  ON dpolint
  FOR EACH ROW
  EXECUTE PROCEDURE dpoldoklupdatesumNaklady();



-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 456, 't', %appVersion%, clock_timestamp());
