--------------------------------------------------------------------------------
-- Bug 23723 – [winstrom] -Zboží - Skladové karty - Doplnit pole název
--------------------------------------------------------------------------------

ALTER TABLE skarty
  ADD COLUMN nazev character varying(255),
  ADD COLUMN nazeva character varying(255),
  ADD COLUMN nazevb character varying(255),
  ADD COLUMN nazevc character varying(255);


UPDATE skarty AS k
SET nazev = c.nazev, nazeva = c.nazeva, nazevb = c.nazevb, nazevc = c.nazevc
FROM ccenik AS c
WHERE k.idcenik = c.idcenik;


CREATE OR REPLACE FUNCTION ccenikupdateskarta()
  RETURNS trigger AS $$
begin
  IF ( not compareVarchar(NEW.nazev, OLD.nazev) OR
        not compareVarchar(NEW.nazeva, OLD.nazeva) OR
        not compareVarchar(NEW.nazevb, OLD.nazevb) OR
        not compareVarchar(NEW.nazevc, OLD.nazevc) ) THEN 
    UPDATE skarty
    SET nazev = NEW.nazev, nazeva = NEW.nazeva, nazevb = NEW.nazevb, nazevc = NEW.nazevc
    WHERE idcenik = NEW.idcenik;
  END IF; 
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
--ALTER FUNCTION public.dpolfakupdatedanevid() OWNER TO %firmaRole%;   puvodne chybny vlastnik
ALTER FUNCTION public.ccenikupdateskarta() OWNER TO %firmaRole%;

CREATE TRIGGER ccenikupdateskarta AFTER UPDATE ON ccenik
  FOR EACH ROW EXECUTE PROCEDURE ccenikupdateskarta();


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 476, 't', %appVersion%, clock_timestamp());
