-------------------------------------------------------------------------------------------------------------------------------------------------
-- Bug 23875 – [winstrom] - Požadavky na výdej - vytvoření faktury na zboží, které není na skladě - následně výdejku s evidencí těchto požadavků
-------------------------------------------------------------------------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dcanulozitpolozku(i_skladkartaid integer, i_datum date, i_polskladid integer, i_mnozmj numeric, i_typpohybuk character varying, i_adresarid integer, i_sarze character varying, i_expirace date) RETURNS boolean
    AS $$ 
declare 
  _stavMjKDatu numeric(19,6); 
  zaznam Record; 
  loc_MnozMj numeric(19,6); 
  _sklzapor boolean;  
begin 
  /* nahrajeme stav skladu pred danou menenou nebo pridavanou prijmenkou nebo vydejkou */ 
  _stavMjKDatu := (select dGetStavNaSklade(i_SkladKartaId, i_datum, i_PolSkladId, i_adresarid, i_sarze, i_expirace, i_typPohybuK)); 
 
  loc_MnozMj := i_MnozMj; 
  /* pokud jde o vydej musim odecitat */   
  if i_TypPohybuK = 'typPohybu.vydej' then   
    loc_MnozMj := 0-loc_MnozMj;   
  end if; 
   
  /* pridam k tomuto stavu mnozstvi mj na pridavane polozce*/ 
  _stavMjKDatu := _stavMjKDatu + loc_MnozMj; 
 
  /* provedu kontrolu na zaporny stav skladu */ 
  if _stavMjKDatu < 0 then  
    select sklzapor into _sklzapor from nNastav where i_datum >= PlatiOdData order by PlatiOdData desc limit 1;  
    if (_sklzapor is null) then  
      select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1;   
    end if;  
    if _sklzapor is null or _sklzapor = false then  
      return false;  
    end if;  
  end if;  
   
  /*-------------------------------------------------------------------------------------------------------------------------------------------*/ 
  /* a zacnu se pokouset pricist nasledujici polozky */ 
  for zaznam in select * from dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad 
    where ps.datUcto >= i_datum and ps.idKarty = i_SkladKartaId and ps.idPolSklad > i_PolSkladId order by ps.datUcto asc  
    loop   
     
    loc_MnozMJ := zaznam.MnozMJ; 
     
    /* pokud jde o vydej musim odecitat */   
    if zaznam.typPohybuK = 'typPohybu.vydej' then   
      loc_MnozMJ := 0-loc_MnozMJ;   
    end if; 
 
    /* prictu mnozstvi an dane polozce */  
    _stavMjKDatu = _stavMjKDatu + loc_MnozMJ; 
 
    /* provedu kontrolu na zaporny stav skladu */ 
    if _stavMjKDatu < 0 then  
      select sklzapor into _sklzapor from nNastav where zaznam.DatUcto >= PlatiOdData order by PlatiOdData desc limit 1;  
      if (_sklzapor is null) then  
	select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1;   
      end if;  
      if _sklzapor is null or _sklzapor = false then  
        return false;  
      end if;  
    end if;  
 
  end loop;  
 
  return true;  
end 
$$
    LANGUAGE plpgsql;
ALTER FUNCTION public.dcanulozitpolozku(i_skladkartaid integer, i_datum date, i_polskladid integer, i_mnozmj numeric, i_typpohybuk character varying, i_adresarid integer, i_sarze character varying, i_expirace date) OWNER TO %firmaRole%;


DROP FUNCTION dgetstavnasklade(integer, date, integer, character varying, date);


CREATE OR REPLACE FUNCTION dpolskladupdate()
  RETURNS trigger AS
$BODY$ 
declare 
  tmp_rozsirenepolozky_exists boolean; 
  _updatuj boolean; 
  _pocetPolozek integer; 
  _rozsirenaPolozka record; 
  _sklFifo boolean; 
  _vypnutySklad character varying;
  _mazatTmpTable boolean; 
begin 
  if(NEW.idBspSkl = OLD.idBspSkl and NEW.idCenik = OLD.idCenik and comparedate(NEW.datVyst, OLD.datVyst)
    and comparevarchar(NEW.typPolozkyK, OLD.typPolozkyK)
    and comparevarchar(NEW.sarze, OLD.sarze) and comparedate(NEW.expirace, OLD.expirace)
    and NEW.mnozMj = OLD.mnozMj and NEW.cenaMj = OLD.cenaMj and NEW.sumZkl = OLD.sumZkl and NEW.sumZklMen = OLD.sumZklMen
    and NEW.storno = OLD.storno 
  ) then
    return NEW;
  end if;

  /* 
    prepocet skladu budeme provadet jen v okamziku kdy neexistuje tabulka tmp_rozsirenePolozky 
    nebo kdyz tato tabulka existuje ale neni v ni obsazeno polozka kteoru chceme updatovat 
  */ 
  select getglotxvariable('vypniSklad') into _vypnutySklad; 
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then 
    _updatuj = true; 
    tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky')); 
    if(tmp_rozsirenepolozky_exists = true) then 
      select count(*) into _pocetPolozek from tmp_rozsirenePolozky where idPolSklad = NEW.idPolSklad; 
      if(_pocetPolozek > 0) then 
        _updatuj = false; 
      end if; 
    end if; 
 
    if(OLD.idPolSklad < 0 and NEW.idPolSklad > 0) then 
      _updatuj = false; 
    end if; 
   
    _sklfifo := (select isfifosklad(NEW.datvyst));   
    if (_sklfifo) then   
      --fifo   
      if (OLD.storno=false and NEW.storno=true) then   
        execute sfifoStorno(OLD.idpolsklad, OLD.iddoklsklad);   
      end if;     
      if (OLD.cenamj <> NEW.cenamj) then   
        execute sfifocenamj(OLD.idpolsklad, OLD.iddoklsklad, NEW.cenamj);   
      end if;     
      --fifo konec   
    end if;   

    -- tohle musi byt i pro prumerne ceny protoze jinak se negeneruji fifo vazby
    if (OLD.mnozMj = 0.0 and NEW.mnozMj != 0.0) then
      execute sfifovydej(NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, NEW.idkarty, NEW.mnozMjPlan);
    end if;
    
    if(_updatuj) then 
 
      -- generuji rozsirene polozky 
      select skladGenerujRozsirenePolozky(NEW.datVyst, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable; 
     
      execute putglotxvariable('zurnalTxName', 'prepocetSkladu'); 
  
      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
          execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
        end if; 
      end loop; 

      if(OLD.storno = false) then
        execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.datVyst, OLD.idKarty, OLD.idDoklSklad, OLD.idBspSkl, -1);
      end if;

      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
          execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
        else
          if(NEW.storno = false) then
            execute sprepoctiskladkartu(NEW.mnozMj, NEW.cenaMj, NEW.datVyst, NEW.idKarty, NEW.idDoklSklad, NEW.idBspSkl, 1);
          end if;
        end if;
      end loop; 
 
      if(_mazatTmpTable) then 
        drop table tmp_RozsirenePolozky; 
        drop table tmp_SkladoveKarty; 
        execute removeglotxvariable('zurnalTxName'); 
      end if; 
        
    end if; 
  end if;
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdate() OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION obchodrealizovatelnost(iddokl integer) RETURNS numeric
    AS $$  
declare 
  zbyvaNakl numeric(15,2); 
  moznoSklad numeric(15,2); 
  moznoNesklad numeric(15,2); 
  vysledek numeric(6,2); 
  _idUcetniObdobi integer; 
  _idadresar integer;
  _typPohybuK character varying;
begin  
  select idUcetObdobi into _idUcetniObdobi from nUcetObdobi where (DATE(NOW()) >= PlatiOdData and DATE(NOW()) <= PlatiDoData) limit 1; 
   
  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into zbyvaNakl from dPolObch where idDoklObch = idDokl; 
  
  select idfirmy, typPohybuK into _idadresar, _typPohybuK from ddoklobch where iddoklobch = iddokl;
  
  if(_typPohybuK = 'typPohybu.prijem') then
    _typPohybuK = 'typPohybu.vydej';
  else
    _typPohybuK = 'typPohybu.prijem';
  end if;

  select coalesce(sum(a.procpol), 0) into moznoSklad from 
   (select minValue( 
        maxValue(dgetstavnasklade((select idKarty from sKarty where idCenik = P.idCenik AND idSkladu = P.idBspSkl AND idUcetObdobi = _idUcetniObdobi), DATE(NOW()), -1, _idadresar, null, null, _typPohybuK), 0),
        sum(mnozMj-mnozMjReal)) 
    * (sum(cenamj * (mnozMj-mnozMjReal)) / sum(mnozMj-mnozMjReal)) as procpol
    from dPolObch as P where idDoklObch = idDokl and typPolozkyK = 'typPolozky.katalog' and mnozMj-mnozMjReal > 0
    group by idcenik, idbspskl) as a;
 
  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into moznoNesklad from dPolObch where idDoklObch = idDokl and typPolozkyK <> 'typPolozky.katalog'; 
 
  if (zbyvaNakl = 0) then 
    vysledek := 100 ; 
  else 
    vysledek := ((moznoSklad + moznoNesklad) / zbyvaNakl) * 100; 
  end if; 
   
  return vysledek; 
end;  
$$
    LANGUAGE plpgsql;
ALTER FUNCTION public.obchodrealizovatelnost(iddokl integer) OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION sprepoctiskladkartu(i_mnozmj numeric, i_cenamj numeric, i_datvyst date, i_skladkartaid integer, i_doklskladid integer, i_skladid integer, i_nasobic integer)
  RETURNS void AS
$BODY$    
/* Prepocte stavy na skladove karte s id = iSkladKartaId */    
declare    
  /* Deklarace promennych */    
  _PomMnozMJ numeric(19,6);    
  _StavMJ numeric(19,6);    
  _StavTuz numeric(19,2);    
  _StavMen numeric(19,2);    
  _PrumCenaTuz numeric(19,6);    
  _PrumCenaMen numeric(19,6);    
  _PoslCenaTuz numeric(19,6);    
  _PoslCenaMen numeric(19,6);    
  _TypPohybuK varchar(50);    
  _DatPosl date;    
  _kurzSkladKarty numeric(19,6);   
  _kurzDokladu numeric(19,6);   
  loc_MnozMJ numeric(19,6);   
  _sklzapor boolean;  
  _sklfifo boolean;    
   
  /* Deklarace kurzoru pro nacteni potrebnych dat ze skladove karty a dokladu */   
  declare ThisDoklSklad cursor for select TypPohybuK from dDoklSklad where idDoklSklad = i_DoklSkladId;   
  declare ThisSkladKarta cursor for select StavMJ,StavTuz,StavMen,PrumCenaTuz,PrumCenaMen,DatPosl from sKarty where idKarty = i_SkladKartaId;     
begin   
  loc_MnozMJ:= i_MnozMJ;   
   
  /* Nacteni dat ze skladove karty */   
  open ThisSkladKarta;   
  fetch ThisSkladKarta into _StavMJ,   
    _StavTuz,_StavMen,_PrumCenaTuz,_PrumCenaMen,_DatPosl;   
  close ThisSkladKarta;   
     
  /* Zjisteni typPohybuK */   
  open ThisDoklSklad;   
  fetch ThisDoklSklad into _TypPohybuK;   
  close ThisDoklSklad;   
  
  /* zjisteni meny skladove karty */  
  _KurzSkladKarty := (select getKurzFromSklad(i_skladId, i_DatVyst));  
  _KurzDokladu := (select getKurzFromDoklad(i_doklSkladId, i_DatVyst));  
    
  /* pokud jde o vydej musim odecitat */   
  if _TypPohybuK = 'typPohybu.vydej' then   
    loc_MnozMJ:= 0-loc_MnozMJ;   
  end if;   
     
  /* Vypocet StavMJ */   
  _StavMJ:=_StavMJ+loc_MnozMJ*i_Nasobic;   
  
  if _StavMJ < 0 then  
    select sklzapor into _sklzapor from nNastav where i_DatVyst >= PlatiOdData order by PlatiOdData desc limit 1;  
	if (_sklzapor is null) then  
		select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1;   
	end if;  
    if _sklzapor is null or _sklzapor = false then  
        /*raise exception '0002:sPreporctiSkladKartu: neni povolen zaporny stav skladu';*/  
    end if;  
  end if;  
	  
     
  /* Vypocet StavTuz */   
  if (loc_MnozMJ = 0 and _TypPohybuK = 'typPohybu.prijem')then    
    _PomMnozMJ:=1;   
  else   
    _PomMnozMJ:=loc_MnozMJ;   
  end if;   
  _StavTuz:=_StavTuz+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu);
  /* Vypocet StavMen */   
  _StavMen:=_StavMen+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu)/_KurzSkladKarty;   
  
  /* Vypocet prumernych cen ma byt proveden jen pri prijmu*/  
  if _TypPohybuK = 'typPohybu.prijem' then
    /* Vypocet PrumCenaTuz */   
    if _StavMJ > 0 then   
      _PrumCenaTuz:=_StavTuz/_StavMJ;   
    end if;   
    /* Vypocet PrumCenaMen */   
    if _StavMJ > 0 then   
      _PrumCenaMen:=_StavMen/_StavMJ;   
    end if;   
  end if;   
   
  /* Prepocteni stavu skladu pro FIFO */
  -- drobna uprava prumerne ceny pokud by doslo k chybe vlivem zaokrouhleni a pro fifo nutnost  
  --_sklfifo := (select isfifosklad(i_DatVyst));  
  --if (_sklfifo) then  
    if(_StavMJ <> 0.0) then 
      _PrumCenaTuz := _StavTuz / _StavMJ;  
      _PrumCenaMen := _StavMen / _StavMJ; 
    end if; 
  --end if;  
   
  /* Nastaveni posledni ceny */   
  _PoslCenaTuz:= i_CenaMJ * _KurzDokladu;  
  _PoslCenaMen:= i_CenaMJ;   
  
  /* Nastaveni data posledniho pohybu na karte */   
  if _DatPosl is null then   
    _DatPosl:= i_DatVyst;   
  end if;   
  if _DatPosl < i_DatVyst then   
    _DatPosl:=i_DatVyst;   
  end if;   
  
  /* Update v databazi */
  if(_TypPohybuK = 'typPohybu.vydej') then
    update sKarty set StavMJ = _StavMJ,    
      StavTuz = _StavTuz,    
      StavMen = _StavMen,    
      PrumCenaTuz = _PrumCenaTuz,    
      PrumCenaMen = _PrumCenaMen,
      DatPosl = _DatPosl where    
      idKarty = i_SkladKartaId;    
  else
    update sKarty set StavMJ = _StavMJ,    
      StavTuz = _StavTuz,    
      StavMen = _StavMen,    
      PrumCenaTuz = _PrumCenaTuz,    
      PrumCenaMen = _PrumCenaMen,    
      PoslCenaTuz = _PoslCenaTuz,    
      PoslCenaMen = _PoslcenaMen,    
      DatPosl = _DatPosl where    
      idKarty = i_SkladKartaId;    
  end if;  
end;   
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION sprepoctiskladkartu(numeric, numeric, date, integer, integer, integer, integer) OWNER TO %firmaRole%;


DROP FUNCTION dgetstavnasklade(integer, date, integer, integer, character varying, date);


DROP FUNCTION dgetstavnasklade(integer, integer, date, integer, integer, character varying, date);


-- funkce na zjisteni stavu skladu, ktera si sama dohleda skladovou kartu
CREATE OR REPLACE FUNCTION dgetstavnasklade(_idCenik integer, _idSklad integer, _datum date, i_polskladid integer, _idFirma integer, i_sarze character varying, i_expirace date, i_typPohybuK character varying)
  RETURNS numeric AS $$
declare
  _idUcetObd integer;
  _idKarty integer;
  _mnozMj numeric(19,6);
begin
  select idUcetObdobi into _idUcetObd from nUcetObdobi where platioddata <= _datum and platidodata >= _datum;
  
  select idkarty into _idKarty from skarty where iducetobdobi = _idUcetObd and idskladu = _idSklad and idcenik = _idCenik;

  select dgetstavnasklade(_idKarty, _datum, i_polskladid, _idFirma, i_sarze, i_expirace, i_typPohybuK) into _mnozMj;
  
  return _mnozMj;
end; 
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dgetstavnasklade(integer, integer, date, integer, integer, character varying, date, character varying) OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION dpolskladinsertkusovnik(i_idPolSklad integer)
  RETURNS integer AS
$BODY$
declare
    _polSklad record;
    _typPohybuK varchar;
    _typZasobyK varchar;
    _skladove boolean;
    _idKusovnik integer;
    _iducetobdobi integer;
    _stavNaSklade numeric;
    _sklKarta record;
    _cenik record;
    _sklzapor boolean;
    _idVydejPolSklad integer;
    _idParovanyDoklad integer;
    potKus record;
    _parKusMnoz numeric;
    _i integer;
    _kurz numeric;
    _isCiziMena boolean;
    _idMeny integer;
    _mnozMj numeric;
    _cenaMj numeric;
    _sumZkl numeric;
    _newSumZkl numeric;
    _sumZklMen numeric;
    _idSkladPotKus integer;
    _idProtiUcetDoklad integer;
    _idStred integer;
    _kopStred boolean;
    _sklad record;
    _typPohybuSkladK character varying;
    _cenaMjSkl numeric(19,6);
    _cenaMjNeskl numeric(19,6);
    _navazanaPolSklad record;
    _rozpadlaPolSklad record;
    _kurzDokladu numeric;
begin
  select * into _polSklad from dpolsklad where idpolsklad = i_idpolSklad;

  -- napriklad pokud se jedna o prevodku mezi sklady nechceme z prijemky vytvaret prevodku
  if (_polSklad.prevodka = true) then
    return null;
  end if;

  -- typem pohybu musi byt prijem
  select typpohybuk into _typPohybuK from ddoklsklad d where d.iddoklsklad = _polSklad.iddoklsklad;
  if (_typPohybuK <> 'typPohybu.prijem') then
    return null;
  end if;

  -- pokud neni nastaven typ pohybu sklad prijem z vyroby tak koncime
  select typpohybuskladk into _typPohybuSkladK from ddoklsklad d where d.iddoklsklad = _polSklad.iddoklsklad;
  if(_typPohybuSkladK is null or _typPohybuSkladK <> 'typPohybuSklad.prijemVyrob') then
    return null;
  end if;

  -- idcenik odkazuje na neco co je soucasti kusovniku.
  select ckus.idkusovnik into _idKusovnik from ckusovnik ckus where ckus.idcenik = _polSklad.idcenik
    and exists (select 1 from ckusovnik cPot where cPot.idotec = ckus.idkusovnik);
  if (_idKusovnik is null) then
    return null;
  end if;

  -- vytvorime nebo nalezneme zparovany doklad skl vydej
  select findparovanydoklsklad(_polSklad.iddoklsklad, _polSklad.modul, 'typVazbyDokl.hlavaSklKus') into _idParovanyDoklad;
  if (_idParovanyDoklad is null) then
    select createdoklsklad(_polSklad.idpolsklad, _polSklad.iddoklsklad, _polSklad.modul) into _idParovanyDoklad;
  end if;

  if(_idParovanyDoklad is null) then
    return null;
  end if;

  select isDoklSkladMenaCizi(_idParovanyDoklad, _polSklad.datVyst) into _isCiziMena;
  select getkurzfromdoklad(_idParovanyDoklad, _polSklad.datVyst) into _kurz;
  select idMeny into _idMeny from dDoklSklad where idDoklSklad = _idParovanyDoklad;

  _i = 0;
  _newSumZkl = 0.0;
  _cenaMjSkl = 0.0;
  _cenaMjNeskl = 0.0;

  perform putglotxvariable('zurnalTxName', 'rozpadKusovniku');

  -- pro vsechny kusovniky, ktere jsou pod nasim kusovnikem a jsou skladove nebo vyroba a nemaji nulove mnozstvi
  for potKus in (select * from ckusovnik cPot where cPot.idotec = _idKusovnik and cPot.mnoz > 0.0) loop
    select * into _cenik from cCenik where idCenik = potKus.idCenik;

    select mnoz into _parKusMnoz from ckusovnik where idkusovnik = _idKusovnik;

    select skladove into _skladove from cCenik cen where cen.idCenik = potKus.idCenik;
    if (not _skladove) then
        _newSumZkl = _newSumZkl + ((_cenik.nakupcena * potKus.mnoz * _polSklad.mnozMj) / _parKusMnoz);
        _cenaMjNeskl = _cenaMjNeskl + ((_cenik.nakupcena * potKus.mnoz) / _parKusMnoz);
        continue;
    end if;
    _i = _i + 1;

    select findIdUcetniObdobiKDatu(_polSklad.datVyst) into _iducetobdobi;
    -- vybereme skladovou kartu podle preferovaneho skladu
    select null into _sklKarta;
    _idSkladPotKus = null;

    select getPrefIdSkladu(
	(select idstred from ddoklsklad where iddoklsklad = _polSklad.iddoklsklad),
	_cenik.idskupzboz, potKus.idcenik) into _idSkladPotKus;

    if (_idSkladPotKus is not null) then
	select * into _sklKarta from skarty where idcenik = potKus.idcenik and idSkladu = _idSkladPotKus and iducetobdobi = _iducetobdobi;
    end if;

    -- sklad karta nebyla nalezena podle preferovaneho skladu, vezmeme sklad stejny jako z vytvarene polozky
    if (_sklKarta is null) then
	select * into _sklKarta from skarty where idcenik = potKus.idcenik and idSkladu = _polSklad.idBspSkl and iducetobdobi = _iducetobdobi;
	select _polSklad.idStred into _idStred;
	select _polSklad.kopstred into _kopStred;
    else
        select idstred into _idStred from dbsp d where _sklKarta.idskladu = d.idbsp;
	select false into _kopStred;
    end if;

    -- skladovou
    if (_sklKarta is null) then
	raise exception 'Nebyla nalezena skladova karta k polozce ceniku %. Definujte mapovani skladu pro tuto polozku nebo ji pridejte na sklad %',
		_cenik.kod, (select kod from dtypdokl where idtypdokl = _polSklad.idskladu);
    end if;

   _mnozMj = (potKus.mnoz / _parKusMnoz) * _polSklad.mnozMj;
   _cenaMj = _sklKarta.prumCenaTuz / _kurz;
   _sumZkl = _mnozMj * _sklKarta.prumCenaTuz;
   _cenaMjSkl = _cenaMjSkl + (_cenaMj * (potKus.mnoz / _parKusMnoz));
   _newSumZkl = _newSumZkl + _sumZkl;

   if(_isCiziMena) then
     _sumZklMen = _mnozMj * _cenaMj;
   else
     _sumZklMen = 0.0;
   end if;

    -- TODO doplnit sarze a expirace
    select dgetstavnasklade(_sklKarta.idkarty, _polSklad.datVyst, -1, _polSklad.idfirmy, NULL, NULL, _typPohybuK) into _stavNaSklade;

    -- osetreni zda je povoleny zaporny stav na sklade
    if (_stavNaSklade - _mnozMj < 0) then
        select sklzapor into _sklzapor from nNastav where _polSklad.datVyst >= PlatiOdData order by PlatiOdData desc limit 1;
        if (_sklzapor is null) then
            select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1;
        end if;
        if _sklzapor is null or _sklzapor = false then
            raise exception '0002:sPreporctiSkladKartu: neni povolen zaporny stav skladu';
        end if;
    end if;

    select nextval('seq_dpolsklad'::regclass) into _idVydejPolSklad;

    if(_cenik.idskupzboz is not null) then
      select idprotiucetsklv into _idProtiUcetDoklad from cskupzboz where idskupzboz = _cenik.idskupzboz;
    end if;
    if(_idProtiUcetDoklad is null) then
      select idprotiucet into _idProtiUcetDoklad from ddoklsklad where iddoklsklad = _idParovanyDoklad;
    end if;

    select * into _sklad from dBsp where _sklKarta.idSkladu = idBsp;

    insert into dpolsklad(idPolSklad, idcenik, idBspSkl, idkarty, datVyst, datUcto, modul, typPolozkyK, idDoklSklad,
        mnozMj, cenaMj, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni,
        nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni, idStred, idZakazky, idMeny, kopstred)
    values (_idVydejPolSklad, potKus.idcenik, _sklKarta.idSkladu, _sklKarta.idkarty, _polSklad.datVyst, _polSklad.datUcto, _polSklad.modul, _polSklad.typpolozkyk, _idParovanyDoklad,
        _mnozMj, _cenaMj, _sumZkl, _sumZklMen, _idProtiUcetDoklad, _sklad.idprimucet, false, false, _polSklad.baleniid, _polSklad.mnozbaleni,
        _cenik.nazev, _cenik.nazevA, _cenik.nazevB, _cenik.nazevC, NULL, NULL, _polSklad.cisRad * 100 + _i, true,
        _idStred, _polSklad.idZakazky, _idMeny, _kopStred);

    insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)
      values (0.0, _polSklad.idpolsklad, _idVydejPolSklad, 'SKL', 'SKL', false, 'typVazbyDokl.polozkaSklKus');

  end loop;

  perform removeglotxvariable('zurnalTxName');

  select getkurzfromdoklad(_polSklad.iddoklsklad, _polSklad.datvyst) into _kurz;
  _cenaMj = _newSumZkl / _polSklad.mnozMj / _kurz;

  select isDoklSkladMenaCizi(_polSklad.iddoklsklad, _polSklad.datVyst) into _isCiziMena;
  if (_isCiziMena) then
    _sumZklMen = _polSklad.cenaMj * _polSklad.mnozMj;
  else
    _sumZklMen = 0.0;
  end if;


  select getKurzFromDoklad(_polSklad.idDoklSklad, _polSklad.datVyst) into _kurzDokladu;
  _cenaMjSkl = 0.0;
  _cenaMj = _cenaMjNeskl;
  _sumZkl = _cenaMjNeskl * _polSklad.mnozMj;
  for _navazanaPolSklad in (select * from dPolSklad where idPolSklad in
    (select idTabB from dvazebtab where idTabA = _polSklad.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus') )
    loop
      if(_navazanaPolSklad.mnozMj <> 0.0) then
        _cenaMj = _cenaMj + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
        _cenaMjSkl = _cenaMjSkl + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
      else
        raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
      end if;
      _sumZkl = _sumZkl + _navazanaPolSklad.sumZkl;

      -- musime zohlednit i pripadne rozpady skladovych polozek
      for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in
        (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad))
        loop
          if(_rozpadlaPolSklad.mnozMj <> 0.0) then
            _cenaMj = _cenaMj + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
            _cenaMjSkl = _cenaMjSkl + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
          else
            raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
          end if;
          _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl;
      end loop;
  end loop;

  update dpolsklad set
       sumzkl = _sumZkl,
       cenaMj = _cenaMj,
       --sumZklMen = _sumZklMen,
       cenaMjSkl = _cenaMjSkl,
       cenaMjNeskl = _cenaMjNeskl
     where idpolsklad = _polSklad.idpolsklad;

  execute sprepoctisumydokladu(_polSklad.idDoklSklad);

  return _polSklad.idPolSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsertkusovnik(integer) OWNER TO %firmaRole%;


create or replace function skladPrepoctiRozsirenouPolozku(i_idrozsirenepolozky integer, sign integer) returns void as
$BODY$
declare
  _skladKarta record;
  _rozsirenaPolozka record;
  _polSklad record;
  _navazanaPolSklad record;
  _stavMj numeric(19,6);
  _stavTuz numeric(19,6);
  _stavMen numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _prumCenaMen numeric(19,6);
  _pocetNavazanych integer;
  _cenaMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _kurzDokladu numeric(19,6);
  _kurzSkladKarty numeric(19,6);
  _isCiziMena boolean;
  _sklfifo boolean;
  _datPosl date; 
  _PoslCenaTuz numeric(19,6);     
  _PoslCenaMen numeric(19,6);     
  _cenaMjSkl numeric(19,6);
  _updateCena boolean;
  _rozpadlaPolSklad record;
  _sumZklProCenaMj numeric(19,6);
  _mnozMjProCenaMj numeric(19,6);
  _cenaMjPoriz numeric(19,6);
  --_cenaMjNakl numeric(19,6);
begin
  select * into _rozsirenaPolozka from tmp_RozsirenePolozky where idpolsklad = i_idrozsirenepolozky;
  select * into _polSklad from dPolSklad where idPolSklad = i_idrozsirenepolozky;
  if(_polSklad is null) then
    -- muze se stat ze v rozsirenych polozkach je uz polozka ktera byla v ramci transakce smazana
    return;
  end if;
  
  select * into _skladKarta from sKarty where idKarty = _rozsirenaPolozka.idskladkarty;
  select getKurzFromDoklad(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _kurzDokladu;

  if(sign = 1) then
    if(_rozsirenaPolozka.skupina = 1) then
      if(_polSklad.mnozMj = 0.0) then
        _stavTuz = _polSklad.cenaMj * _kurzDokladu;
      else
        select sumZkl into _stavTuz from dpolsklad where idPolSklad = _rozsirenaPolozka.idPolSklad;
      end if;
    else
      -- pokud se jedna o prijemku z prevodky nebo vyroby tak se musi cena nastavit podle navazane vydejky
      _cenaMjSkl = 0.0;
      _sklfifo := (select isfifosklad(_rozsirenaPolozka.datum));
      -- menit cenu budeme jen pokud to neni fifo
      _updateCena = not _sklFifo;
      if(_rozsirenaPolozka.skupina = 2 and _rozsirenaPolozka.typPohybuK = 'typPohybu.prijem') then
        select * into _navazanaPolSklad from dPolSklad 
            where idPolSklad = (select idTabA from dvazebtab where idTabB = _rozsirenaPolozka.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod');
        if(_navazanaPolSklad is null) then
          _cenaMj = _polSklad.cenaMjNeskl;
          _cenaMjSkl = 0.0;
          _cenaMjPoriz = _cenaMj;
          _sumZkl = _polSklad.cenaMjNeskl * _polSklad.mnozMj;
          for _navazanaPolSklad in (select * from dPolSklad where idPolSklad in 
            (select idTabB from dvazebtab where idTabA = _rozsirenaPolozka.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus') )
            loop
            if(_navazanaPolSklad.mnozMj <> 0.0) then
              _cenaMj = _cenaMj + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
              _cenaMjSkl = _cenaMjSkl + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
            else
              raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
            end if;
            _sumZkl = _sumZkl + _navazanaPolSklad.sumZkl;

            -- musime zohlednit i pripadne rozpady skladovych polozek
            for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in
              (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad))
            loop
              if(_rozpadlaPolSklad.mnozMj <> 0.0) then
                _cenaMj = _cenaMj + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
                _cenaMjSkl = _cenaMjSkl + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
              else
                raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
              end if;
              _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl;
            end loop;

            _cenaMjPoriz = _cenaMj;

            -- ovsem pokud se jedna o vyrobu musime zmenit cenu prijmky z vyroby
            _updateCena = true;
          end loop;
          _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl;
          _sumZkl = _sumZkl + (_polSklad.mnozMj * _polSklad.cenaMjNakl);
        else
          _sumZklProCenaMj = 0.0;
          _mnozMjProCenaMj = 0.0;
          if(_navazanaPolSklad.mnozMj <> 0.0) then
            _sumZklProCenaMj = _sumZklProCenaMj + _navazanaPolSklad.sumZkl / _kurzDokladu;
            _mnozMjProCenaMj = _mnozMjProCenaMj + _navazanaPolSklad.mnozMj;
          else
            raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
          end if;
          _sumZkl = _navazanaPolSklad.sumZkl;
          -- musime zohlednit i pripadne rozpady skladovych polozek
          for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in
            (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad order by idpolskladcil desc)
            order by idpolsklad desc) 
          loop
            if(_polSklad.mnozMj > _mnozMjProCenaMj) then
              if(_rozpadlaPolSklad.mnozMj <> 0.0) then
                _sumZklProCenaMj = _sumZklProCenaMj + _rozpadlaPolSklad.sumZkl / _kurzDokladu;
                _mnozMjProCenaMj = _mnozMjProCenaMj + _rozpadlaPolSklad.mnozMj;
              else
                raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
              end if;
              _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl;
            end if;
          end loop;

          if(_mnozMjProCenaMj <> 0.0) then
            _cenaMjPoriz = _sumZklProCenaMj / _mnozMjProCenaMj;
          else
            raise exception '_mnozMjProCenaMj je 0.0'; -- TODO vyresit co se bude dit
          end if;
          _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl;
          _sumZkl = _sumZkl + (_polSklad.mnozMj * _polSklad.cenaMjNakl);
          --_sumZkl = _polSklad.mnozMj * _cenaMj;
          -- ovsem pokud se jedna o prevodku musime zmenit cenu prijmky z prevodky
          _updateCena = true;
        end if;
        _sumZklMen = 0.0;
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _isCiziMena;
        if(_isCiziMena) then
          _sumZklMen = _polSklad.mnozMj * _cenaMj;
        end if;
      else
        _cenaMj = _skladKarta.prumCenaTuz;
        _cenaMjPoriz = _skladKarta.prumCenaTuz;
        if(_kurzDokladu is not null and _kurzDokladu <> 0.0) then
          _cenaMj = _cenaMj / _kurzDokladu;
        end if;
        _sumZkl = _polSklad.mnozMj * _skladKarta.prumCenaTuz;
        _sumZklMen = 0.0;
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _isCiziMena;
        if(_isCiziMena) then
          _sumZklMen = _polSklad.mnozMj * _cenaMj; 
        end if;
      end if;

      if (_updateCena) then
        update dPolSklad set
          cenaMjPoriz = _cenaMjPoriz,
          cenaMj = _cenaMj,
          cenaMjSkl = _cenaMjSkl,
          sumZkl = _sumZkl,
          sumZklMen = _sumZklMen
          where idPolSklad = _rozsirenaPolozka.idPolSklad;
      end if;

      execute sprepoctisumydokladu(_rozsirenaPolozka.idDoklSkladPolozky);

      select sumZkl into _stavTuz from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
    end if;
  else
    if(_polSklad.mnozMj = 0.0 and _rozsirenaPolozka.typpohybuk = 'typPohybu.prijem') then
      _stavTuz = _polSklad.cenaMj * _kurzDokladu;
    else
      select sumZkl into _stavTuz from dpolsklad where idPolSklad = i_idrozsirenepolozky;
    end if;
  end if;

  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.vydej') then
    _stavMj = _skladKarta.stavMj - (sign*_polSklad.mnozMj);
    _stavTuz = _skladKarta.stavTuz - (sign*_stavTuz);
  else
    _stavMj = _skladKarta.stavMj + (sign*_polSklad.mnozMj);
    _stavTuz = _skladKarta.stavTuz + (sign*_stavTuz);
  end if;

  if(_stavMj is null) then
    raise exception 'stav mj je null a idpolsklad je % a _skladkarta je % a _polSklad je %',i_idrozsirenepolozky, _skladkarta, _polSklad;
  end if;

  _prumCenaTuz = _skladKarta.prumCenaTuz;
  if(_stavMj <> 0.0) then
    _prumCenaTuz = _stavTuz / _stavMj;
  end if;
  if(_prumCenaTuz is null) then
    raise exception 'prumCenaTuz je null, _stavTuz je %, _stavMj je %', _stavTuz, _stavMj;
  end if; 
 
  _datPosl = _skladKarta.datPosl;
  if(_datPosl is null or _datPosl < _polSklad.datVyst) then
    _datPosl = _polSklad.datVyst;
  end if;

  _poslCenaTuz = _skladKarta.poslCenaTuz;
  _poslCenaMen = _skladKarta.poslCenaMen;
  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.prijem') then
    _PoslCenaTuz := _polSklad.cenaMj * _KurzDokladu;   
    _PoslCenaMen := _polSklad.cenaMj; 
  end if;
 
  _KurzSkladKarty := (select getKurzFromSklad(_skladKarta.idSkladu, _rozsirenaPolozka.datum));
  if (not _rozsirenaPolozka.storno) then
    update skarty set 
      stavmj = _stavMj,
      stavTuz = _stavTuz,
      stavMen = round(_stavTuz / _kurzSkladKarty, 2),
      prumCenaTuz = _prumCenaTuz,
      prumCenaMen = _prumCenaTuz / _kurzSkladKarty,
      datPosl = _datPosl,
      poslCenaTuz = _poslCenaTuz,
      poslCenaMen = _poslCenaMen
      where idkarty = _rozsirenaPolozka.idSkladKarty;
  end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladPrepoctiRozsirenouPolozku(integer, integer) OWNER TO %firmaRole%;


-- trigger pri update rezervace
CREATE OR REPLACE FUNCTION srezervaceupdaterezer()
  RETURNS trigger AS $$
declare
  zmena numeric(19,6);
  puvodni numeric(19,6);
  volnosklad numeric(19,6);
begin
  if (getglotxvariable('rezerDisableTrigger') is not null) then
    return NEW;
  end if;

  zmena = NEW.mnozstvi;
  puvodni = 0;
  if (tg_op = 'UPDATE') then
    if (NEW.idsklad = OLD.idsklad and NEW.idcenik = OLD.idcenik and NEW.mnozstvi = OLD.mnozstvi and NEW.datumod = OLD.datumod) then
      return NEW;
    end if;
  
    if (NEW.idsklad <> OLD.idsklad or NEW.idcenik <> OLD.idcenik) then          -- pokud menime zbozi na rezervaci
      if (OLD.skladmj > 0) then                                                 -- a nejake bylo na sklade
        perform srezervujzprijemky(OLD.idcenik, OLD.idsklad, OLD.skladmj);     -- muzeme ho zarezervovat nekomu jinemu
      end if;
    else
      puvodni = OLD.skladmj;
      zmena = NEW.mnozstvi - OLD.skladmj;
      if (NEW.mnozstvi > OLD.mnozstvi) then             -- mnozstvi se zvetsilo
        if (OLD.skladmj < OLD.mnozstvi) then            -- pokud na sklade bylo min nez zarezervovano, tak stejne nic na sklade nenajdem
          zmena = 0;
        end if;
      end if;
    end if;
  end if;
  
  if (zmena > 0) then
    select dgetstavnasklade(NEW.idcenik, NEW.idsklad, date(now()), -1, -1, null, null, 'typPohybu.vydej') into volnosklad;
    
    update srezervace set skladmj = puvodni + minvalue(mnozstvi-puvodni, volnosklad) where idrezervace = NEW.idrezervace;
  else
    if (zmena < 0) then
      update srezervace set skladmj = puvodni + zmena where idrezervace = NEW.idrezervace;
    
      perform srezervujzprijemky(NEW.idcenik, NEW.idsklad, -zmena);
    end if;
  end if;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.srezervaceupdaterezer() OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION daapolskladinsertmnozmj()
  RETURNS trigger AS
$BODY$ 
declare 
  _stavSkladu numeric(19,6);
  _typPohybuK character varying;
  _stavSkladK character varying;
begin
  select typPohybuK into _typPohybuK from ddoklsklad where iddoklsklad = NEW.idDoklSklad;
  -- TODO Doplnit  
  select dgetstavnasklade(NEW.idKarty, NEW.datVyst, -1, null, null, _typPohybuK) into _stavSkladu;
  
  NEW.mnozMjPlan = NEW.mnozMj;

  --raise exception '% % %', _typPohybuK, NEW.mnozMj, _stavSkladu;
  if(_typPohybuK = 'typPohybu.vydej' and NEW.mnozMj > _stavSkladu) then
    NEW.mnozMj = 0.0;
    
    select stavSkladK into _stavSkladK from ddoklsklad where idDoklSklad = NEW.idDoklSklad;
    if(compareVarchar(_stavSkladK, 'stavSklad.vygenFakt')) then
      update ddoklsklad set stavSkladK = 'stavSklad.vygenFaktNeuplny' where idDoklSklad = NEW.idDoklSklad;
    end if;
    if(compareVarchar(_stavSkladK, 'stavSklad.vygenPokl')) then
      update ddoklsklad set stavSkladK = 'stavSklad.vygenPoklNeuplny' where idDoklSklad = NEW.idDoklSklad;
    end if;

  end if;
  
  return NEW;
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION daapolskladinsertmnozmj() OWNER TO %firmaRole%;


CREATE TRIGGER daapolskladinsertmnozmj
  BEFORE INSERT
  ON dpolsklad
  FOR EACH ROW
  EXECUTE PROCEDURE daapolskladinsertmnozmj();


CREATE OR REPLACE FUNCTION skladrealizujpozadavky()
  RETURNS void AS
$BODY$ 
declare
  _polSklad record;
  _polSkladDoklSklad record;
  _stavSkladu numeric(19,6);
  _pocetPozadavku integer;
begin
  for _polSklad in (
    select p.*, d.typPohybuK, d.stavSkladK from dpolsklad p join ddoklsklad d on p.idDoklSklad = d.idDoklSklad
    where typPohybuK = 'typPohybu.vydej' and mnozMj = 0 and mnozMjPlan != 0
    order by datSklad, idPolSklad) loop
      select dgetstavnasklade(_polSklad.idkarty, _polSklad.datSklad, /*_polSklad.idpolsklad*/ -1, _polSklad.sarze, _polSklad.expirace, _polSklad.typPohybuK) into _stavSkladu;
      if(_stavSkladu >= _polSklad.mnozMjPlan) then
        update dpolsklad set mnozMj = mnozMjPlan, sumZkl = mnozMjPlan * cenaMj where idpolsklad = _polSklad.idPolSklad;
        perform sprepoctisumydokladu(_polSklad.iddoklsklad);
        
        select count(*) into _pocetPozadavku from dpolSklad where idDoklSklad = _polSklad.idDoklSklad and mnozMj = 0.0 and mnozMjPlan != 0.0;
        if(_pocetPozadavku = 0) then
          if(compareVarchar(_polSklad.stavSkladK, 'stavSklad.vygenFaktNeuplny')) then
            update ddoklsklad set stavSkladK = 'stavSklad.vygenFakt' where idDoklSklad = _polSklad.idDoklSklad;
          end if;
          if(compareVarchar(_polSklad.stavSkladK, 'stavSklad.vygenPoklNeuplny')) then
            update ddoklsklad set stavSkladK = 'stavSklad.vygenPokl' where idDoklSklad = _polSklad.idDoklSklad;
          end if;
        end if;
      end if;
  end loop;
end;    
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladrealizujpozadavky() OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION dgetstavnasklade(i_skladkartaid integer, i_datum date, i_polskladid integer, i_sarze character varying, i_expirace date, i_typPohybuK character varying)
  RETURNS numeric AS
$BODY$      
declare     
  _pocMj numeric(19,6);     
  _obratMj numeric(19,6);     
  _stavMj numeric(19,6);     
  _idcenik integer;   
  _idskladu integer;   
  _typPohybuK character varying(50);   
  _sadaItemCount integer; 
  _polozkaSady record; 
  _idSkladKarty integer; 
  _iducetniobdobi integer; 
  _idPolSklad integer; 
  _stavSkladuSady numeric(19,6); 
  _mnozMj numeric(19,6); 
  _stavMjKarty numeric(19,6); 
  _rozpadlaPolSklad record; 
begin     
  SELECT pocatMj INTO _pocMj     
  FROM sKarty     
  WHERE idKarty = i_skladkartaid;     
     
  if (i_datum is null) then     
    raise exception '0005:dGetStavNaSklade : Vstupni parametr datum je null.';      
  end if;   
   
  _typPohybuK := i_typPohybuK;   
  --if (i_polskladid >= 0) then   
  --  select typPohybuK into _typPohybuK from ddoklsklad    
  --    where iddoklsklad = (select iddoklsklad from dpolsklad where idpolsklad = i_polskladid);   
  --end if;   
   
  select idcenik, idskladu, iducetobdobi into _idcenik, _idskladu, _iducetniobdobi from skarty where idkarty = i_skladkartaid; 
 
  -- zjistim jestli nahodu dany cenik neni sada nebo komplet 
  select count(*) into _sadaItemCount from csady where idceniksada = _idCenik; 
  -- pokud se nejedna o sadu tak funguju normalne 
  if(_sadaItemCount = 0) then 
    if ((i_sarze is null or i_sarze = '') and i_expirace is null) then    
      -- zkusime zjistit stav skladu k datu 
      if (i_polSkladId < 0) then       
        SELECT sum(CASE ds.typPohybuK WHEN 'typPohybu.prijem' THEN ps.mnozMj ELSE -ps.mnozMj END) INTO _obratMj       
        FROM dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad       
        WHERE idkarty = i_skladkartaid AND ps.storno <> true AND ps.datUcto <= i_datum;       
      else       
        SELECT sum(CASE ds.typPohybuK WHEN 'typPohybu.prijem' THEN ps.mnozMj ELSE -ps.mnozMj END) INTO _obratMj       
        FROM dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad       
        WHERE idkarty = i_skladkartaid AND ps.storno <> true AND (ps.datUcto < i_datum OR (ps.datUcto = i_datum AND ps.idPolSklad < i_polskladid));       
      end if;    
      if(_obratMj is null) then _obratMj = 0.0; end if;       
      if(_pocMj is null) then _pocMj = 0.0; end if;        
      _stavMj = _pocMj + _obratMj;    
      -- zkusime vypocitat stav na vrcholu 
      select stavMj into _stavMjKarty from skarty where idkarty = i_skladkartaid; 
      _mnozMj = 0.0; 
      if(i_polSkladId >= 0) then 
        select mnozMj into _mnozMj from dPolSklad where idPolSklad = i_polSkladId; 
      end if;
      for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in  
        (select idpolskladcil from svazbypolsklad where idpolskladzdroj = i_polSkladId))  
      loop  
        _mnozMj = _mnozMj + _rozpadlaPolSklad.mnozMj; 
      end loop; 
      if(_typPohybuK = 'typPohybu.vydej') then 
        _stavMjKarty = _stavMjKarty + _mnozMj; 
      else 
        _stavMjKarty = _stavMjKarty - _mnozMj; 
      end if; 
      
      -- spravna hodnota dle bugu 21375 minimum z obou hodnot 
      if(_typPohybuK = 'typPohybu.vydej') then 
        select minValue(_stavMj, _stavMjKarty) into _stavMj; 
      end if; 
    else    
      if ((i_sarze is not null and i_sarze <> '') and (i_expirace is null)) then    
        --raise exception 'idCenik = % and idSkladu = %', _idCenik, _idSkladu;   
       
        select sum(pocet) into _stavMj from dpolskladf where idcenik = _idcenik and idskladu = _idskladu and sarze = i_sarze;    
      elsif ((i_sarze is null or i_sarze = '') and (i_expirace is not null)) then    
        select sum(pocet) into _stavMj from dpolskladf where idcenik = _idcenik and idskladu = _idskladu and expirace = i_expirace;    
      else    
        select sum(pocet) into _stavMj from dpolskladf where idcenik = _idcenik and idskladu = _idskladu and sarze = i_sarze and expirace = i_expirace;    
      end if;    
      if (_typPohybuK is not null and _typPohybuK = 'typPohybu.prijem') then    
        select mnozMj into _obratMj from dpolsklad where idpolsklad = i_polskladid;    
        if(_stavMj is null) then    
          _stavMj := -_obratMj;    
        else    
          _stavMj := _stavMj - _obratMj;    
        end if;    
      elsif (_typPohybuK is not null and _typPohybuK = 'typPohybu.vydej') then    
        select mnozMj into _obratMj from dpolsklad where idpolsklad = i_polskladid;    
        if(_stavMj is null) then    
          _stavMj := _obratMj;    
        else    
          _stavMj := _stavMj + _obratMj;    
        end if;    
      end if;    
    end if;   
  else 
    for _polozkaSady in 
      select * from cSady where idCenikSada = _idCenik 
    loop 
      select idKarty into _idSkladKarty from sKarty where idCenik = _polozkaSady.idCenik and idSkladu = _idskladu and idUcetObdobi = _iducetniobdobi; 
      if(_idSkladKarty is not null) then  
        if(_stavMj is null) then 
          _stavMj = 9999999999999.0; -- vic uz pretejka 
        end if; 
        _idPolSklad = -1; 
        --TODO nejak doresit _idPolSklad, sarze a expirace; 
        select dgetstavnasklade(_idSkladKarty, i_datum, -1, i_sarze, i_expirace, _typPohybuK) into _stavSkladuSady; 
        _stavSkladuSady = _stavSkladuSady / _polozkaSady.mnozMj; 
	if(i_polskladid > 0) then 
	  select mnozMj into _mnozMj from dPolSklad where idPolSklad = i_polSkladId; 
          _stavSkladuSady = _stavSkladuSady + (_mnozMj/_polozkaSady.mnozMj); 
        end if; 
        select minValue(_stavMj, _stavSkladuSady) into _stavMj; 
      end if; 
    end loop; 
  end if;  
  
  -- muze se stat ze _stavMj je null a to znamena ze na sklade nic neni  
  if(_stavMj is null) then  
    _stavMj := 0;  
  end if;  
    
  RETURN _stavMj;      
end      
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnasklade(integer, date, integer, character varying, date, character varying) OWNER TO %firmaRole%;


-- Function: dgetstavnasklade(integer, date, integer, integer, character varying, date)
-- DROP FUNCTION dgetstavnasklade(integer, date, integer, integer, character varying, date);
CREATE OR REPLACE FUNCTION dgetstavnasklade(i_skladkartaid integer, i_datum date, i_polskladid integer, i_firmaid integer, i_sarze character varying, i_expirace date, i_typpohybuK character varying)
  RETURNS numeric AS
$BODY$ 
declare 
  _sklad integer; 
  _cenik integer; 
  _stavMj numeric(19,6); 
  _firmaRezerMj numeric(19,6); 
  _celkemRezerMj numeric(19,6); 
begin 
  SELECT dgetstavnasklade(i_skladkartaid, i_datum, i_polskladid, i_sarze, i_expirace, i_typPohybuK) INTO _stavMj; 
  
  -- vymazeme jiz neplatne rezervace 
  delete from srezervace where datumdo is not null and datumdo < date(now()); 
  -- nacteme si info ze skladove karty 
  SELECT idCenik, idSkladu INTO _cenik, _sklad FROM sKarty WHERE idKarty = i_skladkartaid; 
  -- zjistime kolik je celkem rezervovano 
  select coalesce(sum(skladmj), 0) into _celkemRezerMj from srezervace 
    where idcenik = _cenik and idsklad = _sklad and (datumOd is null or datumOd <= i_datum) and (datumDo is null or datumDo >= i_datum);
   
  IF (i_firmaid > 0) THEN 
    -- zjistime kolik ma firma rezervovano 
    select coalesce(sum(skladmj), 0) into _firmaRezerMj from srezervace where idfirmy = i_firmaid and idcenik = _cenik and idsklad = _sklad; 
  ELSE 
    _firmaRezerMj := 0; 
  END IF; 
   
  -- spocteme kolik mu muzeme dat 
  _stavMj := minValue(_stavMj, maxValue(_stavMj - _celkemRezerMj, 0) + _firmaRezerMj); 
   
  RETURN _stavMj; 
end 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnasklade(integer, date, integer, integer, character varying, date, character varying) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION dpoldokldeletesklad()
  RETURNS trigger AS
$BODY$ 
declare 
  _idPolDokl integer; 
  _idDoklad integer; 
  _idDoklSklad integer;
  _pocetPozadavku integer;
  _stavSkladK character varying; 
begin 
  if(OLD.modul like 'POK') then 
    _idPolDokl = OLD.idPolInt; 
    _idDoklad = OLD.idDoklInt; 
  elsif(OLD.modul like 'FAP' or OLD.modul like 'FAV') then 
    _idPolDokl = OLD.idPolFak; 
    _idDoklad = OLD.idDoklFak; 
  else 
    _idPolDokl = null; 
    _idDoklad = null; 
  end if; 
 
  if(_idPolDokl is not null) then 
    execute deleteNavazanePolSklad(_idPolDokl, OLD.modul); 
  end if; 
 
  if(_idDoklad is not null) then 
    select findParovanyDoklSklad(_idDoklad, OLD.modul) into _idDoklSklad; 
    if(_idDoklSklad is not null) then 
      execute sprepoctiSumyDokladu(_idDoklSklad); 

      select stavSkladK into _stavSkladK from ddoklsklad where idDoklSklad = _idDoklSklad; 
      select count(*) into _pocetPozadavku from dpolSklad where idDoklSklad = _idDoklSklad and mnozMj = 0.0 and mnozMjPlan != 0.0;
  
      if(_pocetPozadavku = 0) then
        if(compareVarchar(_stavSkladK, 'stavSklad.vygenFaktNeuplny')) then
          update ddoklsklad set stavSkladK = 'stavSklad.vygenFakt' where idDoklSklad = _idDoklSklad;
        end if;
        if(compareVarchar(_stavSkladK, 'stavSklad.vygenPoklNeuplny')) then
          update ddoklsklad set stavSkladK = 'stavSklad.vygenPokl' where idDoklSklad = _idDoklSklad;
        end if;
      end if; 
    end if; 
  end if; 
   
  return OLD; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldokldeletesklad() OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 491, 't', %appVersion%, clock_timestamp());
