------------------------------------------------------------------------------------
-- Bug 22487 – [WinStrom] Sazby DPH nepodporuji ext id
------------------------------------------------------------------------------------

alter table wextid add column idSazbaDph integer;
alter table wextid add constraint wextid_idSazbaDph FOREIGN KEY (idSazbaDph)
      REFERENCES uSazbyDph (idSazbyDph) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE;

CREATE INDEX wExtId_IdSazbyDph_index ON wExtId USING btree (idSazbaDph);

------------------------------------------------------------------------------------
-- Bug 19952 – [WinStrom] Přidat podporu externích ID na více míst
------------------------------------------------------------------------------------

-- externi ID pro mzdy

alter table wextid add column idBanSpojMzdy integer;
alter table wextid add column idDite integer;
alter table wextid add column idNepritomnost integer;
alter table wextid add column idOsoba integer;
alter table wextid add column idOsobaHlav integer;
alter table wextid add column idPracPom integer;
alter table wextid add column idPracPomHlav integer;
alter table wextid add column idSkupOsob integer;
alter table wextid add column idSmeny integer;
alter table wextid add column idSrazka integer;
alter table wextid add column idStalaMzdSloz integer;

alter table wextid add CONSTRAINT wextid_idBanSpojMzdy FOREIGN KEY (idBanSpojMzdy)
      REFERENCES aBanSpoj(idBanSpoj) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade;
alter table wextid add CONSTRAINT wextid_idDite FOREIGN KEY (idDite)
      REFERENCES pDite(idDite) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade;
alter table wextid add CONSTRAINT wextid_idNepritomnost FOREIGN KEY (idNepritomnost)
      REFERENCES pNepritomnost(idNepritomnost) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade;
alter table wextid add CONSTRAINT wextid_idOsoba FOREIGN KEY (idOsoba)
      REFERENCES pOsoba(idOsoba) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade;
alter table wextid add CONSTRAINT wextid_idOsobaHlav FOREIGN KEY (idOsobaHlav)
      REFERENCES pOsobaHlav(idOsobaHlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade;
alter table wextid add CONSTRAINT wextid_idPracPom FOREIGN KEY (idPracPom)
      REFERENCES pPracPom(idPracPom) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade;
alter table wextid add CONSTRAINT wextid_idPracPomHlav FOREIGN KEY (idPracPomHlav)
      REFERENCES pPracPomHlav(idPracPomHlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade;
alter table wextid add CONSTRAINT wextid_idSkupOsob FOREIGN KEY (idSkupOsob)
      REFERENCES pSkupOsob(idSkupOsob) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade;
alter table wextid add CONSTRAINT wextid_idSmeny FOREIGN KEY (idSmeny)
      REFERENCES pSmeny(idSmeny) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade;
alter table wextid add CONSTRAINT wextid_idSrazka FOREIGN KEY (idSrazka)
      REFERENCES pSrazka(idSrazka) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade;
alter table wextid add CONSTRAINT wextid_idStalaMzdSloz FOREIGN KEY (idStalaMzdSloz)
      REFERENCES pStalaMzdSloz(idStalaMzdSloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade;

CREATE INDEX wExtId_IdBanSpojMzdy_index ON wExtId USING btree (idBanSpojMzdy);
CREATE INDEX wExtId_IdDite_index ON wExtId USING btree (idDite);
CREATE INDEX wExtId_IdNepritomnost_index ON wExtId USING btree (idNepritomnost);
CREATE INDEX wExtId_IdOsoba_index ON wExtId USING btree (idOsoba);
CREATE INDEX wExtId_IdOsobaHlav_index ON wExtId USING btree (idOsobaHlav);
CREATE INDEX wExtId_IdPracPom_index ON wExtId USING btree (idPracPom);
CREATE INDEX wExtId_IdPracPomHlav_index ON wExtId USING btree (idPracPomHlav);
CREATE INDEX wExtId_IdSkupOsob_index ON wExtId USING btree (idSkupOsob);
CREATE INDEX wExtId_IdSmeny_index ON wExtId USING btree (idSmeny);
CREATE INDEX wExtId_IdSrazka_index ON wExtId USING btree (idSrazka);
CREATE INDEX wExtId_IdStalaMzdSloz_index ON wExtId USING btree (idStalaMzdSloz);

-- externi ID pro majetek

alter table wextid add column idTypMaj integer;
alter table wextid add column idMajetek integer;
alter table wextid add column idTypLeas integer;
alter table wextid add column idLeasing integer;
alter table wextid add column idUmisteni integer;

alter table wextid add CONSTRAINT wextid_idTypMaj FOREIGN KEY (idTypMaj)
      REFERENCES mTypMaj(idTypMaj) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade;
alter table wextid add CONSTRAINT wextid_idMajetek FOREIGN KEY (idMajetek)
      REFERENCES mMajetek(idMajetku) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade;
alter table wextid add CONSTRAINT wextid_idTypLeas FOREIGN KEY (idTypLeas)
      REFERENCES mTypLeas(idTypLeas) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade;
alter table wextid add CONSTRAINT wextid_idLeasing FOREIGN KEY (idLeasing)
      REFERENCES mLeasing(idLeasing) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade;
alter table wextid add CONSTRAINT wextid_idUmisteni FOREIGN KEY (idUmisteni)
      REFERENCES mUmisteni(idUmisteni) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE cascade;

CREATE INDEX wExtId_IdTypMaj_index ON wExtId USING btree (idTypMaj);
CREATE INDEX wExtId_IdMajetek_index ON wExtId USING btree (idMajetek);
CREATE INDEX wExtId_IdTypLeas_index ON wExtId USING btree (idTypLeas);
CREATE INDEX wExtId_IdLeasing_index ON wExtId USING btree (idLeasing);
CREATE INDEX wExtId_IdUmisteni_index ON wExtId USING btree (idUmisteni);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 492, 't', %appVersion%, clock_timestamp());
