--------------------------------------------------------------------------------
-- Bug 24148 – [WinStrom] Pořadí výpočtu průměrné ceny
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION createdoklsklad(_idpoldokl integer, _iddoklad integer, _modul character varying)
  RETURNS integer AS
$BODY$
declare
  _doklad record;
  _polDokl record;
  _doklSklad record;
  _idDoklSklad integer;
  _cisDoklad character varying;
  _idrada integer;
  _rada record;
  _sklad record;
  _idUcetObd integer;
  _radaRok record;
  _typPohybuSklad character varying;
  _idTypUcOp integer;
  _cisloDokladuCursor refCursor;
  _typDoklFak record;
  _typDoklSkl record;
  _idUcetSklad integer;
  _idProtiUcet integer;
  _typUcOp record;
  _kurz numeric(19,6);
  _idMenyTuzemsko integer;
  _idMenySklad integer;
  _kurzMnozstvi numeric(19,6);
  _typVazby character varying;
  _stavSklad character varying;
  _typPohybuSkladK character varying;
  _isDobropis boolean;
  _datSklad date; 
  _ucetObdPlatiOd date;
  _ucetObdPlatiDo date;
begin
  if(_modul like 'POK') then
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad;
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    _stavSklad = 'stavSklad.vygenPokl';
  elsif (_modul like 'FAV' or _modul like 'FAP') then
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad;
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    _stavSklad = 'stavSklad.vygenFakt';
  else
    select * into _doklad from dDoklSklad where idDoklSklad = _idDoklad;
    select * into _polDokl from dPolSklad where idPolSklad = _idPolDokl;
    _stavSklad = 'stavSklad.vyroba';
  end if;

  --select * into _sklad from dTypDokl where idTypDokl = _polDokl.idskladu;
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;
  select * into _typDoklFak from dTypDokl where idTypDokl = _doklad.idTypDokl;

  if(_typDoklFak.typDoklK like 'typDokladu.dobropis') then
    _isDobropis = true;
  else
    _isDobropis = false;
  end if;
 
  if(_doklad.idTypDoklSkl is null) then 
    if((_modul like 'FAV' and _isDobropis) or (_modul like 'FAP')) then
      --pro dobropisy vydanych faktur a prijate faktury budeme mit prijemku
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuprijem;
    elsif((_modul like 'FAV' and not _isDobropis)) then
      --pro dobropisy prijatych faktur a vydane faktury budeme mit vydejku
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej;
    elsif(_modul like 'POK' and _doklad.typPohybuK like 'typPohybu.prijem') then
      --pro prijmovy pokladni doklad budeme mit vydejku
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej;
    elsif(_modul like 'POK' and _doklad.typPohybuK like 'typPohybu.vydej') then
      --pro vydajovy pokladni doklad budeme mit prijemku
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuprijem;
    elsif(_modul like 'SKL') then
      -- vyroba
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej;
    else
      raise exception 'createdoklsklad:Nespravny modul %', _modul;
    end if;
    if(_typDoklSkl is null) then
      return null;
    end if;
  else
    select * into _typDoklSkl from dTypDokl where idTypDokl = _doklad.idTypDoklSkl;
  end if;

  -- urceni spravneho typu pohybu
  if((_typDoklFak.modul like 'FAV') and (_typDoklFak.typDoklK like 'typDokladu.dobropis')) then
    _typPohybuSklad = _doklad.typPohybuK;
  else
    if(_doklad.typPohybuK like 'typPohybu.prijem') then
      _typPohybuSklad = 'typPohybu.vydej';
    else
      _typPohybuSklad = 'typPohybu.prijem';
    end if;
  end if;

  -- doplneni zbyvajicich veci zavislich na typu pohybu
  if(_typPohybuSklad like 'typPohybu.prijem') then
    _idrada = _typDoklSkl.idRadyPrijem;
    if(_idrada is null) then
      _idRada = _sklad.idRadyPrijem;
    end if;
    if(_idRada is null) then
      raise exception 'Neni odkud natahnout dokladovou radu.';
    end if;
    _idTypUcOp = _typDoklSkl.idTypUcOpP;
    if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then
      _typPohybuSkladK = 'typPohybuSklad.prijemPoFak';
    else
      _typPohybuSkladK = 'typPohybuSklad.prijemVyrob';
    end if;
  else
    _idrada = _typDoklSkl.idRadyVydej;
    if(_idrada is null) then
      _idRada = _sklad.idRadyVydej;
    end if;
    if(_idRada is null) then
      raise exception 'Neni odkud natahnout dokladovou radu.';
    end if;
    _idTypUcOp = _typDoklSkl.idTypUcOpV;
    if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then
      _typPohybuSkladK = 'typPohybuSklad.vydejPoFak';
    else
      _typPohybuSkladK = 'typPohybuSklad.vydejVyrob';
    end if;
  end if;

  _idUcetSklad = _sklad.idPrimUcet;
  select * into _typUcOp from utypucop where idtypucop = _idTypUcOp;
  if(_typPohybuSklad like 'typPohybu.prijem') then
    _idProtiUcet = _typUcOp.idProtiucetP;
  else
    _idProtiUcet = _typUcOp.idProtiucetV;
  end if;
  if(_modul = 'FAP') then
    _idProtiUcet = _doklad.idProtiUcet;
  end if;

  select * into _rada from drady where idRady = _idrada;
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _idUcetObd;
  select * into _radaRok from dRadyRok where iducetobdobi = _idUcetObd and idrady = _idrada;

  select nextval('seq_ddoklsklad') into _idDoklSklad;
  select dgetcisdokl(null, _idrada, _idUcetObd, 'SKL', _typPohybuSklad) into _cisloDokladuCursor;
  fetch _cisloDokladuCursor into _cisDoklad;

  -- ziskani kurzu pro menu skladu
  -- select getKurzFromSklad(_polDokl.idSkladu, _polDokl.datVyst) into _kurz;
  -- nejde pouzit protoze potrebuju jak kurz tak kurzove mnozstvi a ne prepocteny nna kurzove mnozstvi 1
  select idMeny into _idMenyTuzemsko from nNastav where _polDokl.datVyst >= PlatiOdData order by PlatiOdData desc limit 1;
  if (_idMenyTuzemsko is null) then
    select idMeny into _idMenyTuzemsko from nNastav where PlatiOdData is null limit 1;
  end if;
  --select idMeny into _idMenySklad from dTypDokl where idTypDokl = _polDokl.idSkladu;

  if(_sklad.idMeny is null or _sklad.idMeny = _idMenyTuzemsko) then
    _kurz = 0.0;
    _kurzMnozstvi = 1;
  else
    select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy
      where idMeny = _sklad.idMeny and _polDokl.datVyst >= PlatiOdData and typkurzuk = 'typKurzu.obecny'
      order by PlatiOdData desc limit 1;
    if(_kurz is null) then
      select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy
        where idMeny = _sklad.idMeny and PlatiOdData is null and typkurzuk = 'typKurzu.obecny'
        limit 1;
    end if;
    if(_kurz is null) then
      raise exception '0001:getKurzFromSklad : neexistuje kurz!';
    end if;
  end if;

  /*select CURRENT_DATE into _datSklad;
  select platiOdData, platiDoData into _ucetObdPlatiOd, _ucetObdPlatiDo from nucetobdobi where idUcetObdobi = _idUcetObd;
  if(_datSklad < _ucetObdPlatiOd) then
    _datSklad = _ucetObdPlatiOd;
  elsif (_datSklad > _ucetObdPlatiDo) then
    _datSklad = _ucetObdPlatiDo;
  else
    -- datSklad je v pohode
  end if;*/
  _datSklad = _doklad.datVyst;
 
  if(_isDobropis) then
    if(_modul like 'FAV') then
      _typPohybuSkladK = 'typPohybuSklad.prijemVratka';
    else
      _typPohybuSkladK = 'typPohybuSklad.prijemVydejVratka';
    end if;
  end if;

  -- vytvoreni noveho skladoveho dokladu
  insert into dDoklSklad (idDoklSklad, lastUpdate, datVyst, datSklad, datUcto, kod, modul, typPohybuK, idTypDokl, idBsp,ucetni,
         idFirmy, nazFirmy, ulice, mesto, psc, idStatu, ic, dic, vatId,
         idMur, idKrajUrc, idStatUrc, idTypUcOp, cisObj, cisDodak, doprava, idDruhDopr, popis, poznam,
         idStred, idZakazky, idMeny, kurz, kurzMnozstvi,
         eanKod, idstatpuvod, idstatodesl,
         idPrimUcet, idProtiUcet, idRady, idPolRady, zdrojProFak, stavSkladK , typPohybuSkladK,
         idCinnost, idKontaktOsoba, idZodpOsoba
         )
       values (_idDoklSklad, LOCALTIMESTAMP, _doklad.datVyst, _datSklad, _doklad.datVyst, _cisDoklad, 'SKL', _typPohybuSklad, _typDoklSkl.idTypDokl, _sklad.idBsp, _typDoklSkl.ucetni,
         _doklad.idFirmy, _doklad.nazFirmy, _doklad.ulice, _doklad.mesto, _doklad.psc, _doklad.idStatu, _doklad.ic, _doklad.dic, _doklad.vatId,
         _doklad.idMur, _doklad.idKrajUrc, _doklad.idStatUrc, _idTypUcOp, _doklad.cisObj, null, _doklad.doprava, _doklad.idDruhDopr, _doklad.popis, _doklad.poznam,
         _doklad.idStred, _doklad.idZakazky, _sklad.idMeny, _kurz, _kurzMnozstvi,
         _doklad.eanKod, _doklad.idstatpuvod, _doklad.idstatodesl,
         _idUcetSklad, _idProtiUcet, _idRada, _radaRok.idRadyRok, false, _stavSklad, _typPohybuSkladK,
         _doklad.idCinnost, _doklad.idKontaktOsoba, _doklad.idZodpOsoba
         );


  if (_modul = 'SKL') then
    _typVazby = 'typVazbyDokl.hlavaSklKus';
  else
    _typVazby = 'typVazbyDokl.hlavaSkl';
  end if;

  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)
       values (0.0, _idDoklad, _idDoklSklad, _doklad.modul, 'SKL', false, _typVazby);

  return _idDoklSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createdoklsklad(integer, integer, character varying) OWNER TO %firmaRole%;

-- Function: sprepoctisumydokladu(integer, date)
-- DROP FUNCTION sprepoctisumydokladu(integer, date);
CREATE OR REPLACE FUNCTION sprepoctisumydokladu(i_iddoklsklad integer, i_datVyst date)
  RETURNS void AS
$BODY$
declare
 _sumZkl numeric(15,2);
 _sumZklMen numeric(15,2);
 _sumZklDoklad numeric(15,2);
 _sumZklMenDoklad numeric(15,2);
 _datVyst date;
 _datUcto date;
begin
 select sum(sumZkl), sum(sumZklMen) into _sumZkl, _sumZklMen from dPolSklad where idDoklSklad = i_idDoklSklad and stornoPol = false;
 select sumCelkem, sumCelkemMen, datVyst, datUcto into _sumZklDoklad, _sumZklMenDoklad, _datVyst, _datUcto from dDoklSklad where idDoklSklad = i_idDoklSklad;
 if(_sumZkl is null) then _sumZkl = 0.0; end if;
 if(_sumZklMen is null) then _sumZklMen = 0.0; end if;
 if(_sumZkl <> _sumZklDoklad or _sumZklMen <> _sumZklMenDoklad or not compareDate(i_datVyst, _datVyst) or not compareDate(i_datVyst, _datUcto)) then
   update dDoklSklad set lastUpdate = LOCALTIMESTAMP, sumCelkem = _sumZkl, sumCelkemMen = _sumZklMen, sumOsv = _sumZkl, sumOsvMen = _sumZklMen, datVyst = i_datVyst, datUcto = i_datVyst, datSklad = i_datVyst where idDoklSklad = i_idDoklSklad;
 end if;
end
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisumydokladu(integer, date) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 515, 't', %appVersion%, clock_timestamp());