--------------------------------------------------------------------------------
-- Bug 24233 – [WinStrom] Umoznit prechod na Postgresql 9.x
--------------------------------------------------------------------------------

-- Toto je potreba u PostgreSQL 9.1
DROP FUNCTION IF EXISTS deletevazuzel(tablename character varying, _idZaznamu integer);

CREATE OR REPLACE FUNCTION deletevazuzel(tablename character varying, _idZaznamu integer)
  RETURNS void AS
$BODY$ 
begin 
    -- tyhle vazebni uzly smazeme, ukazovaly by totiz na smazany zaznam 
    delete from wvazuzel mazvu
        where mazvu.idvazuzel in 
            -- vazebni uzly k tomuhle stromu s tableName a s timto zaznamem tj. ukazuje na idZaznamu 
            (select idvazuzel 
            from wvazuzel vu 
            left join wuzel u on vu.iduzlu = u.iduzel 
            left join wstrom s on u.idstrom = s.idstrom 
            where vu.idzaznamu = _idZaznamu
            and s.tabulka = tableName); 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION deletevazuzel(character varying, integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 531, 't', %appVersion%, clock_timestamp());
