---------------------------------------------------------------------------------------
-- Bug 25789 – [WinStrom] Zboží - chyba při hromadné objednávce, pokud je rezervace
-- Bug 25844 – [WinStrom] Problém s rezervacemi
---------------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dgetstavnasklade(i_skladkartaid integer, i_datum date, i_polskladid integer, i_firmaid integer, i_sarze character varying, i_expirace date, i_typpohybuK character varying)
  RETURNS numeric AS
$BODY$ 
declare 
  _sklad integer; 
  _cenik integer; 
  _stavMj numeric(19,6); 
  _firmaRezerMj numeric(19,6); 
  _celkemRezerMj numeric(19,6); 
begin 
  SELECT dgetstavnasklade(i_skladkartaid, i_datum, i_polskladid, i_sarze, i_expirace, i_typPohybuK) INTO _stavMj; 
  
  -- vymazeme jiz neplatne rezervace 
  delete from srezervace where datumdo is not null and datumdo < date(now()); 
  -- nacteme si info ze skladove karty 
  SELECT idCenik, idSkladu INTO _cenik, _sklad FROM sKarty WHERE idKarty = i_skladkartaid; 
  -- zjistime kolik je celkem rezervovano - od/do ignorujeme (bug 25844, 25789), muselo by se zohlednovat uz pri plneni pole skladmj a nebo toto pole idealne vyhodit
  select coalesce(sum(skladmj), 0) into _celkemRezerMj from srezervace where idcenik = _cenik and idsklad = _sklad;
   
  IF (i_firmaid > 0) THEN 
    -- zjistime kolik ma firma rezervovano 
    select coalesce(sum(skladmj), 0) into _firmaRezerMj from srezervace where idfirmy = i_firmaid and idcenik = _cenik and idsklad = _sklad; 
  ELSE 
    _firmaRezerMj := 0; 
  END IF; 
   
  -- spocteme kolik mu muzeme dat 
  _stavMj := minValue(_stavMj, maxValue(_stavMj - _celkemRezerMj, 0) + _firmaRezerMj); 
   
  RETURN _stavMj; 
end 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnasklade(integer, date, integer, integer, character varying, date, character varying) OWNER TO %firmaRole%;

--------------------------------------------------------------------------------
-- Bug 25679 – [winstrom] mzdy - výpočet dovolené
--------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
    pocet integer;
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  -- kalkulacku aktualizujeme jen pro cechy
  if (stat = 'CZ_CZ') then
-- zacatek ceskeho bloku
-- update slozek
ALTER TABLE pmzdsloz DISABLE TRIGGER pmzdslozupdatedatumvypoctu;

UPDATE pcismzdsloz SET lastupdate = '2011-10-18 00:00:00.000', vsdnyprac = false WHERE idcismzdsloz = 47;

ALTER TABLE pmzdsloz ENABLE TRIGGER pmzdslozupdatedatumvypoctu;

-- update hlavicky kalkulacky
-- update inicializacnich radek kalkulacky
UPDATE pmzdcalcinit SET lastupdate = '2011-10-18 00:00:00.000', zpracdatumk = 'mzdCalcZpracDatum.mesicPredKon' WHERE idmzdcalcinit = 48;

-- update radek kalkulacky
-- pracovni pomery
-- parametry pro typ prac pom

-- konec ceskeho bloku
  end if; 
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 535, 't', %appVersion%, clock_timestamp());
