--------------------------------------------------------------------------------
-- Bug 24892 – [winstrom] mzdy - zrušení výpočtu
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION popravslozkypromesic(_rok integer, _mesic integer, _idosoba integer)
  RETURNS void AS $$
declare aktdatum date;
        datumpo date;
begin
  aktdatum = date (_rok || '-' || _mesic || '-01');
  datumpo = aktdatum + interval '1 month';

  -- smazeme jiz nepotrebne
  delete from pmzdsloz as M using pstalamzdsloz as S where M.idstalamzdsloz = S.idstalamzdsloz
    and M.idstalamzdsloz is not null and M.rok = _rok and M.mesic = _mesic and (_idosoba = -1 or M.idosoba = _idosoba) and
      not ((S.datumod is null or (S.datumod < datumpo)) and (S.datumdo is null or (S.datumdo >= aktdatum)));

  delete from pmzdsloz as M using psrazka as S where M.idsrazka = S.idsrazka
    and M.idsrazka is not null and M.rok = _rok and M.mesic = _mesic and (_idosoba = -1 or M.idosoba = _idosoba) and
      not ((S.srazkaod is null or (S.srazkaod < datumpo)) and (S.srazkado is null or (S.srazkado >= aktdatum)));

  -- nastavime aktualni hodnoty
  perform pupdatemzdslozfromstalasloz(idmzdsloz, idstalamzdsloz) from pmzdsloz as S where
    rok = _rok and mesic = _mesic and idstalamzdsloz is not null and (_idosoba = -1 or idosoba = _idosoba)
    and zmenaCastMzd = false;

  perform pupdatemzdslozfromsrazka(idmzdsloz, idsrazka) from pmzdsloz as S where 
    rok = _rok and mesic = _mesic and idsrazka is not null and (_idosoba = -1 or idosoba = _idosoba)
    and zmenaCastMzd = false;
  
  -- vygenerujeme chybejici slozky
  perform pupdatemzdslozfromstalasloz(pcreatemzdslozfromcis(idcismzdsloz, idpracpom, S.idosoba, _rok, _mesic), idstalamzdsloz)
    from pstalamzdsloz as S inner join ppracpomhlav as P on P.idpracpomhlav = S.idpracpom
    where (_idosoba = -1 or S.idosoba = _idosoba)
      and (aktivniod is null or aktivniod < datumpo) and (aktivnido is null or aktdatum <= aktivnido)
      and (datumod is null or (datumod < datumpo)) and (datumdo is null or (datumdo >= aktdatum))
      and (select count(*) from pmzdsloz where rok = _rok and mesic = _mesic and idstalamzdsloz = S.idstalamzdsloz) = 0;

  perform pupdatemzdslozfromsrazka(pcreatemzdslozfromcis(idcismzdsloz, null, S.idosoba, _rok, _mesic), idsrazka)
    from psrazka as S inner join ppracpomhlav as P on P.idosoba = S.idosoba
    where (_idosoba = -1 or S.idosoba = _idosoba)
      and (aktivniod is null or aktivniod < datumpo) and (aktivnido is null or aktdatum <= aktivnido)
      and (srazkaod is null or (srazkaod < datumpo)) and (srazkado is null or (srazkado >= aktdatum))
      and (select count(*) from pmzdsloz where rok = _rok and mesic = _mesic and idsrazka = S.idsrazka) = 0
    limit 1;
end; 
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.popravslozkypromesic(integer, integer, integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 559, 't', %appVersion%, clock_timestamp());
