--------------------------------------------------------------------------------
-- Bug 27767 – [WinStrom] Výpočet mzdy mimo platnost pracovního poměru
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION ppracpomhlavdeleteslozky()
  RETURNS trigger AS $$
declare
  pomeru integer;
  maxdo date;
begin
  delete from pmzdsloz where idpracpom = OLD.idpracpomhlav;
  delete from psmeny where idpracpom = OLD.idpracpomhlav;
  
  select count(*) into pomeru from ppracpomhlav where idpracpomhlav <> OLD.idpracpomhlav and idosoba = OLD.idosoba;
  if (pomeru = 0) then
    delete from pmzdsloz where idosoba = OLD.idosoba;
  else
    select count(*) into pomeru from ppracpomhlav where idpracpomhlav <> OLD.idpracpomhlav and idosoba = OLD.idosoba and aktivnido is null;
    if (pomeru = 0) then
      select max(aktivnido) into maxdo from ppracpomhlav where idpracpomhlav <> OLD.idpracpomhlav and idosoba = OLD.idosoba;
      
      delete from pmzdsloz where idosoba = OLD.idosoba and ((rok > date_part('year', maxdo)) or (rok = date_part('year', maxdo) and mesic > date_part('month', maxdo)));
    end if;
    
    select min(aktivniod) into maxdo from ppracpomhlav where idpracpomhlav <> OLD.idpracpomhlav and idosoba = OLD.idosoba;
    delete from pmzdsloz where idosoba = OLD.idosoba and ((rok < date_part('year', maxdo)) or (rok = date_part('year', maxdo) and mesic < date_part('month', maxdo)));
  end if;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ppracpomhlavdeleteslozky() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 576, 't', %appVersion%, clock_timestamp());
