--------------------------------------------------------------------------------
-- Bug 29499 – [WinStrom] Individualni cenik a cena 0.0
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION calcceny(c_nakupCena numeric, c_cenazakl numeric,
  c_ceny numeric[], c_limmnoz numeric[], odberCena numeric,
  h_idcenhlad integer, h_typcenyvychozik varchar, h_typvypcenyk varchar, h_typcenyvychozi25k varchar, h_typvypceny25k varchar, 
  h_zaokrjakk varchar, h_zaokrnak varchar, h_proczakl numeric, h_procento numeric[], h_limmnoz numeric[])
  RETURNS numeric[] AS $$
declare
  vychozicena numeric;
  cena1 numeric;
  ceny numeric[];
  i integer;
begin
  -- otestujeme zda nemame cenu pro konretniho odberatele
  if odberCena is not null and odberCena > 0 then
    return array[odbercena, 0, 0, 0, 0, 0, 0, 0, 0, null];
  end if;

  if (h_idcenhlad is null) then
    for i in 1..4 loop
      ceny[i] = 0;
      if (c_limmnoz[i] > 0) then
        ceny[i] = c_ceny[i];
      end if;
    end loop;
    vychozicena = c_cenazakl;
    if vychozicena = 0 then
      vychozicena = null;
    end if;
    
    return vychozicena || ceny || c_limmnoz || cast(h_idcenhlad as numeric);
  end if;
  
  vychozicena = (CASE h_typcenyvychozik
    WHEN 'typCenyVychozi.nakCena' THEN c_nakupCena
    WHEN 'typCenyVychozi.zaklCena' THEN c_cenazakl
    ELSE null
  END);
  
  cena1 = calccena(vychozicena, h_typvypcenyk, h_proczakl);
  
  vychozicena = (CASE h_typcenyvychozi25k
    WHEN 'typCenyVychozi.nakCena' THEN c_nakupCena
    WHEN 'typCenyVychozi.zaklCena' THEN cena1
    ELSE null
  END);
  
  cena1 = zaokrouhli(cena1, h_zaokrjakk, h_zaokrnak);
  for i in 1..4 loop
    ceny[i] = 0;
    if (h_limmnoz[i] > 0) then
      ceny[i] = zaokrouhli(calccena(vychozicena, h_typvypceny25k, h_procento[i]), h_zaokrjakk, h_zaokrnak);
    end if;
  end loop;
  
  return cena1 || ceny || h_limmnoz || cast(h_idcenhlad as numeric);
end; 
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.calcceny(numeric, numeric, numeric[], numeric[], numeric, integer, 
   varchar, varchar, varchar, varchar, varchar, varchar, numeric, numeric[], numeric[]) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 615, 't', %appVersion%, clock_timestamp());
