--------------------------------------------------------------------------------
-- Bug 30094 – [winstrom] mzdy - účtování cestovních náhrad
--------------------------------------------------------------------------------

ALTER TABLE nnastav ADD COLUMN idmzdtdintcestdolim integer;
ALTER TABLE nnastav ADD CONSTRAINT nnastav_idmzdtdintcestdolim FOREIGN KEY (idmzdtdintcestdolim)
  REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
CREATE INDEX nNastav_IdMzdTdIntCestDoLim_index ON nNastav USING btree (IdMzdTdIntCestDoLim);

ALTER TABLE pskuposob ADD COLUMN idtdintcestdolim integer;
ALTER TABLE pskuposob ADD CONSTRAINT pskuposob_idtdintcestdolim FOREIGN KEY (idtdintcestdolim)
  REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
CREATE INDEX pSkupOsob_IdTdIntCestDoLim_index ON pSkupOsob USING btree (IdTdIntCestDoLim);

ALTER TABLE ppracpom ADD COLUMN idtdintcestdolim integer;
ALTER TABLE ppracpom ADD CONSTRAINT ppracpom_idtdintcestdolim FOREIGN KEY (idtdintcestdolim)
  REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
CREATE INDEX pPracPom_IdTdIntCestDoLim_index ON pPracPom USING btree (IdTdIntCestDoLim);

--------------------------------------------------------------------------------
-- Bug 30093 – [winstrom] mzdy - příplatek za práci ve ztíženém prostředí
--------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
    pocet integer;
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  -- kalkulacku aktualizujeme jen pro cechy
  if (stat = 'CZ_CZ') then
-- zacatek ceskeho bloku
-- update slozek

ALTER TABLE pmzdsloz DISABLE TRIGGER pmzdslozupdatedatumvypoctu;

UPDATE pcismzdsloz SET nazev = 'Příplatek za práci ve ztíženém prac. prostředí', vscastnahod = true, castkahod = 4.81 WHERE idcismzdsloz = 35;

ALTER TABLE pmzdsloz ENABLE TRIGGER pmzdslozupdatedatumvypoctu;

-- konec ceskeho bloku
  end if; 
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 630, 't', %appVersion%, clock_timestamp());