--------------------------------------------------------------------------------
-- Bug 30006 – [winstrom] objednavka oznacena "Hotovo" sa neponuka na vyskladnenie
--------------------------------------------------------------------------------

-- trigger pri update rezervace
CREATE OR REPLACE FUNCTION srezervaceupdaterezer()
  RETURNS trigger AS $$
declare
  zmena numeric(19,6);
  puvodni numeric(19,6);
  volnosklad numeric(19,6);
begin
  if (getglotxvariable('rezerDisableTrigger') is not null) then
    return NEW;
  end if;

  zmena = NEW.mnozstvi;
  puvodni = 0;
  if (tg_op = 'UPDATE') then
    if (NEW.idsklad = OLD.idsklad and NEW.idcenik = OLD.idcenik and NEW.mnozstvi = OLD.mnozstvi and NEW.datumod = OLD.datumod) then
      return NEW;
    end if;
  
    if (NEW.idsklad <> OLD.idsklad or NEW.idcenik <> OLD.idcenik) then          -- pokud menime zbozi na rezervaci
      if (OLD.skladmj > 0) then                                                 -- a nejake bylo na sklade
        perform srezervujzprijemky(OLD.idcenik, OLD.idsklad, OLD.skladmj);     -- muzeme ho zarezervovat nekomu jinemu
      end if;
    else
      puvodni = OLD.skladmj;
      zmena = NEW.mnozstvi - OLD.skladmj;
      if (NEW.mnozstvi > OLD.mnozstvi) then             -- mnozstvi se zvetsilo
        if (OLD.skladmj < OLD.mnozstvi) then            -- pokud na sklade bylo min nez zarezervovano, tak stejne nic na sklade nenajdem
          zmena = 0;
        end if;
      end if;
    end if;
  end if;
  
  if (zmena > 0) then
    select dgetstavnaskladeaktualni(NEW.idcenik, NEW.idsklad, date(now()), -1) into volnosklad;
    
    update srezervace set skladmj = puvodni + minvalue(mnozstvi-puvodni, volnosklad) where idrezervace = NEW.idrezervace;
  else
    if (zmena < 0) then
      update srezervace set skladmj = puvodni + zmena where idrezervace = NEW.idrezervace;
    
      perform srezervujzprijemky(NEW.idcenik, NEW.idsklad, -zmena);
    end if;
  end if;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.srezervaceupdaterezer() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 633, 't', %appVersion%, clock_timestamp());
