--------------------------------------------------------------------------------
-- Bug 29969 – [WinStrom] - Objednávky přijaté - realizovatelnost objednávky
--------------------------------------------------------------------------------

-- odstranění triggeru místo kterého byl v upgradu 626 odstraněn jiný
DROP TRIGGER IF EXISTS dpolskladupdaterealizovatelnost ON dpolsklad;
DROP FUNCTION IF EXISTS dpolskladupdaterealizovatelnost();

-- trigger resici smazani skladove polozky pokud nahodou neexistuje
CREATE OR REPLACE FUNCTION dpolskladdeleterezer()
  RETURNS trigger AS $$
begin
  if (OLD.mnozMj > 0) then
    perform srezervujzprijemky(OLD.idCenik, OLD.idBspSkl, -OLD.mnozMj);
  end if;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolskladdeleterezer() OWNER TO %firmaRole%;

-- odstranění triggeru pokud existuje, aby šel následně vytvořit
DROP TRIGGER IF EXISTS dpolskladdeleterezer ON dpolsklad;

-- navěšení triggeru na tabulku položek skladovych dokladů
CREATE TRIGGER dpolskladdeleterezer AFTER DELETE ON dpolsklad
  FOR EACH ROW EXECUTE PROCEDURE dpolskladdeleterezer();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 671, 't', %appVersion%, clock_timestamp());
