--------------------------------------------------------------------------------
-- Bug 31596 – [WinStrom] - Faktury - Umožnit odpočet neuhrazené zálohy
--------------------------------------------------------------------------------

ALTER TABLE nnastav ADD COLUMN odpocneuhrzalfav boolean NOT NULL DEFAULT false;
ALTER TABLE nnastav ADD COLUMN odpocneuhrzalfap boolean NOT NULL DEFAULT false;

-- trigger nastavující účet na položce odpočtu zálohy, pokud zálohu napřed odpočtu a až poté uhradim
CREATE OR REPLACE FUNCTION dvazebtabinsertuhradazal()
  RETURNS trigger AS $$
declare _idProti integer;
        _typPohybu varchar;
        _pocetPol integer;
        _idUcetPol integer;
        _idMdPol integer;
begin
  if NEW.typVazbyK = 'typVazbyDokl.uhradaZALOHY' then
    select idProtiUcet, typPohybuK into _idProti, _typPohybu from ddoklint where iddoklint = NEW.idTabB;
    
    -- pokud na uhrazujicih dokladu ucet neni a vysledna polozka je jenom jedna pouzijeme ucet z polozky
    if (_idProti is null) then
      select count(*), min(idZklDalUcet), min(idZklMdUcet) into _pocetPol, _idUcetPol, _idMdPol
        from dPolFak as P inner join dVazebTab as V on P.idPolFak = V.idTabA and V.typVazbyK = 'typVazbyDokl.odpocetZALOHY' where V.idTabB = NEW.idTabA;
      if (_typPohybu <> 'typPohybu.prijem') then
        _idUcetPol = _idMdPol;
      end if;
      
      if (_pocetPol = 1 and _idUcetPol is not null) then
        update ddoklint set idProtiUcet = _idUcetPol where iddoklint = NEW.idTabB;
        return NEW;
      end if;
    end if;
    
    if (_typPohybu = 'typPohybu.prijem') then
      update dPolFak set lastupdate = now(), idZklDalUcet = _idProti where idPolFak in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.odpocetZALOHY' and idTabB = NEW.idTabA)
        and compareId(idZklDalUcet, _idProti) = false;
    else
      update dPolFak set lastupdate = now(), idZklMdUcet  = _idProti where idPolFak in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.odpocetZALOHY' and idTabB = NEW.idTabA)
        and compareId(idZklMdUcet,  _idProti) = false;
    end if;
  end if;
  
  return NEW;
end;   
$$ LANGUAGE plpgsql;
ALTER FUNCTION dvazebtabinsertuhradazal() OWNER TO %firmaRole%;

CREATE TRIGGER dvazebtabinsertuhradazal AFTER INSERT ON dvazebtab
  FOR EACH ROW EXECUTE PROCEDURE dvazebtabinsertuhradazal();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 676, 't', %appVersion%, clock_timestamp());
