--------------------------------------------------------------------------------
-- Bug 32455 – [FlexiBee] Aktualizovat číselník finančních úřadů
--------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  -- kalkulacku aktualizujeme jen pro cechy, pro vsechny ostatni ji smazeme
  if (stat = 'CZ_CZ') then
-- zacatek ceskeho bloku

INSERT INTO aadresar (lastupdate, kod, nazev, show, platiod, platido, postovnishodna, limitfak, platcedph, bonita, typvztahuk, kodpojistovny, nazevpojistovny, pocetpriloh, uuid)
 VALUES 
('2012-01-08 00:00:00.000', 'FÚ - 013', 'SFÚ - specializovaný FÚ', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '013', 'SFÚ', 0, 'CZ_FU_013'),
('2012-01-08 00:00:00.000', 'FÚ - 049', 'Finanční úřad Benátky nad Jizerou', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '049', 'Benátky nad Jizerou', 0, 'CZ_FU_049'),
('2012-01-08 00:00:00.000', 'FÚ - 054', 'Finanční úřad Pečky', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '054', 'Pečky', 0, 'CZ_FU_054'),
('2012-01-08 00:00:00.000', 'FÚ - 058', 'Finanční úřad Praha východ', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '058', 'Praha východ', 0, 'CZ_FU_058'),
('2012-01-08 00:00:00.000', 'FÚ - 064', 'Finanční úřad Březnice', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '064', 'Březnice', 0, 'CZ_FU_064'),
('2012-01-08 00:00:00.000', 'FÚ - 093', 'Finanční úřad Kamenice nad Lipou', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '093', 'Kamenice nad Lipou', 0, 'CZ_FU_093'),
('2012-01-08 00:00:00.000', 'FÚ - 120', 'Finanční úřad Kdyně', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '120', 'Kdyně', 0, 'CZ_FU_120'),
('2012-01-08 00:00:00.000', 'FÚ - 130', 'Finanční úřad Toužim', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '130', 'Toužim', 0, 'CZ_FU_130'),
('2012-01-08 00:00:00.000', 'FÚ - 147', 'Finanční úřad Manětín', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '147', 'Manětín', 0, 'CZ_FU_147'),
('2012-01-08 00:00:00.000', 'FÚ - 156', 'Finanční úřad Chodov', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '156', 'Chodov', 0, 'CZ_FU_156'),
('2012-01-08 00:00:00.000', 'FÚ - 161', 'Finanční úřad Bor', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '161', 'Bor', 0, 'CZ_FU_161'),
('2012-01-08 00:00:00.000', 'FÚ - 173', 'Finanční úřad Doksy', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '173', 'Doksy', 0, 'CZ_FU_173'),
('2012-01-08 00:00:00.000', 'FÚ - 174', 'Finanční úřad Mimoň', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '174', 'Mimoň', 0, 'CZ_FU_174'),
('2012-01-08 00:00:00.000', 'FÚ - 184', 'Finanční úřad Vejprty', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '184', 'Vejprty', 0, 'CZ_FU_184'),
('2012-01-08 00:00:00.000', 'FÚ - 229', 'Finanční úřad Chlumec nad Cidlinou', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '229', 'Chlumec nad Cidlinou', 0, 'CZ_FU_229'),
('2012-01-08 00:00:00.000', 'FÚ - 234', 'Finanční úřad Heřmanův Městec', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '234', 'Heřmanův Městec', 0, 'CZ_FU_234'),
('2012-01-08 00:00:00.000', 'FÚ - 285', 'Finanční úřad Letovice', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '285', 'Letovice', 0, 'CZ_FU_285'),
('2012-01-08 00:00:00.000', 'FÚ - 315', 'Finanční úřad Polná', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '315', 'Polná', 0, 'CZ_FU_315'),
('2012-01-08 00:00:00.000', 'FÚ - 316', 'Finanční úřad Třešť', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '316', 'Třešť', 0, 'CZ_FU_316'),
('2012-01-08 00:00:00.000', 'FÚ - 327', 'Finanční úřad Němčice nad Hanou', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '327', 'Němčice nad Hanou', 0, 'CZ_FU_327'),
('2012-01-08 00:00:00.000', 'FÚ - 331', 'Finanční úřad Jemnice', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '331', 'Jemnice', 0, 'CZ_FU_331'),
('2012-01-08 00:00:00.000', 'FÚ - 337', 'Finanční úřad Bojkovice', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '337', 'Bojkovice', 0, 'CZ_FU_337'),
('2012-01-08 00:00:00.000', 'FÚ - 347', 'Finanční úřad Hrušovany n.Jevišovkou', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '347', 'Hrušovany n.Jevišovkou', 0, 'CZ_FU_347'),
('2012-01-08 00:00:00.000', 'FÚ - 395', 'Finanční úřad Kojetín', true, 2013, 9999, true, 0.0, false, 0, 'typVztahu.financniUrad', '395', 'Kojetín', 0, 'CZ_FU_395');

-- konec ceskeho bloku
end if; 
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
INSERT INTO dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
    VALUES (nextval('seq_dbversion'), 691, 't', %appVersion%, clock_timestamp());
