--------------------------------------------------------------------------------
-- Bug 34786 – [FlexiBee] - Tisk štítků na balík s adresou a čárovým kódem PPL
--------------------------------------------------------------------------------

ALTER TABLE dformadopravy ADD COLUMN cisbal boolean NOT NULL DEFAULT false;
ALTER TABLE dformadopravy ADD COLUMN cisbalakt integer DEFAULT 0;
ALTER TABLE dformadopravy ADD COLUMN cisbalod integer DEFAULT 0;
ALTER TABLE dformadopravy ADD COLUMN cisbaldo integer DEFAULT 0;
ALTER TABLE dformadopravy ADD COLUMN cisbalodbud integer DEFAULT 0;
ALTER TABLE dformadopravy ADD COLUMN cisbaldobud integer DEFAULT 0;
ALTER TABLE dformadopravy ADD COLUMN cisbalcislic integer DEFAULT 0;
ALTER TABLE dformadopravy ADD COLUMN cisbalprefix character varying(30);
ALTER TABLE dformadopravy ADD COLUMN cisbalpostfix character varying(30);

ALTER TABLE ddoklfak ADD COLUMN balikpocet integer DEFAULT 0;
ALTER TABLE ddoklfak ADD COLUMN balikvytvxml boolean NOT NULL DEFAULT false;
ALTER TABLE ddoklfak ADD COLUMN balikzacislovan boolean NOT NULL DEFAULT false;

ALTER TABLE ddoklint ADD COLUMN balikpocet integer DEFAULT 0;
ALTER TABLE ddoklint ADD COLUMN balikvytvxml boolean NOT NULL DEFAULT false;
ALTER TABLE ddoklint ADD COLUMN balikzacislovan boolean NOT NULL DEFAULT false;

ALTER TABLE ddoklsklad ADD COLUMN balikpocet integer DEFAULT 0;
ALTER TABLE ddoklsklad ADD COLUMN balikvytvxml boolean NOT NULL DEFAULT false;
ALTER TABLE ddoklsklad ADD COLUMN balikzacislovan boolean NOT NULL DEFAULT false;

ALTER TABLE ddoklobch ADD COLUMN balikpocet integer DEFAULT 0;
ALTER TABLE ddoklobch ADD COLUMN balikvytvxml boolean NOT NULL DEFAULT false;
ALTER TABLE ddoklobch ADD COLUMN balikzacislovan boolean NOT NULL DEFAULT false;

CREATE SEQUENCE seq_dcislobal
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_dcislobal OWNER TO %firmaRole%;

CREATE TABLE dcislobal
(
  idcislobal integer DEFAULT nextval('seq_dcislobal'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  cislo character varying(100),
  idformadopravy integer NOT NULL,
  iddoklfak integer,
  iddoklobch integer,
  iddoklsklad integer,
  CONSTRAINT dcislobal_pkey PRIMARY KEY (idcislobal),
  CONSTRAINT dcislobal_idformadopravy FOREIGN KEY (idformadopravy)
      REFERENCES dformadopravy (idformadopravy) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT dcislobal_iddoklfak FOREIGN KEY (iddoklfak)
      REFERENCES ddoklfak (iddoklfak) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT dcislobal_iddoklobch FOREIGN KEY (iddoklobch)
      REFERENCES ddoklobch (iddoklobch) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT dcislobal_iddoklsklad FOREIGN KEY (iddoklsklad)
      REFERENCES ddoklsklad (iddoklsklad) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE dcislobal OWNER TO %firmaRole%;

CREATE INDEX dCisloBal_IdFormaDopravy_index ON dCisloBal USING btree (IdFormaDopravy);
CREATE INDEX dCisloBal_IdDoklFak_index ON dCisloBal USING btree (IdDoklFak);
CREATE INDEX dCisloBal_IdDoklSklad_index ON dCisloBal USING btree (IdDoklSklad);
CREATE INDEX dCisloBal_IdDoklObch_index ON dCisloBal USING btree (IdDoklObch);

-- zvyseni verze databaze
INSERT INTO dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  VALUES (nextval('seq_dbversion'), 751, 't', %appVersion%, clock_timestamp());
