-------------------------------------------------------------------------
-- Bug 36616 – [FlexiBee] Chybně nastavená databázová role při zkracování jejího názvu
-------------------------------------------------------------------------

-- funkce vznikla 2009-07-27 v upgrade126.sql, ale do create2.sql byla přidána až 2010-01-18,
-- takže mohou existovat firmy, kde funkce chybí => doplnění:

create or replace function testuniquekodvplatnosti() 
        returns trigger as 
$BODY$
declare
        pocetstejnych integer;
begin
        select count(1) into pocetstejnych from asmerkod akod
                where akod.kod = new.kod and (akod.platiod < new.platido and akod.platido > new.platiod);
        if (pocetstejnych != 0) then
                raise exception 'Test unikatnosti kodu % s platiOd % do platiDo % neprosel.', new.kod, new.platiod, new.platido;
        end if;
        return new;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;


-- oprava vlastníků databázových objektů FlexiBee

ALTER TABLE public.seq_aadresar OWNER TO %firmaRole%;
ALTER TABLE public.aadresar OWNER TO %firmaRole%;
ALTER TABLE public.seq_abanspoj OWNER TO %firmaRole%;
ALTER TABLE public.abanspoj OWNER TO %firmaRole%;
ALTER TABLE public.seq_akontakty OWNER TO %firmaRole%;
ALTER TABLE public.akontakty OWNER TO %firmaRole%;
ALTER TABLE public.seq_amisturc OWNER TO %firmaRole%;
ALTER TABLE public.amisturc OWNER TO %firmaRole%;
ALTER TABLE public.seq_askupfir OWNER TO %firmaRole%;
ALTER TABLE public.askupfir OWNER TO %firmaRole%;
ALTER TABLE public.seq_asmerkod OWNER TO %firmaRole%;
ALTER TABLE public.asmerkod OWNER TO %firmaRole%;
ALTER TABLE public.seq_astaty OWNER TO %firmaRole%;
ALTER TABLE public.astaty OWNER TO %firmaRole%;
ALTER TABLE public.seq_audalosti OWNER TO %firmaRole%;
ALTER TABLE public.audalosti OWNER TO %firmaRole%;
ALTER TABLE public.seq_ccenik OWNER TO %firmaRole%;
ALTER TABLE public.ccenik OWNER TO %firmaRole%;
ALTER TABLE public.seq_cmerjed OWNER TO %firmaRole%;
ALTER TABLE public.cmerjed OWNER TO %firmaRole%;
ALTER TABLE public.seq_cskupzboz OWNER TO %firmaRole%;
ALTER TABLE public.cskupzboz OWNER TO %firmaRole%;
ALTER TABLE public.seq_dbversion OWNER TO %firmaRole%;
ALTER TABLE public.dbversion OWNER TO %firmaRole%;
ALTER TABLE public.seq_ddoklfak OWNER TO %firmaRole%;
ALTER TABLE public.ddoklfak OWNER TO %firmaRole%;
ALTER TABLE public.seq_ddoklint OWNER TO %firmaRole%;
ALTER TABLE public.ddoklint OWNER TO %firmaRole%;
ALTER TABLE public.seq_ddoklobch OWNER TO %firmaRole%;
ALTER TABLE public.ddoklobch OWNER TO %firmaRole%;
ALTER TABLE public.seq_ddoklsklad OWNER TO %firmaRole%;
ALTER TABLE public.ddoklsklad OWNER TO %firmaRole%;
ALTER TABLE public.seq_delbanformat OWNER TO %firmaRole%;
ALTER TABLE public.delbanformat OWNER TO %firmaRole%;
ALTER TABLE public.seq_dkonsym OWNER TO %firmaRole%;
ALTER TABLE public.dkonsym OWNER TO %firmaRole%;
ALTER TABLE public.seq_dpolfak OWNER TO %firmaRole%;
ALTER TABLE public.dpolfak OWNER TO %firmaRole%;
ALTER TABLE public.seq_dpolint OWNER TO %firmaRole%;
ALTER TABLE public.dpolint OWNER TO %firmaRole%;
ALTER TABLE public.seq_dpolobch OWNER TO %firmaRole%;
ALTER TABLE public.dpolobch OWNER TO %firmaRole%;
ALTER TABLE public.seq_dpolprikazuhr OWNER TO %firmaRole%;
ALTER TABLE public.dpolprikazuhr OWNER TO %firmaRole%;
ALTER TABLE public.seq_dpolsklad OWNER TO %firmaRole%;
ALTER TABLE public.dpolsklad OWNER TO %firmaRole%;
ALTER TABLE public.seq_dprikazuhr OWNER TO %firmaRole%;
ALTER TABLE public.dprikazuhr OWNER TO %firmaRole%;
ALTER TABLE public.seq_drady OWNER TO %firmaRole%;
ALTER TABLE public.drady OWNER TO %firmaRole%;
ALTER TABLE public.seq_dradydiry OWNER TO %firmaRole%;
ALTER TABLE public.dradydiry OWNER TO %firmaRole%;
ALTER TABLE public.seq_dradyrok OWNER TO %firmaRole%;
ALTER TABLE public.dradyrok OWNER TO %firmaRole%;
ALTER TABLE public.seq_dtypdokl OWNER TO %firmaRole%;
ALTER TABLE public.dtypdokl OWNER TO %firmaRole%;
ALTER TABLE public.seq_dvazebtab OWNER TO %firmaRole%;
ALTER TABLE public.dvazebtab OWNER TO %firmaRole%;
ALTER TABLE public.seq_idodpodm OWNER TO %firmaRole%;
ALTER TABLE public.idodpodm OWNER TO %firmaRole%;
ALTER TABLE public.seq_idruhdopr OWNER TO %firmaRole%;
ALTER TABLE public.idruhdopr OWNER TO %firmaRole%;
ALTER TABLE public.seq_iintrmerjed OWNER TO %firmaRole%;
ALTER TABLE public.iintrmerjed OWNER TO %firmaRole%;
ALTER TABLE public.seq_ikrajurc OWNER TO %firmaRole%;
ALTER TABLE public.ikrajurc OWNER TO %firmaRole%;
ALTER TABLE public.seq_inomen OWNER TO %firmaRole%;
ALTER TABLE public.inomen OWNER TO %firmaRole%;
ALTER TABLE public.seq_iobchtrans OWNER TO %firmaRole%;
ALTER TABLE public.iobchtrans OWNER TO %firmaRole%;
ALTER TABLE public.seq_izvlpoh OWNER TO %firmaRole%;
ALTER TABLE public.izvlpoh OWNER TO %firmaRole%;
ALTER TABLE public.seq_mdannakl OWNER TO %firmaRole%;
ALTER TABLE public.mdannakl OWNER TO %firmaRole%;
ALTER TABLE public.seq_mdanodpisy OWNER TO %firmaRole%;
ALTER TABLE public.mdanodpisy OWNER TO %firmaRole%;
ALTER TABLE public.seq_mleasing OWNER TO %firmaRole%;
ALTER TABLE public.mleasing OWNER TO %firmaRole%;
ALTER TABLE public.seq_mmajetek OWNER TO %firmaRole%;
ALTER TABLE public.mmajetek OWNER TO %firmaRole%;
ALTER TABLE public.seq_msazby OWNER TO %firmaRole%;
ALTER TABLE public.msazby OWNER TO %firmaRole%;
ALTER TABLE public.seq_msplatkal OWNER TO %firmaRole%;
ALTER TABLE public.msplatkal OWNER TO %firmaRole%;
ALTER TABLE public.seq_mtypleas OWNER TO %firmaRole%;
ALTER TABLE public.mtypleas OWNER TO %firmaRole%;
ALTER TABLE public.seq_mtypmaj OWNER TO %firmaRole%;
ALTER TABLE public.mtypmaj OWNER TO %firmaRole%;
ALTER TABLE public.seq_mucetodpisy OWNER TO %firmaRole%;
ALTER TABLE public.mucetodpisy OWNER TO %firmaRole%;
ALTER TABLE public.seq_mudalosti OWNER TO %firmaRole%;
ALTER TABLE public.mudalosti OWNER TO %firmaRole%;
ALTER TABLE public.seq_mumisteni OWNER TO %firmaRole%;
ALTER TABLE public.mumisteni OWNER TO %firmaRole%;
ALTER TABLE public.seq_mzapujcky OWNER TO %firmaRole%;
ALTER TABLE public.mzapujcky OWNER TO %firmaRole%;
ALTER TABLE public.seq_nnastav OWNER TO %firmaRole%;
ALTER TABLE public.nnastav OWNER TO %firmaRole%;
ALTER TABLE public.seq_nucetobdobi OWNER TO %firmaRole%;
ALTER TABLE public.nucetobdobi OWNER TO %firmaRole%;
ALTER TABLE public.seq_skarty OWNER TO %firmaRole%;
ALTER TABLE public.skarty OWNER TO %firmaRole%;
ALTER TABLE public.seq_uclendph OWNER TO %firmaRole%;
ALTER TABLE public.uclendph OWNER TO %firmaRole%;
ALTER TABLE public.seq_ukurzy OWNER TO %firmaRole%;
ALTER TABLE public.ukurzy OWNER TO %firmaRole%;
ALTER TABLE public.seq_umeny OWNER TO %firmaRole%;
ALTER TABLE public.umeny OWNER TO %firmaRole%;
ALTER TABLE public.seq_uobraty OWNER TO %firmaRole%;
ALTER TABLE public.uobraty OWNER TO %firmaRole%;
ALTER TABLE public.seq_usazbydph OWNER TO %firmaRole%;
ALTER TABLE public.usazbydph OWNER TO %firmaRole%;
ALTER TABLE public.seq_usesradky OWNER TO %firmaRole%;
ALTER TABLE public.usesradky OWNER TO %firmaRole%;
ALTER TABLE public.seq_usesrozpaduce OWNER TO %firmaRole%;
ALTER TABLE public.usesrozpaduce OWNER TO %firmaRole%;
ALTER TABLE public.seq_usesstdpred OWNER TO %firmaRole%;
ALTER TABLE public.usesstdpred OWNER TO %firmaRole%;
ALTER TABLE public.seq_usessumace OWNER TO %firmaRole%;
ALTER TABLE public.usessumace OWNER TO %firmaRole%;
ALTER TABLE public.seq_usestavy OWNER TO %firmaRole%;
ALTER TABLE public.usestavy OWNER TO %firmaRole%;
ALTER TABLE public.seq_usesuzivpred OWNER TO %firmaRole%;
ALTER TABLE public.usesuzivpred OWNER TO %firmaRole%;
ALTER TABLE public.seq_ustducty OWNER TO %firmaRole%;
ALTER TABLE public.ustducty OWNER TO %firmaRole%;
ALTER TABLE public.seq_ustrediska OWNER TO %firmaRole%;
ALTER TABLE public.ustrediska OWNER TO %firmaRole%;
ALTER TABLE public.seq_utyporg OWNER TO %firmaRole%;
ALTER TABLE public.utyporg OWNER TO %firmaRole%;
ALTER TABLE public.seq_uucty OWNER TO %firmaRole%;
ALTER TABLE public.uucty OWNER TO %firmaRole%;
ALTER TABLE public.seq_uzakazky OWNER TO %firmaRole%;
ALTER TABLE public.uzakazky OWNER TO %firmaRole%;
ALTER TYPE public.vazbadokladu OWNER TO %firmaRole%;
ALTER TABLE public.seq_wcolumn OWNER TO %firmaRole%;
ALTER TABLE public.wcolumn OWNER TO %firmaRole%;
ALTER TABLE public.wkli_aadresar OWNER TO %firmaRole%;
ALTER TABLE public.wkli_akontakt OWNER TO %firmaRole%;
ALTER TABLE public.wkli_audalost OWNER TO %firmaRole%;
ALTER TABLE public.wkli_cenik OWNER TO %firmaRole%;
ALTER TABLE public.wkli_doklfak OWNER TO %firmaRole%;
ALTER TABLE public.wkli_doklint OWNER TO %firmaRole%;
ALTER TABLE public.wkli_doklobch OWNER TO %firmaRole%;
ALTER TABLE public.wkli_doklsklad OWNER TO %firmaRole%;
ALTER TABLE public.wkli_mleasing OWNER TO %firmaRole%;
ALTER TABLE public.wkli_mmajetek OWNER TO %firmaRole%;
ALTER TABLE public.seq_wlokcis OWNER TO %firmaRole%;
ALTER TABLE public.wlokcis OWNER TO %firmaRole%;
ALTER TABLE public.seq_wokna OWNER TO %firmaRole%;
ALTER TABLE public.wokna OWNER TO %firmaRole%;
ALTER TABLE public.seq_wsetting OWNER TO %firmaRole%;
ALTER TABLE public.wsetting OWNER TO %firmaRole%;
ALTER TABLE public.seq_wuzivatel OWNER TO %firmaRole%;
ALTER TABLE public.wuzivatel OWNER TO %firmaRole%;
ALTER TABLE public.seq_wvybklice OWNER TO %firmaRole%;
ALTER TABLE public.wvybklice OWNER TO %firmaRole%;
ALTER TABLE public.seq_woscert OWNER TO %firmaRole%;
ALTER TABLE public.woscert OWNER TO %firmaRole%;
ALTER TABLE public.seq_woscertcipher OWNER TO %firmaRole%;
ALTER TABLE public.woscertcipher OWNER TO %firmaRole%;
ALTER TABLE public.seq_wadrcert OWNER TO %firmaRole%;
ALTER TABLE public.wadrcert OWNER TO %firmaRole%;
ALTER TABLE public.seq_wadrcertcipher OWNER TO %firmaRole%;
ALTER TABLE public.wadrcertcipher OWNER TO %firmaRole%;
ALTER TABLE public.seq_wautcert OWNER TO %firmaRole%;
ALTER TABLE public.wautcert OWNER TO %firmaRole%;
ALTER TABLE public.seq_wautcertcipher OWNER TO %firmaRole%;
ALTER TABLE public.wautcertcipher OWNER TO %firmaRole%;
ALTER FUNCTION public.add_column_if_not_exists(table_name character varying, column_name character varying, column_def character varying) OWNER TO %firmaRole%;
ALTER FUNCTION public.add_constraint_if_not_exists(table_name character varying, constraint_name character varying, constraint_value character varying) OWNER TO %firmaRole%;
ALTER FUNCTION public.bigid(id bigint, mod bigint) OWNER TO %firmaRole%;
ALTER FUNCTION public.compareid(ida integer, idb integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.createorupdateobraty(boolean, boolean, date, integer, integer, integer, integer, integer, numeric, numeric) OWNER TO %firmaRole%;
ALTER FUNCTION public.createorupdateobraty(ucetni boolean, storno boolean, datumucto date, castkamducet integer, castkadalucet integer, mena integer, stredisko integer, castka numeric, castkamen numeric) OWNER TO %firmaRole%;
ALTER FUNCTION public.ddokldelete() OWNER TO %firmaRole%;
ALTER FUNCTION public.ddokldeleteobchvazba() OWNER TO %firmaRole%;
ALTER FUNCTION public.ddokldelraddiru() OWNER TO %firmaRole%;
ALTER FUNCTION public.ddoklfakinsdelpreceneni() OWNER TO %firmaRole%;
ALTER FUNCTION public.ddoklfakupdatepreceneni() OWNER TO %firmaRole%;
ALTER FUNCTION public.ddoklfakupdateucty() OWNER TO %firmaRole%;
ALTER FUNCTION public.ddoklfakupdatezauctovano() OWNER TO %firmaRole%;
ALTER FUNCTION public.ddoklintupdateucty() OWNER TO %firmaRole%;
ALTER FUNCTION public.ddoklintupdatezauctovano() OWNER TO %firmaRole%;
ALTER FUNCTION public.ddoklskladupdateucty() OWNER TO %firmaRole%;
ALTER FUNCTION public.ddoklskladupdatezauctovano() OWNER TO %firmaRole%;
ALTER FUNCTION public.dgetcisdokl(i_iddokl integer, i_idrady integer, i_iducetniobdobi integer, i_modul character varying, i_typpohybuk character varying) OWNER TO %firmaRole%;
ALTER FUNCTION public.dnastavucetdokladu(tabulka integer, iddoklad integer, ucet integer, newiducet integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.dnastavuctypolozek(tabulka integer, iddoklad integer, mdzkl boolean, mddph boolean, dalzkl boolean, daldph boolean, newiducet integer, typdph character varying) OWNER TO %firmaRole%;
ALTER FUNCTION public.dpoldokldeleteobchvazba() OWNER TO %firmaRole%;
ALTER FUNCTION public.dpoldokldeleteucto() OWNER TO %firmaRole%;
ALTER FUNCTION public.dpoldoklinsertucto() OWNER TO %firmaRole%;
ALTER FUNCTION public.dpoldoklupdateucto() OWNER TO %firmaRole%;
ALTER FUNCTION public.dpolfakdeletevazba() OWNER TO %firmaRole%;
ALTER FUNCTION public.dpolfakupdateucty() OWNER TO %firmaRole%;
ALTER FUNCTION public.dpolfakupdatezauctovano() OWNER TO %firmaRole%;
ALTER FUNCTION public.dpolintupdatezauctovano() OWNER TO %firmaRole%;
ALTER FUNCTION dpolskladdelete() OWNER TO %firmaRole%;
ALTER FUNCTION dpolskladinsert() OWNER TO %firmaRole%;
ALTER FUNCTION dpolskladupdate() OWNER TO %firmaRole%;
ALTER FUNCTION public.dpolskladupdateucty() OWNER TO %firmaRole%;
ALTER FUNCTION public.dpolskladupdatezauctovano() OWNER TO %firmaRole%;
ALTER FUNCTION public.drop_constraint_if_exists(table_name character varying, constraint_name character varying) OWNER TO %firmaRole%;
ALTER FUNCTION public.duniquecisdokl(i_iddokl integer, i_modul character varying, i_typpohybuk character varying, i_cisdokl character varying) OWNER TO %firmaRole%;
ALTER FUNCTION public.dvazebtabinsdelpreceneni() OWNER TO %firmaRole%;
ALTER FUNCTION public.dvratcisdokl(i_idrady integer, i_iducetobdobi integer, i_cisdokl character varying) OWNER TO %firmaRole%;
ALTER FUNCTION public.dvytvorcisdokl(i_prefix character varying, i_cisakt integer, i_postfix character varying, i_zobraznuly boolean, i_cisdelka integer, i_iducetniobdobi integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.dzalozradurok(i_idrady integer, i_iducetniobdobi integer, i_modul character varying) OWNER TO %firmaRole%;
ALTER FUNCTION public.dzdoklcheckvazby() OWNER TO %firmaRole%;
ALTER FUNCTION public.dzkontrolujvazebnitab(i_iddokl integer, i_isdoklad boolean, i_modul character varying) OWNER TO %firmaRole%;
ALTER FUNCTION public.dzpoldoklcheckvazby() OWNER TO %firmaRole%;
ALTER FUNCTION public.findvazbydokladu(_iddokl integer, _modul character varying) OWNER TO %firmaRole%;
ALTER FUNCTION public.findvicevazeb(_inserttab character varying, _iddokl integer, _modul character varying, _uroven integer, _prechodvp boolean) OWNER TO %firmaRole%;
ALTER FUNCTION public.fnn(x numeric) OWNER TO %firmaRole%;
ALTER FUNCTION public.generateuniquekod(i_kod character varying, i_tablename character varying, infix character varying) OWNER TO %firmaRole%;
ALTER FUNCTION public.getdoklnamepostfixbymodul(modul character varying) OWNER TO %firmaRole%;
ALTER FUNCTION public.getkurzfromdoklad(i_doklskladid integer, i_datvyst date) OWNER TO %firmaRole%;
ALTER FUNCTION public.getkurzfromsklad(i_skladid integer, i_datvyst date) OWNER TO %firmaRole%;
ALTER FUNCTION public.isdokladzuctovan(iddokl integer, doklpostfix character varying) OWNER TO %firmaRole%;
ALTER FUNCTION public.isdoklskladmenacizi(i_dokladid integer, i_datvyst date) OWNER TO %firmaRole%;
ALTER FUNCTION public.maxvalue(num1 numeric, num2 numeric) OWNER TO %firmaRole%;
ALTER FUNCTION public.mdannakldelete() OWNER TO %firmaRole%;
ALTER FUNCTION public.mdannaklinsert() OWNER TO %firmaRole%;
ALTER FUNCTION public.mdannaklupdate() OWNER TO %firmaRole%;
ALTER FUNCTION public.minvalue(num1 numeric, num2 numeric) OWNER TO %firmaRole%;
ALTER FUNCTION public.mmajetekdeleteucto() OWNER TO %firmaRole%;
ALTER FUNCTION public.mmajetekinsertucto() OWNER TO %firmaRole%;
ALTER FUNCTION public.mmajetekupdateucto() OWNER TO %firmaRole%;
ALTER FUNCTION public.msplatkaldelete() OWNER TO %firmaRole%;
ALTER FUNCTION public.msplatkalinsert() OWNER TO %firmaRole%;
ALTER FUNCTION public.msplatkalupdate() OWNER TO %firmaRole%;
ALTER FUNCTION public.obchodrealizovatelnost(iddokl integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.prepoctiobraty(iducetobd integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.sodectiskladkartu(i_mnozmj numeric, i_cenamj numeric, i_datvyst date, i_skladkartaid integer, i_doklskladid integer, i_skladid integer, i_nasobic integer) OWNER TO %firmaRole%;
ALTER FUNCTION sprepoctiskladkartu(numeric, numeric, date, integer, integer, integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION sprepoctiskladkartu(numeric, numeric, numeric, date, integer, integer, integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.unastavchybapreceneni(datum date) OWNER TO %firmaRole%;
ALTER FUNCTION public.uobratyinsertupdate() OWNER TO %firmaRole%;
ALTER FUNCTION public.uuctydelete() OWNER TO %firmaRole%;
ALTER FUNCTION public.uuzavriucetniobdobi(idoldobdobi integer, idnewobdobi integer, iducet701 integer, iducet702 integer, iducet710 integer, iducet431 integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.to_ascii(bytea, name) OWNER TO %firmaRole%;
ALTER TABLE seq_wreport OWNER TO %firmaRole%;
ALTER TABLE wreport OWNER TO %firmaRole%;
ALTER TABLE public.seq_wprilohadata OWNER TO %firmaRole%;
ALTER TABLE wprilohadata OWNER TO %firmaRole%;
ALTER FUNCTION delete_priloha_data_LO() OWNER TO %admin%;
ALTER FUNCTION update_priloha_data_LO() OWNER TO %admin%;
ALTER TABLE public.seq_wpriloha OWNER TO %firmaRole%;
ALTER TABLE wpriloha OWNER TO %firmaRole%;
ALTER FUNCTION public.findmatcheditems(i_text character varying, i_table character varying,
  i_pkcolumn character varying, i_kodcolumn character varying, i_nazevcolumn character varying, i_nazevL10nColumn character varying,
  i_jineKodyColumns character varying[], i_jineKodyTitles character varying[],
  i_condClause character varying, i_orderClause character varying, i_startIndex integer, i_pageSize integer) OWNER TO %firmaRole%;
ALTER TABLE public.seq_uDanEvid OWNER TO %firmaRole%;
ALTER TABLE udanevid OWNER TO %firmaRole%;
ALTER FUNCTION public.uUpdateDanEvid(integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.dpolintupdatedanevid() OWNER TO %firmaRole%;
ALTER FUNCTION public.dpolfakupdatedanevid() OWNER TO %firmaRole%;
ALTER FUNCTION public.dvazebtabinsertdeletedanevid() OWNER TO %firmaRole%;
ALTER TABLE seq_svyrobnicislohlav OWNER TO %firmaRole%;
ALTER TABLE svyrobnicislohlav OWNER TO %firmaRole%;
ALTER TABLE seq_svyrobnicislo OWNER TO %firmaRole%;
ALTER TABLE svyrobnicislo OWNER TO %firmaRole%;
ALTER TABLE public.seq_sfifovazby OWNER TO %firmaRole%;
ALTER TABLE sfifovazby OWNER TO %firmaRole%;
ALTER TABLE public.seq_svazbypolsklad OWNER TO %firmaRole%;
ALTER TABLE svazbypolsklad OWNER TO %firmaRole%;
ALTER FUNCTION "jevydano"(integer) OWNER TO %firmaRole%;
ALTER TABLE dpolskladdoklad OWNER TO %firmaRole%;
ALTER TABLE dpolskladf OWNER TO %firmaRole%;
ALTER FUNCTION sfifovydej(integer, integer, integer, integer, numeric, boolean) OWNER TO %firmaRole%;
ALTER FUNCTION sfifostorno(integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION sfifocenamj(integer, integer, numeric(19,6)) OWNER TO %firmaRole%;
ALTER FUNCTION isfifosklad(date) OWNER TO %firmaRole%;
ALTER TABLE seq_srezervace OWNER TO %firmaRole%;
ALTER TABLE public.seq_wDataPrava OWNER TO %firmaRole%;
ALTER TABLE wDataPrava OWNER TO %firmaRole%;
ALTER TABLE srezervace OWNER TO %firmaRole%;
ALTER FUNCTION public.rezervujPolObch(integer, integer, integer, numeric) OWNER TO %firmaRole%;
ALTER FUNCTION public.dpolobchupdaterezer() OWNER TO %firmaRole%;
ALTER FUNCTION public.dpolobchdeleterezer() OWNER TO %firmaRole%;
ALTER FUNCTION public.ddoklobchupdaterezer() OWNER TO %firmaRole%;
ALTER FUNCTION public.odrezervuj(integer, integer, integer, numeric) OWNER TO %firmaRole%;
ALTER FUNCTION public.dpolskladupdaterezer() OWNER TO %firmaRole%;
ALTER FUNCTION public.dgetstavnasklade(integer, integer, date, integer, integer, character varying, date, character varying) OWNER TO %firmaRole%;
ALTER FUNCTION sprepoctisklad(integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION istableexist(varchar) OWNER TO %firmaRole%;
ALTER TABLE public.seq_utypucop OWNER TO %firmaRole%;
ALTER TABLE utypucop OWNER TO %firmaRole%;
ALTER TABLE dpolskladfBezVC OWNER TO %firmaRole%;
ALTER FUNCTION svyrobnicisloupdate() OWNER TO %firmaRole%;
ALTER TABLE seq_wtexty OWNER TO %firmaRole%;
ALTER TABLE wtexty OWNER TO %firmaRole%;
ALTER TABLE public.seq_wkonektor OWNER TO %firmaRole%;
ALTER TABLE wkonektor OWNER TO %firmaRole%;
ALTER TABLE public.seq_ccenhlad OWNER TO %firmaRole%;
ALTER TABLE public.ccenhlad OWNER TO %firmaRole%;
ALTER TABLE cchl_skz OWNER TO %firmaRole%;
ALTER FUNCTION public.dpolprikazuhrupdateprikaz() OWNER TO %firmaRole%;
ALTER FUNCTION public.dprikazuhrupdatecastka() OWNER TO %firmaRole%;
ALTER FUNCTION svyrobnicisloupdate_delete() OWNER TO %firmaRole%;
ALTER FUNCTION public.spustprotyporg(int, text) OWNER TO %firmaRole%;
ALTER FUNCTION public.spustprotyporg(int[], text) OWNER TO %firmaRole%;
ALTER TABLE public.seq_cdodavatele OWNER TO %firmaRole%;
ALTER TABLE public.cdodavatele OWNER TO %firmaRole%;
ALTER TABLE public.seq_codberatele OWNER TO %firmaRole%;
ALTER TABLE public.codberatele OWNER TO %firmaRole%;
ALTER TABLE public.seq_csady OWNER TO %firmaRole%;
ALTER TABLE public.csady OWNER TO %firmaRole%;
ALTER TABLE public.seq_cpoplatky OWNER TO %firmaRole%;
ALTER TABLE public.cpoplatky OWNER TO %firmaRole%;
ALTER TABLE public.seq_cpodobne OWNER TO %firmaRole%;
ALTER TABLE public.cpodobne OWNER TO %firmaRole%;
ALTER TABLE public.seq_wstrom OWNER TO %firmaRole%;
ALTER TABLE wstrom OWNER TO %firmaRole%;
ALTER TABLE public.seq_wuzel OWNER TO %firmaRole%;
ALTER TABLE wuzel OWNER TO %firmaRole%;
ALTER TABLE public.seq_wvazuzel OWNER TO %firmaRole%;
ALTER TABLE wvazuzel OWNER TO %firmaRole%;
ALTER TABLE public.seq_wzamky OWNER TO %firmaRole%;
ALTER TABLE public.wzamky OWNER TO %firmaRole%;
ALTER FUNCTION public.wzamkynastavzamky() OWNER TO %firmaRole%;
ALTER FUNCTION updatePocetPriloh(integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION insertPocetPriloh() OWNER TO %firmaRole%;
ALTER FUNCTION deletePocetPriloh() OWNER TO %firmaRole%;
ALTER FUNCTION dpoldoklinsertsklad() OWNER TO %firmaRole%;
ALTER FUNCTION dpoldoklupdatesklad() OWNER TO %firmaRole%;
ALTER FUNCTION dpoldokldeletesklad() OWNER TO %firmaRole%;
ALTER FUNCTION fillpolskladsada(integer, character varying) OWNER TO %firmaRole%;
ALTER FUNCTION fillPolSklad(integer, integer, character varying) OWNER TO %firmaRole%;
ALTER FUNCTION createPolSkladSada(integer, character varying) OWNER TO %firmaRole%;
ALTER FUNCTION createPolSklad(integer, character varying) OWNER TO %firmaRole%;
ALTER FUNCTION createdoklsklad(integer, integer, character varying) OWNER TO %firmaRole%;
ALTER FUNCTION findparovanydoklsklad(integer, character varying) OWNER TO %firmaRole%;
ALTER FUNCTION findparovanydoklsklad(integer, character varying, character varying) OWNER TO %firmaRole%;
ALTER FUNCTION findparovanydoklsklad(integer, character varying, character varying, boolean) OWNER TO %firmaRole%;
ALTER FUNCTION findIdUcetniObdobiKDatu(date) OWNER TO %firmaRole%;
ALTER FUNCTION findZklMdUcetIfVydej(integer, character varying) OWNER TO %firmaRole%;
ALTER FUNCTION deletenavazanepolsklad(integer, character varying) OWNER TO %firmaRole%;
ALTER FUNCTION deletenavazanepolsklad(integer, character varying, boolean) OWNER TO %firmaRole%;
ALTER FUNCTION findParovanyDoklSklad(integer, character varying) OWNER TO %firmaRole%;
ALTER FUNCTION sprepoctisumydokladu(integer) OWNER TO %firmaRole%;
ALTER FUNCTION sprepoctisumydokladu(integer, date) OWNER TO %firmaRole%;
ALTER FUNCTION sVyrobniCisloInsertUpdate() OWNER TO %firmaRole%;
ALTER TABLE public.seq_ckusovnik OWNER TO %firmaRole%;
ALTER TABLE ckusovnik OWNER TO %firmaRole%;
ALTER FUNCTION dpolskladinsertkusovnik() OWNER TO %firmaRole%;
ALTER FUNCTION dpolskladinsertkusovnik(integer) OWNER TO %firmaRole%;
ALTER FUNCTION dpolskladdeletesklad() OWNER TO %firmaRole%;
ALTER FUNCTION svyrobniCisloInsertUpdateZavyrobneno() OWNER TO %firmaRole%;
ALTER TABLE public.seq_apsc OWNER TO %firmaRole%;
ALTER TABLE public.apsc OWNER TO %firmaRole%;
ALTER FUNCTION cankusovnikhavecenik(integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION findkusovniky(integer, boolean) OWNER TO %firmaRole%;
ALTER FUNCTION svyrobnicisloupdatesklad() OWNER TO %firmaRole%;
ALTER FUNCTION drop_column_if_exists(character varying, character varying) OWNER TO %firmaRole%;
ALTER FUNCTION testuniquekodvplatnosti() OWNER TO %firmaRole%;
ALTER FUNCTION fn_triggerall(DoEnable boolean) OWNER TO %firmaRole%;
ALTER TABLE public.seq_wzurnal OWNER TO %admin%;
ALTER TABLE public.wzurnal OWNER TO %admin%;
ALTER FUNCTION putglotxvariable(i_kod character varying, i_hodnota character varying) OWNER TO %firmaRole%;
ALTER FUNCTION removeglotxvariable(i_kod character varying) OWNER TO %firmaRole%;
ALTER FUNCTION getglotxvariable(i_kod character varying) OWNER TO %firmaRole%;
ALTER FUNCTION public.logzurnal() OWNER TO %admin%;
ALTER FUNCTION create_or_drop_zurnal_triggers(docreate boolean) OWNER TO %admin%;
ALTER FUNCTION exist_zurnal_triggers() OWNER TO %admin%;
alter table changelog owner to %admin%;
alter function logchanges() owner to %admin%;
ALTER FUNCTION create_or_drop_changes_triggers(docreate boolean) OWNER TO %admin%;
ALTER FUNCTION exist_changes_triggers() OWNER TO %admin%;
ALTER TABLE public.seq_hook OWNER TO %firmaRole%;
alter table hook owner to %firmaRole%;
ALTER TABLE public.seq_smapsklad OWNER TO %firmaRole%;
ALTER TABLE smapsklad OWNER TO %firmaRole%;
ALTER FUNCTION getPrefIdSkladu(integer, integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION errorInInsertKusovnik(character varying, character varying, integer, date, integer, integer, boolean) OWNER TO %firmaRole%;
ALTER FUNCTION public.mudalostiinsertucto() OWNER TO %firmaRole%;
ALTER FUNCTION public.mudalostiupdateucto() OWNER TO %firmaRole%;
ALTER FUNCTION public.mudalostideleteucto() OWNER TO %firmaRole%;
ALTER FUNCTION skladGenerujRozsirenePolozky(timestamp, integer, integer ) OWNER TO %firmaRole%;
ALTER FUNCTION skladInsertRozsirenouPolozku(integer) OWNER TO %firmaRole%;
ALTER FUNCTION skladVynulujSkladoveKarty() OWNER TO %firmaRole%;
ALTER FUNCTION skladOdpoctiRozsirenouPolozku(integer) OWNER TO %firmaRole%;
ALTER FUNCTION skladZapoctiRozsirenouPolozku(integer) OWNER TO %firmaRole%;
ALTER FUNCTION skladPrepoctiRozsirenouPolozku(integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION skladGetCenaMjNakup(integer, character varying, numeric(19,6)) OWNER TO %firmaRole%;
ALTER FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, date, integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION dpolskladupdatecenamjnakupnafakture() OWNER TO %firmaRole%;
ALTER FUNCTION svyrobnicislocreatehlav() OWNER TO %firmaRole%;
ALTER FUNCTION svyrobnicislodeletehlav() OWNER TO %firmaRole%;
ALTER FUNCTION ddokladupdatesklad() OWNER TO %firmaRole%;
ALTER TABLE seq_wrole OWNER TO %firmaRole%;
ALTER TABLE wrole OWNER TO %firmaRole%;
ALTER TABLE seq_wpristprava OWNER TO %firmaRole%;
ALTER TABLE wpristprava OWNER TO %firmaRole%;
ALTER TABLE seq_ucinnost OWNER TO %firmaRole%;
ALTER TABLE ucinnost OWNER TO %firmaRole%;
ALTER FUNCTION dzpoldoklcheckvyrcisl() OWNER TO %firmaRole%;
alter function public.deletevazuzel(character varying, integer) owner to %firmaRole%;
alter function public.ccenikdeletevazuzel() owner to %firmaRole%;
ALTER FUNCTION findUzlySCenikemVyrobce(integer, integer) OWNER TO %firmaRole%;
ALTER TABLE seq_wsablona OWNER TO %firmaRole%;
ALTER TABLE wsablona OWNER TO %firmaRole%;
ALTER FUNCTION comparevarchar(varchar, varchar) OWNER TO %firmaRole%;
ALTER FUNCTION compareNumeric(numeric, numeric) OWNER TO %firmaRole%;
ALTER FUNCTION ismenacizi(integer, date) OWNER TO %firmaRole%;
ALTER TABLE public.seq_atypakt OWNER TO %firmaRole%;
ALTER TABLE atypakt OWNER TO %firmaRole%;
ALTER TABLE public.seq_atypnaklakt OWNER TO %firmaRole%;
ALTER TABLE atypnaklakt OWNER TO %firmaRole%;
ALTER TABLE public.seq_anaklakt OWNER TO %firmaRole%;
ALTER TABLE anaklakt OWNER TO %firmaRole%;
ALTER TABLE public.seq_utypzakazky OWNER TO %firmaRole%;
ALTER TABLE utypzakazky OWNER TO %firmaRole%;
ALTER TABLE public.seq_ustavzakazky OWNER TO %firmaRole%;
ALTER TABLE ustavzakazky OWNER TO %firmaRole%;
ALTER TABLE public.seq_uvyhzakazky OWNER TO %firmaRole%;
ALTER TABLE uvyhzakazky OWNER TO %firmaRole%;
ALTER TABLE public.akon_audalost OWNER TO %firmaRole%;
ALTER TABLE public.wuziv_audalost OWNER TO %firmaRole%;
ALTER FUNCTION public.srezervujzprijemky(integer, integer, numeric) OWNER TO %firmaRole%;
ALTER FUNCTION public.dpolskladdeleterezer() OWNER TO %firmaRole%;
ALTER FUNCTION public.srezervaceupdaterezer() OWNER TO %firmaRole%;
ALTER FUNCTION public.srezervacedeleterezer() OWNER TO %firmaRole%;
ALTER FUNCTION public.ccenikupdatedodavatel() OWNER TO %firmaRole%;
ALTER FUNCTION public.cdodavateleupdatedodavatel() OWNER TO %firmaRole%;
ALTER FUNCTION public.cdodavateledeletedodavatel() OWNER TO %firmaRole%;
ALTER TABLE seq_dautotisk OWNER TO %firmaRole%;
ALTER TABLE dautotisk OWNER TO %firmaRole%;
ALTER TABLE public.seq_wfiltry OWNER TO %firmaRole%;
ALTER TABLE wfiltry OWNER TO %firmaRole%;
ALTER FUNCTION public.srezervaceupdateskladkarta() OWNER TO %firmaRole%;
ALTER FUNCTION navazobratynaucetobdobi(date, date, integer) OWNER TO %firmaRole%;
ALTER FUNCTION nucetniobdobiinsert() OWNER TO %firmaRole%;
ALTER FUNCTION nucetniobdobiupdate() OWNER TO %firmaRole%;
ALTER FUNCTION nucetniobdobidelete() OWNER TO %firmaRole%;
ALTER FUNCTION findmnozzkusovniku(integer, integer, numeric, boolean, integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION findmnozzkusovniku(integer[], integer[], numeric[], boolean, integer) OWNER TO %firmaRole%;
ALTER TABLE public.seq_wdotazy OWNER TO %firmaRole%;
ALTER TABLE wdotazy OWNER TO %firmaRole%;
ALTER TABLE public.seq_wdotazyparam OWNER TO %firmaRole%;
ALTER TABLE wdotazyparam OWNER TO %firmaRole%;
ALTER TABLE public.seq_wdotazyprop OWNER TO %firmaRole%;
ALTER TABLE wdotazyprop OWNER TO %firmaRole%;
ALTER TABLE public.seq_dbsp OWNER TO %firmaRole%;
ALTER TABLE public.dbsp OWNER TO %firmaRole%;
ALTER FUNCTION ddoklskladupdatekusovnik() OWNER TO %firmaRole%;
ALTER FUNCTION dpoldoklupdatesumNaklady() OWNER TO %firmaRole%;
ALTER TABLE public.seq_sumisteni OWNER TO %firmaRole%;
ALTER TABLE public.sumisteni OWNER TO %firmaRole%;
ALTER FUNCTION public.ccenikupdateskarta() OWNER TO %firmaRole%;
ALTER FUNCTION public.skartyinsertzceniku() OWNER TO %firmaRole%;
ALTER FUNCTION public.ddoklfaktupdateprodejky() OWNER TO %firmaRole%;
ALTER FUNCTION public.ddoklfaktupdateprodejkyafter() OWNER TO %firmaRole%;
ALTER FUNCTION public.dvazebtabdeletevazbaprodejky() OWNER TO %firmaRole%;
ALTER FUNCTION svyrobnicislohlavupdateKod() OWNER TO %firmaRole%;
ALTER FUNCTION svyrobnicisloupdatehlav() OWNER TO %firmaRole%;
ALTER TABLE public.seq_cskupcen OWNER TO %firmaRole%;
ALTER TABLE cskupcen OWNER TO %firmaRole%;
ALTER TABLE cskc_chl OWNER TO %firmaRole%;
ALTER TABLE cchl_adr OWNER TO %firmaRole%;
ALTER TABLE cchl_cen OWNER TO %firmaRole%;
ALTER FUNCTION public.zaokrouhli(numeric, varchar, varchar) OWNER TO %firmaRole%;
ALTER FUNCTION public.calccena(numeric, varchar, numeric) OWNER TO %firmaRole%;
ALTER FUNCTION public.calcceny(integer, integer, integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.calcceny(numeric, numeric, numeric[], numeric[], numeric, integer, 
   varchar, varchar, varchar, varchar, varchar, varchar, numeric, numeric[], numeric[]) OWNER TO %firmaRole%;
ALTER TABLE ccenhladusers OWNER TO %firmaRole%;
ALTER TABLE ccenhladview OWNER TO %firmaRole%;
ALTER FUNCTION sumtext_agg(character varying, character varying) OWNER TO %firmaRole%;
ALTER AGGREGATE sumtext(character varying) OWNER TO %firmaRole%;
ALTER TABLE public.seq_udphpren OWNER TO %firmaRole%;
ALTER TABLE public.udphpren OWNER TO %firmaRole%;
ALTER FUNCTION daapolskladinsertmnozmj() OWNER TO %firmaRole%;
ALTER FUNCTION skladrealizujpozadavky() OWNER TO %firmaRole%;
ALTER FUNCTION dgetstavnasklade(integer, date, integer, character varying, date, character varying) OWNER TO %firmaRole%;
ALTER FUNCTION dgetstavnasklade(integer, date, integer, integer, character varying, date, character varying) OWNER TO %firmaRole%;
ALTER TABLE seq_dformauhradycis OWNER TO %firmaRole%;
ALTER TABLE dformauhradycis OWNER TO %firmaRole%;
ALTER TABLE seq_dformauhradyzauc OWNER TO %firmaRole%;
ALTER TABLE dformauhradyzauc OWNER TO %firmaRole%;
ALTER TABLE seq_dformauhrady OWNER TO %firmaRole%;
ALTER TABLE dformauhrady OWNER TO %firmaRole%;
ALTER FUNCTION public.dpolintupdateucty() OWNER TO %firmaRole%;
ALTER FUNCTION dGetStavNaSkladeAktualni(integer) OWNER TO %firmaRole%;
ALTER FUNCTION dgetstavnaskladeaktualni(integer, integer, date) OWNER TO %firmaRole%;
ALTER TABLE seq_dstavsml OWNER TO %firmaRole%;
ALTER TABLE dstavsml OWNER TO %firmaRole%;
ALTER TABLE public.seq_dtypsml OWNER TO %firmaRole%;
ALTER TABLE public.dtypsml OWNER TO %firmaRole%;
ALTER TABLE public.seq_dsmlouvy OWNER TO %firmaRole%;
ALTER TABLE public.dsmlouvy OWNER TO %firmaRole%;
ALTER TABLE public.seq_dpolsml OWNER TO %firmaRole%;
ALTER TABLE public.dpolsml OWNER TO %firmaRole%;
ALTER TABLE public.wkli_smlouva OWNER TO %firmaRole%;
ALTER TABLE public.wkli_polsml OWNER TO %firmaRole%;
ALTER TABLE public.seq_dzurnalsml OWNER TO %firmaRole%;
ALTER TABLE public.dzurnalsml OWNER TO %firmaRole%;
ALTER FUNCTION dgetrezervovano(integer, integer, integer) OWNER TO %firmaRole%;
ALTER TABLE public.SEQ_URADEKPRIZNANIDPH OWNER TO %firmaRole%;
ALTER TABLE public.uRadekPriznaniDph OWNER TO %firmaRole%;
ALTER TABLE public.seq_dformadopravy OWNER TO %firmaRole%;
ALTER TABLE dformadopravy OWNER TO %firmaRole%;
ALTER FUNCTION public.drefreshrealizovatelnost() OWNER TO %firmaRole%;
ALTER FUNCTION public.dgetstavnaskladeaktualni(integer, integer, date, integer) OWNER TO %firmaRole%;
ALTER FUNCTION ddoklskladupdateceny() OWNER TO %firmaRole%;
ALTER TABLE public.wkli_cdodavatele OWNER TO %firmaRole%;
ALTER TABLE public.wkli_dformauhrady OWNER TO %firmaRole%;
ALTER TABLE public.wkli_dformauhradycis OWNER TO %firmaRole%;
ALTER TABLE public.wkli_dformadopravy OWNER TO %firmaRole%;
ALTER TABLE public.wkli_dbsp OWNER TO %firmaRole%;
ALTER TABLE public.wkli_cskupzboz OWNER TO %firmaRole%;
ALTER TABLE public.wkli_dstavsml OWNER TO %firmaRole%;
ALTER TABLE public.wkli_dtypsml OWNER TO %firmaRole%;
ALTER TABLE public.wkli_ustredisko OWNER TO %firmaRole%;
ALTER TABLE public.wkli_atypakt OWNER TO %firmaRole%;
ALTER TABLE public.wkli_ucinnost OWNER TO %firmaRole%;
ALTER TABLE wkli_polfak OWNER TO %firmaRole%;
ALTER TABLE wkli_polint OWNER TO %firmaRole%;
ALTER TABLE wkli_polobch OWNER TO %firmaRole%;
ALTER TABLE wkli_polsklad OWNER TO %firmaRole%;
ALTER FUNCTION dabpolskladupdatedeletepozadavky() OWNER TO %firmaRole%;
alter table public.seq_cstavcen owner to %firmaRole%;
alter table cstavcen owner to %firmaRole%;
ALTER TABLE public.wkli_stavcen OWNER TO %firmaRole%;
ALTER TABLE public.stavcen_cenik OWNER TO %firmaRole%;
alter table public.seq_cprislusenstvi owner to %firmaRole%;
alter table cprislusenstvi owner to %firmaRole%;
alter table public.seq_ctypatribut owner to %firmaRole%;
alter table ctypatribut owner to %firmaRole%;
alter table public.seq_ctypzbozi owner to %firmaRole%;
alter table ctypzbozi owner to %firmaRole%;
ALTER TABLE public.wkli_typzbozi OWNER TO %firmaRole%;
ALTER TABLE public.ctypatribut_typzbozi OWNER TO %firmaRole%;
alter table public.seq_catribut owner to %firmaRole%;
alter table catribut owner to %firmaRole%;
ALTER FUNCTION public.dvazebtabinsdelpreplatek() OWNER TO %firmaRole%;
ALTER TABLE public.seq_wvazbatyp OWNER TO %firmaRole%;
ALTER TABLE wvazbatyp OWNER TO %firmaRole%;
ALTER TABLE wkli_wvazbatyp OWNER TO %firmaRole%;
ALTER TABLE public.seq_wvazba OWNER TO %firmaRole%;
ALTER TABLE wvazba OWNER TO %firmaRole%;
ALTER FUNCTION public.existcolumn(varchar, varchar) OWNER TO %firmaRole%;
ALTER FUNCTION public.wvazbadetail(integer, varchar, varchar, integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.findvazbyautomat(varchar, integer) OWNER TO %firmaRole%;
alter table public.seq_sinventura owner to %firmaRole%;
alter table sInventura owner to %firmaRole%;
alter table public.seq_spolinventura owner to %firmaRole%;
alter table spolinventura owner to %firmaRole%;
ALTER FUNCTION inventuraAktualizujMnozMjKarta(integer) OWNER TO %firmaRole%;
ALTER FUNCTION dvazebtabinsertuhradazal() OWNER TO %firmaRole%;
ALTER FUNCTION sprepoctiSumyDoklFak(integer, character varying) OWNER TO %firmaRole%;
ALTER FUNCTION dpolskladupdatecenamjnafap() OWNER TO %firmaRole%;
alter table public.seq_cekokom owner to %firmaRole%;
alter table cekokom owner to %firmaRole%;
ALTER TABLE public.wkli_amisturc OWNER TO %firmaRole%;
ALTER TABLE public.seq_wparam OWNER TO %firmaRole%;
ALTER TABLE public.wparam OWNER TO %firmaRole%;
ALTER FUNCTION bigid(character varying, character varying, character varying, character varying, character varying) OWNER TO %firmaRole%;
ALTER FUNCTION ws_lexize(character varying) OWNER TO %firmaRole%;
ALTER TABLE public.seq_wactdefinice OWNER TO %firmaRole%;
ALTER TABLE public.wactdefinice OWNER TO %firmaRole%;
ALTER TABLE public.seq_wactskupina OWNER TO %firmaRole%;
ALTER TABLE public.wactskupina OWNER TO %firmaRole%;
ALTER TABLE public.seq_wactclenstvi OWNER TO %firmaRole%;
ALTER TABLE public.wactclenstvi OWNER TO %firmaRole%;
ALTER TABLE wdotaz_wreport OWNER TO %firmaRole%;
ALTER FUNCTION dpoldokldeleteobchvazba() OWNER TO %firmaRole%;
ALTER FUNCTION szkontrolujsklad(integer, integer) OWNER TO %firmaRole%;
ALTER TABLE public.seq_wskupvybklic OWNER TO %firmaRole%;
ALTER TABLE public.wskupvybklic OWNER TO %firmaRole%;
ALTER TABLE public.seq_dcislobal OWNER TO %firmaRole%;
ALTER TABLE dcislobal OWNER TO %firmaRole%;
ALTER FUNCTION createpolskladdobropis(integer, integer, character varying, character varying) OWNER TO %firmaRole%;
ALTER TABLE public.wkli_wuzivatel OWNER TO %firmaRole%;
ALTER TABLE public.seq_wzastupnosti OWNER TO %firmaRole%;
ALTER TABLE public.wzastupnosti OWNER TO %firmaRole%;
ALTER FUNCTION findparovanydoklsklad(integer, character varying, character varying, boolean, integer) OWNER TO %firmaRole%;
ALTER FUNCTION zapisDatVystDoDatSklad(integer) OWNER TO %firmaRole%;
ALTER TABLE public.seq_pskuposob OWNER TO %firmaRole%;
ALTER TABLE pskuposob OWNER TO %firmaRole%;
ALTER TABLE public.seq_posobahlav OWNER TO %firmaRole%;
ALTER TABLE posobahlav OWNER TO %firmaRole%;
ALTER TABLE public.seq_posoba OWNER TO %firmaRole%;
ALTER TABLE posoba OWNER TO %firmaRole%;
ALTER TABLE public.seq_pdite OWNER TO %firmaRole%;
ALTER TABLE pdite OWNER TO %firmaRole%;
ALTER TABLE wkli_zosoba OWNER TO %firmaRole%;
ALTER TABLE wkli_zdite OWNER TO %firmaRole%;
ALTER TABLE pdite_posoba OWNER TO %firmaRole%;
ALTER TABLE public.seq_pcismzdsloz OWNER TO %firmaRole%;
ALTER TABLE pcismzdsloz OWNER TO %firmaRole%;
ALTER TABLE public.seq_ptyppracpom OWNER TO %firmaRole%;
ALTER TABLE ptyppracpom OWNER TO %firmaRole%;
ALTER TABLE public.seq_ppracpomhlav OWNER TO %firmaRole%;
ALTER TABLE ppracpomhlav OWNER TO %firmaRole%;
ALTER TABLE public.seq_ppracpom OWNER TO %firmaRole%;
ALTER TABLE ppracpom OWNER TO %firmaRole%;
ALTER TABLE public.seq_pnepritomnost OWNER TO %firmaRole%;
ALTER TABLE pnepritomnost OWNER TO %firmaRole%;
ALTER TABLE public.seq_psmeny OWNER TO %firmaRole%;
ALTER TABLE psmeny OWNER TO %firmaRole%;
ALTER TABLE wkli_pnepritomnost OWNER TO %firmaRole%;
ALTER TABLE public.seq_pstalamzdsloz OWNER TO %firmaRole%;
ALTER TABLE pstalamzdsloz OWNER TO %firmaRole%;
ALTER TABLE public.seq_psrazka OWNER TO %firmaRole%;
ALTER TABLE psrazka OWNER TO %firmaRole%;
ALTER TABLE public.seq_pmzdsloz OWNER TO %firmaRole%;
ALTER TABLE pmzdsloz OWNER TO %firmaRole%;
ALTER TABLE wkli_pmzdsloz OWNER TO %firmaRole%;
ALTER TABLE wkli_pstalamzdsloz OWNER TO %firmaRole%;
ALTER TABLE public.seq_pmzdcalchlav OWNER TO %firmaRole%;
ALTER TABLE pmzdcalchlav OWNER TO %firmaRole%;
ALTER TABLE public.seq_pmzdcalcinit OWNER TO %firmaRole%;
ALTER TABLE pmzdcalcinit OWNER TO %firmaRole%;
ALTER TABLE public.seq_pmzdcalc OWNER TO %firmaRole%;
ALTER TABLE pmzdcalc OWNER TO %firmaRole%;
ALTER TABLE public.seq_ptyppracpomparam OWNER TO %firmaRole%;
ALTER TABLE ptyppracpomparam OWNER TO %firmaRole%;
ALTER TABLE public.seq_pmzdcalchrom OWNER TO %firmaRole%;
ALTER TABLE pmzdcalchrom OWNER TO %firmaRole%;
ALTER TABLE public.seq_pmzdvazbazav OWNER TO %firmaRole%;
ALTER TABLE pmzdvazbazav OWNER TO %firmaRole%;
ALTER TABLE public.seq_pmzdyparam OWNER TO %firmaRole%;
ALTER TABLE pmzdyparam OWNER TO %firmaRole%;
ALTER TABLE public.seq_ppracestred OWNER TO %firmaRole%;
ALTER TABLE ppracestred OWNER TO %firmaRole%;
ALTER TABLE seq_wextid OWNER TO %firmaRole%;
ALTER table wextid owner to %firmaRole%;
ALTER FUNCTION public.pismzdyzamek(integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.pcantriggerchangeslozku(integer, integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.pgeneratesmenyforpracpom(integer, integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.pupdatemzdslozfromcis(integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.pupdatemzdslozfromsrazka(integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.pupdatemzdslozfromstalasloz(integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.pgeneratemzdslozforpracpomandmesic(integer, integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.pgeneratemzdslozforpracpom(integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.pgeneratemzdslozforpracpom(integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.popravslozkypromesic(integer, integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.ppracpomupdateaktivni() OWNER TO %firmaRole%;
ALTER FUNCTION public.ppracpomhlavupdatemzdsloz() OWNER TO %firmaRole%;
ALTER FUNCTION public.nucetobdobiupdatemzdsloz() OWNER TO %firmaRole%;
ALTER FUNCTION public.pstalamzdslozupdatemzdsloz() OWNER TO %firmaRole%;
ALTER FUNCTION public.pstalamzdslozdeletemzdsloz() OWNER TO %firmaRole%;
ALTER FUNCTION public.psrazkaupdatemzdsloz() OWNER TO %firmaRole%;
ALTER FUNCTION public.psrazkadeletemzdsloz() OWNER TO %firmaRole%;
ALTER FUNCTION public.pnepritomnostdeletemzdsloz() OWNER TO %firmaRole%;
ALTER FUNCTION public.pmzdcalcdeletecisrad() OWNER TO %firmaRole%;
ALTER FUNCTION public.pmzdcalchromdeletecisrad() OWNER TO %firmaRole%;
ALTER FUNCTION public.pcreatemzdslozfromcis(integer, integer, integer, integer, integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.pcreatemzdslozforsmeny(integer) OWNER TO %firmaRole%;
ALTER FUNCTION public.psmenyupdatemzdsloz() OWNER TO %firmaRole%;
ALTER FUNCTION public.ppracpomhlavdeleteslozky() OWNER TO %firmaRole%;
ALTER FUNCTION public.ddoklfakdeletemzdvazba() OWNER TO %firmaRole%;
ALTER FUNCTION public.dpolfakdeletemzdvazba() OWNER TO %firmaRole%;
ALTER FUNCTION public.ddoklintdeletemzdvazba() OWNER TO %firmaRole%;
ALTER FUNCTION public.pcismzdslozupdatemzdsloz() OWNER TO %firmaRole%;
ALTER FUNCTION comparedate(date, date) OWNER TO %firmaRole%;
ALTER FUNCTION iskonecmesice(date) OWNER TO %firmaRole%;
ALTER FUNCTION public.pmzdslozupdatedatumvypoctu() OWNER TO %firmaRole%;
ALTER FUNCTION public.posobaupdatehlavicka() OWNER TO %firmaRole%;
ALTER FUNCTION dactiviticreatetask() OWNER TO %firmaRole%;
ALTER FUNCTION dactivitiupdatetask() OWNER TO %firmaRole%;
ALTER FUNCTION dactivitideletetask() OWNER TO %firmaRole%;
ALTER TABLE act_id_group OWNER TO %firmaRole%;
ALTER TABLE act_id_membership OWNER TO %firmaRole%;
ALTER TABLE act_id_user OWNER TO %firmaRole%;
ALTER TABLE public.ACT_GE_PROPERTY OWNER TO %firmaRole%;
ALTER TABLE public.ACT_GE_BYTEARRAY OWNER TO %firmaRole%;
ALTER TABLE public.ACT_RE_DEPLOYMENT OWNER TO %firmaRole%;
ALTER TABLE public.ACT_RE_MODEL OWNER TO %firmaRole%;
ALTER TABLE public.ACT_RU_EXECUTION OWNER TO %firmaRole%;
ALTER TABLE public.ACT_RU_JOB OWNER TO %firmaRole%;
ALTER TABLE public.ACT_RE_PROCDEF OWNER TO %firmaRole%;
ALTER TABLE public.ACT_RU_TASK OWNER TO %firmaRole%;
ALTER TABLE public.ACT_RU_IDENTITYLINK OWNER TO %firmaRole%;
ALTER TABLE public.ACT_RU_VARIABLE OWNER TO %firmaRole%;
ALTER TABLE public.ACT_RU_EVENT_SUBSCR OWNER TO %firmaRole%;
ALTER TABLE public.ACT_HI_PROCINST OWNER TO %firmaRole%;
ALTER TABLE public.ACT_HI_ACTINST OWNER TO %firmaRole%;
ALTER TABLE public.ACT_HI_TASKINST OWNER TO %firmaRole%;
ALTER TABLE public.ACT_HI_VARINST OWNER TO %firmaRole%;
ALTER TABLE public.ACT_HI_DETAIL OWNER TO %firmaRole%;
ALTER TABLE public.ACT_HI_COMMENT OWNER TO %firmaRole%;
ALTER TABLE public.ACT_HI_ATTACHMENT OWNER TO %firmaRole%;
ALTER TABLE public.ACT_ID_GROUP OWNER TO %firmaRole%;
ALTER TABLE public.ACT_ID_MEMBERSHIP OWNER TO %firmaRole%;
ALTER TABLE public.ACT_ID_USER OWNER TO %firmaRole%;
ALTER TABLE public.ACT_ID_INFO OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 799, 't', %appVersion%, clock_timestamp());
