-----------------------------------------------------------------------------------------
-- Bug 37173 – [WinStrom] Umoznit omezit Vypis polozek v zaporu na sklad a rozsah datumu
-----------------------------------------------------------------------------------------

DROP FUNCTION szkontrolujsklad(integer, integer);

CREATE OR REPLACE FUNCTION szkontrolujsklad(i_ucetobd integer, i_typvypisu integer, i_idsklad integer, i_datumod date, i_datumdo date)
  RETURNS void AS
$BODY$  
declare  
  _pocatek_ucetobd date; 
  _konec_ucetobd date;  
  _mazatTmpTable boolean; 
  _pocetPred integer;  
  _skladKartaId integer; 
  _rozsirenaSkladKarta record; 
  _stavMj numeric(19,6); 
  _rozsirenaPolozka record; 
  _index integer; 
  tmp_result_exists boolean;  
begin  
  -- 1 = vypis skladovych karet, ktere jsou spatne 
  -- 2 = vypis skladovych karet, ktere jsou spatne i s polozkama, ktere je do tohoto spatne privadeji 
  -- 3 = do tabulky 
  -- else = exception 
   
  if(i_typVypisu = 3) then 
    tmp_result_exists := (select istableexist('tmp_result'));  
    if(tmp_result_exists <> true) then  
      CREATE TEMPORARY TABLE tmp_result (  
        idpolsklad integer,  
        idskladkarty integer, 
        sklad character varying, 
        cenik character varying 
        --iddoklskladMaster integer,  
        --iddoklskladpolozky integer,  
        --datum timestamp,   
        --skupina integer,  
        --typPohybuK character varying,  
        --storno boolean,  
        --cenyRucne boolean,  
        --evidVyrCis boolean,  
        --idcenik integer,  
        --idbspskl integer,  
        --mnozMj numeric(19,6)  
        --cenaMj numeric(19,6),  
        --sumZkl numeric(19,6)  
      ) WITH (OIDS=TRUE) ON COMMIT DROP;  
  
      --CREATE INDEX tmp_RozsirenePolozky_idpolsklad_index ON tmp_RozsirenePolozky USING btree (idpolsklad );  
        
      -- tabulky zde byli vytvoreny tim padem se musi vracet true    
      --_result = true;  
    else 
      delete from tmp_result; 
    end if;  
  end if; 
    
  select platioddata, platidodata into _pocatek_ucetobd, _konec_ucetobd from nucetobdobi where iducetobdobi = i_ucetobd;  
  
  -- nagenerovani pomocnych tabulek  
  select skladGenerujRozsirenePolozky(_pocatek_ucetobd, -1, -1) into _mazatTmpTable;  
  
  select count(*) into _pocetPred from tmp_SkladoveKarty; 
  raise notice 'pocet skladkaret pred %', _pocetPred; 
 
  select count(*) into _pocetPred from tmp_RozsirenePolozky;  
  raise notice 'pocet pred %', _pocetPred; 
 
  _index = 0; 
  for _skladKartaId in (select * from tmp_SkladoveKarty) loop 
    select * into _rozsirenaSkladKarta from ( 
      select idkarty, c.kod as cenikKod, s.kod as skladKod 
        from skarty k 
        left join ccenik c on k.idcenik = c.idcenik 
        left join dbsp s on s.idbsp = k.idskladu 
      where idkarty = _skladKartaId) as sklkar; 
    _index = _index + 1; 
    --raise notice 'pocitam skladovou kartu id = % a je to jiz %. karta', _skladKartaId, _index; 
    select pocatMj into _stavMj from skarty where idkarty = _skladKartaId; 
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky  
        where storno = false and idskladkarty = _skladKartaId 
        order by datVyst, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop  
      if(_rozsirenaPolozka.typPohybuK = 'typPohybu.prijem') then 
        _stavMj = _stavMj + _rozsirenaPolozka.mnozMj; 
      else 
        _stavMj = _stavMj - _rozsirenaPolozka.mnozMj; 
      end if; 
      if(_stavMj < 0.0) then 
        if(i_typVypisu = 1) then 
          raise notice 'v zaporu je skladova karta id=%, sklad=%, cenik=%', _skladKartaId, _rozsirenaSkladKarta.skladKod, _rozsirenaSkladKarta.cenikKod; 
          exit; 
        elsif(i_typVypisu = 2) then 
          raise notice 'skladova karta id=% je v minusu po polozce id=%', _skladKartaId, _rozsirenaPolozka.idPolSklad; 
        elsif(i_typVypisu = 3) then 
          if(i_idsklad is null or i_idsklad = _rozsirenaPolozka.idBspSkl) then
            if(i_datumod is null or i_datumod <= _rozsirenaPolozka.datVyst) then
	      if(i_datumdo is null or i_datumdo >= _rozsirenaPolozka.datVyst) then
                insert into tmp_result(idpolsklad, idskladkarty, sklad, cenik) 
                  values (_rozsirenaPolozka.idPolSklad, _skladKartaId, _rozsirenaSkladKarta.skladKod, _rozsirenaSkladKarta.cenikKod); 
              end if;
            end if;
          end if;
        else 
          raise exception 'Nepodporovany typ vypisu ale skladov karta s id % je v zaporu po polozce id %', _skladKartaId, _rozsirenaPolozka.idPolSklad; 
        end if; 
      end if; 
    end loop; 
  end loop; 
 
  if(_mazatTmpTable) then  
    drop table tmp_RozsirenePolozky;  
    drop table tmp_SkladoveKarty;  
    execute removeglotxvariable('zurnalTxName');  
    execute removeglotxvariable('probihaPrepocetSkladu');  
  end if;  
  
end;  
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION szkontrolujsklad(integer, integer, integer, date, date) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 800, 't', %appVersion%, clock_timestamp());
