--------------------------------------------------------------------------------
-- Bug 36929 – [FlexiBee] Přidat podporu příloh ke uzlům stromu (tinit)
--------------------------------------------------------------------------------

ALTER TABLE wpriloha
  ADD COLUMN iduzel integer,
  ADD CONSTRAINT wpriloha_iduzel FOREIGN KEY (iduzel)
      REFERENCES wuzel (iduzel) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX wpriloha_iduzel_index ON wpriloha USING btree (iduzel);

ALTER TABLE wuzel
  ADD COLUMN pocetPriloh integer not null default 0;


create or replace function updatePocetPriloh(prilohaid integer, addon integer) returns void as
$BODY$
declare
    priloha record;
begin
    select * into priloha from wpriloha p where p.idpriloha = prilohaid;

    if (priloha.idreport is not null) then
        update wreport
        set pocetPriloh =   (select count(1)+addon
                            from wpriloha p
                            where p.idreport = priloha.idreport)
        where idreport = priloha.idreport;
    end if;


    if (priloha.idadresar is not null) then
        update aadresar
        set pocetPriloh =   (select count(1)+addon
                            from wpriloha p
                            where p.idadresar = priloha.idadresar)
        where idfirmy = priloha.idadresar;
    end if;

    if (priloha.idkontakt is not null) then
        update akontakty set pocetPriloh =  (select count(1)+addon
                                            from wpriloha p
                                            where p.idkontakt = priloha.idkontakt)
        where idkontakt = priloha.idkontakt;
    end if;

    if (priloha.idcenik is not null) then
        update ccenik set pocetPriloh = (select count(1)+addon
                                        from wpriloha p
                                        where p.idcenik = priloha.idcenik)
        where idcenik = priloha.idcenik;
    end if;

    if (priloha.iddoklfak is not null) then
        update ddoklfak set pocetPriloh =   (select count(1)+addon
                                            from wpriloha p
                                            where p.iddoklfak = priloha.iddoklfak)
        where iddoklfak = priloha.iddoklfak;
    end if;

    if (priloha.iddoklint is not null) then
        update ddoklint set pocetPriloh =   (select count(1)+addon
                                            from wpriloha p
                                            where p.iddoklint = priloha.iddoklint)
        where iddoklint = priloha.iddoklint;
    end if;

    if (priloha.iddoklobch is not null) then
        update ddoklobch set pocetPriloh =  (select count(1)+addon
                                            from wpriloha p
                                            where p.iddoklobch = priloha.iddoklobch)
        where iddoklobch = priloha.iddoklobch;
    end if;

    if (priloha.iddoklsklad is not null) then
        update ddoklsklad set pocetPriloh = (select count(1)+addon
                                            from wpriloha p
                                            where p.iddoklsklad = priloha.iddoklsklad)
        where iddoklsklad = priloha.iddoklsklad;
    end if;

    if (priloha.idosoba is not null) then
        update posoba set pocetPriloh = (select count(1)+addon
                                            from wpriloha p
                                            where p.idosoba = priloha.idosoba)
        where idosobahlav = priloha.idosoba;
    end if;

    if (priloha.idadrudalost is not null) then
        update audalosti set pocetPriloh = (select count(1)+addon
                                            from wpriloha p
                                            where p.idadrudalost = priloha.idadrudalost)
        where idudalost = priloha.idadrudalost;
    end if;

    if (priloha.idzakazky is not null) then
        update uzakazky set pocetPriloh = (select count(1)+addon
                                            from wpriloha p
                                            where p.idzakazky = priloha.idzakazky)
        where idzakazky = priloha.idzakazky;
    end if;

    if (priloha.idkonektor is not null) then
        update wkonektor set pocetPriloh = (select count(1)+addon
                                            from wpriloha p
                                            where p.idkonektor = priloha.idkonektor)
        where idkonektor = priloha.idkonektor;
    end if;

    if (priloha.idsmlouvy is not null) then
        update dsmlouvy set pocetPriloh = (select count(1)+addon
                                            from wpriloha p
                                            where p.idsmlouvy = priloha.idsmlouvy)
        where idsmlouvy = priloha.idsmlouvy;
    end if;

    if (priloha.idpolsml is not null) then
        update dpolsml set pocetPriloh = (select count(1)+addon
                                            from wpriloha p
                                            where p.idpolsml = priloha.idpolsml)
        where idpolsml = priloha.idpolsml;
    end if;

    if (priloha.idmajetek is not null) then
        update mmajetek set pocetPriloh = (select count(1)+addon
                                            from wpriloha p
                                            where p.idmajetek = priloha.idmajetek)
        where idmajetku = priloha.idmajetek;
    end if;

    if (priloha.idleasing is not null) then
        update mleasing set pocetPriloh = (select count(1)+addon
                                            from wpriloha p
                                            where p.idpolsml = priloha.idleasing)
        where idleasing = priloha.idleasing;
    end if;

    if (priloha.iduzel is not null) then
        update wuzel set pocetPriloh = (select count(1)+addon
                                        from wpriloha p
                                        where p.idpolsml = priloha.iduzel)
        where iduzel = priloha.iduzel;
    end if;

end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION updatePocetPriloh(integer, integer) OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 803, 't', %appVersion%, clock_timestamp());
