--------------------------------------------------------------------------------
-- Bug 36694 – [Winstrom] SK - kontrolný výkaz daň z pridanej hodnoty (sk)
--------------------------------------------------------------------------------

CREATE SEQUENCE seq_uclenkonvykdph
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_uclenkonvykdph OWNER TO %firmaRole%;


CREATE TABLE uclenkonvykdph (
    idclenkonvykdph integer DEFAULT nextval('seq_uclenkonvykdph'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    idstatu integer NOT NULL,
    uuid character varying(50),
    CONSTRAINT uclenkonvykdph_pkey PRIMARY KEY (idclenkonvykdph),
    CONSTRAINT uclenkonvykdph_idstatu FOREIGN KEY (idstatu)
      REFERENCES astaty (idstatu) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.uclenkonvykdph OWNER TO %firmaRole%;

CREATE INDEX uClenKonVykDph_IdStatu_index ON uClenKonVykDph USING btree (IdStatu);

INSERT INTO uclenkonvykdph (idclenkonvykdph, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, idstatu, uuid) 
VALUES (1, '2013-12-23 13:27:36.635', 'A.1.', 'Údaje z vyhotovenej faktúry o dodaní tovarov a služieb, ktorú bol platiteľ dane povinný vyhotoviť podľa § 71 až 75 zákona, pri ktorých je osobou povinnou platiť daň (okrem zjednodušenej faktúry a faktúry o dodaní plnení oslobodených od dane)', NULL, NULL, NULL, 'Údaje z vyhotovenej faktúry o dodaní tovarov a služieb, ktorú bol platiteľ dane povinný vyhotoviť podľa § 71 až 75 zákona, pri ktorých je osobou povinnou platiť daň (okrem zjednodušenej faktúry a faktúry o dodaní plnení oslobodených od dane)', NULL, true, 9999, 0, (select IdStatu from aStaty where uuid  like '%_SK'), 'SK A.1.');
INSERT INTO uclenkonvykdph (idclenkonvykdph, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, idstatu, uuid)
VALUES (2, '2013-12-23 13:28:09.262', 'A.2.', 'Údaje z vyhotovenej faktúry o dodaní tovarov, ktorú bol platiteľ dane povinný vyhotoviť podľa § 71 až 75 zákona, pri ktorých je osobou povinnou platiť daň príjemca plnenia podľa § 69 ods. 12 písm. f)až i) zákona', NULL, NULL, NULL, 'Údaje z vyhotovenej faktúry o dodaní tovarov, ktorú bol platiteľ dane povinný vyhotoviť podľa § 71 až 75 zákona, pri ktorých je osobou povinnou platiť daň príjemca plnenia podľa § 69 ods. 12 písm. f)až i) zákona', NULL, true, 9999, 0, (select IdStatu from aStaty where uuid  like '%_SK'), 'SK A.2.');
INSERT INTO uclenkonvykdph (idclenkonvykdph, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, idstatu, uuid) 
VALUES (3, '2013-12-23 13:28:36.687', 'B.1.', 'Údaje z prijatej faktúry, pri ktorej je osobou povinnou platiť daň príjemca plnenia podľa § 69 ods. 2, 3, 6, 7 a 9 až 12 zákona (okrem faktúry o dodaní plnení oslobodených od dane)', NULL, NULL, NULL, 'Údaje z prijatej faktúry, pri ktorej je osobou povinnou platiť daň príjemca plnenia podľa § 69 ods. 2, 3, 6, 7 a 9 až 12 zákona (okrem faktúry o dodaní plnení oslobodených od dane)', NULL, true, 9999, 0, (select IdStatu from aStaty where uuid  like '%_SK'), 'SK B.1.');
INSERT INTO uclenkonvykdph (idclenkonvykdph, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, idstatu, uuid) 
VALUES (4, '2013-12-23 13:29:01.301', 'B.2.', 'Údaje z prijatej faktúry, z ktorej príjemca plnenia uplatňuje odpočítanie dane a ktorú vyhotovil platiteľ dane, ktorý je osobou povinnou platiť daň podľa § 69 ods. 1 zákona', NULL, NULL, NULL, 'Údaje z prijatej faktúry, z ktorej príjemca plnenia uplatňuje odpočítanie dane a ktorú vyhotovil platiteľ dane, ktorý je osobou povinnou platiť daň podľa § 69 ods. 1 zákona', NULL, true, 9999, 0, (select IdStatu from aStaty where uuid  like '%_SK'), 'SK B.2.');
INSERT INTO uclenkonvykdph (idclenkonvykdph, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, idstatu, uuid) 
VALUES (5, '2013-12-23 13:29:21.572', 'B.3.', 'Údaje zo všetkých prijatých zjednodušených faktúr podľa § 74 ods. 3 písm. a) až c) zákona, z ktorých príjemca plnenia uplatňuje odpočítanie dane', NULL, NULL, NULL, 'Údaje zo všetkých prijatých zjednodušených faktúr podľa § 74 ods. 3 písm. a) až c) zákona, z ktorých príjemca plnenia uplatňuje odpočítanie dane', NULL, true, 9999, 0, (select IdStatu from aStaty where uuid  like '%_SK'), 'SK B.3.');
INSERT INTO uclenkonvykdph (idclenkonvykdph, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, idstatu, uuid) 
VALUES (6, '2013-12-23 13:29:38.933', 'C.1.', 'Údaje z vyhotovenej opravnej faktúry', NULL, NULL, NULL, 'Údaje z vyhotovenej opravnej faktúry', NULL, true, 9999, 0, (select IdStatu from aStaty where uuid  like '%_SK'), 'SK C.1.');
INSERT INTO uclenkonvykdph (idclenkonvykdph, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, idstatu, uuid) 
VALUES (7, '2013-12-23 13:29:57.292', 'C.2.', 'Údaje z prijatej opravnej faktúry', NULL, NULL, NULL, 'Údaje z prijatej opravnej faktúry', NULL, true, 9999, 0, (select IdStatu from aStaty where uuid  like '%_SK'), 'SK C.2.');
INSERT INTO uclenkonvykdph (idclenkonvykdph, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, idstatu, uuid) 
VALUES (8, '2013-12-23 13:30:14.389', 'D.1.', 'Údaje o obratoch evidovaných všetkými elektronickými registračnými pokladnicami', NULL, NULL, NULL, 'Údaje o obratoch evidovaných všetkými elektronickými registračnými pokladnicami', NULL, true, 9999, 0, (select IdStatu from aStaty where uuid  like '%_SK'), 'SK D.1.');
INSERT INTO uclenkonvykdph (idclenkonvykdph, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, idstatu, uuid) 
VALUES (9, '2013-12-23 13:31:14.923', 'D.2.', 'Údaje o dodaní tovarov a služieb, ktoré sa neevidujú elektronickou registračnou pokladnicou', NULL, NULL, NULL, 'Údaje o dodaní tovarov a služieb, ktoré sa neevidujú elektronickou registračnou pokladnicou', NULL, true, 9999, 0, (select IdStatu from aStaty where uuid  like '%_SK'), 'SK D.2.');

select setval('seq_uclenkonvykdph', (select max(idclenkonvykdph)+1 from uclenkonvykdph));

alter table ddoklfak add column idclenkonvykdph integer,
  add constraint ddoklfak_idclenkonvykdph FOREIGN KEY (idclenkonvykdph)
      REFERENCES uclenkonvykdph (idclenkonvykdph) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;
alter table dpolfak add column idclenkonvykdph integer,
  add column kopclenkonvykdph boolean NOT NULL DEFAULT true,
  add constraint dpolfak_idclenkonvykdph FOREIGN KEY (idclenkonvykdph)
      REFERENCES uclenkonvykdph (idclenkonvykdph) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  add column ciselnyKodZbozi character varying(255),
  add column druhZbozi character varying(255);

alter table ddoklint add column idclenkonvykdph integer,
  add constraint ddoklint_idclenkonvykdph FOREIGN KEY (idclenkonvykdph)
      REFERENCES uclenkonvykdph (idclenkonvykdph) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;
alter table dpolint add column idclenkonvykdph integer,
  add column kopclenkonvykdph boolean NOT NULL DEFAULT true,
  add constraint dpolint_idclenkonvykdph FOREIGN KEY (idclenkonvykdph)
      REFERENCES uclenkonvykdph (idclenkonvykdph) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  add column ciselnyKodZbozi character varying(255),
  add column druhZbozi character varying(255);

alter table ddoklobch add column idclenkonvykdph integer,
  add constraint ddoklobch_idclenkonvykdph FOREIGN KEY (idclenkonvykdph)
      REFERENCES uclenkonvykdph (idclenkonvykdph) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;
alter table dpolobch add column idclenkonvykdph integer,
  add column kopclenkonvykdph boolean NOT NULL DEFAULT true,
  add constraint dpolobch_idclenkonvykdph FOREIGN KEY (idclenkonvykdph)
      REFERENCES uclenkonvykdph (idclenkonvykdph) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  add column ciselnyKodZbozi character varying(255),
  add column druhZbozi character varying(255);

alter table ddoklsklad add column idclenkonvykdph integer,
  add constraint ddoklsklad_idclenkonvykdph FOREIGN KEY (idclenkonvykdph)
      REFERENCES uclenkonvykdph (idclenkonvykdph) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;
alter table dpolsklad add column idclenkonvykdph integer,
  add column kopclenkonvykdph boolean NOT NULL DEFAULT true,
  add constraint dpolsklad_idclenkonvykdph FOREIGN KEY (idclenkonvykdph)
      REFERENCES uclenkonvykdph (idclenkonvykdph) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  add column ciselnyKodZbozi character varying(255),
  add column druhZbozi character varying(255);

alter table dtypdokl add column idclenkonvykdph integer,
  add constraint dtypdokl_idclenkonvykdph FOREIGN KEY (idclenkonvykdph)
      REFERENCES uclenkonvykdph (idclenkonvykdph) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX dDoklFak_IdClenKonVykDph_index ON dDoklFak USING btree (IdClenKonVykDph);
CREATE INDEX dPolFak_IdClenKonVykDph_index ON dPolFak USING btree (IdClenKonVykDph);
CREATE INDEX dDoklInt_IdClenKonVykDph_index ON dDoklInt USING btree (IdClenKonVykDph);
CREATE INDEX dPolInt_IdClenKonVykDph_index ON dPolInt USING btree (IdClenKonVykDph);
CREATE INDEX dDoklObch_IdClenKonVykDph_index ON dDoklObch USING btree (IdClenKonVykDph);
CREATE INDEX dPolObch_IdClenKonVykDph_index ON dPolObch USING btree (IdClenKonVykDph);
CREATE INDEX dDoklSklad_IdClenKonVykDph_index ON dDoklSklad USING btree (IdClenKonVykDph);
CREATE INDEX dPolSklad_IdClenKonVykDph_index ON dPolSklad USING btree (IdClenKonVykDph);
CREATE INDEX dTypDokl_IdClenKonVykDph_index ON dTypDokl USING btree (IdClenKonVykDph);

alter table ccenik add column ciselnyKodZbozi character varying(255),
  add column druhZbozi character varying(255);


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 808, 't', %appVersion%, clock_timestamp());
