--------------------------------------------------------------------------------
-- Bug 37564 – winstrom mzdy - hlavička osoby ztratí jméno
--------------------------------------------------------------------------------

DROP FUNCTION IF EXISTS skladrealizujpozadavky();

CREATE OR REPLACE FUNCTION skladrealizujpozadavky(i_idpolsklad integer, i_limit integer)
  RETURNS integer AS
$BODY$ 
declare
  _polSklad record;
  _polSkladDoklSklad record;
  _stavSkladu numeric(19,6);
  _cenaMj numeric(19,6);
  _pocetPozadavku integer;
  _pocet integer;
  _resultId integer;
begin
  _pocet = 0;
  _resultId = null;
  for _polSklad in (
    select p.*, d.typPohybuK, d.stavSkladK from dpolsklad p join ddoklsklad d on p.idDoklSklad = d.idDoklSklad
    where typPohybuK = 'typPohybu.vydej' and mnozMj = 0 and mnozMjPlan != 0 and p.storno = false and idPolSklad > i_idpolsklad
    order by datSklad, idPolSklad) loop
      _pocet = _pocet + 1;
      exit when _pocet > i_limit;
      _resultId = _polSklad.idPolSklad;
      --select dgetstavnasklade(_polSklad.idkarty, _polSklad.datSklad, /*_polSklad.idpolsklad*/ -1, _polSklad.sarze, _polSklad.expirace, _polSklad.typPohybuK) into _stavSkladu;
      select stavMj, prumCenaTuz into _stavSkladu, _cenaMj from skarty where idkarty = _polSklad.idKarty;
      
      if(_stavSkladu >= _polSklad.mnozMjPlan) then
        update skarty set
          pozadavkyMj = pozadavkyMj - _polSklad.mnozMjPlan,
          stavMjSPozadavky = stavMjSPozadavky + _polSklad.mnozMjPlan
        where idkarty = _polSklad.idKarty;
        
        update dpolsklad set mnozMj = mnozMjPlan, cenaMj = _cenaMj, sumZkl = mnozMjPlan * _cenaMj, datSklad = LOCALTIMESTAMP, lastupdate = LOCALTIMESTAMP
          where idpolsklad = _polSklad.idPolSklad;
        perform sprepoctisumydokladu(_polSklad.iddoklsklad);
        
        select count(*) into _pocetPozadavku from dpolSklad where idDoklSklad = _polSklad.idDoklSklad and mnozMj = 0.0 and mnozMjPlan != 0.0;
        if(_pocetPozadavku = 0) then
          if(compareVarchar(_polSklad.stavSkladK, 'stavSklad.vygenFaktNeuplny')) then
            update ddoklsklad set stavSkladK = 'stavSklad.vygenFakt' where idDoklSklad = _polSklad.idDoklSklad;
          end if;
          if(compareVarchar(_polSklad.stavSkladK, 'stavSklad.vygenPoklNeuplny')) then
            update ddoklsklad set stavSkladK = 'stavSklad.vygenPokl' where idDoklSklad = _polSklad.idDoklSklad;
          end if;
        end if;
      end if;
  end loop;
  return _resultId;
end;    
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladrealizujpozadavky(integer, integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 810, 't', %appVersion%, clock_timestamp());
