--------------------------------------------------------------------------------
-- Bug 37614 – [FlexiBee] Upravit report o změnách dokladu i o štítky (emeldi)
--------------------------------------------------------------------------------

CREATE SEQUENCE seq_wkli_aadresar
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_aadresar OWNER TO %firmaRole%;
alter table wkli_aadresar add column idwkli_aadresar integer NOT NULL DEFAULT nextval('seq_wkli_aadresar'::regclass);
alter table wkli_aadresar drop CONSTRAINT wkli_aadresar_pkey;
alter table wkli_aadresar add  CONSTRAINT wkli_aadresar_pkey primary key(idwkli_aadresar);
alter table wkli_aadresar add  CONSTRAINT wkli_aadresar_idfirmy_idvybklic_unique_key UNIQUE (idfirmy, idvybklic);
CREATE INDEX wkli_aadresar_idfirmy_index ON wkli_aadresar USING btree (idfirmy);
CREATE INDEX wkli_aadresar_idvybklic_index ON wkli_aadresar USING btree (idvybklic);

CREATE SEQUENCE seq_wkli_akontakt
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_akontakt OWNER TO %firmaRole%;
alter table wkli_akontakt add column idwkli_akontakt integer NOT NULL DEFAULT nextval('seq_wkli_akontakt'::regclass);
alter table wkli_akontakt drop CONSTRAINT wkli_akontakt_pkey;
alter table wkli_akontakt add  CONSTRAINT wkli_akontakt_pkey primary key(idwkli_akontakt);
alter table wkli_akontakt add  CONSTRAINT wkli_akontakt_idkontakt_idvybklic_unique_key UNIQUE (idkontakt, idvybklic);
CREATE INDEX wkli_akontakt_idkontakt_index ON wkli_akontakt USING btree (idkontakt);
CREATE INDEX wkli_akontakt_idvybklic_index ON wkli_akontakt USING btree (idvybklic);

CREATE SEQUENCE seq_wkli_amisturc
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_amisturc OWNER TO %firmaRole%;
alter table wkli_amisturc add column idwkli_amisturc integer NOT NULL DEFAULT nextval('seq_wkli_amisturc'::regclass);
alter table wkli_amisturc drop CONSTRAINT wkli_amisturc_pkey;
alter table wkli_amisturc add  CONSTRAINT wkli_amisturc_pkey primary key(idwkli_amisturc);
alter table wkli_amisturc add  CONSTRAINT wkli_amisturc_idmur_idvybklic_unique_key UNIQUE (idmur, idvybklic);

CREATE SEQUENCE seq_wkli_atypakt
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_atypakt OWNER TO %firmaRole%;
alter table wkli_atypakt add column idwkli_atypakt integer NOT NULL DEFAULT nextval('seq_wkli_atypakt'::regclass);
alter table wkli_atypakt drop CONSTRAINT wkli_atypakt_pkey;
alter table wkli_atypakt add  CONSTRAINT wkli_atypakt_pkey primary key(idwkli_atypakt);
alter table wkli_atypakt add  CONSTRAINT wkli_atypakt_idtypakt_idvybklic_unique_key UNIQUE (idtypakt, idvybklic);

CREATE SEQUENCE seq_wkli_audalost
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_audalost OWNER TO %firmaRole%;
alter table wkli_audalost add column idwkli_audalost integer NOT NULL DEFAULT nextval('seq_wkli_audalost'::regclass);
alter table wkli_audalost drop CONSTRAINT wkli_audalost_pkey;
alter table wkli_audalost add  CONSTRAINT wkli_audalost_pkey primary key(idwkli_audalost);
alter table wkli_audalost add  CONSTRAINT wkli_audalost_idudalost_idvybklic_unique_key UNIQUE (idudalost, idvybklic);
CREATE INDEX wkli_audalost_idudalost_index ON wkli_audalost USING btree (idudalost);
CREATE INDEX wkli_audalost_idvybklic_index ON wkli_audalost USING btree (idvybklic);

CREATE SEQUENCE seq_wkli_cdodavatele
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_cdodavatele OWNER TO %firmaRole%;
alter table wkli_cdodavatele add column idwkli_cdodavatele integer NOT NULL DEFAULT nextval('seq_wkli_cdodavatele'::regclass);
alter table wkli_cdodavatele drop CONSTRAINT wkli_cdodavatele_pkey;
alter table wkli_cdodavatele add  CONSTRAINT wkli_cdodavatele_pkey primary key(idwkli_cdodavatele);
alter table wkli_cdodavatele add  CONSTRAINT wkli_cdodavatele_iddodavatel_idvybklic_unique_key UNIQUE (iddodavatel, idvybklic);

CREATE SEQUENCE seq_wkli_cenik
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_cenik OWNER TO %firmaRole%;
alter table wkli_cenik add column idwkli_cenik integer NOT NULL DEFAULT nextval('seq_wkli_cenik'::regclass);
alter table wkli_cenik drop CONSTRAINT wkli_cenik_pkey;
alter table wkli_cenik add  CONSTRAINT wkli_cenik_pkey primary key(idwkli_cenik);
alter table wkli_cenik add  CONSTRAINT wkli_cenik_idcenik_idvybklic_unique_key UNIQUE (idcenik, idvybklic);
CREATE INDEX wkli_cenik_idcenik_index ON wkli_cenik USING btree (idcenik);
CREATE INDEX wkli_cenik_idvybklic_index ON wkli_cenik USING btree (idvybklic);

CREATE SEQUENCE seq_wkli_cskupzboz
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_cskupzboz OWNER TO %firmaRole%;
alter table wkli_cskupzboz add column idwkli_cskupzboz integer NOT NULL DEFAULT nextval('seq_wkli_cskupzboz'::regclass);
alter table wkli_cskupzboz drop CONSTRAINT wkli_cskupzboz_pkey;
alter table wkli_cskupzboz add  CONSTRAINT wkli_cskupzboz_pkey primary key(idwkli_cskupzboz);
alter table wkli_cskupzboz add  CONSTRAINT wkli_cskupzboz_idskupzboz_idvybklic_unique_key UNIQUE (idskupzboz, idvybklic);

CREATE SEQUENCE seq_wkli_dbsp
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_dbsp OWNER TO %firmaRole%;
alter table wkli_dbsp add column idwkli_dbsp integer NOT NULL DEFAULT nextval('seq_wkli_dbsp'::regclass);
alter table wkli_dbsp drop CONSTRAINT wkli_dbsp_pkey;
alter table wkli_dbsp add  CONSTRAINT wkli_dbsp_pkey primary key(idwkli_dbsp);
alter table wkli_dbsp add  CONSTRAINT wkli_dbsp_idbsp_idvybklic_unique_key UNIQUE (idbsp, idvybklic);

CREATE SEQUENCE seq_wkli_dformadopravy
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_dformadopravy OWNER TO %firmaRole%;
alter table wkli_dformadopravy add column idwkli_dformadopravy integer NOT NULL DEFAULT nextval('seq_wkli_dformadopravy'::regclass);
alter table wkli_dformadopravy drop CONSTRAINT wkli_dformadopravy_pkey;
alter table wkli_dformadopravy add  CONSTRAINT wkli_dformadopravy_pkey primary key(idwkli_dformadopravy);
alter table wkli_dformadopravy add  CONSTRAINT wkli_dformadopravy_idformadopravy_idvybklic_unique_key UNIQUE (idformadopravy, idvybklic);

CREATE SEQUENCE seq_wkli_dformauhrady
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_dformauhrady OWNER TO %firmaRole%;
alter table wkli_dformauhrady add column idwkli_dformauhrady integer NOT NULL DEFAULT nextval('seq_wkli_dformauhrady'::regclass);
alter table wkli_dformauhrady drop CONSTRAINT wkli_dformauhrady_pkey;
alter table wkli_dformauhrady add  CONSTRAINT wkli_dformauhrady_pkey primary key(idwkli_dformauhrady);
alter table wkli_dformauhrady add  CONSTRAINT wkli_dformauhrady_idformauhrady_idvybklic_unique_key UNIQUE (idformauhrady, idvybklic);

CREATE SEQUENCE seq_wkli_dformauhradycis
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_dformauhradycis OWNER TO %firmaRole%;
alter table wkli_dformauhradycis add column idwkli_dformauhradycis integer NOT NULL DEFAULT nextval('seq_wkli_dformauhradycis'::regclass);
alter table wkli_dformauhradycis drop CONSTRAINT wkli_dformauhradycis_pkey;
alter table wkli_dformauhradycis add  CONSTRAINT wkli_dformauhradycis_pkey primary key(idwkli_dformauhradycis);
alter table wkli_dformauhradycis add  CONSTRAINT wkli_dformauhradycis_idformauhradycis_idvybklic_unique_key UNIQUE (idformauhradycis, idvybklic);

CREATE SEQUENCE seq_wkli_doklfak
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_doklfak OWNER TO %firmaRole%;
alter table wkli_doklfak add column idwkli_doklfak integer NOT NULL DEFAULT nextval('seq_wkli_doklfak'::regclass);
alter table wkli_doklfak drop CONSTRAINT wkli_doklfak_pkey;
alter table wkli_doklfak add  CONSTRAINT wkli_doklfak_pkey primary key(idwkli_doklfak);
alter table wkli_doklfak add  CONSTRAINT wkli_doklfak_iddoklfak_idvybklic_unique_key UNIQUE (iddoklfak, idvybklic);
CREATE INDEX wkli_doklfak_iddoklfak_index ON wkli_doklfak USING btree (iddoklfak);
CREATE INDEX wkli_doklfak_idvybklic_index ON wkli_doklfak USING btree (idvybklic);

CREATE SEQUENCE seq_wkli_doklint
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_doklint OWNER TO %firmaRole%;
alter table wkli_doklint add column idwkli_doklint integer NOT NULL DEFAULT nextval('seq_wkli_doklint'::regclass);
alter table wkli_doklint drop CONSTRAINT wkli_doklint_pkey;
alter table wkli_doklint add  CONSTRAINT wkli_doklint_pkey primary key(idwkli_doklint);
alter table wkli_doklint add  CONSTRAINT wkli_doklint_iddoklint_idvybklic_unique_key UNIQUE (iddoklint, idvybklic);
CREATE INDEX wkli_doklint_iddoklint_index ON wkli_doklint USING btree (iddoklint);
CREATE INDEX wkli_doklint_idvybklic_index ON wkli_doklint USING btree (idvybklic);

CREATE SEQUENCE seq_wkli_doklobch
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_doklobch OWNER TO %firmaRole%;
alter table wkli_doklobch add column idwkli_doklobch integer NOT NULL DEFAULT nextval('seq_wkli_doklobch'::regclass);
alter table wkli_doklobch drop CONSTRAINT wkli_doklobch_pkey;
alter table wkli_doklobch add  CONSTRAINT wkli_doklobch_pkey primary key(idwkli_doklobch);
alter table wkli_doklobch add  CONSTRAINT wkli_doklobch_iddoklobch_idvybklic_unique_key UNIQUE (iddoklobch, idvybklic);
CREATE INDEX wkli_doklobch_iddoklobch_index ON wkli_doklobch USING btree (iddoklobch);
CREATE INDEX wkli_doklobch_idvybklic_index ON wkli_doklobch USING btree (idvybklic);

CREATE SEQUENCE seq_wkli_doklsklad
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_doklsklad OWNER TO %firmaRole%;
alter table wkli_doklsklad add column idwkli_doklsklad integer NOT NULL DEFAULT nextval('seq_wkli_doklsklad'::regclass);
alter table wkli_doklsklad drop CONSTRAINT wkli_doklsklad_pkey;
alter table wkli_doklsklad add  CONSTRAINT wkli_doklsklad_pkey primary key(idwkli_doklsklad);
alter table wkli_doklsklad add  CONSTRAINT wkli_doklsklad_iddoklsklad_idvybklic_unique_key UNIQUE (iddoklsklad, idvybklic);
CREATE INDEX wkli_doklsklad_iddoklsklad_index ON wkli_doklsklad USING btree (iddoklsklad);
CREATE INDEX wkli_doklsklad_idvybklic_index ON wkli_doklsklad USING btree (idvybklic);

CREATE SEQUENCE seq_wkli_dstavsml
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_dstavsml OWNER TO %firmaRole%;
alter table wkli_dstavsml add column idwkli_dstavsml integer NOT NULL DEFAULT nextval('seq_wkli_dstavsml'::regclass);
alter table wkli_dstavsml drop CONSTRAINT wkli_dstavsml_pkey;
alter table wkli_dstavsml add  CONSTRAINT wkli_dstavsml_pkey primary key(idwkli_dstavsml);
alter table wkli_dstavsml add  CONSTRAINT wkli_dstavsml_idstavsml_idvybklic_unique_key UNIQUE (idstavsml, idvybklic);

CREATE SEQUENCE seq_wkli_dtypsml
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_dtypsml OWNER TO %firmaRole%;
alter table wkli_dtypsml add column idwkli_dtypsml integer NOT NULL DEFAULT nextval('seq_wkli_dtypsml'::regclass);
alter table wkli_dtypsml drop CONSTRAINT wkli_dtypsml_pkey;
alter table wkli_dtypsml add  CONSTRAINT wkli_dtypsml_pkey primary key(idwkli_dtypsml);
alter table wkli_dtypsml add  CONSTRAINT wkli_dtypsml_idtypsml_idvybklic_unique_key UNIQUE (idtypsml, idvybklic);

CREATE SEQUENCE seq_wkli_mleasing
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_mleasing OWNER TO %firmaRole%;
alter table wkli_mleasing add column idwkli_mleasing integer NOT NULL DEFAULT nextval('seq_wkli_mleasing'::regclass);
alter table wkli_mleasing drop CONSTRAINT wkli_mleasing_pkey;
alter table wkli_mleasing add  CONSTRAINT wkli_mleasing_pkey primary key(idwkli_mleasing);
alter table wkli_mleasing add  CONSTRAINT wkli_mleasing_idleasing_idvybklic_unique_key UNIQUE (idleasing, idvybklic);
CREATE INDEX wkli_mleasing_idleasing_index ON wkli_mleasing USING btree (idleasing);
CREATE INDEX wkli_mleasing_idvybklic_index ON wkli_mleasing USING btree (idvybklic);

CREATE SEQUENCE seq_wkli_mmajetek
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_mmajetek OWNER TO %firmaRole%;
alter table wkli_mmajetek add column idwkli_mmajetek integer NOT NULL DEFAULT nextval('seq_wkli_mmajetek'::regclass);
alter table wkli_mmajetek drop CONSTRAINT wkli_mmajetek_pkey;
alter table wkli_mmajetek add  CONSTRAINT wkli_mmajetek_pkey primary key(idwkli_mmajetek);
alter table wkli_mmajetek add  CONSTRAINT wkli_mmajetek_idmajetku_idvybklic_unique_key UNIQUE (idmajetku, idvybklic);
CREATE INDEX wkli_mmajetek_idmajetku_index ON wkli_mmajetek USING btree (idmajetku);
CREATE INDEX wkli_mmajetek_idvybklic_index ON wkli_mmajetek USING btree (idvybklic);

CREATE SEQUENCE seq_wkli_pmzdsloz
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_pmzdsloz OWNER TO %firmaRole%;
alter table wkli_pmzdsloz add column idwkli_pmzdsloz integer NOT NULL DEFAULT nextval('seq_wkli_pmzdsloz'::regclass);
alter table wkli_pmzdsloz drop CONSTRAINT wkli_pmzdsloz_pkey;
alter table wkli_pmzdsloz add  CONSTRAINT wkli_pmzdsloz_pkey primary key(idwkli_pmzdsloz);
alter table wkli_pmzdsloz add  CONSTRAINT wkli_pmzdsloz_idmzdsloz_idvybklic_unique_key UNIQUE (idmzdsloz, idvybklic);
CREATE INDEX wkli_pmzdsloz_idmzdsloz_index ON wkli_pmzdsloz USING btree (idmzdsloz);
CREATE INDEX wkli_pmzdsloz_idvybklic_index ON wkli_pmzdsloz USING btree (idvybklic);

CREATE SEQUENCE seq_wkli_pnepritomnost
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_pnepritomnost OWNER TO %firmaRole%;
alter table wkli_pnepritomnost add column idwkli_pnepritomnost integer NOT NULL DEFAULT nextval('seq_wkli_pnepritomnost'::regclass);
alter table wkli_pnepritomnost drop CONSTRAINT wkli_pnepritomnost_pkey;
alter table wkli_pnepritomnost add  CONSTRAINT wkli_pnepritomnost_pkey primary key(idwkli_pnepritomnost);
alter table wkli_pnepritomnost add  CONSTRAINT wkli_pnepritomnost_idnepritomnost_idvybklic_unique_key UNIQUE (idnepritomnost, idvybklic);
CREATE INDEX wkli_pnepritomnost_idnepritomnost_index ON wkli_pnepritomnost USING btree (idnepritomnost);
CREATE INDEX wkli_pnepritomnost_idvybklic_index ON wkli_pnepritomnost USING btree (idvybklic);

CREATE SEQUENCE seq_wkli_polfak
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_polfak OWNER TO %firmaRole%;
alter table wkli_polfak add column idwkli_polfak integer NOT NULL DEFAULT nextval('seq_wkli_polfak'::regclass);
alter table wkli_polfak drop CONSTRAINT wkli_polfak_pkey;
alter table wkli_polfak add  CONSTRAINT wkli_polfak_pkey primary key(idwkli_polfak);
alter table wkli_polfak add  CONSTRAINT wkli_polfak_idpolfak_idvybklic_unique_key UNIQUE (idpolfak, idvybklic);

CREATE SEQUENCE seq_wkli_polint
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_polint OWNER TO %firmaRole%;
alter table wkli_polint add column idwkli_polint integer NOT NULL DEFAULT nextval('seq_wkli_polint'::regclass);
alter table wkli_polint drop CONSTRAINT wkli_polint_pkey;
alter table wkli_polint add  CONSTRAINT wkli_polint_pkey primary key(idwkli_polint);
alter table wkli_polint add  CONSTRAINT wkli_polint_idpolint_idvybklic_unique_key UNIQUE (idpolint, idvybklic);

CREATE SEQUENCE seq_wkli_polobch
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_polobch OWNER TO %firmaRole%;
alter table wkli_polobch add column idwkli_polobch integer NOT NULL DEFAULT nextval('seq_wkli_polobch'::regclass);
alter table wkli_polobch drop CONSTRAINT wkli_polobch_pkey;
alter table wkli_polobch add  CONSTRAINT wkli_polobch_pkey primary key(idwkli_polobch);
alter table wkli_polobch add  CONSTRAINT wkli_polobch_idpolobch_idvybklic_unique_key UNIQUE (idpolobch, idvybklic);

CREATE SEQUENCE seq_wkli_polsklad
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_polsklad OWNER TO %firmaRole%;
alter table wkli_polsklad add column idwkli_polsklad integer NOT NULL DEFAULT nextval('seq_wkli_polsklad'::regclass);
alter table wkli_polsklad drop CONSTRAINT wkli_polsklad_pkey;
alter table wkli_polsklad add  CONSTRAINT wkli_polsklad_pkey primary key(idwkli_polsklad);
alter table wkli_polsklad add  CONSTRAINT wkli_polsklad_idpolsklad_idvybklic_unique_key UNIQUE (idpolsklad, idvybklic);

CREATE SEQUENCE seq_wkli_polsml
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_polsml OWNER TO %firmaRole%;
alter table wkli_polsml add column idwkli_polsml integer NOT NULL DEFAULT nextval('seq_wkli_polsml'::regclass);
alter table wkli_polsml drop CONSTRAINT wkli_polsml_pkey;
alter table wkli_polsml add  CONSTRAINT wkli_polsml_pkey primary key(idwkli_polsml);
alter table wkli_polsml add  CONSTRAINT wkli_polsml_idpolsml_idvybklic_unique_key UNIQUE (idpolsml, idvybklic);

CREATE SEQUENCE seq_wkli_pstalamzdsloz
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_pstalamzdsloz OWNER TO %firmaRole%;
alter table wkli_pstalamzdsloz add column idwkli_pstalamzdsloz integer NOT NULL DEFAULT nextval('seq_wkli_pstalamzdsloz'::regclass);
alter table wkli_pstalamzdsloz drop CONSTRAINT wkli_pstalamzdsloz_pkey;
alter table wkli_pstalamzdsloz add  CONSTRAINT wkli_pstalamzdsloz_pkey primary key(idwkli_pstalamzdsloz);
alter table wkli_pstalamzdsloz add  CONSTRAINT wkli_pstalamzdsloz_idstalamzdsloz_idvybklic_unique_key UNIQUE (idstalamzdsloz, idvybklic);
CREATE INDEX wkli_pstalamzdsloz_idstalamzdsloz_index ON wkli_pstalamzdsloz USING btree (idstalamzdsloz);
CREATE INDEX wkli_pstalamzdsloz_idvybklic_index ON wkli_pstalamzdsloz USING btree (idvybklic);

CREATE SEQUENCE seq_wkli_smlouva
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_smlouva OWNER TO %firmaRole%;
alter table wkli_smlouva add column idwkli_smlouva integer NOT NULL DEFAULT nextval('seq_wkli_smlouva'::regclass);
alter table wkli_smlouva drop CONSTRAINT wkli_smlouva_pkey;
alter table wkli_smlouva add  CONSTRAINT wkli_smlouva_pkey primary key(idwkli_smlouva);
alter table wkli_smlouva add  CONSTRAINT wkli_smlouva_idsmlouvy_idvybklic_unique_key UNIQUE (idsmlouvy, idvybklic);

CREATE SEQUENCE seq_wkli_stavcen
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_stavcen OWNER TO %firmaRole%;
alter table wkli_stavcen add column idwkli_stavcen integer NOT NULL DEFAULT nextval('seq_wkli_stavcen'::regclass);
alter table wkli_stavcen drop CONSTRAINT wkli_stavcen_pkey;
alter table wkli_stavcen add  CONSTRAINT wkli_stavcen_pkey primary key(idwkli_stavcen);
alter table wkli_stavcen add  CONSTRAINT wkli_stavcen_idstavcen_idvybklic_unique_key UNIQUE (idstavcen, idvybklic);

CREATE SEQUENCE seq_wkli_typzbozi
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_typzbozi OWNER TO %firmaRole%;
alter table wkli_typzbozi add column idwkli_typzbozi integer NOT NULL DEFAULT nextval('seq_wkli_typzbozi'::regclass);
alter table wkli_typzbozi drop CONSTRAINT wkli_typzbozi_pkey;
alter table wkli_typzbozi add  CONSTRAINT wkli_typzbozi_pkey primary key(idwkli_typzbozi);
alter table wkli_typzbozi add  CONSTRAINT wkli_typzbozi_idtypzbozi_idvybklic_unique_key UNIQUE (idtypzbozi, idvybklic);

CREATE SEQUENCE seq_wkli_ucinnost
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_ucinnost OWNER TO %firmaRole%;
alter table wkli_ucinnost add column idwkli_ucinnost integer NOT NULL DEFAULT nextval('seq_wkli_ucinnost'::regclass);
alter table wkli_ucinnost drop CONSTRAINT wkli_ucinnost_pkey;
alter table wkli_ucinnost add  CONSTRAINT wkli_ucinnost_pkey primary key(idwkli_ucinnost);
alter table wkli_ucinnost add  CONSTRAINT wkli_ucinnost_idcinnost_idvybklic_unique_key UNIQUE (idcinnost, idvybklic);

CREATE SEQUENCE seq_wkli_ustredisko
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_ustredisko OWNER TO %firmaRole%;
alter table wkli_ustredisko add column idwkli_ustredisko integer NOT NULL DEFAULT nextval('seq_wkli_ustredisko'::regclass);
alter table wkli_ustredisko drop CONSTRAINT wkli_ustredisko_pkey;
alter table wkli_ustredisko add  CONSTRAINT wkli_ustredisko_pkey primary key(idwkli_ustredisko);
alter table wkli_ustredisko add  CONSTRAINT wkli_ustredisko_idstred_idvybklic_unique_key UNIQUE (idstred, idvybklic);

CREATE SEQUENCE seq_wkli_wuzivatel
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_wuzivatel OWNER TO %firmaRole%;
alter table wkli_wuzivatel add column idwkli_wuzivatel integer NOT NULL DEFAULT nextval('seq_wkli_wuzivatel'::regclass);
alter table wkli_wuzivatel drop CONSTRAINT wkli_wuzivatel_pkey;
alter table wkli_wuzivatel add  CONSTRAINT wkli_wuzivatel_pkey primary key(idwkli_wuzivatel);
alter table wkli_wuzivatel add  CONSTRAINT wkli_wuzivatel_iduzivatel_idvybklic_unique_key UNIQUE (iduzivatel, idvybklic);

CREATE SEQUENCE seq_wkli_wvazbatyp
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_wvazbatyp OWNER TO %firmaRole%;
alter table wkli_wvazbatyp add column idwkli_wvazbatyp integer NOT NULL DEFAULT nextval('seq_wkli_wvazbatyp'::regclass);
alter table wkli_wvazbatyp drop CONSTRAINT wkli_vazba_typ_pkey;
alter table wkli_wvazbatyp add  CONSTRAINT wkli_wvazbatyp_pkey primary key(idwkli_wvazbatyp);
alter table wkli_wvazbatyp add  CONSTRAINT wkli_wvazbatyp_idvazbatyp_idvybklic_unique_key UNIQUE (idvazbatyp, idvybklic);

CREATE SEQUENCE seq_wkli_zdite
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_zdite OWNER TO %firmaRole%;
alter table wkli_zdite add column idwkli_zdite integer NOT NULL DEFAULT nextval('seq_wkli_zdite'::regclass);
alter table wkli_zdite drop CONSTRAINT wkli_zdite_pkey;
alter table wkli_zdite add  CONSTRAINT wkli_zdite_pkey primary key(idwkli_zdite);
alter table wkli_zdite add  CONSTRAINT wkli_zdite_iddite_idvybklic_unique_key UNIQUE (iddite, idvybklic);
CREATE INDEX wkli_zdite_iddite_index ON wkli_zdite USING btree (iddite);
CREATE INDEX wkli_zdite_idvybklic_index ON wkli_zdite USING btree (idvybklic);

CREATE SEQUENCE seq_wkli_zosoba
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_wkli_zosoba OWNER TO %firmaRole%;
alter table wkli_zosoba add column idwkli_zosoba integer NOT NULL DEFAULT nextval('seq_wkli_zosoba'::regclass);
alter table wkli_zosoba drop CONSTRAINT wkli_zosoba_pkey;
alter table wkli_zosoba add  CONSTRAINT wkli_zosoba_pkey primary key(idwkli_zosoba);
alter table wkli_zosoba add  CONSTRAINT wkli_zosoba_idosoba_idvybklic_unique_key UNIQUE (idosoba, idvybklic);
CREATE INDEX wkli_zosoba_idosoba_index ON wkli_zosoba USING btree (idosoba);
CREATE INDEX wkli_zosoba_idvybklic_index ON wkli_zosoba USING btree (idvybklic);

UPDATE wdotazy SET dotaz = e'select \n   (case when  tabulka = ''dpolfak'' then ''Položka dok.'' else \n     (case when tabulka = ''ddoklfak'' then ''Hlavička dok.'' else \n       (case when tabulka = ''wkli_doklfak'' then ''Štítek na hlavičku'' else ''Štítek na položku'' end)\n     end)\n   end) as Hlavicka_polozka ,\n\n   ( case when tabulka = ''wkli_doklfak'' then \n       (case when op = ''DELETE'' then\n       (select kod from wvybklice where idvybklice = to_number((select starahod from wzurnal w2 where w2.idzaznamu = w1.idzaznamu and w2.sloupec = ''idvybklic'' limit 1), ''99999999''))\n       else\n       (select kod from wvybklice where idvybklice = (select idvybklic from wkli_doklfak wd where wd.idwkli_doklfak = w1.idzaznamu limit 1))\n       end)\n    else \n   ( case when tabulka = ''wkli_polfak'' then \n       (case when op = ''DELETE'' then\n       (select kod from wvybklice where idvybklice = to_number((select starahod from wzurnal w2 where w2.idzaznamu = w1.idzaznamu and w2.sloupec = ''idvybklic'' limit 1), ''99999999''))\n       else\n       (select kod from wvybklice where idvybklice = (select idvybklic from wkli_polfak wd where wd.idwkli_polfak = w1.idzaznamu limit 1))\n       end)\n    else \n    \n   (case when  tabulka = ''dpolfak'' and op <> ''DELETE'' \n                then (select nazev from dpolfak where idpolfak = idzaznamu) \n                else (case when op = ''DELETE'' and sloupec = ''iddoklfak'' and tabulka = ''dpolfak''\n                      and to_number(starahod, ''99999999'') = <<id_dokladu>>\n                          then (select starahod from wzurnal as w2 where w1.idzaznamu = w2.idzaznamu  and w2.sloupec = ''nazev'' limit 1) || \n                              '';  množství MJ = '' ||\n                              (select starahod from wzurnal as w2 where w1.idzaznamu = w2.idzaznamu and w2.sloupec = ''mnozmj'' limit 1) || \n                              '', cena za MJ = '' ||\n                              (select starahod from wzurnal as w2 where w1.idzaznamu = w2.idzaznamu and w2.sloupec = ''cenamj'' limit 1)\n                          else\n                              null\n                          end)  \n               end) end) end) as Nazev , \n   (case when tabulka = ''dpolfak''and  op <> ''DELETE'' \n       then (select cisrad from dpolfak where idpolfak = idzaznamu) \n       else (case when op = ''DELETE'' and sloupec = ''iddoklfak'' and tabulka = ''dpolfak''  and to_number(starahod, ''99999999'') = <<id_dokladu>> \n            then (select to_number(starahod, ''99999999'') from wzurnal as w2 where w1.idzaznamu = w2.idzaznamu  and w2.sloupec = ''cisrad'' limit 1) \n            else null end)\n       end) as Poradi_polozky, \n   (case when (tabulka = ''dpolfak'' or tabulka = ''wkli_doklfak'' or tabulka = ''wkli_polfak'') and op = ''DELETE'' \n       then '' - odstranění -''\n       else sloupec\n       end) as Sloupec, \n    Starahod as Puvodni_hodnota, \n    Novahod as zmenena_na, \n    Uziv as Uzivatelem, \n   (case when op = ''INSERT'' then ''vloženo'' else (case when op = ''UPDATE'' then ''změna'' else ''smazáno'' end) end) as Operace, \n      to_char(datcas, ''YYYY.MM.DD - HH24:MI:SS'') as datcas\nfrom wzurnal as w1\n   where \n      (tabulka = ''ddoklfak'' and idzaznamu = <<id_dokladu>>)\n      or\n      (tabulka = ''dpolfak'' and (\n         idzaznamu in (select idpolfak from dpolfak as p where p.iddoklfak = <<id_dokladu>>) or\n          (sloupec = ''iddoklfak'' and tabulka = ''dpolfak'' and to_number(starahod, ''99999999'') = <<id_dokladu>>)\n      ))\n      or\n      (tabulka = ''wkli_doklfak'' and (\n         idzaznamu in (select idwkli_doklfak from wkli_doklfak as p where p.iddoklfak = <<id_dokladu>>) or\n          (sloupec = ''iddoklfak'' and tabulka = ''wkli_doklfak'' and to_number(starahod, ''99999999'') = <<id_dokladu>>)\n      ))\n      or\n      (tabulka = ''wkli_polfak'' and (\n         idzaznamu in (select idwkli_polfak from wkli_polfak as p where p.idpolfak in (select idpolfak from dpolfak as p where p.iddoklfak = <<id_dokladu>>)) or\n          (sloupec = ''idpolfak'' and tabulka = ''wkli_polfak'' and to_number(starahod, ''99999999'') in (select idpolfak from dpolfak as p where p.iddoklfak = <<id_dokladu>>))\n      ))' WHERE uuid = 'FAKTURY-ZMENY';
UPDATE wdotazy SET dotaz = e'select \n   (case when  tabulka = ''dpolint'' then ''Položka dok.'' else \n     (case when tabulka = ''ddoklint'' then ''Hlavička dok.'' else \n       (case when tabulka = ''wkli_doklint'' then ''Štítek na hlavičku'' else ''Štítek na položku'' end)\n     end)\n   end) as Hlavicka_polozka ,\n\n   ( case when tabulka = ''wkli_doklint'' then \n       (case when op = ''DELETE'' then\n       (select kod from wvybklice where idvybklice = to_number((select starahod from wzurnal w2 where w2.idzaznamu = w1.idzaznamu and w2.sloupec = ''idvybklic'' limit 1), ''99999999''))\n       else\n       (select kod from wvybklice where idvybklice = (select idvybklic from wkli_doklint wd where wd.idwkli_doklint = w1.idzaznamu limit 1))\n       end)\n    else \n   ( case when tabulka = ''wkli_polint'' then \n       (case when op = ''DELETE'' then\n       (select kod from wvybklice where idvybklice = to_number((select starahod from wzurnal w2 where w2.idzaznamu = w1.idzaznamu and w2.sloupec = ''idvybklic'' limit 1), ''99999999''))\n       else\n       (select kod from wvybklice where idvybklice = (select idvybklic from wkli_polint wd where wd.idwkli_polint = w1.idzaznamu limit 1))\n       end)\n    else \n    \n   (case when  tabulka = ''dpolint'' and op <> ''DELETE'' \n                then (select nazev from dpolint where idpolint = idzaznamu) \n                else (case when op = ''DELETE'' and sloupec = ''iddoklint'' and tabulka = ''dpolint''\n                      and to_number(starahod, ''99999999'') = <<id_dokladu>>\n                          then (select starahod from wzurnal as w2 where w1.idzaznamu = w2.idzaznamu  and w2.sloupec = ''nazev'' limit 1) || \n                              '';  množství MJ = '' ||\n                              (select starahod from wzurnal as w2 where w1.idzaznamu = w2.idzaznamu and w2.sloupec = ''mnozmj'' limit 1) || \n                              '', cena za MJ = '' ||\n                              (select starahod from wzurnal as w2 where w1.idzaznamu = w2.idzaznamu and w2.sloupec = ''cenamj'' limit 1)\n                          else\n                              null\n                          end)  \n               end) end) end) as Nazev , \n   (case when tabulka = ''dpolint''and  op <> ''DELETE'' \n       then (select cisrad from dpolint where idpolint = idzaznamu) \n       else (case when op = ''DELETE'' and sloupec = ''iddoklint'' and tabulka = ''dpolint''  and to_number(starahod, ''99999999'') = <<id_dokladu>> \n            then (select to_number(starahod, ''99999999'') from wzurnal as w2 where w1.idzaznamu = w2.idzaznamu  and w2.sloupec = ''cisrad'' limit 1) \n            else null end)\n       end) as Poradi_polozky, \n   (case when (tabulka = ''dpolint'' or tabulka = ''wkli_doklint'' or tabulka = ''wkli_polint'') and op = ''DELETE'' \n       then '' - odstranění -''\n       else sloupec\n       end) as Sloupec, \n    Starahod as Puvodni_hodnota, \n    Novahod as zmenena_na, \n    Uziv as Uzivatelem, \n   (case when op = ''INSERT'' then ''vloženo'' else (case when op = ''UPDATE'' then ''změna'' else ''smazáno'' end) end) as Operace, \n      to_char(datcas, ''YYYY.MM.DD - HH24:MI:SS'') as datcas\nfrom wzurnal as w1\n   where \n      (tabulka = ''ddoklint'' and idzaznamu = <<id_dokladu>>)\n      or\n      (tabulka = ''dpolint'' and (\n         idzaznamu in (select idpolint from dpolint as p where p.iddoklint = <<id_dokladu>>) or\n          (sloupec = ''iddoklint'' and tabulka = ''dpolint'' and to_number(starahod, ''99999999'') = <<id_dokladu>>)\n      ))\n      or\n      (tabulka = ''wkli_doklint'' and (\n         idzaznamu in (select idwkli_doklint from wkli_doklint as p where p.iddoklint = <<id_dokladu>>) or\n          (sloupec = ''iddoklint'' and tabulka = ''wkli_doklint'' and to_number(starahod, ''99999999'') = <<id_dokladu>>)\n      ))\n      or\n      (tabulka = ''wkli_polint'' and (\n         idzaznamu in (select idwkli_polint from wkli_polint as p where p.idpolint in (select idpolint from dpolint as p where p.iddoklint = <<id_dokladu>>)) or\n          (sloupec = ''idpolint'' and tabulka = ''wkli_polint'' and to_number(starahod, ''99999999'') in (select idpolint from dpolint as p where p.iddoklint = <<id_dokladu>>))\n      ))' WHERE uuid = 'INT.,BAN.,POK.-ZMENY';
UPDATE wdotazy SET dotaz = e'select \n   (case when  tabulka = ''dpolobch'' then ''Položka dok.'' else \n     (case when tabulka = ''ddoklobch'' then ''Hlavička dok.'' else \n       (case when tabulka = ''wkli_doklobch'' then ''Štítek na hlavičku'' else ''Štítek na položku'' end)\n     end)\n   end) as Hlavicka_polozka ,\n\n   ( case when tabulka = ''wkli_doklobch'' then \n       (case when op = ''DELETE'' then\n       (select kod from wvybklice where idvybklice = to_number((select starahod from wzurnal w2 where w2.idzaznamu = w1.idzaznamu and w2.sloupec = ''idvybklic'' limit 1), ''99999999''))\n       else\n       (select kod from wvybklice where idvybklice = (select idvybklic from wkli_doklobch wd where wd.idwkli_doklobch = w1.idzaznamu limit 1))\n       end)\n    else \n   ( case when tabulka = ''wkli_polobch'' then \n       (case when op = ''DELETE'' then\n       (select kod from wvybklice where idvybklice = to_number((select starahod from wzurnal w2 where w2.idzaznamu = w1.idzaznamu and w2.sloupec = ''idvybklic'' limit 1), ''99999999''))\n       else\n       (select kod from wvybklice where idvybklice = (select idvybklic from wkli_polobch wd where wd.idwkli_polobch = w1.idzaznamu limit 1))\n       end)\n    else \n    \n   (case when  tabulka = ''dpolobch'' and op <> ''DELETE'' \n                then (select nazev from dpolobch where idpolobch = idzaznamu) \n                else (case when op = ''DELETE'' and sloupec = ''iddoklobch'' and tabulka = ''dpolobch''\n                      and to_number(starahod, ''99999999'') = <<id_dokladu>>\n                          then (select starahod from wzurnal as w2 where w1.idzaznamu = w2.idzaznamu  and w2.sloupec = ''nazev'' limit 1) || \n                              '';  množství MJ = '' ||\n                              (select starahod from wzurnal as w2 where w1.idzaznamu = w2.idzaznamu and w2.sloupec = ''mnozmj'' limit 1) || \n                              '', cena za MJ = '' ||\n                              (select starahod from wzurnal as w2 where w1.idzaznamu = w2.idzaznamu and w2.sloupec = ''cenamj'' limit 1)\n                          else\n                              null\n                          end)  \n               end) end) end) as Nazev , \n   (case when tabulka = ''dpolobch''and  op <> ''DELETE'' \n       then (select cisrad from dpolobch where idpolobch = idzaznamu) \n       else (case when op = ''DELETE'' and sloupec = ''iddoklobch'' and tabulka = ''dpolobch''  and to_number(starahod, ''99999999'') = <<id_dokladu>> \n            then (select to_number(starahod, ''99999999'') from wzurnal as w2 where w1.idzaznamu = w2.idzaznamu  and w2.sloupec = ''cisrad'' limit 1) \n            else null end)\n       end) as Poradi_polozky, \n   (case when (tabulka = ''dpolobch'' or tabulka = ''wkli_doklobch'' or tabulka = ''wkli_polobch'') and op = ''DELETE'' \n       then '' - odstranění -''\n       else sloupec\n       end) as Sloupec, \n    Starahod as Puvodni_hodnota, \n    Novahod as zmenena_na, \n    Uziv as Uzivatelem, \n   (case when op = ''INSERT'' then ''vloženo'' else (case when op = ''UPDATE'' then ''změna'' else ''smazáno'' end) end) as Operace, \n      to_char(datcas, ''YYYY.MM.DD - HH24:MI:SS'') as datcas\nfrom wzurnal as w1\n   where \n      (tabulka = ''ddoklobch'' and idzaznamu = <<id_dokladu>>)\n      or\n      (tabulka = ''dpolobch'' and (\n         idzaznamu in (select idpolobch from dpolobch as p where p.iddoklobch = <<id_dokladu>>) or\n          (sloupec = ''iddoklobch'' and tabulka = ''dpolobch'' and to_number(starahod, ''99999999'') = <<id_dokladu>>)\n      ))\n      or\n      (tabulka = ''wkli_doklobch'' and (\n         idzaznamu in (select idwkli_doklobch from wkli_doklobch as p where p.iddoklobch = <<id_dokladu>>) or\n          (sloupec = ''iddoklobch'' and tabulka = ''wkli_doklobch'' and to_number(starahod, ''99999999'') = <<id_dokladu>>)\n      ))\n      or\n      (tabulka = ''wkli_polobch'' and (\n         idzaznamu in (select idwkli_polobch from wkli_polobch as p where p.idpolobch in (select idpolobch from dpolobch as p where p.iddoklobch = <<id_dokladu>>)) or\n          (sloupec = ''idpolobch'' and tabulka = ''wkli_polobch'' and to_number(starahod, ''99999999'') in (select idpolobch from dpolobch as p where p.iddoklobch = <<id_dokladu>>))\n      ))\n' WHERE uuid = 'OBCHOD-ZMENY';
UPDATE wdotazy SET dotaz = e'select \n   (case when  tabulka = ''dpolsklad'' then ''Položka dok.'' else \n     (case when tabulka = ''ddoklsklad'' then ''Hlavička dok.'' else \n       (case when tabulka = ''wkli_doklsklad'' then ''Štítek na hlavičku'' else ''Štítek na položku'' end)\n     end)\n   end) as Hlavicka_polozka ,\n\n   ( case when tabulka = ''wkli_doklsklad'' then \n       (case when op = ''DELETE'' then\n       (select kod from wvybklice where idvybklice = to_number((select starahod from wzurnal w2 where w2.idzaznamu = w1.idzaznamu and w2.sloupec = ''idvybklic'' limit 1), ''99999999''))\n       else\n       (select kod from wvybklice where idvybklice = (select idvybklic from wkli_doklsklad wd where wd.idwkli_doklsklad = w1.idzaznamu limit 1))\n       end)\n    else \n   ( case when tabulka = ''wkli_polsklad'' then \n       (case when op = ''DELETE'' then\n       (select kod from wvybklice where idvybklice = to_number((select starahod from wzurnal w2 where w2.idzaznamu = w1.idzaznamu and w2.sloupec = ''idvybklic'' limit 1), ''99999999''))\n       else\n       (select kod from wvybklice where idvybklice = (select idvybklic from wkli_polsklad wd where wd.idwkli_polsklad = w1.idzaznamu limit 1))\n       end)\n    else \n    \n   (case when  tabulka = ''dpolsklad'' and op <> ''DELETE'' \n                then (select nazev from dpolsklad where idpolsklad = idzaznamu) \n                else (case when op = ''DELETE'' and sloupec = ''iddoklsklad'' and tabulka = ''dpolsklad''\n                      and to_number(starahod, ''99999999'') = <<id_dokladu>>\n                          then (select starahod from wzurnal as w2 where w1.idzaznamu = w2.idzaznamu  and w2.sloupec = ''nazev'' limit 1) || \n                              '';  množství MJ = '' ||\n                              (select starahod from wzurnal as w2 where w1.idzaznamu = w2.idzaznamu and w2.sloupec = ''mnozmj'' limit 1) || \n                              '', cena za MJ = '' ||\n                              (select starahod from wzurnal as w2 where w1.idzaznamu = w2.idzaznamu and w2.sloupec = ''cenamj'' limit 1)\n                          else\n                              null\n                          end)  \n               end) end) end) as Nazev , \n   (case when tabulka = ''dpolsklad''and  op <> ''DELETE'' \n       then (select cisrad from dpolsklad where idpolsklad = idzaznamu) \n       else (case when op = ''DELETE'' and sloupec = ''iddoklsklad'' and tabulka = ''dpolsklad''  and to_number(starahod, ''99999999'') = <<id_dokladu>> \n            then (select to_number(starahod, ''99999999'') from wzurnal as w2 where w1.idzaznamu = w2.idzaznamu  and w2.sloupec = ''cisrad'' limit 1) \n            else null end)\n       end) as Poradi_polozky, \n   (case when (tabulka = ''dpolsklad'' or tabulka = ''wkli_doklsklad'' or tabulka = ''wkli_polsklad'') and op = ''DELETE'' \n       then '' - odstranění -''\n       else sloupec\n       end) as Sloupec, \n    Starahod as Puvodni_hodnota, \n    Novahod as zmenena_na, \n    Uziv as Uzivatelem, \n   (case when op = ''INSERT'' then ''vloženo'' else (case when op = ''UPDATE'' then ''změna'' else ''smazáno'' end) end) as Operace, \n      to_char(datcas, ''YYYY.MM.DD - HH24:MI:SS'') as datcas\nfrom wzurnal as w1\n   where \n      (tabulka = ''ddoklsklad'' and idzaznamu = <<id_dokladu>>)\n      or\n      (tabulka = ''dpolsklad'' and (\n         idzaznamu in (select idpolsklad from dpolsklad as p where p.iddoklsklad = <<id_dokladu>>) or\n          (sloupec = ''iddoklsklad'' and tabulka = ''dpolsklad'' and to_number(starahod, ''99999999'') = <<id_dokladu>>)\n      ))\n      or\n      (tabulka = ''wkli_doklsklad'' and (\n         idzaznamu in (select idwkli_doklsklad from wkli_doklsklad as p where p.iddoklsklad = <<id_dokladu>>) or\n          (sloupec = ''iddoklsklad'' and tabulka = ''wkli_doklsklad'' and to_number(starahod, ''99999999'') = <<id_dokladu>>)\n      ))\n      or\n      (tabulka = ''wkli_polsklad'' and (\n         idzaznamu in (select idwkli_polsklad from wkli_polsklad as p where p.idpolsklad in (select idpolsklad from dpolsklad as p where p.iddoklsklad = <<id_dokladu>>)) or\n          (sloupec = ''idpolsklad'' and tabulka = ''wkli_polsklad'' and to_number(starahod, ''99999999'') in (select idpolsklad from dpolsklad as p where p.iddoklsklad = <<id_dokladu>>))\n      ))' WHERE uuid = 'SKLAD-ZMENY';
UPDATE wdotazy SET dotaz = e'select \n   (case when tabulka = ''aadresar'' then (select nazev from aadresar where idfirmy = idzaznamu) else '''' end) as nazev ,\n   (case when tabulka = ''wkli_aadresar'' then ''Štítek'' else Sloupec end) as Sloupec, \n   (case when tabulka = ''wkli_aadresar'' then \n     (case when op = ''DELETE'' then (select kod from wvybklice where idvybklice = to_number((select starahod from wzurnal w2 where w2.idzaznamu = w1.idzaznamu and w2.sloupec = ''idvybklic'' limit 1), ''99999999'')) else ''''end) \n     else Starahod end) as Puvodni_hodnota, \n   (case when tabulka = ''wkli_aadresar'' then\n     (select kod from wvybklice where idvybklice = (select idvybklic from wkli_aadresar where idwkli_aadresar = idzaznamu limit 1)) \n     else Novahod end) as zmenena_na, \n   Uziv as Uzivatelem, \n   to_char(datcas, ''YYYY.MM.DD - HH24:MI:SS'') as datcas\n   from wzurnal w1\n     where (tabulka = ''aadresar'' and idzaznamu = <<id_firmy>> and op = ''UPDATE'')\n        or (tabulka = ''wkli_aadresar'' and (idzaznamu in (select idwkli_aadresar from wkli_aadresar as p where p.idfirmy = <<id_firmy>>) or\n          (sloupec = ''idfirmy'' and tabulka = ''wkli_aadresar'' and to_number(starahod, ''99999999'') = <<id_firmy>>)\n      ))\n     order by sloupec, datcas,idzaznamu' WHERE uuid = 'ADRESAR-ZMENY';
UPDATE wdotazy SET dotaz = e'select \n   (case when tabulka = ''ccenik'' then (select nazev from ccenik where idcenik = idzaznamu) else '''' end) as nazev ,\n   (case when tabulka = ''wkli_cenik'' then ''Štítek'' else Sloupec end) as Sloupec, \n   (case when tabulka = ''wkli_cenik'' then \n     (case when op = ''DELETE'' then (select kod from wvybklice where idvybklice = to_number((select starahod from wzurnal w2 where w2.idzaznamu = w1.idzaznamu and w2.sloupec = ''idvybklic'' limit 1), ''99999999'')) else ''''end) \n     else Starahod end) as Puvodni_hodnota, \n   (case when tabulka = ''wkli_cenik'' then\n     (select kod from wvybklice where idvybklice = (select idvybklic from wkli_cenik where idwkli_cenik = idzaznamu limit 1)) \n     else Novahod end) as zmenena_na, \n   Uziv as Uzivatelem, \n   to_char(datcas, ''YYYY.MM.DD - HH24:MI:SS'') as datcas\n   from wzurnal w1\n     where (tabulka = ''ccenik'' and idzaznamu = <<id_cenik>> and op = ''UPDATE'')\n        or (tabulka = ''wkli_cenik'' and (idzaznamu in (select idwkli_cenik from wkli_cenik as p where p.idcenik = <<id_cenik>>) or\n          (sloupec = ''idcenik'' and tabulka = ''wkli_cenik'' and to_number(starahod, ''99999999'') = <<id_cenik>>)\n      ))\n     order by sloupec, datcas,idzaznamu' WHERE uuid = 'CENIK-ZMENY';
UPDATE wdotazy SET dotaz = e'select \n   (case when tabulka = ''mmajetek'' then (select nazev from mmajetek where idmajetku = idzaznamu) else '''' end) as nazev ,\n   (case when tabulka = ''wkli_mmajetek'' then ''Štítek'' else Sloupec end) as Sloupec, \n   (case when tabulka = ''wkli_mmajetek'' then \n     (case when op = ''DELETE'' then (select kod from wvybklice where idvybklice = to_number((select starahod from wzurnal w2 where w2.idzaznamu = w1.idzaznamu and w2.sloupec = ''idvybklic'' limit 1), ''99999999'')) else ''''end) \n     else Starahod end) as Puvodni_hodnota, \n   (case when tabulka = ''wkli_mmajetek'' then\n     (select kod from wvybklice where idvybklice = (select idvybklic from wkli_mmajetek where idwkli_mmajetek = idzaznamu limit 1)) \n     else Novahod end) as zmenena_na, \n   Uziv as Uzivatelem, \n   to_char(datcas, ''YYYY.MM.DD - HH24:MI:SS'') as datcas\n   from wzurnal w1\n     where (tabulka = ''mmajetek'' and idzaznamu = <<id_majetku>> and op = ''UPDATE'')\n        or (tabulka = ''wkli_mmajetek'' and (idzaznamu in (select idwkli_mmajetek from wkli_mmajetek as p where p.idmajetku = <<id_majetku>>) or\n          (sloupec = ''idmajetku'' and tabulka = ''wkli_mmajetek'' and to_number(starahod, ''99999999'') = <<id_majetku>>)\n      ))\n     order by sloupec, datcas,idzaznamu' WHERE uuid = 'MAJETEK-ZMENY';

-- musime promozat zurnal protoze stare zaznamy tabulek wkli_ maji spatne idzaznamu
delete from wzurnal where tabulka like 'wkli_%';

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 814, 't', %appVersion%, clock_timestamp());
