--------------------------------------------------------------------------------
-- Bug 40794 - [Legis] Druhá snížená sazba DPH ve výši 10 %
--------------------------------------------------------------------------------

ALTER TABLE utypucop
    ADD COLUMN iddphsniz2ucet integer;

CREATE INDEX utypucop_iddphsniz2ucet_index ON utypucop USING btree (iddphsniz2ucet);


ALTER TABLE ddoklfak
    ADD COLUMN sumdphsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN sumdphsniz2men numeric(15,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN sumzklsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN sumzklsniz2men numeric(15,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN szbdphsniz2 numeric(6,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN dphsniz2koef boolean DEFAULT false NOT NULL,
    ADD COLUMN iddphsniz2ucet integer,
    ADD COLUMN idsazbydphsniz2 integer;

CREATE INDEX ddoklfak_iddphsniz2ucet_index ON ddoklfak USING btree (iddphsniz2ucet);
CREATE INDEX ddoklfak_idsazbydphsniz2_index ON ddoklfak USING btree (idsazbydphsniz2);


ALTER TABLE ddoklint
    ADD COLUMN sumdphsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN sumdphsniz2men numeric(15,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN sumzklsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN sumzklsniz2men numeric(15,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN szbdphsniz2 numeric(6,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN dphsniz2koef boolean DEFAULT false NOT NULL,
    ADD COLUMN iddphsniz2ucet integer,
    ADD COLUMN idsazbydphsniz2 integer;

CREATE INDEX ddoklint_iddphsniz2ucet_index ON ddoklint USING btree (iddphsniz2ucet);
CREATE INDEX ddoklint_idsazbydphsniz2_index ON ddoklint USING btree (idsazbydphsniz2);


ALTER TABLE ddoklobch
    ADD COLUMN sumdphsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN sumdphsniz2men numeric(15,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN sumzklsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN sumzklsniz2men numeric(15,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN szbdphsniz2 numeric(6,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN dphsniz2koef boolean DEFAULT false NOT NULL,
    ADD COLUMN iddphsniz2ucet integer,
    ADD COLUMN idsazbydphsniz2 integer;

CREATE INDEX ddoklobch_iddphsniz2ucet_index ON ddoklobch USING btree (iddphsniz2ucet);
CREATE INDEX ddoklobch_idsazbydphsniz2_index ON ddoklobch USING btree (idsazbydphsniz2);


ALTER TABLE ddoklsklad
    ADD COLUMN sumdphsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN sumdphsniz2men numeric(15,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN sumzklsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN sumzklsniz2men numeric(15,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN szbdphsniz2 numeric(6,2) DEFAULT 0.0 NOT NULL,
    ADD COLUMN dphsniz2koef boolean DEFAULT false NOT NULL,
    ADD COLUMN iddphsniz2ucet integer,
    ADD COLUMN idsazbydphsniz2 integer;

CREATE INDEX ddoklsklad_iddphsniz2ucet_index ON ddoklsklad USING btree (iddphsniz2ucet);
CREATE INDEX ddoklsklad_idsazbydphsniz2_index ON ddoklsklad USING btree (idsazbydphsniz2);


-- Vložení 2. snížené sazby DPH pro ČR
CREATE OR REPLACE FUNCTION doUpgrade()
  RETURNS void AS
$BODY$    
declare
  pom integer;
  _idstatu integer;
begin    
    select idstatu into _idstatu from astaty where uuid like '%_CZ';

    -- Sazba DPH 10%
    pom = 0;
    select count(1) into pom from usazbydph
    where typSzbDphK = 'typSzbDph.dphSniz2' and szbdph = 10.00 and idstatu = _idstatu
      and (platioddata is null or platioddata >= '2015-01-01');

    if (pom = 0) then
        INSERT INTO usazbydph (lastupdate, platidodata, platioddata, popis, poznam, szbdph, typszbdphk, idstatu, uuid)
            VALUES ('2014-12-08 15:30:00.000', NULL, '2015-01-01', NULL, NULL, 10.00, 'typSzbDph.dphSniz2',
            _idstatu, 'CZ_10_2015');
    end if;

end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION doUpgrade() OWNER TO %firmaRole%;

select doUpgrade();
drop function doUpgrade();


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
    values (nextval('seq_dbversion'), 877, 't', %appVersion%, clock_timestamp());