---------------------------------------------------------------------------------------------------------------
-- Bug 41434 - Upravit označení dovolené na výplatní pásce: čerpaná dovolená  
---------------------------------------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
begin
  select a.uuid into stat from nnastav n 
    left join utyporg u on u.idtyporg = n.idtyporg
    left join astaty a on a.idstatu = u.idstatu
  order by coalesce(n.platioddata, '1900-01-01') desc limit 1;

  if (stat = 'CZ_CZ') then

-- zacatek ceskeho bloku
alter table pmzdsloz disable trigger pmzdslozupdatedatumvypoctu;

UPDATE pcismzdsloz SET nazev = 'Čerpaná dovolená od poč. roku' WHERE IdCisMzdSloz = 185;

alter table pmzdsloz enable trigger pmzdslozupdatedatumvypoctu;
-- konec ceskeho bloku
    
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 918, 't', %appVersion%, clock_timestamp());
