--Bug 44372 - Zpřístupnit výběr kódů přenesení DPH i pro slovenskou firmu, která je registrovaná k DPH v Čechách

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying;
begin
    select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
        where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
    
    if (stat = 'SK_SK') then

        insert into udphpren (kod, nazev, platiod, platido, uuid)
        values
        ('2618 00 00','Granulovaná struska (struskový písek) z výroby železa nebo oceli', 0, 2011, 'CZ_2618_00_00'),
        ('2619 00','Struska, zpěněná struska (jiná než granulovaná struska), okuje a jiné odpady z výroby železa nebo oceli', 0, 2011, 'CZ_2619_00'),
        ('2620','Struska, popel a zbytky (jiné než z výroby železa nebo oceli), obsahující kovy, arsen, nebo jejich sloučeniny', 0, 2011, 'CZ_2620'),
        ('3915','Odpady, úlomky a odřezky z plastů ', 0, 2011, 'CZ_3915'),
        ('4004 00 00','Odpady, úlomky a odřezky z kaučuku (jiné než z tvrdého kaučuku) a prášky a zrna z nich', 0, 2011, 'CZ_4004_00_00'),
        ('4707','Sběrový papír, kartón nebo lepenka (odpad a výmět)', 0, 2011, 'CZ_4707'),
        ('6310',' Použité nebo nové hadry, motouzy, šňůry, provazy a lana z textilních materiálů ve formě zbytků nebo výrobků vyřazených z používání', 0, 2011, 'CZ_6310'),
        ('7001 00 10','Skleněné střepy a jiné skleněné odpady', 0, 2011, 'CZ_7001_00_10'),
        ('7112','Odpad a šrot z drahých kovů nebo z kovů plátovaných drahými kovy, ostatní odpad a šrot obsahující drahé kovy nebo sloučeniny drahých kovů, používaný hlavně pro rekuperaci drahých kovů', 0, 2011, 'CZ_7112'),
        ('7204','Odpad a šrot ze železa nebo oceli,  přetavený odpad ze železa nebo oceli v ingotech', 0, 2011, 'CZ_7204'),
        ('7404 00','Měděný odpad a šrot', 0, 2011, 'CZ_7404_00'),
        ('7503 00','Niklový odpad a šrot', 0, 2011, 'CZ_7503_00'),
        ('7602 00','Hliníkový odpad a šrot', 0, 2011, 'CZ_7602_00'),
        ('7802 00 00','Olověný odpad a šrot', 0, 2011, 'CZ_7802_00_00'),
        ('7902 00 00','Zinkový odpad a šrot', 0, 2011, 'CZ_7902_00_00'),
        ('8002 00 00','Cínový odpad a šrot', 0, 2011, 'CZ_8002_00_00'),
        ('8101 97 00','Odpad a šrot z wolframu', 0, 2011, 'CZ_8101_97_00'),
        ('8102 97 00','Odpad a šrot z molybdenu', 0, 2011, 'CZ_8102_97_00'),
        ('8103 30 00','Odpad a šrot z tantalu', 0, 2011, 'CZ_8103_30_00'),
        ('8104 20 00','Odpad a šrot z hořčíku', 0, 2011, 'CZ_8104_20_00'),
        ('8105 30 00','Odpad a šrot z kobaltu ex ', 0, 2011, 'CZ_8105_30_00'),
        ('8106 00 10','Odpad a šrot z bismutu', 0, 2011, 'CZ_8106_00_10'),
        ('8107 30 00','Odpad a šrot z kadmia', 0, 2011, 'CZ_8107_30_00'),
        ('8108 30 00','Odpad a šrot z titanu', 0, 2011, 'CZ_8108_30_00'),
        ('8109 30 00','Odpad a šrot ze zirkonia', 0, 2011, 'CZ_8109_30_00'),
        ('8110 20 00','Odpad a šrot z antimonu', 0, 2011, 'CZ_8110_20_00'),
        ('8111 00 19','Odpad a šrot z manganu', 0, 2011, 'CZ_8111_00_19'),
        ('8112 13 00','Odpad a šrot z berylia', 0, 2011, 'CZ_8112_13_00'),
        ('8112 22 00','Odpad a šrot z chrómu', 0, 2011, 'CZ_8112_22_00'),
        ('8112 52 00','Odpad a šrot z thallia', 0, 2011, 'CZ_8112_52_00'),
        ('8112 92 21','Odpad a šrot z niobu (columbia),  gallia,  rhenia,  india,  vanadu a germania', 0, 2011, 'CZ_8112_92_21'),
        ('8113 00 40','Odpad a šrot z cermetů', 0, 2011, 'CZ_8113_00_40'),
        ('8548 10','Odpad a zbytky galvanických článků, baterií a elektrických akumulátorů,  nepoužitelné galvanické články, baterie a elektrické akumulátory.', 0, 2011, 'CZ_8548_10');
        
        -- Kódy § 92a platné od 1.1.2012
        insert into udphpren (kod, nazev, platiod, platido, uuid)
        values
        ('1', '§ 92b – zlato', 2012, 9999, 'CZ_§92_1_2012'),
        ('2', '§ 92d – povolenky (do 31. 3. 2015)', 2012, 2015,'CZ_§92_2_2012'),
        ('4', '§ 92e – stavební a montážní práce', 2012, 9999,'CZ_§92_4_2012'),
        ('5', '§ 92c – zboží uvedené v příloze č. 5', 2012, 9999,'CZ_§92_5_2012');
        
        -- Kódy § 92a platné od 1.4.2015
        INSERT INTO udphpren (kod, nazev, omezPrenDanPovK, platiod, platido, uuid) SELECT '11', '§ 92f – povolenky (od 1. 4. 2015)','omezPrenDanPov.bezOmezeni', 2015, 9999, 'CZ_§92_11_2015' WHERE NOT EXISTS (SELECT 1 FROM udphpren WHERE kod='11');
        INSERT INTO udphpren (kod, nazev, omezPrenDanPovK, platiod, platido, uuid) SELECT '12', '§ 92f – obiloviny a technické plodiny','omezPrenDanPov.odCastky100k', 2015, 9999, 'CZ_§92_12_2015' WHERE NOT EXISTS (SELECT 1 FROM udphpren WHERE kod='12');
        INSERT INTO udphpren (kod, nazev, omezPrenDanPovK, platiod, platido, uuid) SELECT '13', '§ 92f – kovy','omezPrenDanPov.odCastky100k', 2015, 9999, 'CZ_§92_13_2015' WHERE NOT EXISTS (SELECT 1 FROM udphpren WHERE kod='13');
        INSERT INTO udphpren (kod, nazev, omezPrenDanPovK, platiod, platido, uuid) SELECT '14', '§ 92f – mobilní telefony','omezPrenDanPov.odCastky100k', 2015, 9999, 'CZ_§92_14_2015' WHERE NOT EXISTS (SELECT 1 FROM udphpren WHERE kod='14');
        INSERT INTO udphpren (kod, nazev, omezPrenDanPovK, platiod, platido, uuid) SELECT '15', '§ 92f – integrované obvody','omezPrenDanPov.odCastky100k', 2015, 9999, 'CZ_§92_15_2015' WHERE NOT EXISTS (SELECT 1 FROM udphpren WHERE kod='15');
        INSERT INTO udphpren (kod, nazev, omezPrenDanPovK, platiod, platido, uuid) SELECT '16', '§ 92f – přenosná zařízení pro automatizované zpracování dat','omezPrenDanPov.odCastky100k', 2015, 9999, 'CZ_§92_16_2015' WHERE NOT EXISTS (SELECT 1 FROM udphpren WHERE kod='16');
        INSERT INTO udphpren (kod, nazev, omezPrenDanPovK, platiod, platido, uuid) SELECT '17', '§ 92f – videoherní konzole','omezPrenDanPov.odCastky100k', 2015, 9999, 'CZ_§92_17_2015' WHERE NOT EXISTS (SELECT 1 FROM udphpren WHERE kod='17');
        -- kód § 92d platný od 1.1.2016
        INSERT INTO udphpren (kod, nazev, omezPrenDanPovK, platiod, platido, uuid) SELECT '3', '§ 92d – dodání nemovité věci','omezPrenDanPov.bezOmezeni', 2016, 9999, 'CZ_§92_3_2016' WHERE NOT EXISTS (SELECT 1 FROM udphpren WHERE kod='3');
        
              
    end if;
 end;
 $$ LANGUAGE plpgsql;
 ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
    values (nextval('seq_dbversion'), 969, 't', %appVersion%, clock_timestamp());