--------------------------------------------------------------------------------
-- Bug 44120 - Aktualizace standardní účtové osnovy pro rok 2016 (pro podnikatele)
--------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
    _idtyporg integer;
    cnt integer; 
begin
  select idtyporg into _idtyporg from nnastav where ((select max(platioddata) from nnastav) is null
        or (select max(platioddata) from nnastav) = platioddata);

  if (_idtyporg = 1) then
    update ustducty set lastupdate = '2016-01-14 00:00:00', poznam = 'Účet platný do 31.12.2015.' where uuid in 
        ('CZ_POD_011','CZ_POD_071','CZ_POD_589','CZ_POD_593','CZ_POD_594','CZ_POD_610','CZ_POD_611','CZ_POD_612','CZ_POD_613','CZ_POD_614',
        'CZ_POD_620','CZ_POD_621','CZ_POD_622','CZ_POD_623','CZ_POD_624','CZ_POD_680','CZ_POD_681','CZ_POD_688');
    update ustducty set lastupdate = '2016-01-14 00:00:00', poznam = 'Účtu skončila platnost' where uuid in ('CZ_POD_312','CZ_POD_386','CZ_POD_387','CZ_POD_422');
    update ustducty set nazev = 'Směnky k inkasu' where uuid = 'CZ_POD_312'; 

    -- pridani uctu
    cnt := (select count(*) from ustducty where kod = '068');
    if (cnt = 0) then
       INSERT INTO ustducty (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, druhuctuk, saldo, typuctuk, idtyporg, uuid)
            VALUES ('2016-01-14 00:00:00', '068', 'Zápůjčky a úvěry ostatní', NULL, NULL, NULL, 9999, 2016, NULL, 'Účet platný od 1.1.2016.', true, 'druhUctu.aktivni', false, 'typUctu.rozvahovy', 1,
            'CZ_POD_068');
    else
       UPDATE ustducty set lastupdate = '2016-01-14 00:00:00', platido = 9999, platiod = 2016, poznam = 'Účet platný od 1.1.2016.', druhuctuk = 'druhUctu.aktivni', typuctuk = 'typUctu.rozvahovy', uuid = 'CZ_POD_068' where kod = '068';
    end if;
    
    cnt := (select count(*) from ustducty where kod = '254');
    if (cnt = 0) then
        INSERT INTO ustducty (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, druhuctuk, saldo, typuctuk, idtyporg, uuid)
        VALUES ('2016-01-14 00:00:00', '254', 'Podíly - ovládaná nebo ovládající osoba', NULL, NULL, NULL, 9999, 2016, NULL, 'Účet platný od 1.1.2016.', true, 'druhUctu.aktivni', false, 'typUctu.rozvahovy', 1,
        'CZ_POD_254');
    else
        UPDATE ustducty set lastupdate = '2016-01-14 00:00:00', platido = 9999, platiod = 2016, poznam = 'Účet platný od 1.1.2016.', druhuctuk = 'druhUctu.aktivni', typuctuk = 'typUctu.rozvahovy', uuid = 'CZ_POD_254' where kod = '254';
    end if; 
    
    cnt := (select count(*) from ustducty where kod = '547');
    if (cnt = 0) then
        INSERT INTO ustducty (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, druhuctuk, saldo, typuctuk, idtyporg, uuid)
        VALUES ('2016-01-14 00:00:00', '547', 'Mimořádné provozní náklady', NULL, NULL, NULL, 9999, 2016, NULL, 'Účet platný od 1.1.2016.', true, 'druhUctu.naklady', false, 'typUctu.vysledkovy', 1,
        'CZ_POD_547');
    else
        UPDATE ustducty set lastupdate = '2016-01-14 00:00:00', platido = 9999, platiod = 2016, poznam = 'Účet platný od 1.1.2016.', druhuctuk = 'druhUctu.naklady', typuctuk = 'typUctu.vysledkovy', uuid = 'CZ_POD_547' where kod = '547';
    end if; 
    
    cnt := (select count(*) from ustducty where kod = '565');
    if (cnt = 0) then
        INSERT INTO ustducty (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, druhuctuk, saldo, typuctuk, idtyporg, uuid)
        VALUES ('2016-01-14 00:00:00', '565', 'Mimořádné finanční náklady', NULL, NULL, NULL, 9999, 2016, NULL, 'Účet platný od 1.1.2016.', true, 'druhUctu.naklady', false, 'typUctu.vysledkovy', 1,
        'CZ_POD_565');
    else
        UPDATE ustducty set lastupdate = '2016-01-14 00:00:00', platido = 9999, platiod = 2016, poznam = 'Účet platný od 1.1.2016.', druhuctuk = 'druhUctu.naklady', typuctuk = 'typUctu.vysledkovy', uuid = 'CZ_POD_565' where kod = '565';
    end if; 
    
    cnt := (select count(*) from ustducty where kod = '583');
    if (cnt = 0) then
        INSERT INTO ustducty (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, druhuctuk, saldo, typuctuk, idtyporg, uuid)
        VALUES ('2016-01-14 00:00:00', '583', 'Změna stavu výrobků', NULL, NULL, NULL, 9999, 2016, NULL, 'Účet platný od 1.1.2016.', true, 'druhUctu.naklady', false, 'typUctu.vysledkovy', 1,
        'CZ_POD_583');
    else
        UPDATE ustducty set lastupdate = '2016-01-14 00:00:00', platido = 9999, platiod = 2016, poznam = 'Účet platný od 1.1.2016.', druhuctuk = 'druhUctu.naklady', typuctuk = 'typUctu.vysledkovy', uuid = 'CZ_POD_583' where kod = '583';
    end if; 
    
    cnt := (select count(*) from ustducty where kod = '585');
    if (cnt = 0) then
        INSERT INTO ustducty (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, druhuctuk, saldo, typuctuk, idtyporg, uuid)
        VALUES ('2016-01-14 00:00:00', '585', 'Aktivace materiálu a zboží', NULL, NULL, NULL, 9999, 2016, NULL, 'Účet platný od 1.1.2016.', true, 'druhUctu.naklady', false, 'typUctu.vysledkovy', 1,
        'CZ_POD_585'); 
    else
        UPDATE ustducty set lastupdate = '2016-01-14 00:00:00', platido = 9999, platiod = 2016, poznam = 'Účet platný od 1.1.2016.', druhuctuk = 'druhUctu.naklady', typuctuk = 'typUctu.vysledkovy', uuid = 'CZ_POD_585' where kod = '585';
    end if; 
    
    cnt := (select count(*) from ustducty where kod = '586');
    if (cnt = 0) then
        INSERT INTO ustducty (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, druhuctuk, saldo, typuctuk, idtyporg, uuid)
        VALUES ('2016-01-14 00:00:00', '586', 'Aktivace vnitropodnikových služeb', NULL, NULL, NULL, 9999, 2016, NULL, 'Účet platný od 1.1.2016.', true, 'druhUctu.naklady', false, 'typUctu.vysledkovy', 1,
        'CZ_POD_586');
    else
        UPDATE ustducty set lastupdate = '2016-01-14 00:00:00', platido = 9999, platiod = 2016, poznam = 'Účet platný od 1.1.2016.', druhuctuk = 'druhUctu.naklady', typuctuk = 'typUctu.vysledkovy', uuid = 'CZ_POD_586' where kod = '586';
    end if; 
    
    cnt := (select count(*) from ustducty where kod = '587');
    if (cnt = 0) then
        INSERT INTO ustducty (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, druhuctuk, saldo, typuctuk, idtyporg, uuid)
        VALUES ('2016-01-14 00:00:00', '587', 'Aktivace dlouhodobého nehmotného majetku', NULL, NULL, NULL, 9999, 2016, NULL, 'Účet platný od 1.1.2016.', true, 'druhUctu.naklady', false, 'typUctu.vysledkovy', 1,
        'CZ_POD_587');
    else
        UPDATE ustducty set lastupdate = '2016-01-14 00:00:00', platido = 9999, platiod = 2016, poznam = 'Účet platný od 1.1.2016.', druhuctuk = 'druhUctu.naklady', typuctuk = 'typUctu.vysledkovy', uuid = 'CZ_POD_587' where kod = '587';
    end if; 
    
    cnt := (select count(*) from ustducty where kod = '649');
    if (cnt = 0) then
        INSERT INTO ustducty (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, druhuctuk, saldo, typuctuk, idtyporg, uuid)
        VALUES ('2016-01-14 00:00:00', '649', 'Mimořádné provozní výnosy', NULL, NULL, NULL, 9999, 2016, NULL, 'Účet platný od 1.1.2016.', true, 'druhUctu.vynosy', false, 'typUctu.vysledkovy', 1,
        'CZ_POD_649');
    else
        UPDATE ustducty set lastupdate = '2016-01-14 00:00:00', platido = 9999, platiod = 2016, poznam = 'Účet platný od 1.1.2016.', druhuctuk = 'druhUctu.vynosy', typuctuk = 'typUctu.vysledkovy', uuid = 'CZ_POD_649' where kod = '649';
    end if; 
    
    cnt := (select count(*) from ustducty where kod = '669');
    if (cnt = 0) then
        INSERT INTO ustducty (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, druhuctuk, saldo, typuctuk, idtyporg, uuid)
        VALUES ('2016-01-14 00:00:00', '669', 'Mimořádné finanční výnosy', NULL, NULL, NULL, 9999, 2016, NULL, 'Účet platný od 1.1.2016.', true, 'druhUctu.vynosy', false, 'typUctu.vysledkovy', 1,
        'CZ_POD_669');
    else
        UPDATE ustducty set lastupdate = '2016-01-14 00:00:00', platido = 9999, platiod = 2016, poznam = 'Účet platný od 1.1.2016.', druhuctuk = 'druhUctu.vynosy', typuctuk = 'typUctu.vysledkovy', uuid = 'CZ_POD_669' where kod = '669';
    end if; 
    
    cnt := (select count(*) from ustducty where kod = '432');
    if (cnt = 0) then
        INSERT INTO ustducty (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, druhuctuk, saldo, typuctuk, idtyporg, uuid) 
        VALUES ('2016-01-14 00:00:00', '432', 'Zálohy na podíly na zisku', NULL, NULL, NULL, 9999, 2016, NULL, NULL, true, 'druhUctu.pasivni', false, 'typUctu.rozvahovy', 1,
        'CZ_POD_432');
    else
        UPDATE ustducty set lastupdate = '2016-01-14 00:00:00', platido = 9999, platiod = 2016, poznam = 'Účet platný od 1.1.2016.', druhuctuk = 'druhUctu.pasivni', typuctuk = 'typUctu.rozvahovy', uuid = 'CZ_POD_432' where kod = '432';
    end if; 
 
    update ustducty set lastupdate = '2016-01-14 00:00:00', kod = '599', nazev = 'Tvorba a zúčtování rezervy na daň z příjmů', platido = 9999, platiod = 2016, 
        druhuctuk = 'druhUctu.naklady', typuctuk = 'typUctu.vysledkovy' where uuid = 'CZ_POD_599';
 
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 970, 't', %appVersion%, clock_timestamp());