-------------------------------------------------------------------
-- Bug 44796 - Do výpočtu mezd promítnout Velký pátek 
-------------------------------------------------------------------

create or replace function pregenerujSmeny()
    returns void as $$
declare
    stat character varying;
    _idPracPomHlav integer;
begin
	
	for _idPracPomHlav in (select distinct ph.idpracpomhlav from ppracpom pp
            inner join ppracpomhlav ph on ph.idpracpomhlav = pp.idpracpomhlav
            inner join posobahlav o on o.idosobahlav = ph.idosoba
        where
           (pp.aktivnido is null or pp.aktivnido >= '2016-03-25')
            and 
            pp.aktivniod <= '2016-03-25'
	   ) loop
	   
	   -- updatneme směny:
	   perform pgeneratesmenyforpracpom(_idPracPomHlav, 2016, 3);
	end loop;
	
	
 end;
 $$ LANGUAGE plpgsql;
 ALTER FUNCTION pregenerujSmeny() OWNER TO %firmaRole%;

 -- vložení Velkých pátků

INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (24, '2016-03-01 00:00:00', 'svatek', '2016-03-25');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (25, '2016-03-01 00:00:00', 'svatek', '2017-04-14');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (26, '2016-03-01 00:00:00', 'svatek', '2018-03-30');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (27, '2016-03-01 00:00:00', 'svatek', '2019-04-19');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (28, '2016-03-01 00:00:00', 'svatek', '2020-04-10');

-- Velký pátek + Velikonoční pondělí
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (29, '2016-03-01 00:00:00', 'svatek', '2021-04-02');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (30, '2016-03-01 00:00:00', 'svatek', '2021-04-05');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (31, '2016-03-01 00:00:00', 'svatek', '2022-04-15');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (32, '2016-03-01 00:00:00', 'svatek', '2022-04-18');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (33, '2016-03-01 00:00:00', 'svatek', '2023-04-07');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (34, '2016-03-01 00:00:00', 'svatek', '2023-04-10');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (35, '2016-03-01 00:00:00', 'svatek', '2024-03-29');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (36, '2016-03-01 00:00:00', 'svatek', '2024-04-01');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (37, '2016-03-01 00:00:00', 'svatek', '2025-04-18');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (38, '2016-03-01 00:00:00', 'svatek', '2025-04-21');

SELECT pg_catalog.setval('seq_pmzdyparam', 38, true); 

select pregenerujSmeny();

drop function pregenerujSmeny();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 986, 't', %appVersion%, clock_timestamp());