CREATE OR REPLACE FUNCTION create_or_drop_ostatni_zurnal_triggers(docreate boolean)
  RETURNS void AS
$BODY$
BEGIN
  -- Na nektere z tabulek muze byt uvalen zamek (napr. typu AccessShareLock)
  LOCK TABLE wkli_aadresar IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_akontakt IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_amisturc IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_atypakt IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_audalost IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_cdodavatele IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_cenik IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_cskupzboz IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_dbsp IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_dformadopravy IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_dformauhrady IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_dformauhradycis IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_doklfak IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_doklint IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_doklobch IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_doklsklad IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_dstavsml IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_dtypsml IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_mleasing IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_mmajetek IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_pmzdsloz IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_pnepritomnost IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_polfak IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_polint IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_polobch IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_polsklad IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_polsml IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_pstalamzdsloz IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_smlouva IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_stavcen IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_typzbozi IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_ucinnost IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_ustredisko IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_wuzivatel IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_wvazbatyp IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_zdite IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE wkli_zosoba IN ACCESS EXCLUSIVE MODE NOWAIT;
  
  IF docreate THEN
    CREATE TRIGGER wkli_aadresarzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_aadresar FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_akontaktzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_akontakt FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_amisturczurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_amisturc FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_atypaktzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_atypakt FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_audalostzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_audalost FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_cdodavatelezurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_cdodavatele FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_cenikzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_cenik FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_cskupzbozzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_cskupzboz FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_dbspzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_dbsp FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_dformadopravyzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_dformadopravy FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_dformauhradyzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_dformauhrady FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_dformauhradyciszurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_dformauhradycis FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_doklfakzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_doklfak FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_doklintzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_doklint FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_doklobchzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_doklobch FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_doklskladzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_doklsklad FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_dstavsmlzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_dstavsml FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_dtypsmlzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_dtypsml FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_mleasingzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_mleasing FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_mmajetekzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_mmajetek FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_pmzdslozzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_pmzdsloz FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_pnepritomnostzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_pnepritomnost FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_polfakzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_polfak FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_polintzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_polint FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_polobchzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_polobch FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_polskladzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_polsklad FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_polsmlzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_polsml FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_pstalamzdslozzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_pstalamzdsloz FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_smlouvazurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_smlouva FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_stavcenzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_stavcen FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_typzbozizurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_typzbozi FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_ucinnostzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_ucinnost FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_ustrediskozurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_ustredisko FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_wuzivatelzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_wuzivatel FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_wvazbatypzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_wvazbatyp FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_zditezurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_zdite FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER wkli_zosobazurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON wkli_zosoba FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

  ELSE
    DROP TRIGGER IF EXISTS wkli_aadresarzurnal ON wkli_aadresar;
    DROP TRIGGER IF EXISTS wkli_akontaktzurnal ON wkli_akontakt;
    DROP TRIGGER IF EXISTS wkli_amisturczurnal ON wkli_amisturc;
    DROP TRIGGER IF EXISTS wkli_atypaktzurnal ON wkli_atypakt;
    DROP TRIGGER IF EXISTS wkli_audalostzurnal ON wkli_audalost;
    DROP TRIGGER IF EXISTS wkli_cdodavatelezurnal ON wkli_cdodavatele;
    DROP TRIGGER IF EXISTS wkli_cenikzurnal ON wkli_cenik;
    DROP TRIGGER IF EXISTS wkli_cskupzbozzurnal ON wkli_cskupzboz;
    DROP TRIGGER IF EXISTS wkli_dbspzurnal ON wkli_dbsp;
    DROP TRIGGER IF EXISTS wkli_dformadopravyzurnal ON wkli_dformadopravy;
    DROP TRIGGER IF EXISTS wkli_dformauhradyzurnal ON wkli_dformauhrady;
    DROP TRIGGER IF EXISTS wkli_dformauhradyciszurnal ON wkli_dformauhradycis;
    DROP TRIGGER IF EXISTS wkli_doklfakzurnal ON wkli_doklfak;
    DROP TRIGGER IF EXISTS wkli_doklintzurnal ON wkli_doklint;
    DROP TRIGGER IF EXISTS wkli_doklobchzurnal ON wkli_doklobch;
    DROP TRIGGER IF EXISTS wkli_doklskladzurnal ON wkli_doklsklad;
    DROP TRIGGER IF EXISTS wkli_dstavsmlzurnal ON wkli_dstavsml;
    DROP TRIGGER IF EXISTS wkli_dtypsmlzurnal ON wkli_dtypsml;
    DROP TRIGGER IF EXISTS wkli_mleasingzurnal ON wkli_mleasing;
    DROP TRIGGER IF EXISTS wkli_mmajetekzurnal ON wkli_mmajetek;
    DROP TRIGGER IF EXISTS wkli_pmzdslozzurnal ON wkli_pmzdsloz;
    DROP TRIGGER IF EXISTS wkli_pnepritomnostzurnal ON wkli_pnepritomnost;
    DROP TRIGGER IF EXISTS wkli_polfakzurnal ON wkli_polfak;
    DROP TRIGGER IF EXISTS wkli_polintzurnal ON wkli_polint;
    DROP TRIGGER IF EXISTS wkli_polobchzurnal ON wkli_polobch;
    DROP TRIGGER IF EXISTS wkli_polskladzurnal ON wkli_polsklad;
    DROP TRIGGER IF EXISTS wkli_polsmlzurnal ON wkli_polsml;
    DROP TRIGGER IF EXISTS wkli_pstalamzdslozzurnal ON wkli_pstalamzdsloz;
    DROP TRIGGER IF EXISTS wkli_smlouvazurnal ON wkli_smlouva;
    DROP TRIGGER IF EXISTS wkli_stavcenzurnal ON wkli_stavcen;
    DROP TRIGGER IF EXISTS wkli_typzbozizurnal ON wkli_typzbozi;
    DROP TRIGGER IF EXISTS wkli_ucinnostzurnal ON wkli_ucinnost;
    DROP TRIGGER IF EXISTS wkli_ustrediskozurnal ON wkli_ustredisko;
    DROP TRIGGER IF EXISTS wkli_wuzivatelzurnal ON wkli_wuzivatel;
    DROP TRIGGER IF EXISTS wkli_wvazbatypzurnal ON wkli_wvazbatyp;
    DROP TRIGGER IF EXISTS wkli_zditezurnal ON wkli_zdite;
    DROP TRIGGER IF EXISTS wkli_zosobazurnal ON wkli_zosoba;
  END IF;
END;
$BODY$
LANGUAGE 'plpgsql' VOLATILE;
