<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:template match="winstrom">
	<CONTACTS>
		<xsl:apply-templates select="adresar"/>
	</CONTACTS>
    </xsl:template>

<!--
flexibee2xml -t adresar-out.xslt -x adresar.xml -o adresar-out.xml
-->

    <xsl:template match="adresar">
	<CONTACT>
	    <ICP><xsl:value-of select="id"/></ICP>
	    <CODE><xsl:value-of select="kod"/></CODE>
	    <NAME><xsl:value-of select="nazev"/></NAME>
	    <SPECID><xsl:value-of select="ic"/></SPECID>
	    <VATID><xsl:value-of select="dic"/></VATID>
	    <TYPE>1</TYPE>
	    <ORIGIN><xsl:choose>
     	    <xsl:when test="stat = 'code:CZ' or stat = ''">1</xsl:when>
     	    <xsl:otherwise>2</xsl:otherwise>
         </xsl:choose></ORIGIN>
	    <VAT><xsl:choose>
     	    <xsl:when test="platceDph = 'true'">1</xsl:when>
     	    <xsl:otherwise>0</xsl:otherwise>
         </xsl:choose></VAT>
	    <WWW><xsl:value-of select="www"/></WWW>
	    <SUPP><xsl:choose>
     	    <xsl:when test="typVztahuK = 'typVztahu.odberDodav' or typVztahuK = 'typVztahu.dodavatel'">1</xsl:when>
     	    <xsl:otherwise>0</xsl:otherwise>
         </xsl:choose></SUPP>
	    <CUST><xsl:choose>
     	    <xsl:when test="typVztahuK = 'typVztahu.odberDodav' or typVztahuK = 'typVztahu.odberatel'">1</xsl:when>
     	    <xsl:otherwise>0</xsl:otherwise>
         </xsl:choose></CUST>
	    <PROD><xsl:choose>
     	    <xsl:when test="typVztahuK = 'typVztahu.vyrobce'">1</xsl:when>
     	    <xsl:otherwise>0</xsl:otherwise>
         </xsl:choose></PROD>
	    <STREET><xsl:value-of select="ulice"/></STREET>
	    <TOWN><xsl:value-of select="mesto"/></TOWN>
	    <PSC><xsl:value-of select="psc"/></PSC>
	    <TEL><xsl:value-of select="tel"/></TEL>
	    <FAX><xsl:value-of select="fax"/></FAX>
	    <EMAIL><xsl:value-of select="email"/></EMAIL>
	    <VALID>1</VALID>
	</CONTACT>
    </xsl:template>

</xsl:stylesheet>
