<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:key name="skupZbozKey" match="skupZboz" use="."/>

    <xsl:template match="winstrom">
    
	<NEW_ARTICLES>
<!--        <xsl:for-each select="cenik/skupZboz">
     	<xsl:if test="generate-id(.) = generate-id(key('skupZbozKey', .)[1])">
          <ARTICLE>
            <CTLG_CATEGORY>0</CTLG_CATEGORY>
            <CTLG_EXT_CODE><xsl:value-of select="java:flexibee.Tool.split(@showAs, ':', 0)"/></CTLG_EXT_CODE>
            <CTLG_DESC><xsl:value-of select="java:flexibee.Tool.trim(java:flexibee.Tool.split(@showAs, ':', 1))"/></CTLG_DESC>
		    <UNIT_CODE></UNIT_CODE>
		    <CTLG_SUBGRP_CODE></CTLG_SUBGRP_CODE>
		    <VAT_TARIFF>10</VAT_TARIFF>
		    <CTLG_WEIGHTED>0</CTLG_WEIGHTED>
		    <GLOB_OFFER>1</GLOB_OFFER>
          </ARTICLE>
        </xsl:if>
      </xsl:for-each>
-->
	
		<xsl:apply-templates select="cenik"/>
	</NEW_ARTICLES>
    </xsl:template>
<!--
flexibee2xml -t cenik-out.xslt -x cenik.xml -o cenik-out.xml
-->

    <xsl:template match="cenik">
    
	<RECORD>
          <ARTICLE>
            <CTLG_CATEGORY>
            <xsl:choose>
            	<xsl:when test="typZasobyK = 'typZasoby.sluzba'">2</xsl:when>
            	<xsl:when test="typZasobyK = 'typZasoby.vyrobek'">5</xsl:when>
            	<xsl:when test="typZasobyK = 'typZasoby.material'">6</xsl:when>
            	<xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
            </CTLG_CATEGORY>
            <CTLG_EXT_CODE><xsl:value-of select="id"/></CTLG_EXT_CODE>
            <CTLG_DESC><xsl:value-of select="nazev"/></CTLG_DESC>
		    <UNIT_CODE><xsl:choose>
                    <xsl:when test="mj1 = 'code:KS' or mj1 = ''">Ks</xsl:when>
                    <xsl:otherwise><xsl:value-of select="java:flexibee.Tool.split(mj1, ':', 1)"/></xsl:otherwise>
                </xsl:choose></UNIT_CODE>
		    <CTLG_SUBGRP_CODE>NEZ</CTLG_SUBGRP_CODE>
		    <VAT_TARIFF>                
            	<xsl:choose>
                      <xsl:when test="typSzbDphK = 'typSzbDph.dphOsv'">0</xsl:when>
                      <xsl:when test="typSzbDphK = 'typSzbDph.dphSniz'">10</xsl:when>
                      <xsl:when test="typSzbDphK = 'typSzbDph.dphZakl'">20</xsl:when>
	        	</xsl:choose>
			</VAT_TARIFF>
            <CTLG_WEIGHTED><xsl:choose>
                  <xsl:when test="mj1 = 'code:KG' or mj1 = 'code:G'">1</xsl:when>
                  <xsl:otherwise>0</xsl:otherwise>
              </xsl:choose></CTLG_WEIGHTED>
		    <GLOB_OFFER>1</GLOB_OFFER>
          </ARTICLE>

        <BASIC_VAR>
          <DATA>
            <CTLG_DESC><xsl:value-of select="nazev"/></CTLG_DESC>
            <CTLG_CASH_NAME><xsl:value-of select="kod"/></CTLG_CASH_NAME>
            <CTLG_MEMO><xsl:value-of select="poznam"/></CTLG_MEMO>
            <CTLG_VOLUME><xsl:value-of select="objem"/></CTLG_VOLUME>
            <CTLG_WEIGHT><xsl:value-of select="hmotMj"/></CTLG_WEIGHT>
          </DATA>
          <xsl:if test="kodPlu != '' or eanKod != ''">
          <CTLG_PLU>
          <xsl:if test="eanKod != ''">
            <PLU_NUMBER>
              <PLU_CODE><xsl:value-of select="eanKod"/></PLU_CODE>
              <MAIN_PLU>1</MAIN_PLU>
              <GLOB_OFFER>1</GLOB_OFFER>
            </PLU_NUMBER>
          </xsl:if>
          <xsl:if test="kodPlu != ''">
            <PLU_NUMBER>
              <PLU_CODE><xsl:value-of select="kodPlu"/></PLU_CODE>
              <MAIN_PLU>0</MAIN_PLU>
              <GLOB_OFFER>1</GLOB_OFFER>
              <CTLG_VOLUME><xsl:value-of select="objem"/></CTLG_VOLUME>
              <CTLG_WEIGHT><xsl:value-of select="hmotMj"/></CTLG_WEIGHT>
            </PLU_NUMBER>
          </xsl:if>
          </CTLG_PLU>
          </xsl:if>
          <PRICES>
            <PRICE>
              <PL_CODE>E</PL_CODE>
              <PL_DESC>Základní cena</PL_DESC>              
              <PRICE_VALUE>
                <xsl:choose>
                  <xsl:when test="typCenyDphK = 'typCeny.bezDph'">
                    <xsl:choose>
                      <xsl:when test="typSzbDphK = 'typSzbDph.dphOsv'">
                        <xsl:value-of select="cenaZakl"/>
                      </xsl:when>
                      <xsl:when test="typSzbDphK = 'typSzbDph.dphSniz'">
                        <xsl:value-of select="cenaZakl * 1.1"/>
                      </xsl:when>
                      <xsl:when test="typSzbDphK = 'typSzbDph.dphZakl'">
                        <xsl:value-of select="cenaZakl * 1.2"/>
                      </xsl:when>
                    </xsl:choose>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:value-of select="cenaZakl"/>
                  </xsl:otherwise>
                </xsl:choose>
              </PRICE_VALUE>
              <PRICE_TYPE>1</PRICE_TYPE>
            </PRICE>
          </PRICES>

<!-- dodavatele zatím neimportujeme -->
<!--          
          <SUPPLIERS>
           <xsl:for-each select="dodavatele/dodavatel">
            <SUPPLIER>
              <SUPP_CODE><xsl:value-of select="java:flexibee.Tool.split(firma/@showAs, ':', 0)"/></SUPP_CODE>
              <SUPP_NAME><xsl:value-of select="java:flexibee.Tool.trim(java:flexibee.Tool.split(firma/@showAs, ':', 1))"/></SUPP_NAME>
              <OFFER_PRICE><xsl:value-of select="nakupCena"/></OFFER_PRICE>
              <GLOB_OFFER>1</GLOB_OFFER>
            </SUPPLIER>
            </xsl:for-each>
          </SUPPLIERS>
-->
        </BASIC_VAR>
	</RECORD>
    </xsl:template>

</xsl:stylesheet>