<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="MoneyData">
    <winstrom version="1.0">
      <xsl:apply-templates select="SeznamKmKarta"/>
    </winstrom>
  </xsl:template>

  <xsl:template match="SeznamKmKarta">
    <xsl:apply-templates select="KmKarta"/>
  </xsl:template>

  <xsl:template match="KmKarta">

  <xsl:if test="MJ != ''">
    <merna-jednotka update="ignore">
      <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(MJ)"/></id>
      <kod><xsl:value-of select="java:flexibee.Tool.toUpper(MJ)"/></kod>
      <nazev><xsl:value-of select="MJ"/></nazev>
    </merna-jednotka>
  </xsl:if>
  
  <cenik>
    <id>ext:mS3cen:<xsl:value-of select="substring(GUID, 2, string-length(GUID)-2)"/></id>
    <popis><xsl:value-of select="Popis"/></popis>
    <kod><xsl:value-of select="substring(GUID, 2, 20)"/></kod>
    <xsl:choose>
      <xsl:when test="Popis"><nazev><xsl:value-of select="substring(Popis, 1, 255)"/></nazev></xsl:when>
      <xsl:when test="Zkratka"><nazev><xsl:value-of select="Zkratka"/></nazev></xsl:when>
      <xsl:otherwise><nazev><xsl:value-of select="substring(GUID, 2, string-length(GUID)-2)"/></nazev></xsl:otherwise>
    </xsl:choose>
    
    <nazevA><xsl:value-of select="Popis1"/></nazevA>
    <nazevB><xsl:value-of select="Popis2"/></nazevB>
    <nazevC><xsl:value-of select="Popis3"/></nazevC>
    <xsl:if test="MJ != ''">
      <mjHmot>code:<xsl:value-of select="java:flexibee.Tool.toUpper(MJ)"/></mjHmot>
      <mj1>code:<xsl:value-of select="java:flexibee.Tool.toUpper(MJ)"/></mj1>
    </xsl:if>
    <eanKod><xsl:value-of select="BarCode"/></eanKod>
    <kodPlu><xsl:value-of select="UzivCode"/></kodPlu>
    <mjZarukyK>    
      <xsl:choose><xsl:when test="TypZarDoby = 'R'">mjZaruky.rok</xsl:when>
      <xsl:otherwise>mjZaruky.mesic</xsl:otherwise></xsl:choose>
    </mjZarukyK>
    <zaruka><xsl:value-of select="ZarDoba"/></zaruka>
    
    <evidVyrCis>
      <xsl:choose><xsl:when test="EvVyrCis = '1'">true</xsl:when>
      <xsl:otherwise>false</xsl:otherwise></xsl:choose>
    </evidVyrCis>
    
    <typZasobyK>
      <xsl:choose><xsl:when test="./konfigurace/Druh_zas = 'Z'">typZasoby.zbozi</xsl:when>
      <xsl:when test="./konfigurace/Druh_zas = 'M'">typZasoby.material</xsl:when>
      <xsl:when test="./konfigurace/Druh_zas = 'V'">typZasoby.vyrobek</xsl:when>
      <xsl:when test="./konfigurace/Druh_zas = 'O'">typZasoby.zbozi</xsl:when>
      <xsl:otherwise>typZasoby.zbozi</xsl:otherwise>
      </xsl:choose>
    </typZasobyK>

    <poznam><xsl:value-of select="Pozn"/></poznam>
    <hmotMj><xsl:value-of select="Hmotnost"/></hmotMj>
    <xsl:if test="Obrazek">
    <prilohy>
      <priloha>
        <nazSoub>
          <xsl:choose>
            <xsl:when test="contains(Obrazek, '\')"><xsl:call-template name="lastName"><xsl:with-param name="string" select="Obrazek"></xsl:with-param></xsl:call-template></xsl:when>
            <xsl:otherwise><xsl:value-of select="substring-after(Obrazek, '&lt;CestaAgenda&gt;')"/></xsl:otherwise>
          </xsl:choose>
        </nazSoub>
        <contentType>content/unknown</contentType>
        <typK>typPrilohy.cenik</typK>
        <linkPicture>true</linkPicture>
        
        <link>
          <xsl:choose>
            <xsl:when test="contains(Obrazek, '&lt;CestaAgenda&gt;')"><xsl:value-of select="concat(java:flexibee.Tool.params('agendaPath'), substring-after(Obrazek, '&lt;CestaAgenda&gt;'))"/></xsl:when>
            <xsl:otherwise><xsl:value-of select="Obrazek"/></xsl:otherwise>
          </xsl:choose>
        </link>
      </priloha>
    </prilohy>
    </xsl:if>
  </cenik>
  </xsl:template>
  
  <xsl:template name="lastName">
   <xsl:param name="string" />
   <xsl:choose>
      <xsl:when test="contains($string, '\')">
         <xsl:call-template name="lastName">
            <xsl:with-param name="string" select="substring-after($string, '\')"/>
         </xsl:call-template>
      </xsl:when>
      <xsl:otherwise><xsl:value-of select="$string"/></xsl:otherwise>
   </xsl:choose>
  </xsl:template>

</xsl:stylesheet>
