<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="winstrom">
    <winstrom version="1.0" source="s3">
      <xsl:apply-templates select="interni-doklad"/>
    </winstrom>
  </xsl:template>
  
  <!--
  CISLO,N,11,0	
  DATUM,D	
  ZDROJ,C,2	
  ZRADEK,N,11,0	
  DOKLAD,C,10	
  POPIS,C,50	
  UCMD,C,6	
  UCD,C,6	
  CASTKA,N,15,4	
  STRED,C,10	
  ZAKAZKA,C,10	
  CINNOST,C,10	
  PARSYM,C,20	
  PARICO,C,10	
  DEL,L	
  FREE,L	
  POZN,M	
  DATPOR,D	
  TIMPOR,C,5	
  VYST,C,50	
  CASTKACM,N,15,4	
  MENA,C,4	
  KURZ,N,15,4	
  MNOZSTVI,N,11,0	
  SPARMD,L	
  SPARDAL,L	
  ADCISLO,N,11,0	
  DATPLNDPH,D
  -->
  
  <xsl:template match="interni-doklad">
    <xsl:if test="MENA != ''">
      <mena update="ignore">
        <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(MENA)"/></id>
        <kod><xsl:value-of select="java:flexibee.Tool.toUpper(MENA)"/></kod>
        <nazev><xsl:value-of select="MENA"/></nazev>
      </mena>
    </xsl:if>
    
    <!-- ucetni uzaverku XZ naimportujeme -->
    <xsl:if test="FREE = 'false' and ZDROJ != 'XZ' and ZDROJ != 'XP'">
    <interni-doklad>
      <id>ext:mS3id:<xsl:value-of select="java:flexibee.Tool.params('rokMigrace')"/>/<xsl:value-of select="CISLO"/></id>
      <kod><xsl:value-of select="java:flexibee.Tool.params('rokMigrace')"/>/<xsl:value-of select="CISLO"/></kod>
      
      <xsl:if test="DOKLAD != ''">
        <cisDosle><xsl:value-of select="DOKLAD"/></cisDosle>
      </xsl:if>

      <typDokl>code:INT. DOKLAD</typDokl>
      
      <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(DATUM, 'd.M.y')"/></datVyst>
      <datSplat><xsl:value-of select="java:flexibee.Tool.parseDate(DATUM, 'd.M.y')"/></datSplat>
      
      <popis><xsl:value-of select="POPIS"/></popis>
      <xsl:choose>
        <!-- mena K� je kvuli lenosti - nezadavam spravne kodovani z prikazove radky-->
        <xsl:when test="MENA != 'K�' and MENA != 'Kč'">
          <mena>code:<xsl:value-of select="MENA"/></mena>
          <kurz><xsl:value-of select="java:flexibee.Tool.parseMoney(KURZ)"/></kurz>
        </xsl:when>
      </xsl:choose>
      
      <xsl:choose>
        <!-- zaklad -->
        <xsl:when test="not(starts-with(POPIS, 'DPH - '))">
          <xsl:if test="UCMD != '000000'">
            <primUcet>code:<xsl:value-of select="UCMD"/></primUcet>
          </xsl:if>
          <xsl:if test="UCD != '000000'">
            <protiUcet>code:<xsl:value-of select="UCD"/></protiUcet>
          </xsl:if>
        </xsl:when>
        <!-- dph -->
        <xsl:otherwise>
          <xsl:if test="UCD != '000000'">
            <dphZaklUcet>code:<xsl:value-of select="UCD"/></dphZaklUcet>
          </xsl:if>
          <xsl:if test="UCMD != '000000'">
            <dphSnizUcet>code:<xsl:value-of select="UCMD"/></dphSnizUcet>
          </xsl:if>
        </xsl:otherwise>
      </xsl:choose>
      
      <!-- vytvoreni polozek -->
      <polozkyIntDokladu removeAll="true">
        <pokladni-pohyb-polozka>
          <nazev><xsl:value-of select="POPIS"/></nazev>
          <!-- podle uctu rozhodneme zda se jedna o dph nebo o zaklad -->
          <xsl:choose>
            <!-- dph -->
            <xsl:when test="starts-with(UCMD, '343') or starts-with(UCD, '343')">
              <xsl:if test="UCMD != '000000'">
                <dphMdUcet>code:<xsl:value-of select="UCMD"/></dphMdUcet>
                <kopDphMdUcet>false</kopDphMdUcet>
              </xsl:if>
              
              <xsl:if test="UCD != '000000'">
                <dphDalUcet>code:<xsl:value-of select="UCD"/></dphDalUcet>
                <kopDphDalUcet>false</kopDphDalUcet>
              </xsl:if>
              <sumDph><xsl:value-of select="java:flexibee.Tool.parseMoney(CASTKA)"/></sumDph>
            </xsl:when>
            
            <!-- zaklad -->
            <xsl:otherwise>
              <xsl:if test="UCMD != '000000'">
                <zklMdUcet>code:<xsl:value-of select="UCMD"/></zklMdUcet>
                <kopZklMdUcet>false</kopZklMdUcet>
              </xsl:if>
              <xsl:if test="UCD != '000000'">
                <zklDalUcet>code:<xsl:value-of select="UCD"/></zklDalUcet>
                <kopZklDalUcet>false</kopZklDalUcet>
              </xsl:if>
              <sumZkl><xsl:value-of select="java:flexibee.Tool.parseMoney(CASTKA)"/></sumZkl>
              <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
            </xsl:otherwise>
          </xsl:choose>
          <typCenyDphK>typCeny.bezDph</typCenyDphK>
        </pokladni-pohyb-polozka>
      </polozkyIntDokladu>
    </interni-doklad>
    </xsl:if>
  </xsl:template>
</xsl:stylesheet>
