<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
xmlns:rsp="http://www.stormware.cz/schema/version_2/response.xsd" 
xmlns:rdc="http://www.stormware.cz/schema/version_2/documentresponse.xsd" 
xmlns:typ="http://www.stormware.cz/schema/version_2/type.xsd" 
xmlns:lst="http://www.stormware.cz/schema/version_2/list.xsd" 
xmlns:lStk="http://www.stormware.cz/schema/version_2/list_stock.xsd" 
xmlns:lAdb="http://www.stormware.cz/schema/version_2/list_addBook.xsd" 
xmlns:acu="http://www.stormware.cz/schema/version_2/accountingunit.xsd" 
xmlns:inv="http://www.stormware.cz/schema/version_2/invoice.xsd"
xmlns:vch="http://www.stormware.cz/schema/version_2/voucher.xsd"
xmlns:int="http://www.stormware.cz/schema/version_2/intDoc.xsd"
xmlns:stk="http://www.stormware.cz/schema/version_2/stock.xsd"
xmlns:ord="http://www.stormware.cz/schema/version_2/order.xsd"
xmlns:ofr="http://www.stormware.cz/schema/version_2/offer.xsd"
xmlns:enq="http://www.stormware.cz/schema/version_2/enquiry.xsd"
xmlns:vyd="http://www.stormware.cz/schema/version_2/vydejka.xsd"
xmlns:pri="http://www.stormware.cz/schema/version_2/prijemka.xsd"
xmlns:bal="http://www.stormware.cz/schema/version_2/balance.xsd"
xmlns:pre="http://www.stormware.cz/schema/version_2/prevodka.xsd"
xmlns:vyr="http://www.stormware.cz/schema/version_2/vyroba.xsd"
xmlns:pro="http://www.stormware.cz/schema/version_2/prodejka.xsd"
xmlns:con="http://www.stormware.cz/schema/version_2/contract.xsd"
xmlns:adb="http://www.stormware.cz/schema/version_2/addressbook.xsd"
xmlns:prm="http://www.stormware.cz/schema/version_2/parameter.xsd"
xmlns:lCon="http://www.stormware.cz/schema/version_2/list_contract.xsd"
xmlns:ctg="http://www.stormware.cz/schema/version_2/category.xsd"
xmlns:ipm="http://www.stormware.cz/schema/version_2/intParam.xsd"
xmlns:str="http://www.stormware.cz/schema/version_2/storage.xsd"
xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    
	<xsl:output method="xml" encoding="utf-8" />
	
  
  <xsl:key name="kodKey" match="lStk:stock" use="java:flexibee.Tool.toUpper(stk:stockHeader/stk:code)"/>

	
	<!-- 
  flexibee2xml-cli.exe -x cenik-pohoda.xml -t cenik-in.xslt -o cenik.xml
   -->
	
	<xsl:template match="lStk:listStock">
	  <winstrom version="1.0" migration="true">
      <merna-jednotka update="ignore">
        <id>code:M3</id>
        <kod>M3</kod>
        <nazev>Metr krychlový</nazev>
        <typMjK>typMj.objem</typMjK>
      </merna-jednotka>
      
			<xsl:apply-templates select="lStk:stock" mode="cenik"/>
			<xsl:apply-templates select="lStk:stock" mode="karty"/>
      
      <skladovy-pohyb>
        <id>ext:POHODA-INITSKLAD</id>
        <typDokl>code:STANDARD</typDokl>
        <sklad>code:SKLAD</sklad>
        <typPohybuK>typPohybu.prijem</typPohybuK>
        <skladovePolozky removeAll="true"> 
          <xsl:apply-templates select="lStk:stock" mode="prijemka"/>
        </skladovePolozky>
      </skladovy-pohyb>
		</winstrom>
	</xsl:template>
 
  
  <xsl:template match="lStk:stock" mode="cenik">
    <!-- vytvoreni mernych jednotek -->
    <xsl:if test="stk:stockHeader/stk:unit != ''">
	    <merna-jednotka update="ignore">
        <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(stk:stockHeader/stk:unit)"/></id>
        <id>ext:POHODA-MERJED:<xsl:value-of select="java:flexibee.Tool.toUpper(stk:stockHeader/stk:unit)"/></id>
        <kod><xsl:value-of select="java:flexibee.Tool.toUpper(stk:stockHeader/stk:unit)"/></kod>
        <nazev>Migrovaná měrná jednotka z pohody</nazev>
      </merna-jednotka>
	  </xsl:if>
    <xsl:if test="stk:stockHeader/stk:unit2 != ''">
	    <merna-jednotka update="ignore">
        <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(stk:stockHeader/stk:unit2)"/></id>
        <id>ext:POHODA-MERJED:<xsl:value-of select="java:flexibee.Tool.toUpper(stk:stockHeader/stk:unit2)"/></id>
        <kod><xsl:value-of select="java:flexibee.Tool.toUpper(stk:stockHeader/stk:unit2)"/></kod>
        <nazev>Migrovaná měrná jednotka z pohody</nazev>
      </merna-jednotka>
	  </xsl:if>
    <xsl:if test="stk:stockHeader/stk:unit3 != ''">
	    <merna-jednotka update="ignore">
        <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(stk:stockHeader/stk:unit3)"/></id>
        <id>ext:POHODA-MERJED:<xsl:value-of select="java:flexibee.Tool.toUpper(stk:stockHeader/stk:unit3)"/></id>
        <kod><xsl:value-of select="java:flexibee.Tool.toUpper(stk:stockHeader/stk:unit3)"/></kod>
        <nazev>Migrovaná měrná jednotka z pohody</nazev>
      </merna-jednotka>
	  </xsl:if>
    <xsl:if test="stk:stockHeader/stk:typePrice/typ:ids != ''">
      <skupina-zbozi update="ignore">
        <id>ext:POHODA-SKUPZBOZ:<xsl:value-of select="stk:stockHeader/stk:typePrice/typ:id"/></id>
        <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(stk:stockHeader/stk:typePrice/typ:ids)"/></id>
        <kod><xsl:value-of select="java:flexibee.Tool.toUpper(stk:stockHeader/stk:typePrice/typ:ids)"/></kod>
        <nazev>Migrovaná skupina zboží z pohody</nazev>
      </skupina-zbozi>
    </xsl:if>
  
  
    <cenik update="ignore">
      <id>ext:POHODA-CENIK:<xsl:value-of select="stk:stockHeader/stk:id"/></id>
      
      <!-- spojujeme ceniky podle nazvu, kdyz neni tak podle kodu -->
      <xsl:choose>
        <xsl:when test="stk:stockHeader/stk:name != ''">
          <id>ext:POHODA-CEN-NAZ:<xsl:value-of select="stk:stockHeader/stk:name"/></id>
        </xsl:when>
        <xsl:otherwise>
          <id>ext:POHODA-CEN-KOD:<xsl:value-of select="stk:stockHeader/stk:code"/></id>
        </xsl:otherwise>
      </xsl:choose>
      
      
<!--      <xsl:choose>
        <xsl:when test="stk:stockHeader/stk:stockType = 'card'">
          <typZasobyK>typZasoby.zbozi</typZasobyK>
          <xsl:call-template name="skladovaKarta"/>
        </xsl:when>
        <xsl:when test="stk:stockHeader/stk:stockType = 'text'">-->
          <typZasobyK>typZasoby.zbozi</typZasobyK>
<!--        </xsl:when>
        <xsl:when test="stk:stockHeader/stk:stockType = 'service'">
          <typZasobyK>typZasoby.sluzba</typZasobyK>
          <xsl:call-template name="skladovaKarta"/>
        </xsl:when>
        <xsl:when test="stk:stockHeader/stk:stockType = 'package'">
          <typZasobyK>typZasoby.zbozi</typZasobyK>
          <xsl:call-template name="skladovaKarta"/>
        </xsl:when>
        <xsl:when test="stk:stockHeader/stk:stockType = 'set'">
          <typZasobyK>typZasoby.zbozi</typZasobyK>
          <xsl:call-template name="skladovaKarta"/>
        </xsl:when>
        <xsl:when test="stk:stockHeader/stk:stockType = 'product'">
          <typZasobyK>typZasoby.vyrobek</typZasobyK>
          <xsl:call-template name="skladovaKarta"/>
        </xsl:when>
        <xsl:otherwise>
          <typZasobyK>typZasoby.zbozi</typZasobyK>
        </xsl:otherwise>
      </xsl:choose>-->
      
      <xsl:choose>
        <xsl:when test="generate-id(.) = generate-id(key('kodKey', java:flexibee.Tool.toUpper(stk:stockHeader/stk:code))[1]) and string-length(stk:stockHeader/stk:code) &lt; 21">
           <kod><xsl:value-of select="substring(stk:stockHeader/stk:code,1,20)"/></kod>
        </xsl:when>
        <xsl:otherwise>
          <kod><xsl:value-of select="substring(stk:stockHeader/stk:code,1,14)"/>-<xsl:value-of select="stk:stockHeader/stk:id"/></kod>
          <poznam>Kód: <xsl:value-of select="stk:stockHeader/stk:code"/></poznam>
        </xsl:otherwise>
      </xsl:choose>
      
      <eanKod><xsl:value-of select="stk:stockHeader/stk:EAN"/></eanKod>
      <kodPlu><xsl:value-of select="stk:stockHeader/stk:PLU"/></kodPlu>
      <!-- stk:isSales -->
      <evidVyrCis><xsl:value-of select="stk:stockHeader/stk:isSerialNumber"/></evidVyrCis>
      <!-- stk:isInternet -->
      <!-- stk:isBatch - asi sarze -->
      <!-- stk:purchasingRateVAT - dph nakup -->
      <xsl:choose>
        <xsl:when test="stk:stockHeader/stk:stockType = 'high'">
          <typSzbDphK>typSzbDph.dphZakl</typSzbDphK>
        </xsl:when>
        <xsl:when test="stk:stockHeader/stk:stockType = 'low'">
          <typSzbDphK>typSzbDph.dphSniz</typSzbDphK>
        </xsl:when>
        <xsl:when test="stk:stockHeader/stk:stockType = 'none'">
          <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
        </xsl:when>
        <xsl:otherwise>
          <typSzbDphK>typSzbDph.dphZakl</typSzbDphK>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:choose>
        <xsl:when test="stk:stockHeader/stk:name != ''">
          <nazev><xsl:value-of select="stk:stockHeader/stk:name"/></nazev>
        </xsl:when>
        <xsl:otherwise>
          <nazev><xsl:value-of select="stk:stockHeader/stk:code"/></nazev>
        </xsl:otherwise>
      </xsl:choose>
      <popis><xsl:value-of select="stk:stockHeader/stk:nameComplement"/></popis>
      
      <xsl:if test="stk:stockHeader/stk:unit != ''">
        <mj1>code:<xsl:value-of select="java:flexibee.Tool.toUpper(stk:stockHeader/stk:unit)"/></mj1>
      </xsl:if>
      <xsl:if test="stk:stockHeader/stk:unit2 != ''">
        <mj2>code:<xsl:value-of select="java:flexibee.Tool.toUpper(stk:stockHeader/stk:unit2)"/></mj2>
      </xsl:if>
      <xsl:if test="stk:stockHeader/stk:unit3 != ''">
        <mj3>code:<xsl:value-of select="java:flexibee.Tool.toUpper(stk:stockHeader/stk:unit3)"/></mj3>
      </xsl:if>
      <xsl:if test="stk:stockHeader/stk:coefficient2 != ''">
        <mjKoef2><xsl:value-of select="stk:stockHeader/stk:coefficient2"/></mjKoef2>
      </xsl:if>
      <xsl:if test="stk:stockHeader/stk:coefficient3 != ''">
        <mjKoef3><xsl:value-of select="stk:stockHeader/stk:coefficient3"/></mjKoef3>
      </xsl:if>
      <xsl:if test="stk:stockHeader/stk:typePrice/typ:ids != ''">
        <skupZboz>code:<xsl:value-of select="java:flexibee.Tool.toUpper(stk:stockHeader/stk:typePrice/typ:ids)"/></skupZboz>
      </xsl:if>
      
      <!-- stk:weightedPurchasePrice -->
      <xsl:if test="stk:stockHeader/stk:purchasingPrice != ''">
        <xsl:choose>
          <xsl:when test="starts-with(stk:stockHeader/stk:purchasingPrice, '-')">
            <!-- TODO do poznamky -->
          </xsl:when>
          <xsl:otherwise>
            <nakupCena><xsl:value-of select="stk:stockHeader/stk:purchasingPrice"/></nakupCena>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:if>
      <xsl:if test="stk:stockHeader/stk:sellingPrice != ''">
        <xsl:choose>
          <xsl:when test="starts-with(stk:stockHeader/stk:sellingPrice, '-')">
            <!-- TODO do poznamky -->
          </xsl:when>
          <xsl:otherwise>
            <cenaZakl><xsl:value-of select="stk:stockHeader/stk:sellingPrice"/></cenaZakl>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:if>
      <!-- stk:limitMin - skladova karta - POUZITO -->
      <!-- stk:limitMax - skladova karta - POUZITO -->
      <xsl:if test="stk:stockHeader/stk:mass != ''">
        <hmotMj><xsl:value-of select="stk:stockHeader/stk:mass"/></hmotMj>
        <mjHmot if-not-found="null">code:KG</mjHmot>
      </xsl:if>
      <xsl:if test="stk:stockHeader/stk:volume != ''">
        <objem><xsl:value-of select="stk:stockHeader/stk:volume"/></objem>
        <mjObj if-not-found="null">code:M3</mjObj>
      </xsl:if>
      <!-- stk:count - mnozstvi na sklade do skladove karty - POUZITO -->
      <!-- stk:countReceivedOrders -->
      <!-- stk:reservation -->
      <!-- stk:reclamation -->
      <xsl:if test="stk:stockHeader/stk:supplier/typ:id != ''">
        <xsl:choose>
          <!-- pokud nemame k dodavateli doplnujici udaje neriskujeme ze se firma dodavatele nepodari najit pri vytvareni dodavatele -->
          <xsl:when test="stk:stockHeader/stk:orderName != '' or stk:stockHeader/stk:orderName != ''">
            <dodavatele>
              <dodavatel>
                <id>ext:POHODA-DODAVATEL:<xsl:value-of select="stk:stockHeader/stk:id"/></id>
                <firma>ext:POHODA-ADR:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="stk:stockHeader/stk:supplier/typ:id"/></firma>
                <primarni>true</primarni>
                <kodIndi><xsl:value-of select="java:flexibee.Tool.toUpper(substring(stk:stockHeader/stk:orderName,0,20))"/></kodIndi>
                <poznam><xsl:value-of select="stk:stockHeader/stk:orderName"/></poznam>
              </dodavatel>
            </dodavatele>
          </xsl:when>
          <xsl:otherwise>
            <dodavatel if-not-found="null">ext:POHODA-ADR:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="stk:stockHeader/stk:supplier/typ:id"/></dodavatel>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:if>
      <!-- stk:orderQuantity -->
      <!-- stk:countIssuedOrders -->
      
      <xsl:choose>
        <xsl:when test="stk:stockHeader/stk:guaranteeType = 'year'">
          <mjZarukyK>mjZaruky.rok</mjZarukyK>
          <zaruka><xsl:value-of select="stk:stockHeader/stk:guarantee"/></zaruka>
        </xsl:when>
        <xsl:when test="stk:stockHeader/stk:guaranteeType = 'month'">
          <mjZarukyK>mjZaruky.mesic</mjZarukyK>
          <zaruka><xsl:value-of select="stk:stockHeader/stk:guarantee"/></zaruka>
        </xsl:when>
      </xsl:choose>
      
      <xsl:if test="stk:stockHeader/stk:producer != ''">
        <vyrobce if-not-found="null">code:<xsl:value-of select="java:flexibee.Tool.split(java:flexibee.Tool.toUpper(stk:stockHeader/stk:producer), ' ', 0)"/></vyrobce>
      </xsl:if>
      
      <!-- stk:news -->
			<!-- stk:clearanceSale -->
			<!-- stk:sale -->
			<!-- stk:recommended -->
			<!-- stk:discount -->
			<!-- stk:prepare -->
      
      <ceniky-ve-stromu>
			  <strom-cenik>
				  <id>ext:POHODA-STROM-VAZUZEL:<xsl:value-of select="stk:stockHeader/stk:storage/typ:id"/>+<xsl:value-of select="stk:stockHeader/stk:id"/></id>
				  <uzel>ext:POHODA-STROM-UZEL:<xsl:value-of select="stk:stockHeader/stk:storage/typ:id"/></uzel>
			  </strom-cenik>
		  </ceniky-ve-stromu>
    </cenik>
  </xsl:template>
  
  
  <xsl:template match="lStk:stock" mode="karty">
    <cenik>
      <id>ext:POHODA-CENIK:<xsl:value-of select="stk:stockHeader/stk:id"/></id>
      
      <xsl:choose>
        <xsl:when test="stk:stockHeader/stk:name != ''">
          <id>ext:POHODA-CEN-NAZ:<xsl:value-of select="stk:stockHeader/stk:name"/></id>
        </xsl:when>
        <xsl:otherwise>
          <id>ext:POHODA-CEN-KOD:<xsl:value-of select="stk:stockHeader/stk:code"/></id>
        </xsl:otherwise>
      </xsl:choose>
      
      
      <xsl:choose>
        <xsl:when test="stk:stockHeader/stk:stockType = 'card'">
          <typZasobyK>typZasoby.zbozi</typZasobyK>
          <xsl:call-template name="skladovaKarta"/>
        </xsl:when>
        <xsl:when test="stk:stockHeader/stk:stockType = 'text'">
          <typZasobyK>typZasoby.zbozi</typZasobyK>
        </xsl:when>
        <xsl:when test="stk:stockHeader/stk:stockType = 'service'">
          <typZasobyK>typZasoby.sluzba</typZasobyK>
          <xsl:call-template name="skladovaKarta"/>
        </xsl:when>
        <xsl:when test="stk:stockHeader/stk:stockType = 'package'">
          <typZasobyK>typZasoby.zbozi</typZasobyK>
          <xsl:call-template name="skladovaKarta"/>
        </xsl:when>
        <xsl:when test="stk:stockHeader/stk:stockType = 'set'">
          <typZasobyK>typZasoby.zbozi</typZasobyK>
          <xsl:call-template name="skladovaKarta"/>
        </xsl:when>
        <xsl:when test="stk:stockHeader/stk:stockType = 'product'">
          <typZasobyK>typZasoby.vyrobek</typZasobyK>
          <xsl:call-template name="skladovaKarta"/>
        </xsl:when>
        <xsl:otherwise>
          <typZasobyK>typZasoby.zbozi</typZasobyK>
        </xsl:otherwise>
      </xsl:choose>
    </cenik>
  </xsl:template>
  
  
  <xsl:template name="skladovaKarta">
    <skladove>true</skladove>
    
    <skladKarty>
      <skladKarta>
        <id>ext:POHODA-SKL_KAR:<xsl:value-of select="stk:stockHeader/stk:id"/></id>
        <sklad if-not-found="null">code:<xsl:value-of select="java:flexibee.Tool.split(java:flexibee.Tool.toUpper(stk:stockHeader/stk:storage/typ:ids), '/', 0)"/></sklad>
        <aktualniUcetObdobi/>
        <!--  Nahrazeno generovanim dokladu
        <xsl:if test="stk:stockHeader/stk:purchasingPrice != ''">
          <prumCenaTuz><xsl:value-of select="java:flexibee.Tool.parseMoney(stk:stockHeader/stk:purchasingPrice)"/></prumCenaTuz>
        </xsl:if>
        <xsl:if test="stk:stockHeader/stk:count != ''">
          <stavMJ><xsl:value-of select="stk:stockHeader/stk:count"/></stavMJ>
        </xsl:if>-->
        
        <xsl:if test="stk:stockHeader/stk:limitMin != ''">
          <minMJ><xsl:value-of select="stk:stockHeader/stk:limitMin"/></minMJ>
        </xsl:if>
        <xsl:if test="stk:stockHeader/stk:limitMax != ''">
          <maxMJ><xsl:value-of select="stk:stockHeader/stk:limitMax"/></maxMJ>
        </xsl:if>
      </skladKarta>
    </skladKarty>
  </xsl:template>
  
  <xsl:template match="lStk:stock" mode="prijemka">
    <xsl:if test="stk:stockHeader/stk:stockType = 'card' or stk:stockHeader/stk:stockType = 'package' or stk:stockHeader/stk:stockType = 'set' or stk:stockHeader/stk:stockType = 'product'">
    <xsl:if test="stk:stockHeader/stk:count != '0.0'">
    
      <skladovy-pohyb-polozka>
        <cenik>ext:POHODA-CENIK:<xsl:value-of select="stk:stockHeader/stk:id"/></cenik>
        <sklad>code:<xsl:value-of select="java:flexibee.Tool.split(java:flexibee.Tool.toUpper(stk:stockHeader/stk:storage/typ:ids), '/', 0)"/></sklad>
        <skladovaKarta>ext:POHODA-SKL_KAR:<xsl:value-of select="stk:stockHeader/stk:id"/></skladovaKarta>
        <cenaMj><xsl:value-of select="java:flexibee.Tool.parseMoney(stk:stockHeader/stk:purchasingPrice)"/></cenaMj>
        <cenyRucne>true</cenyRucne>
        
        <xsl:choose>
          <xsl:when test="stk:stockHeader/stk:isSerialNumber = 'true'">
            <mnozMj><xsl:value-of select="count(stk:stockSerialNumber/stk:serialNumberItem[stk:count = 1.0])"/></mnozMj>
            <xsl:if test="count(stk:stockSerialNumber/stk:serialNumberItem[stk:count = 1.0]) != stk:stockHeader/stk:count">
              <poznam>Uvedené množství: <xsl:value-of select="stk:stockHeader/stk:count"/></poznam>
            </xsl:if>
            
            <vyrobniCislaPrijata>
              <xsl:for-each select="stk:stockSerialNumber/stk:serialNumberItem">
                <xsl:if test="stk:count = 1.0">
                  <vyrobni-cislo>
                    <kod><xsl:value-of select="stk:serialNumber"/></kod>
                  </vyrobni-cislo>
                </xsl:if>
              </xsl:for-each>
            </vyrobniCislaPrijata>
          </xsl:when>
          <xsl:otherwise>
            <mnozMj><xsl:value-of select="stk:stockHeader/stk:count"/></mnozMj>
          </xsl:otherwise>
        </xsl:choose>
      </skladovy-pohyb-polozka>
    </xsl:if> 
    </xsl:if>
  </xsl:template>
</xsl:stylesheet>
