<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    <xsl:output method="xml" indent="yes"  encoding="utf-8"/>

    <!-- Importovač pro exporty do ESHOPů
	    http://sluzby.heureka.cz/napoveda/import/
	    http://napoveda.seznam.cz/cz/specifikace-xml.html
	-->

    <xsl:template match="SHOP">
	<winstrom version="1.0">
	<xsl:apply-templates select="SHOPITEM"/>
	</winstrom>
    </xsl:template>

    <xsl:template match="SHOPITEM">
	<cenik>
	    <xsl:if test="EAN != ''"><id>ean:<xsl:value-of select="EAN"/></id></xsl:if>

	    <xsl:choose>
		<xsl:when test="ISBN != ''">
		    <id>code:<xsl:value-of select="ISBN"/></id>
		    <kod>:<xsl:value-of select="ISBN"/></kod>

		</xsl:when>
		<xsl:when test="PRODUCTNO != ''">
		    <id>code:<xsl:value-of select="PRODUCTNO"/></id>
		    <kod><xsl:value-of select="PRODUCTNO"/></kod>
		</xsl:when>
	    </xsl:choose>

	    <nazev><xsl:choose>
		<xsl:when test="PRODUCT != ''"><xsl:value-of select="PRODUCT"/></xsl:when>
		<xsl:otherwise><xsl:value-of select="PRODUCTNAME"/></xsl:otherwise>
	    </xsl:choose></nazev>
	    <popis><xsl:value-of select="DESCRIPTION"/>
		<xsl:for-each select="PARAM">
            	    <xsl:value-of select="java:flexibee.Tool.br()"/><xsl:value-of select ="PARAM_NAME"/>: <xsl:value-of select ="VAL"/>

		</xsl:for-each></popis>
	    <typZasobyK>typZasoby.skladem</typZasobyK>
	    <eanKod><xsl:value-of select="EAN"/></eanKod>
	    <xsl:choose>
		<xsl:when test="PRICE != ''">
	    	    <cenaZakl><xsl:value-of select="PRICE"/></cenaZakl>
		    <typCenyDphK>typCeny.bezDph</typCenyDphK>
		</xsl:when>
		<xsl:otherwise>
	    	    <cenaZakl><xsl:value-of select="PRICE_VAT"/></cenaZakl>
		    <typCenyDphK>typCeny.sDph</typCenyDphK>
		</xsl:otherwise>
	    </xsl:choose>
	    <typSzbDphK><xsl:value-of select="java:flexibee.Tool.vatToCode(VAT)"/></typSzbDphK>
	</cenik>

    </xsl:template>

</xsl:stylesheet>